# ifndef yyTree
# define yyTree

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

/* line 21 "" */

  #include "Scanner.h"
  #include "Errors.h"


# ifndef bool
# define bool char
# endif
# define NoTree (tTree) 0L
# define kStart 1
# define kSpecList 2
# define kNoSpec 3
# define kASpec 4
# define kSpec 5
# define kDecl 6
# define kIs 7
# define kAVal 8
# define kVal 9
# define kValRetypes 10
# define kRetypes 11
# define kDefAPro 12
# define kDefSeqPro 13
# define kDefTagPro 14
# define kDefAProc 15
# define kDefProc 16
# define kPrototypeProc 17
# define kDefAFunc 18
# define kDefFunc 19
# define kDefIsFunc 20
# define kPrototypeFunc 21
# define kNullSpec 22
# define kHCode 23
# define kCallFrame 24
# define kParFrame 25
# define kFormals 26
# define kNoFormal 27
# define kAFormal 28
# define kReplicator 29
# define kTagProList 30
# define kNoTagPro 31
# define kATagPro 32
# define kBy 33
# define kByVal 34
# define kByRef 35
# define kByUndef 36
# define kIdList 37
# define kNoId 38
# define kAnId 39
# define kType 40
# define kArray 41
# define kChan 42
# define kTimer 43
# define kUntyped 44
# define kPrimitive 45
# define kNumeric 46
# define kInteger 47
# define kInt 48
# define kInt16 49
# define kInt32 50
# define kInt64 51
# define kReal 52
# define kReal32 53
# define kReal64 54
# define kByte 55
# define kBool 56
# define kTypeList 57
# define kNoType 58
# define kAType 59
# define kProtocol 60
# define kAny 61
# define kNamed 62
# define kSimple 63
# define kCounted 64
# define kSeqProList 65
# define kNoSeqPro 66
# define kASeqPro 67
# define kExpr 68
# define kBinary 69
# define kUnary 70
# define kConst 71
# define kValof 72
# define kFuncCall 73
# define kElementalExpr 74
# define kDefault 75
# define kConvert 76
# define kRound 77
# define kTrunc 78
# define kMostPos 79
# define kMostNeg 80
# define kCountArray 81
# define kUnBound 82
# define kStringElement 83
# define kString 84
# define kStringSubscript 85
# define kStringRange 86
# define kElemental 87
# define kTableElement 88
# define kTable 89
# define kTableSubscript 90
# define kTableRange 91
# define kElement 92
# define kIdentifier 93
# define kElementAccess 94
# define kSubscript 95
# define kRange 96
# define kExprList 97
# define kNoExpr 98
# define kAnExpr 99
# define kOp 100
# define kRelOp 101
# define kLess 102
# define kGreater 103
# define kLessEqual 104
# define kGreaterEqual 105
# define kEqual 106
# define kNotEqual 107
# define kMathsOp 108
# define kAdd 109
# define kSubtract 110
# define kMultiply 111
# define kDivide 112
# define kRem 113
# define kBitOp 114
# define kBitAnd 115
# define kBitOr 116
# define kBitEor 117
# define kShiftOp 118
# define kLeftShift 119
# define kRightShift 120
# define kUniOp 121
# define kSize 122
# define kBitNot 123
# define kNot 124
# define kClockOp 125
# define kPlus 126
# define kMinus 127
# define kTimes 128
# define kLogOp 129
# define kAnd 130
# define kOr 131
# define kAfterOp 132
# define kProcess 133
# define kAssign 134
# define kAltType 135
# define kAlt 136
# define kAltRep 137
# define kParType 138
# define kPar 139
# define kParRep 140
# define kProcessor 141
# define kIfType 142
# define kIf 143
# define kIfRep 144
# define kInput 145
# define kOutput 146
# define kCaseIn 147
# define kAfter 148
# define kSeqRep 149
# define kSeq 150
# define kCase 151
# define kWhile 152
# define kSkip 153
# define kStop 154
# define kInstance 155
# define kCCode 156
# define kNullProcess 157
# define kAltList 158
# define kNoAlt 159
# define kAnAlts 160
# define kAnAlt 161
# define kANewAlt 162
# define kGuard 163
# define kAltInput 164
# define kAltTimer 165
# define kAltCaseIn 166
# define kNoInput 167
# define kChoiceList 168
# define kNoChoice 169
# define kAChoices 170
# define kAChoice 171
# define kANewIf 172
# define kProcList 173
# define kNoProcess 174
# define kAProcess 175
# define kCaseList 176
# define kNoCase 177
# define kACase 178
# define kAccessList 179
# define kAnAccess 180
# define kNoAccess 181
# define kElementList 182
# define kAnElement 183
# define kNoElement 184

typedef unsigned char Tree_tKind;
typedef unsigned short Tree_tMark;
typedef unsigned short Tree_tLabel;
typedef union Tree_Node * tTree;
typedef void (* Tree_tProcTree) ();
/* line 28 "" */

  #include "Symbol.h"

  typedef enum { xxPrototype, xxCDirectives, xxLibrary, xxUsageWarnings,		/* Compile time modes */
                 xxCheckConversions, xxCheckInternals, xxCheckArrays, xxCheckRanges,	/* Error checking modes */
                 xxOccamLines, xxOccamDebug,						/* Debugging */
                 xxSupportINT64, xxLittleEndian, xx16bitINT, xxEmulate,	 		/* Target Architecture */
                 xxSimulatedServer, xxSigTimer,						/* */
 		 xxFasterGOTO, xxCallF90,
                 xxInmosExtensions, xxUserDataTypes, xxSupportPlaced } eExtnModes;

  extern int ExtnModes;
  #define CHK_Mode(x,p) if (!((1<<x)&ExtnModes)) Message("Grammar not allowed under current mode",xxError,p)
  #define ADD_Mode(x)   (ExtnModes|=(1<<x))
  #define REM_Mode(x)   (ExtnModes&=(~(1<<x)))
  #define TOG_Mode(x)   (ExtnModes^=(1<<x))
  #define IS_Mode(x)    ((1<<x)&ExtnModes)
  #define BIT_Mode(x)   (1<<x)
  #define GET_Mode()    (ExtnModes)

  #define SET_Mode(x,b) ((b) ? (ADD_Mode(x)) : (REM_Mode(x)))

  #define ADD_Flag(x,f)   ((f)|=(1<<x))
  #define REM_Flag(x,f)   ((f)&=(~(1<<x)))
  #define TOG_Flag(x,f)   ((f)^=(1<<x))
  #define IS_Flag(x,f)    ((1<<x)&(f))

  #undef putchar
  #undef getchar

/* line 472 "" */

  typedef tTree tType;

  typedef unsigned char *tConstArray;
  #define NoConstArray ((tConstArray)NULL)

  #define DoBndChk(S) S->Subscript.CB
  #define DoLwrBndChk(R) R->Range.CLB
  #define DoUprBndChk(R) R->Range.CUB

  #define ConstFlag(E) E.C
  #define IsConstInt(E) (Tree_IsType(ExprType(E),kInteger) && ConstFlag(E->Expr))
  #define ValConstInt(E) E->Expr.CV.Number

  #define ElementalConst(E) E->Elemental.CA
  #define StringConst(S) S->StringElement.CA

  #define IsConstExpr(E) ConstFlag(E->Expr)
  #define ValConstExpr(E) E->Expr.CV

  #define IsConstIntElement(E) (Tree_IsType(ElementType(E),kInteger) && ConstFlag(E->Element))
  #define ValConstIntElement(E) E->Element.CV.Number

  #define IsConstIntExprList(E) (Tree_IsType(ExprListType(E),kInteger) && ConstFlag(E->ExprList))
  #define IsConstExprList(E)    (ConstFlag(E->ExprList))

  #define ParType(P) (P->ParType.PType)
  #define AltIsPri(P) (P->AltType.Pri)
  typedef enum { xxPar, xxPriPar, xxPlacedPar } tParType;

  #define IsLVIdent(I) I->Identifier.LV
  #define ExprType(E) E->Expr.SynType
  #define ExprListType(E) E->ExprList.SynType
  #define ChoiceListType(E) E->ChoiceList.SynType
  #define ElementType(E) E->Element.SynType
  #define ElementalType(E) E->Elemental.SynType

  #define Writable(E) E->Element.W
  #define TempRequired(EL) EL->ExprList.TR

  typedef enum { xxUnused, xxUsed, xxInput, xxOutput, xxInOut } tUsage; 
  extern tUsage UpdateUsage(tUsage old, tUsage new);

  /*{{{  VUsage*/
  enum { xxxAccess,xxxLRead,xxxLWrite,xxxNLRead,xxxNLWrite,xxxAtomic };
  #define xxLRead   (1<<xxxLRead)
  #define xxLWrite  (1<<xxxLWrite)
  #define xxNLRead  (1<<xxxNLRead)
  #define xxNLWrite (1<<xxxNLWrite)
  #define xxAtomic  (1<<xxxAtomic)
  #define xxAccess  (1<<xxxAccess)
  
  #define AddVUsage(S,U)  { SymbolUsage(S) |= (U); }
  
  #define AddRVUsage(S,P) { tVUsage u = (SymbolDepth(S)<=SymbolDepth(P)) ?  xxNLRead :  xxLRead; AddVUsage(S,xxAccess | u); MarkRefParent(S,SymbolKind(P),xxNLRead); }
  #define AddWVUsage(S,P) { tVUsage u = (SymbolDepth(S)<=SymbolDepth(P)) ? xxNLWrite : xxLWrite; AddVUsage(S,xxAccess | u); MarkRefParent(S,SymbolKind(P),xxNLWrite);}
  /*}}}*/

  typedef enum { xxOccam, xxAtomicOccam, xxF90, xxF77, xxC } tLang;

/* line 695 "" */

  typedef tTree tChain;
  typedef tTree tFrame;
  typedef tTree tChoiceList;
  typedef tTree tIfType;

  extern FILE *yyf;

/* line 859 "" */

  typedef struct tParUsageStruct tParUsageStruct;
  typedef tParUsageStruct* tParUsage;

  typedef struct tLinExpr tLinExpr;
  typedef tLinExpr* pLinExpr;
  #include "Omega.h"
  #include "ParUsage.h"


# ifndef Tree_NodeHead
# define Tree_NodeHead
# endif
typedef struct { Tree_tKind yyKind; Tree_tMark yyMark; Tree_NodeHead } Tree_tNodeHead;
typedef struct { Tree_tNodeHead yyHead; tTree Process; tChain CGNext; tSymbol OuterProc; } yStart;
typedef struct { Tree_tNodeHead yyHead; int VS; int VIn; int VOut; int DCL; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; } ySpecList;
typedef struct { Tree_tNodeHead yyHead; int VS; int VIn; int VOut; int DCL; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; } yNoSpec;
typedef struct { Tree_tNodeHead yyHead; int VS; int VIn; int VOut; int DCL; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tTree Spec; tTree Next; } yASpec;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; } ySpec;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tTree Type; tTree IdList; } yDecl;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tTree Type; tSymbol Sym; tTree Elemental; tUsage U; } yIs;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tTree Type; tSymbol Sym; tTree Expr; } yAVal;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tTree Type; tSymbol Sym; tTree Expr; } yVal;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tTree Type; tSymbol Sym; tTree Expr; } yValRetypes;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tTree Type; tSymbol Sym; tTree Elemental; } yRetypes;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; } yDefAPro;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tSymbol Sym; tTree SeqProList; } yDefSeqPro;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tSymbol Sym; tTree TagProList; } yDefTagPro;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tSymbol Sym; tTree Formals; tUsage U; tChain CGNext; } yDefAProc;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tSymbol Sym; tTree Formals; tUsage U; tChain CGNext; tTree Process; bool ATOMIC; bool isPar; } yDefProc;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tSymbol Sym; tTree Formals; tUsage U; tChain CGNext; tIdent Module; tLang Lang; } yPrototypeProc;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tSymbol Sym; tTree TypeList; tTree Formals; tUsage U; tChain CGNext; } yDefAFunc;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tSymbol Sym; tTree TypeList; tTree Formals; tUsage U; tChain CGNext; tTree Valof; bool ATOMIC; } yDefFunc;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tSymbol Sym; tTree TypeList; tTree Formals; tUsage U; tChain CGNext; tTree ExprList; bool ATOMIC; } yDefIsFunc;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tSymbol Sym; tTree TypeList; tTree Formals; tUsage U; tChain CGNext; tIdent Module; tLang Lang; } yPrototypeFunc;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; } yNullSpec;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tStringRef Code; tSymbol Scope; tChain CGNext; } yHCode;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tIdent Id; tSymbol Sym; } yCallFrame;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; int VS; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tIdent TId; tIdent FId; tSymbol Sym; int Rep; } yParFrame;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; bool InPrototype; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; } yFormals;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; bool InPrototype; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; } yNoFormal;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; bool InPrototype; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; tTree Next; tPosition Pos; tTree By; tTree Type; tSymbol Sym; tUsage U; } yAFormal;
typedef struct { Tree_tNodeHead yyHead; tSymbol Sym; tTree From; tTree For; int VIn; int VOut; tSymbol Parent; bool AtomicSpec; tParUsage PUIn; tParUsage PUOut; bool SE; pLinExpr FromLE; pLinExpr ForLE; } yReplicator;
typedef struct { Tree_tNodeHead yyHead; tParUsage PUIn; tParUsage PUOut; } yTagProList;
typedef struct { Tree_tNodeHead yyHead; tParUsage PUIn; tParUsage PUOut; } yNoTagPro;
typedef struct { Tree_tNodeHead yyHead; tParUsage PUIn; tParUsage PUOut; tTree Next; tSymbol Sym; tTree SeqProList; } yATagPro;
typedef struct { Tree_tNodeHead yyHead; } yBy;
typedef struct { Tree_tNodeHead yyHead; } yByVal;
typedef struct { Tree_tNodeHead yyHead; } yByRef;
typedef struct { Tree_tNodeHead yyHead; } yByUndef;
typedef struct { Tree_tNodeHead yyHead; tSymbol Parent; bool AtomicSpec; } yIdList;
typedef struct { Tree_tNodeHead yyHead; tSymbol Parent; bool AtomicSpec; } yNoId;
typedef struct { Tree_tNodeHead yyHead; tSymbol Parent; bool AtomicSpec; tTree Next; tSymbol Sym; tUsage U; } yAnId;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; } yType;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; tTree Expr; tTree Type; bool SE; pLinExpr LE; } yArray;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; tTree Protocol; } yChan;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; } yTimer;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; } yUntyped;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; } yPrimitive;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; } yNumeric;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; } yInteger;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; } yInt;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; } yInt16;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; } yInt32;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; } yInt64;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; } yReal;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; } yReal32;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; } yReal64;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; } yByte;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; } yBool;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; } yTypeList;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; } yNoType;
typedef struct { Tree_tNodeHead yyHead; int VIn; int VOut; int D; tParUsage PUIn; tParUsage PUOut; tTree Next; tTree Type; } yAType;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tParUsage PUIn; tParUsage PUOut; } yProtocol;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tParUsage PUIn; tParUsage PUOut; } yAny;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tParUsage PUIn; tParUsage PUOut; tSymbol Sym; } yNamed;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tParUsage PUIn; tParUsage PUOut; tTree Type; } ySimple;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tParUsage PUIn; tParUsage PUOut; tTree Length; tTree Type; } yCounted;
typedef struct { Tree_tNodeHead yyHead; tParUsage PUIn; tParUsage PUOut; } ySeqProList;
typedef struct { Tree_tNodeHead yyHead; tParUsage PUIn; tParUsage PUOut; } yNoSeqPro;
typedef struct { Tree_tNodeHead yyHead; tParUsage PUIn; tParUsage PUOut; tTree Next; tTree Protocol; } yASeqPro;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; } yExpr;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; tTree Lop; tTree Rop; tTree Op; } yBinary;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; tTree Expr; tTree Op; } yUnary;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; tValue Value; tTree Type; } yConst;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; tTree SpecList; tTree Process; tTree ExprList; tSymbol Sym; int VS; } yValof;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; tSymbol Sym; tTree ExprList; int Depth; tFrame Frame; } yFuncCall;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; tTree Elemental; bool PAR; } yElementalExpr;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; } yDefault;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; tTree Type; tTree Expr; } yConvert;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; tTree Type; tTree Expr; } yRound;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; tTree Type; tTree Expr; } yTrunc;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; tTree Type; } yMostPos;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; tTree Type; } yMostNeg;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; tTree Length; tTree Expr; } yCountArray;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; } yUnBound;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; tConstArray CA; } yStringElement;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; tConstArray CA; tStringRef Value; int Depth; } yString;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; tConstArray CA; tTree Next; tTree Expr; } yStringSubscript;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int VIn; int VOut; bool C; tValue CV; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; tConstArray CA; tTree Next; tTree From; tTree For; } yStringRange;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int W; int VIn; int VOut; bool C; tValue CV; tConstArray CA; tUsage U; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; bool SE; } yElemental;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int W; int VIn; int VOut; bool C; tValue CV; tConstArray CA; tUsage U; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; bool SE; } yTableElement;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int W; int VIn; int VOut; bool C; tValue CV; tConstArray CA; tUsage U; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; bool SE; tTree ExprList; int Depth; pLinExpr LE; } yTable;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int W; int VIn; int VOut; bool C; tValue CV; tConstArray CA; tUsage U; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; bool SE; tTree Next; tTree Expr; pLinExpr LE; } yTableSubscript;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int W; int VIn; int VOut; bool C; tValue CV; tConstArray CA; tUsage U; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; bool SE; tTree Next; tTree From; tTree For; pLinExpr FromLE; pLinExpr ForLE; } yTableRange;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int W; int VIn; int VOut; bool C; tValue CV; tConstArray CA; tUsage U; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; bool SE; } yElement;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int W; int VIn; int VOut; bool C; tValue CV; tConstArray CA; tUsage U; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; bool SE; tSymbol Sym; tSymbol Scope; } yIdentifier;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int W; int VIn; int VOut; bool C; tValue CV; tConstArray CA; tUsage U; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; bool SE; tTree Next; } yElementAccess;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int W; int VIn; int VOut; bool C; tValue CV; tConstArray CA; tUsage U; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; bool SE; tTree Next; tTree Expr; bool CB; pLinExpr LE; } ySubscript;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tType SynType; int W; int VIn; int VOut; bool C; tValue CV; tConstArray CA; tUsage U; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool LV; bool SE; tTree Next; tTree From; tTree For; bool CLB; bool CUB; pLinExpr FromLE; pLinExpr ForLE; } yRange;
typedef struct { Tree_tNodeHead yyHead; tType SynType; int VIn; int VOut; bool C; bool TR; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool PAR; bool LV; } yExprList;
typedef struct { Tree_tNodeHead yyHead; tType SynType; int VIn; int VOut; bool C; bool TR; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool PAR; bool LV; } yNoExpr;
typedef struct { Tree_tNodeHead yyHead; tType SynType; int VIn; int VOut; bool C; bool TR; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool PAR; bool LV; tTree Next; tTree Expr; } yAnExpr;
typedef struct { Tree_tNodeHead yyHead; } yOp;
typedef struct { Tree_tNodeHead yyHead; } yRelOp;
typedef struct { Tree_tNodeHead yyHead; } yLess;
typedef struct { Tree_tNodeHead yyHead; } yGreater;
typedef struct { Tree_tNodeHead yyHead; } yLessEqual;
typedef struct { Tree_tNodeHead yyHead; } yGreaterEqual;
typedef struct { Tree_tNodeHead yyHead; } yEqual;
typedef struct { Tree_tNodeHead yyHead; } yNotEqual;
typedef struct { Tree_tNodeHead yyHead; } yMathsOp;
typedef struct { Tree_tNodeHead yyHead; } yAdd;
typedef struct { Tree_tNodeHead yyHead; } ySubtract;
typedef struct { Tree_tNodeHead yyHead; } yMultiply;
typedef struct { Tree_tNodeHead yyHead; } yDivide;
typedef struct { Tree_tNodeHead yyHead; } yRem;
typedef struct { Tree_tNodeHead yyHead; } yBitOp;
typedef struct { Tree_tNodeHead yyHead; } yBitAnd;
typedef struct { Tree_tNodeHead yyHead; } yBitOr;
typedef struct { Tree_tNodeHead yyHead; } yBitEor;
typedef struct { Tree_tNodeHead yyHead; } yShiftOp;
typedef struct { Tree_tNodeHead yyHead; } yLeftShift;
typedef struct { Tree_tNodeHead yyHead; } yRightShift;
typedef struct { Tree_tNodeHead yyHead; } yUniOp;
typedef struct { Tree_tNodeHead yyHead; } ySize;
typedef struct { Tree_tNodeHead yyHead; } yBitNot;
typedef struct { Tree_tNodeHead yyHead; } yNot;
typedef struct { Tree_tNodeHead yyHead; } yClockOp;
typedef struct { Tree_tNodeHead yyHead; } yPlus;
typedef struct { Tree_tNodeHead yyHead; } yMinus;
typedef struct { Tree_tNodeHead yyHead; } yTimes;
typedef struct { Tree_tNodeHead yyHead; } yLogOp;
typedef struct { Tree_tNodeHead yyHead; } yAnd;
typedef struct { Tree_tNodeHead yyHead; } yOr;
typedef struct { Tree_tNodeHead yyHead; } yAfterOp;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; } yProcess;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree Lval; tTree Rval; } yAssign;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool Pri; int ARC; } yAltType;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool Pri; int ARC; tTree AltList; } yAlt;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool Pri; int ARC; tTree Replicator; tTree AltList; } yAltRep;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tParType PType; } yParType;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tParType PType; tTree ProcList; } yPar;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tParType PType; tTree Replicator; tTree Process; tSymbol Sym; } yParRep;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree Expr; tIdent Name; tTree Process; } yProcessor;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tChoiceList BackChoiceList; tIfType BackIfType; } yIfType;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tChoiceList BackChoiceList; tIfType BackIfType; tTree ChoiceList; } yIf;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tChoiceList BackChoiceList; tIfType BackIfType; tTree Replicator; tTree ChoiceList; } yIfRep;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree Element; tTree ExprList; } yInput;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree Element; tTree ExprList; } yOutput;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree Element; tTree CaseList; } yCaseIn;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree Element; tTree Expr; } yAfter;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree Replicator; tTree Process; } ySeqRep;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree ProcList; } ySeq;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree Selector; tTree ChoiceList; } yCase;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree Expr; tTree Process; } yWhile;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; } ySkip;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; } yStop;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tSymbol Sym; tTree ExprList; tSymbol Scope; tFrame Frame; } yInstance;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tStringRef Code; tSymbol Scope; } yCCode;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree SpecList; int VS; int VIn; int VOut; bool ATOMIC; int SLC; bool TLA; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; } yNullProcess;
typedef struct { Tree_tNodeHead yyHead; int VS; int VIn; int VOut; int SLC; int ARC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; } yAltList;
typedef struct { Tree_tNodeHead yyHead; int VS; int VIn; int VOut; int SLC; int ARC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; } yNoAlt;
typedef struct { Tree_tNodeHead yyHead; int VS; int VIn; int VOut; int SLC; int ARC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree SpecList; tTree Next; } yAnAlts;
typedef struct { Tree_tNodeHead yyHead; int VS; int VIn; int VOut; int SLC; int ARC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree SpecList; tTree Next; tTree Guard; int Label; } yAnAlt;
typedef struct { Tree_tNodeHead yyHead; int VS; int VIn; int VOut; int SLC; int ARC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree SpecList; tTree Next; tTree AltType; } yANewAlt;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree Expr; int VS; int VIn; int VOut; int SLC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; } yGuard;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree Expr; int VS; int VIn; int VOut; int SLC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree Input; tTree Process; } yAltInput;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree Expr; int VS; int VIn; int VOut; int SLC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree After; tTree Process; } yAltTimer;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree Expr; int VS; int VIn; int VOut; int SLC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree CaseIn; } yAltCaseIn;
typedef struct { Tree_tNodeHead yyHead; tPosition Pos; tTree Expr; int VS; int VIn; int VOut; int SLC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree Process; } yNoInput;
typedef struct { Tree_tNodeHead yyHead; tType SynType; int VS; int VIn; int VOut; bool ATOMIC; int SLC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; } yChoiceList;
typedef struct { Tree_tNodeHead yyHead; tType SynType; int VS; int VIn; int VOut; bool ATOMIC; int SLC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; } yNoChoice;
typedef struct { Tree_tNodeHead yyHead; tType SynType; int VS; int VIn; int VOut; bool ATOMIC; int SLC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree SpecList; tTree Next; } yAChoices;
typedef struct { Tree_tNodeHead yyHead; tType SynType; int VS; int VIn; int VOut; bool ATOMIC; int SLC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree SpecList; tTree Next; tTree ExprList; tTree Process; int Label; } yAChoice;
typedef struct { Tree_tNodeHead yyHead; tType SynType; int VS; int VIn; int VOut; bool ATOMIC; int SLC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree SpecList; tTree Next; tTree IfType; } yANewIf;
typedef struct { Tree_tNodeHead yyHead; int VS; int VIn; int VOut; bool ATOMIC; int SLC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool PAR; tPosition Pos; } yProcList;
typedef struct { Tree_tNodeHead yyHead; int VS; int VIn; int VOut; bool ATOMIC; int SLC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool PAR; tPosition Pos; } yNoProcess;
typedef struct { Tree_tNodeHead yyHead; int VS; int VIn; int VOut; bool ATOMIC; int SLC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; bool PAR; tPosition Pos; tTree Next; tTree Process; tSymbol Sym; } yAProcess;
typedef struct { Tree_tNodeHead yyHead; int VS; int VIn; int VOut; int SLC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; } yCaseList;
typedef struct { Tree_tNodeHead yyHead; int VS; int VIn; int VOut; int SLC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; } yNoCase;
typedef struct { Tree_tNodeHead yyHead; int VS; int VIn; int VOut; int SLC; tSymbol Parent; tParUsage PUIn; tParUsage PUOut; tTree Next; tTree SpecList; tTree ExprList; tTree Process; int Label; } yACase;
typedef struct { Tree_tNodeHead yyHead; } yAccessList;
typedef struct { Tree_tNodeHead yyHead; tTree Next; tSymbol Sym; tTree ElementList; } yAnAccess;
typedef struct { Tree_tNodeHead yyHead; } yNoAccess;
typedef struct { Tree_tNodeHead yyHead; } yElementList;
typedef struct { Tree_tNodeHead yyHead; tTree Next; tTree Element; } yAnElement;
typedef struct { Tree_tNodeHead yyHead; } yNoElement;

union Tree_Node {
 Tree_tKind Kind;
 Tree_tNodeHead yyHead;
 yStart Start;
 ySpecList SpecList;
 yNoSpec NoSpec;
 yASpec ASpec;
 ySpec Spec;
 yDecl Decl;
 yIs Is;
 yAVal AVal;
 yVal Val;
 yValRetypes ValRetypes;
 yRetypes Retypes;
 yDefAPro DefAPro;
 yDefSeqPro DefSeqPro;
 yDefTagPro DefTagPro;
 yDefAProc DefAProc;
 yDefProc DefProc;
 yPrototypeProc PrototypeProc;
 yDefAFunc DefAFunc;
 yDefFunc DefFunc;
 yDefIsFunc DefIsFunc;
 yPrototypeFunc PrototypeFunc;
 yNullSpec NullSpec;
 yHCode HCode;
 yCallFrame CallFrame;
 yParFrame ParFrame;
 yFormals Formals;
 yNoFormal NoFormal;
 yAFormal AFormal;
 yReplicator Replicator;
 yTagProList TagProList;
 yNoTagPro NoTagPro;
 yATagPro ATagPro;
 yBy By;
 yByVal ByVal;
 yByRef ByRef;
 yByUndef ByUndef;
 yIdList IdList;
 yNoId NoId;
 yAnId AnId;
 yType Type;
 yArray Array;
 yChan Chan;
 yTimer Timer;
 yUntyped Untyped;
 yPrimitive Primitive;
 yNumeric Numeric;
 yInteger Integer;
 yInt Int;
 yInt16 Int16;
 yInt32 Int32;
 yInt64 Int64;
 yReal Real;
 yReal32 Real32;
 yReal64 Real64;
 yByte Byte;
 yBool Bool;
 yTypeList TypeList;
 yNoType NoType;
 yAType AType;
 yProtocol Protocol;
 yAny Any;
 yNamed Named;
 ySimple Simple;
 yCounted Counted;
 ySeqProList SeqProList;
 yNoSeqPro NoSeqPro;
 yASeqPro ASeqPro;
 yExpr Expr;
 yBinary Binary;
 yUnary Unary;
 yConst Const;
 yValof Valof;
 yFuncCall FuncCall;
 yElementalExpr ElementalExpr;
 yDefault Default;
 yConvert Convert;
 yRound Round;
 yTrunc Trunc;
 yMostPos MostPos;
 yMostNeg MostNeg;
 yCountArray CountArray;
 yUnBound UnBound;
 yStringElement StringElement;
 yString String;
 yStringSubscript StringSubscript;
 yStringRange StringRange;
 yElemental Elemental;
 yTableElement TableElement;
 yTable Table;
 yTableSubscript TableSubscript;
 yTableRange TableRange;
 yElement Element;
 yIdentifier Identifier;
 yElementAccess ElementAccess;
 ySubscript Subscript;
 yRange Range;
 yExprList ExprList;
 yNoExpr NoExpr;
 yAnExpr AnExpr;
 yOp Op;
 yRelOp RelOp;
 yLess Less;
 yGreater Greater;
 yLessEqual LessEqual;
 yGreaterEqual GreaterEqual;
 yEqual Equal;
 yNotEqual NotEqual;
 yMathsOp MathsOp;
 yAdd Add;
 ySubtract Subtract;
 yMultiply Multiply;
 yDivide Divide;
 yRem Rem;
 yBitOp BitOp;
 yBitAnd BitAnd;
 yBitOr BitOr;
 yBitEor BitEor;
 yShiftOp ShiftOp;
 yLeftShift LeftShift;
 yRightShift RightShift;
 yUniOp UniOp;
 ySize Size;
 yBitNot BitNot;
 yNot Not;
 yClockOp ClockOp;
 yPlus Plus;
 yMinus Minus;
 yTimes Times;
 yLogOp LogOp;
 yAnd And;
 yOr Or;
 yAfterOp AfterOp;
 yProcess Process;
 yAssign Assign;
 yAltType AltType;
 yAlt Alt;
 yAltRep AltRep;
 yParType ParType;
 yPar Par;
 yParRep ParRep;
 yProcessor Processor;
 yIfType IfType;
 yIf If;
 yIfRep IfRep;
 yInput Input;
 yOutput Output;
 yCaseIn CaseIn;
 yAfter After;
 ySeqRep SeqRep;
 ySeq Seq;
 yCase Case;
 yWhile While;
 ySkip Skip;
 yStop Stop;
 yInstance Instance;
 yCCode CCode;
 yNullProcess NullProcess;
 yAltList AltList;
 yNoAlt NoAlt;
 yAnAlts AnAlts;
 yAnAlt AnAlt;
 yANewAlt ANewAlt;
 yGuard Guard;
 yAltInput AltInput;
 yAltTimer AltTimer;
 yAltCaseIn AltCaseIn;
 yNoInput NoInput;
 yChoiceList ChoiceList;
 yNoChoice NoChoice;
 yAChoices AChoices;
 yAChoice AChoice;
 yANewIf ANewIf;
 yProcList ProcList;
 yNoProcess NoProcess;
 yAProcess AProcess;
 yCaseList CaseList;
 yNoCase NoCase;
 yACase ACase;
 yAccessList AccessList;
 yAnAccess AnAccess;
 yNoAccess NoAccess;
 yElementList ElementList;
 yAnElement AnElement;
 yNoElement NoElement;
};

extern tTree TreeRoot;
extern unsigned long Tree_HeapUsed;
extern char * Tree_PoolFreePtr, * Tree_PoolMaxPtr;
extern unsigned short Tree_NodeSize [184 + 1];
extern char * Tree_NodeName [184 + 1];

extern void (* Tree_Exit) ();
extern tTree Tree_Alloc ();
extern tTree MakeTree ARGS((Tree_tKind yyKind));
extern bool Tree_IsType ARGS((register tTree yyt, register Tree_tKind yyKind));

extern tTree mStart ARGS((tTree pProcess));
extern tTree mSpecList ARGS(());
extern tTree mNoSpec ARGS(());
extern tTree mASpec ARGS((tTree pSpec, tTree pNext));
extern tTree mSpec ARGS((tPosition pPos));
extern tTree mDecl ARGS((tPosition pPos, tTree pType, tTree pIdList));
extern tTree mIs ARGS((tPosition pPos, tTree pType, tSymbol pSym, tTree pElemental));
extern tTree mAVal ARGS((tPosition pPos, tTree pType, tSymbol pSym, tTree pExpr));
extern tTree mVal ARGS((tPosition pPos, tTree pType, tSymbol pSym, tTree pExpr));
extern tTree mValRetypes ARGS((tPosition pPos, tTree pType, tSymbol pSym, tTree pExpr));
extern tTree mRetypes ARGS((tPosition pPos, tTree pType, tSymbol pSym, tTree pElemental));
extern tTree mDefAPro ARGS((tPosition pPos));
extern tTree mDefSeqPro ARGS((tPosition pPos, tSymbol pSym, tTree pSeqProList));
extern tTree mDefTagPro ARGS((tPosition pPos, tSymbol pSym, tTree pTagProList));
extern tTree mDefAProc ARGS((tPosition pPos, tSymbol pSym, tTree pFormals));
extern tTree mDefProc ARGS((tPosition pPos, tSymbol pSym, tTree pFormals, tTree pProcess));
extern tTree mPrototypeProc ARGS((tPosition pPos, tSymbol pSym, tTree pFormals, tIdent pModule, tLang pLang));
extern tTree mDefAFunc ARGS((tPosition pPos, tSymbol pSym, tTree pTypeList, tTree pFormals));
extern tTree mDefFunc ARGS((tPosition pPos, tSymbol pSym, tTree pTypeList, tTree pFormals, tTree pValof));
extern tTree mDefIsFunc ARGS((tPosition pPos, tSymbol pSym, tTree pTypeList, tTree pFormals, tTree pExprList));
extern tTree mPrototypeFunc ARGS((tPosition pPos, tSymbol pSym, tTree pTypeList, tTree pFormals, tIdent pModule, tLang pLang));
extern tTree mNullSpec ARGS((tPosition pPos));
extern tTree mHCode ARGS((tPosition pPos, tStringRef pCode, tSymbol pScope));
extern tTree mCallFrame ARGS((tPosition pPos, tIdent pId, tSymbol pSym));
extern tTree mParFrame ARGS((tPosition pPos, tIdent pTId, tIdent pFId, tSymbol pSym, int pRep));
extern tTree mFormals ARGS(());
extern tTree mNoFormal ARGS(());
extern tTree mAFormal ARGS((tTree pNext, tPosition pPos, tTree pBy, tTree pType, tSymbol pSym));
extern tTree mReplicator ARGS((tSymbol pSym, tTree pFrom, tTree pFor));
extern tTree mTagProList ARGS(());
extern tTree mNoTagPro ARGS(());
extern tTree mATagPro ARGS((tTree pNext, tSymbol pSym, tTree pSeqProList));
extern tTree mBy ARGS(());
extern tTree mByVal ARGS(());
extern tTree mByRef ARGS(());
extern tTree mByUndef ARGS(());
extern tTree mIdList ARGS(());
extern tTree mNoId ARGS(());
extern tTree mAnId ARGS((tTree pNext, tSymbol pSym));
extern tTree mType ARGS(());
extern tTree mArray ARGS((tTree pExpr, tTree pType));
extern tTree mChan ARGS((tTree pProtocol));
extern tTree mTimer ARGS(());
extern tTree mUntyped ARGS(());
extern tTree mPrimitive ARGS(());
extern tTree mNumeric ARGS(());
extern tTree mInteger ARGS(());
extern tTree mInt ARGS(());
extern tTree mInt16 ARGS(());
extern tTree mInt32 ARGS(());
extern tTree mInt64 ARGS(());
extern tTree mReal ARGS(());
extern tTree mReal32 ARGS(());
extern tTree mReal64 ARGS(());
extern tTree mByte ARGS(());
extern tTree mBool ARGS(());
extern tTree mTypeList ARGS(());
extern tTree mNoType ARGS(());
extern tTree mAType ARGS((tTree pNext, tTree pType));
extern tTree mProtocol ARGS((tPosition pPos));
extern tTree mAny ARGS((tPosition pPos));
extern tTree mNamed ARGS((tPosition pPos, tSymbol pSym));
extern tTree mSimple ARGS((tPosition pPos, tTree pType));
extern tTree mCounted ARGS((tPosition pPos, tTree pLength, tTree pType));
extern tTree mSeqProList ARGS(());
extern tTree mNoSeqPro ARGS(());
extern tTree mASeqPro ARGS((tTree pNext, tTree pProtocol));
extern tTree mExpr ARGS((tPosition pPos));
extern tTree mBinary ARGS((tPosition pPos, tTree pLop, tTree pRop, tTree pOp));
extern tTree mUnary ARGS((tPosition pPos, tTree pExpr, tTree pOp));
extern tTree mConst ARGS((tPosition pPos, tValue pValue, tTree pType));
extern tTree mValof ARGS((tPosition pPos, tTree pSpecList, tTree pProcess, tTree pExprList, tSymbol pSym, int pVS));
extern tTree mFuncCall ARGS((tPosition pPos, tSymbol pSym, tTree pExprList, int pDepth));
extern tTree mElementalExpr ARGS((tPosition pPos, tTree pElemental));
extern tTree mDefault ARGS((tPosition pPos));
extern tTree mConvert ARGS((tPosition pPos, tTree pType, tTree pExpr));
extern tTree mRound ARGS((tPosition pPos, tTree pType, tTree pExpr));
extern tTree mTrunc ARGS((tPosition pPos, tTree pType, tTree pExpr));
extern tTree mMostPos ARGS((tPosition pPos, tTree pType));
extern tTree mMostNeg ARGS((tPosition pPos, tTree pType));
extern tTree mCountArray ARGS((tPosition pPos, tTree pLength, tTree pExpr));
extern tTree mUnBound ARGS((tPosition pPos));
extern tTree mStringElement ARGS((tPosition pPos));
extern tTree mString ARGS((tPosition pPos, tStringRef pValue, int pDepth));
extern tTree mStringSubscript ARGS((tPosition pPos, tTree pNext, tTree pExpr));
extern tTree mStringRange ARGS((tPosition pPos, tTree pNext, tTree pFrom, tTree pFor));
extern tTree mElemental ARGS((tPosition pPos));
extern tTree mTableElement ARGS((tPosition pPos));
extern tTree mTable ARGS((tPosition pPos, tTree pExprList, int pDepth));
extern tTree mTableSubscript ARGS((tPosition pPos, tTree pNext, tTree pExpr));
extern tTree mTableRange ARGS((tPosition pPos, tTree pNext, tTree pFrom, tTree pFor));
extern tTree mElement ARGS((tPosition pPos));
extern tTree mIdentifier ARGS((tPosition pPos, tSymbol pSym, tSymbol pScope));
extern tTree mElementAccess ARGS((tPosition pPos, tTree pNext));
extern tTree mSubscript ARGS((tPosition pPos, tTree pNext, tTree pExpr));
extern tTree mRange ARGS((tPosition pPos, tTree pNext, tTree pFrom, tTree pFor));
extern tTree mExprList ARGS(());
extern tTree mNoExpr ARGS(());
extern tTree mAnExpr ARGS((tTree pNext, tTree pExpr));
extern tTree mOp ARGS(());
extern tTree mRelOp ARGS(());
extern tTree mLess ARGS(());
extern tTree mGreater ARGS(());
extern tTree mLessEqual ARGS(());
extern tTree mGreaterEqual ARGS(());
extern tTree mEqual ARGS(());
extern tTree mNotEqual ARGS(());
extern tTree mMathsOp ARGS(());
extern tTree mAdd ARGS(());
extern tTree mSubtract ARGS(());
extern tTree mMultiply ARGS(());
extern tTree mDivide ARGS(());
extern tTree mRem ARGS(());
extern tTree mBitOp ARGS(());
extern tTree mBitAnd ARGS(());
extern tTree mBitOr ARGS(());
extern tTree mBitEor ARGS(());
extern tTree mShiftOp ARGS(());
extern tTree mLeftShift ARGS(());
extern tTree mRightShift ARGS(());
extern tTree mUniOp ARGS(());
extern tTree mSize ARGS(());
extern tTree mBitNot ARGS(());
extern tTree mNot ARGS(());
extern tTree mClockOp ARGS(());
extern tTree mPlus ARGS(());
extern tTree mMinus ARGS(());
extern tTree mTimes ARGS(());
extern tTree mLogOp ARGS(());
extern tTree mAnd ARGS(());
extern tTree mOr ARGS(());
extern tTree mAfterOp ARGS(());
extern tTree mProcess ARGS((tPosition pPos, tTree pSpecList));
extern tTree mAssign ARGS((tPosition pPos, tTree pSpecList, tTree pLval, tTree pRval));
extern tTree mAltType ARGS((tPosition pPos, tTree pSpecList, bool pPri));
extern tTree mAlt ARGS((tPosition pPos, tTree pSpecList, bool pPri, tTree pAltList));
extern tTree mAltRep ARGS((tPosition pPos, tTree pSpecList, bool pPri, tTree pReplicator, tTree pAltList));
extern tTree mParType ARGS((tPosition pPos, tTree pSpecList, tParType pPType));
extern tTree mPar ARGS((tPosition pPos, tTree pSpecList, tParType pPType, tTree pProcList));
extern tTree mParRep ARGS((tPosition pPos, tTree pSpecList, tParType pPType, tTree pReplicator, tTree pProcess, tSymbol pSym));
extern tTree mProcessor ARGS((tPosition pPos, tTree pSpecList, tTree pExpr, tIdent pName, tTree pProcess));
extern tTree mIfType ARGS((tPosition pPos, tTree pSpecList));
extern tTree mIf ARGS((tPosition pPos, tTree pSpecList, tTree pChoiceList));
extern tTree mIfRep ARGS((tPosition pPos, tTree pSpecList, tTree pReplicator, tTree pChoiceList));
extern tTree mInput ARGS((tPosition pPos, tTree pSpecList, tTree pElement, tTree pExprList));
extern tTree mOutput ARGS((tPosition pPos, tTree pSpecList, tTree pElement, tTree pExprList));
extern tTree mCaseIn ARGS((tPosition pPos, tTree pSpecList, tTree pElement, tTree pCaseList));
extern tTree mAfter ARGS((tPosition pPos, tTree pSpecList, tTree pElement, tTree pExpr));
extern tTree mSeqRep ARGS((tPosition pPos, tTree pSpecList, tTree pReplicator, tTree pProcess));
extern tTree mSeq ARGS((tPosition pPos, tTree pSpecList, tTree pProcList));
extern tTree mCase ARGS((tPosition pPos, tTree pSpecList, tTree pSelector, tTree pChoiceList));
extern tTree mWhile ARGS((tPosition pPos, tTree pSpecList, tTree pExpr, tTree pProcess));
extern tTree mSkip ARGS((tPosition pPos, tTree pSpecList));
extern tTree mStop ARGS((tPosition pPos, tTree pSpecList));
extern tTree mInstance ARGS((tPosition pPos, tTree pSpecList, tSymbol pSym, tTree pExprList, tSymbol pScope));
extern tTree mCCode ARGS((tPosition pPos, tTree pSpecList, tStringRef pCode, tSymbol pScope));
extern tTree mNullProcess ARGS((tPosition pPos, tTree pSpecList));
extern tTree mAltList ARGS(());
extern tTree mNoAlt ARGS(());
extern tTree mAnAlts ARGS((tTree pSpecList, tTree pNext));
extern tTree mAnAlt ARGS((tTree pSpecList, tTree pNext, tTree pGuard));
extern tTree mANewAlt ARGS((tTree pSpecList, tTree pNext, tTree pAltType));
extern tTree mGuard ARGS((tPosition pPos, tTree pExpr));
extern tTree mAltInput ARGS((tPosition pPos, tTree pExpr, tTree pInput, tTree pProcess));
extern tTree mAltTimer ARGS((tPosition pPos, tTree pExpr, tTree pAfter, tTree pProcess));
extern tTree mAltCaseIn ARGS((tPosition pPos, tTree pExpr, tTree pCaseIn));
extern tTree mNoInput ARGS((tPosition pPos, tTree pExpr, tTree pProcess));
extern tTree mChoiceList ARGS(());
extern tTree mNoChoice ARGS(());
extern tTree mAChoices ARGS((tTree pSpecList, tTree pNext));
extern tTree mAChoice ARGS((tTree pSpecList, tTree pNext, tTree pExprList, tTree pProcess));
extern tTree mANewIf ARGS((tTree pSpecList, tTree pNext, tTree pIfType));
extern tTree mProcList ARGS(());
extern tTree mNoProcess ARGS(());
extern tTree mAProcess ARGS((tTree pNext, tTree pProcess, tSymbol pSym));
extern tTree mCaseList ARGS(());
extern tTree mNoCase ARGS(());
extern tTree mACase ARGS((tTree pNext, tTree pSpecList, tTree pExprList, tTree pProcess));
extern tTree mAccessList ARGS(());
extern tTree mAnAccess ARGS((tTree pNext, tSymbol pSym, tTree pElementList));
extern tTree mNoAccess ARGS(());
extern tTree mElementList ARGS(());
extern tTree mAnElement ARGS((tTree pNext, tTree pElement));
extern tTree mNoElement ARGS(());

extern void WriteTreeNode ARGS((FILE * yyyf, tTree yyt));
extern void WriteTree ARGS((FILE * yyyf, tTree yyt));
extern tTree ReverseTree ARGS((tTree yyOld));
extern bool CheckTree ARGS((tTree yyt));
extern void QueryTree ARGS((tTree yyt));
extern void BeginTree ();
extern void CloseTree ();

# endif
