# ifndef yyTypeChk
# define yyTypeChk

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

# ifndef bool
# define bool char
# endif

# include "Tree.h"

/* line 114 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */

  #define MOSTPOSINT32 ((tInt)((long)0x7FFFFFFFL))
  #define MOSTNEGINT32 ((tInt)((long)-0x80000000L))
  #define INT32MASK    ((tInt)((unsigned long)0xFFFFFFFFL))

  #define MOSTPOSINT16 ((tInt)((short)0x7FFF))
  #define MOSTNEGINT16 ((tInt)((short)0x8000))
  #define INT16MASK    ((tInt)((unsigned short)0xFFFF))

  #define MOSTPOSINT   (IS_Mode(xx16bitINT) ? MOSTPOSINT16 : MOSTPOSINT32)
  #define MOSTNEGINT   (IS_Mode(xx16bitINT) ? MOSTNEGINT16 : MOSTNEGINT32)
  #define INTMASK      (IS_Mode(xx16bitINT) ? INT16MASK : INT32MASK)

  #define BYTEMASK     ((tInt)0xff)
  #define BOOLMASK     ((tInt)0x01)

#ifdef SUPPORT_INT64
  #define MOSTPOSINT64 0x7FFFFFFFFFFFFFFFLL
  #define MOSTNEGINT64 -0x8000000000000000LL
  #define INT64MASK    0xFFFFFFFFFFFFFFFFLL
  #define RNGCHKINT32(v) (((v)>=MOSTNEGINT) && (v <= MOSTPOSINT))
#else
  #define MOSTPOSINT64 MOSTPOSINT32
  #define MOSTNEGINT64 MOSTNEGINT32
  #define INT64MASK    INT32MASK
  #define RNGCHKINT32(v) (true)
#endif

  void RetypeConst(int ss,tConstArray src, int ds, tConstArray dest);


extern void (* TypeChk_Exit) ();

extern void TypeFormals ARGS((tTree yyP1));
extern void TypeDecl ARGS((tTree yyP3, tTree yyP2));
extern tTree TypeAbbrev ARGS((tTree yyP6, tTree yyP5, tPosition yyP4));
extern tTree TypeSubscript ARGS((tTree yyP9, tTree yyP8, tPosition yyP7));
extern tTree TypeRange ARGS((tTree yyP13, tTree yyP12, tTree yyP11, tPosition yyP10));
extern tTree TypeBinary ARGS((tTree yyP17, tTree yyP16, tTree yyP15, tPosition yyP14));
extern tTree TypeUnary ARGS((tTree yyP20, tTree yyP19, tPosition yyP18));
extern tTree TypeExprList ARGS((tTree yyP22));
extern tTree TypeTable ARGS((tTree yyP24, tTree yyP23));
extern tTree StripTypeList ARGS((tTree yyP25));
extern void TypeCheckAssign ARGS((tTree yyP28, tTree yyP27, tPosition yyP26));
extern void TypeCheckResults ARGS((tTree yyP37, tTree yyP36, tPosition yyP35));
extern void TypeCheckParameters ARGS((tTree yyP41, tTree yyP40, tPosition yyP39, int yyP38));
extern void TypeCheckIfList ARGS((tTree yyP44));
extern void TypeCheckTimerInput ARGS((tTree yyP46, tPosition yyP45));
extern void TypeCheckInputProtocol ARGS((tTree yyP49, tTree yyP48, tPosition yyP47));
extern void TypeCheckOutputProtocol ARGS((tTree yyP54, tTree yyP53, tPosition yyP52));
extern void TypeCheckCaseInputs ARGS((tTree yyP57, tTree yyP56, tPosition yyP55));
extern void TypeCheckCaseList ARGS((tTree yyP68, tTree yyP67));
extern void TypeCheckRetypes ARGS((tTree yyP71, tTree yyP70, tPosition yyP69));
extern bool CheckWritable ARGS((tTree yyP83));
extern bool CheckWritableExprList ARGS((tTree yyP84));
extern bool CheckForVals ARGS((tTree yyP85));
extern bool CheckValofScope ARGS((tTree yyP87, int yyP86));
extern bool CheckIsType ARGS((tTree yyP89, Tree_tKind yyP88));
extern bool IsChanOrTimerType ARGS((tTree yyP90));
extern bool IsTimerType ARGS((tTree yyP92));
extern bool IsChanType ARGS((tTree yyP91));
extern bool IsArrayType ARGS((tTree yyP93));
extern int CalcTypeSize ARGS((tTree yyP204));
extern bool CheckEvalBiOp ARGS((tTree yyP101, tTree yyP100));
extern bool CheckEvalUniOp ARGS((tTree yyP106, tTree yyP105, tTree yyP104));
extern tValue EvalBiExpr ARGS((tPosition yyP111, tTree yyP110, tValue yyP109, tTree yyP108, tValue yyP107));
extern tValue EvalUniExpr ARGS((tTree yyP134, tTree yyP133, tTree yyP132));
extern tTree ReduceElement ARGS((tTree yyP206, tTree yyP205));
extern tTree ReduceElemental ARGS((tTree yyP207));
extern bool CheckConstConvert ARGS((tTree yyP135));
extern tValue EvalConstConvert ARGS((tPosition yyP138, tTree yyP137, tTree yyP136));
extern tValue CheckConst ARGS((tPosition yyP142, tTree yyP141, tInt yyP140, bool yyP139));
extern bool CheckConstRoundTrunc ARGS((tTree yyP144, tTree yyP143));
extern tValue EvalConstRound ARGS((tPosition yyP152, tTree yyP151, tTree yyP150, tValue yyP149));
extern tValue EvalConstTrunc ARGS((tPosition yyP148, tTree yyP147, tTree yyP146, tValue yyP145));
extern bool CheckConstId ARGS((tTree yyP153));
extern tValue EvalConstId ARGS((tTree yyP154));
extern tTree MakeConstInt ARGS((int yyP195, tPosition yyP194));
extern bool CheckValidDeclType ARGS((tTree yyP99));
extern tValue EvalConstSubscript ARGS((tTree yyP167, int yyP166, tConstArray yyP165));
extern tInt EvalMostPos ARGS((tTree yyP163));
extern tInt EvalMostNeg ARGS((tTree yyP164));
extern tInt TestIntOVF ARGS((tPosition yyP157, tTree yyP156, tInt yyP155));
extern tInt SignExtendInt ARGS((tTree yyP159, tInt yyP158));
extern void UpdateElementalUsage ARGS((tTree yyP43, tUsage yyP42));
extern tConstArray ConstArrayFromString ARGS((tTree yyP169, tStringRef yyP168));
extern tConstArray ConstArrayFromExprList ARGS((tTree yyP171, tTree yyP170));
extern tConstArray ConstArrayFromDecl ARGS((tTree yyP173, tTree yyP172));
extern tConstArray SubscriptConstArray ARGS((tTree yyP182, tConstArray yyP181, int yyP180));
extern tConstArray RangeConstArray ARGS((tTree yyP179, tConstArray yyP178, int yyP177));
extern tValue ReadConstArray ARGS((tTree yyP184, tConstArray yyP183));
extern void WriteConstArray ARGS((tTree yyP187, tValue yyP186, tConstArray yyP185));
extern tTree ArrayPrimType ARGS((tTree yyP208));
extern void MarkNonAtomicIf ARGS((tTree IF));

extern void BeginTypeChk ();
extern void CloseTypeChk ();

# endif
