.TH omakef 1 "1oct1993" "SPOC Tools" "SPOC Tools"

.SH NAME
omakef \- Makefile generator 
.SH SYNOPSIS
.B omakef [options] file

.SH DESCRIPTION

Makefile generator for
.B SPOC (Southampton Portable Occam Compilation) system.
The compiler support tool omakef generates makefiles to allow occam
applications to be compiled. The command sequences to issue partial and
complete compilations of modules are contained in textual template
files. In principle, the tool simply   walks through an occam source
tree producing a makefile entry for each item of source that is to be
compiled.  The tool has been tested with GNU make version 3.68 and the
unix make distributed with SunOs version 4.1.3.

.SS OPTIONS
.TP
.I "file"
Name of target file to be produced by the generated makefile. The
tool examines the extension of this target file to select the actions
required to generate it. Currently supported extensions are:

.I "<no extension>"
Generate makefile for executable.

.I "\.o"
Generate makefile for object.

.I "\.t"
Generate makefile for object prototype file.

.I "\.a"
Generate makefile for library object.

.I "\.lib"
Generate makefile for library prototype file.

.I "\.x"
Generate makefile for object prototype executable.

.I "\.c"
Generate makefile for intermediate C source.

The filename of the makefile is derived by stripping any extension from
.I file 
and appending the extension .I \.mkf.

.TP
.I "\-g" 
When this option is passed to omakef to switch on source-level
debugging. This is achieved by propagating the option to all occam-to-C
translations and all C compilations.

.TP 
.I "\-z"
This option switches on debug information from omakef showing which
files are referenced by which module.

.TP 
Any command-line option containing an `equals' character
is propagated to the generated makefile between the header definition
section and the rules. This allows the default compilation options to
be overridden or appended.

.TP 
Any other option : These are propagated directly to the
occam-to-C translator.

.SH BUGS
