# include "Cout.h"
# include "yyCout.w"
# include "System.h"
# include <stdio.h>
# include "Tree.h"

# define yyInline
# ifndef NULL
# define NULL 0L
# endif
# ifndef false
# define false 0
# endif
# ifndef true
# define true 1
# endif

# ifdef yyInline
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) \
  if ((ptr = (tree) free) >= (tree) max) ptr = alloc (); \
  free += nodesize [kind]; \
  ptr->yyHead.yyMark = 0; \
  ptr->Kind = kind;
# else
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) ptr = make (kind);
# endif

# define yyWrite(s) (void) fputs (s, yyf)
# define yyWriteNl (void) fputc ('\n', yyf)

/* line 47 "/home/ringwood/smw/occam/source/gmd/c.trafo" */

/*{{{  includes*/
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "Scanner.h"
#include "Errors.h"
#include "DynArray.h"
#include "Symbol.h"
#include "Transform.h"
#include "Fopenenv.h"
#include "TypeChk.h"
/*}}}*/
/*{{{  statics*/
static bool NL = false;
static tPosition POS= {0,0,NULL};
static indent = 0;
static char *outname;                  /* base name of generated file */
static tTree CurProc;
extern FILE* yyf;
static void yyAbort(char *);
extern void Code(tTree);

static int CurrentLabel;

static char M_MAIN[]="<<MAIN>>";             static int S_MAIN= sizeof(M_MAIN)-1; 
static char M_HEADER[]="<<HEADER>>";         static int S_HEADER= sizeof(M_HEADER)-1; 
static char M_CODE[]="<<CODE>>";             static int S_CODE= sizeof(M_CODE)-1;
static char M_NAME[]="<<NAME>>";             static int S_NAME= sizeof(M_NAME)-1;
static char M_PROTOTYPES[]="<<PROTOTYPES>>"; static int S_PROTOTYPES=sizeof(M_PROTOTYPES)-1;
static char M_SWITCHES[]="<<SWITCHES>>";     static int S_SWITCHES= sizeof(M_SWITCHES)-1; 
static char M_PARAMETERS[]="<<PARAMETERS>>"; static int S_PARAMETERS=sizeof(M_PARAMETERS)-1;
static char M_DEBUG[]="<<DEBUG>>";           static int S_DEBUG=sizeof(M_DEBUG)-1;
static char M_SERVERWS[]="<<SERVERWS>>";     static int S_SERVERWS=sizeof(M_SERVERWS)-1;

static char PRM[] = "Param";  /* base name of parameters to library units */
static char DIM[] = "_Dim";   /* hidden dimension extension */
static char CHK[] = "CHK";    /* name of checking macro */
static char RNGCHK[] = "RNGCHK";    /* name of checking macro */
static char RNGCHKLB[] = "RNGCHKLB";    /* name of checking macro */
static char RNGCHKUB[] = "RNGCHKUB";    /* name of checking macro */
static char ASSIGN[] = "ASSIGN";    /* name of array copying macro */
static char MSG_ASM[] = "MSG_ASM";
static char MSG_ARM[] = "MSG_ARM";
static char MSG_AIM[] = "MSG_AIM";
static char MSG_CITL[] = "MSG_CITL";
static char CHK_SWITCH[][20] = { "CHECK_CONVERSIONS","CHECK_INTERNALS","CHECK_ARRAYS","CHECK_RANGES" };
static char ERR_MODES[][20] = { "TERMINATE_ON_ERROR","CONTINUE_ON_ERROR","STOPP_ON_ERROR" };

static char M_SPOC_ISERVER[] = "spoc.iserver";
static int  S_SPOC_ISERVER   = sizeof(M_SPOC_ISERVER)-1;

eErrorModes ErrorMode = xxTerminateOnError;

/*}}}*/
/*{{{  static void ShowPosition()*/
#define SetPosition(P) POS=P
static void ShowPosition()  
{  
  if (IS_Mode(xxOccamLines))
  {  
    if (POS.File!=NULL)
    {
      fprintf(yyf,"#line %3d \"",POS.Line);
      WriteString(yyf,POS.File);
      fprintf(yyf,"\"\n");
    }
  }
}
/*}}}*/
/*{{{  output control*/
#undef yyWrite
/*{{{  static void DoNL()*/
static void DoNL()
{
  if (NL==true) 
  { 
    int i; 
    ShowPosition();
    NL = false; 
    for(i=0;i<indent;i++) fputc(' ',yyf);
  }
}
/*}}}*/
static void Indent()     { if (!NL) fputc('\n',yyf); NL=true; indent+=2; }
static void Outdent()    { if (!NL) fputc('\n',yyf); NL=true; indent-=2; }
static void BigIndent()  { if (!NL) fputc('\n',yyf); NL=true; indent+=10;}
static void BigOutdent() { if (!NL) fputc('\n',yyf); NL=true; indent-=10;}
static void NewLine()    { if (!NL) fputc('\n',yyf); NL=true;}
static void BlankLine()  { NewLine(); fputc('\n',yyf); }
static void ResetIndent() { NL=false; indent=0; }

#define CONDWrite(b,s)   { if (b) yyWrite(s); }
#define COND(b,s)        { if (b) s; }

#define WriteInt(a)  {DoNL(); fprintf(yyf,"%d",(int)a);}

#define WriteReal(a) {DoNL(); fprintf(yyf,"%.*g",a.RNumber.p,a.RNumber.n);} 
#define WriteByte(a) {DoNL(); fprintf(yyf,"\'\\x%02x\'",(unsigned char)a);}
#define WriteBool(a) {DoNL(); fputs((a)?"true":"false",yyf);}
#define WriteStr(a)  {DoNL(); strlen(a); fputs(a,yyf);}
#define WriteChar(a)  {DoNL(); fputc((char)a,yyf);}

#define GenLabel()    WriteLabel(NewLabel())
#define NewLabel()    (++CurrentLabel)
#define WriteLabel(l) { /*Big*/Outdent(); DoNL(); fprintf(yyf,"CASE(%d):  ",(int)l); /*Big*/Indent(); }
#define WriteLabelValue(l) WriteInt(l)

#define yyWrite(a)   {DoNL(); fputs(a,yyf);}

#define WriteId(s)    {DoNL(); WriteIdent(yyf,s);}  

#define WarnNotImp(P,S)    ErrorMessageI(xxNotImplemented,xxWarning,P,xxString,S)
#define WNYI(S,P)          MessageI("C transformation not implemented for ",xxError,P,xxString,Tree_NodeName[S->Kind])

#define WriteOccSym(s) {DoNL(); WriteIdent(yyf,Symbol(s).Id);}


/*{{{  void WriteSymSuffix(tSymbol s)*/
void WriteSymSuffix(tSymbol s)
{
  if (Tree_IsType(SymbolKind(s),kPrototypeFunc))
  {
    tIdent Id=SymbolKind(s)->PrototypeFunc.Module;
    if (Id!=NoIdent)
    {
      fputc('_',yyf);
      WriteIdent(yyf,Id);
    }
  }
  else if (Tree_IsType(SymbolKind(s),kPrototypeProc))
  {
    tIdent Id=SymbolKind(s)->PrototypeProc.Module;
    if (Id!=NoIdent)
    {
      fputc('_',yyf);
      WriteIdent(yyf,Id);
    }
  }
  else if (Symbol(s).Depth==0)
  {
    fprintf(yyf,"_%s",outname);
  }   
  else
    fprintf(yyf,"_%d",s);
}
/*}}}*/
/*{{{  void WriteStrRef(tStringRef r)*/
static void WriteStrRef(tStringRef r)
{
  #define IsPrintable(c) (((c)>=' ') && ((c)<='~'))
  char *temp ;
  int len = LengthSt(r) ;

  DoNL();
  if ((temp = (char*) malloc(len)) == NULL)
    yyAbort("Out of heap") ;
  else
    {
      int i;
      
      StGetString (r,temp) ;

      for (i=0;i<len;i++)
      {
        char c = temp[i] ;

        if (c == '"')
          fprintf(yyf,"\\\"") ;
        else if (c == '\\')
          fprintf(yyf,"\\\\") ;
        else if (c == '\'')
          fprintf(yyf,"\\'") ;
        else if (c == '\?')
          fprintf(yyf,"\\?") ;
        else if (IsPrintable(c))
          fputc(c,yyf) ;
        else if (c == 13)
          fprintf(yyf,"\\r") ;
        else if (c == 10)
          fprintf(yyf,"\\n") ;
        else if (c == '\t')
          fprintf(yyf,"\\t") ;
        else
          fprintf(yyf,"\\x%02x",c) ;
      }
      free(temp) ;
    }
}
/*}}}*/
/*{{{  void WriteStaticSym(tSymbol sym)*/
void WriteStaticSym(tSymbol sym)
{
  tStringRef r = GetStringRef (Symbol(sym).CId);
  char *temp ;
  int len = LengthSt(r) ;

  DoNL() ;

  if ((temp = (char*) malloc(len)) == NULL)
    yyAbort("Out of heap") ;
  else
    {
      int i;
      
      StGetString (r,temp) ;

      for (i=0;i<len;i++)
      {
        char c = temp[i] ;

        if (c == '.')
          fprintf(yyf,"_") ;
        else
          fputc(c,yyf) ;
      }
      free(temp) ;
      WriteSymSuffix(sym);
    }
}
/*}}}*/
/*{{{  void WritetInt(tInt val,bool int64)*/
void WritetInt(tInt val,bool int64)
{
  char str[24];
  int len=0;
  bool neg=(val < 0);
  tInt value=(neg)?-val:val;
  bool hex=(val > 1000000) || (val < -1000000);

#ifndef SUPPORT_INT64
  int64 = false;
#endif
  if (!IS_Mode(xxSupportINT64)) int64=false;

  if (hex)
  {
    int digits = (int64) ? 16 : 8;
    char hexdigits[] = "0123456789ABCDEF";

    while(len < digits) { str[len++] = hexdigits[val & 15]; val = val >> 4; }
    while(len>1 && str[len-1]=='0') --len;

    if (int64 && val == MOSTNEGINT64) fprintf(yyf,"-0x");
    else if (!int64 && val == MOSTNEGINT32) fprintf(yyf,"-0x");
    else fprintf(yyf,"0x");
  }
  else
  {
    while(len==0 || value > 0) { str[len++]='0'+(value % 10); value = value / 10; }
    if (neg) fputc('-',yyf);
  }

  {
    int i = 0;
    int j=len-1;
    char c;

    while(i < j) { c = str[i]; str[i++] = str[j]; str[j--] = c; }
  }
  
  str[len] = 0;
  
  if (int64 && len>8) fprintf(yyf,"%sLL",str);
  else fprintf(yyf,"%s",str);

}
  
  
/*}}}*/
/*{{{  static void WriteSym(int s)*/
static void WriteSym(int s)
{
  DoNL(); 
  WriteIdent(yyf,Symbol(s).CId);
  WriteSymSuffix(s);
}
/*}}}*/

/*}}}*/
/*{{{  access to back list in IfType*/
#define BackIfType(I)     I->IfType.BackIfType
#define BackChoiceList(I) I->IfType.BackChoiceList
/*}}}*/
/*{{{  Specification handling */
#define TypeDepth(T) (T->Type.D)
#define IsTopLevel(S) (Symbol(S).Depth==0)

#define NeedsUnion(PL) (PL->ProcList.SLC > 1)
#define NeedsStruct(P) (P->Process.SpecList->SpecList.DCL > 0)

typedef struct
{
  tIdent Id;
  tIdent PrefixId;
  bool newSpec;
} tSpec;

static unsigned long SpecExtent = 0;
static tSpec *SpecTable = NULL;
static int SpecLevel;

#define CurSpec() SpecTable[SpecLevel]

/* OpenSSpec opens a structure scope if we are in a union and we
   need a new level. The current scope is then a union only if
   we were in a union before and we did not open a structure.  */

#define OpenSSpec(S,b) (!OpenSpec((S) && (b),"struct") && (S))

/* OpenUSpec opens a union scope if we are in a structure and we
   need a new level. The current scope is then a union if we 
   were in a union before or if we just opened a union.        */

#define OpenUSpec(S,b) (OpenSpec(!(S) && (b),"union") || (S))

void InitSpec()
{
  if (SpecExtent == 0)
  {
    SpecExtent = 20;
    MakeArray((char**)&SpecTable,&SpecExtent,sizeof(tSpec));
  }
  SpecLevel = 0;

  CurSpec().Id = NoIdent;
  CurSpec().PrefixId = NoIdent;
}

bool OpenSpec(bool b,char *name)
{
  tIdent id = CurSpec().Id;
  tIdent pfid = CurSpec().PrefixId;

  if (b)
  {
    id = UniqueId(toupper(name[0]));

    if (pfid)
    {
      pfid = PrefixId(pfid,id,'.');
    }
    else
      pfid = id;

    WriteStr(name); NewLine();
    WriteStr("{"); NewLine();
    Indent();
  }

  if (SpecLevel>=SpecExtent) ExtendArray((char**)&SpecTable,&SpecExtent,sizeof(tSpec));

  SpecLevel++;
  CurSpec().PrefixId = pfid;
  CurSpec().Id = id;
  CurSpec().newSpec = b;

  return(b);
}

void CloseSpec()
{
  if (CurSpec().newSpec)
  {
    Outdent();
    WriteStr("} ");
    WriteId(CurSpec().Id);
    WriteStr(";"); NewLine();
  }
  SpecLevel--;
}
/*}}}*/
/*{{{  Blocks*/
static unsigned long BlockExtent = 0;
static bool *BlockTable = NULL;
static int BlockLevel;

#define CurBlock BlockTable[BlockLevel]

void InitBlocks()
{
  if (BlockExtent == 0)
  {
    BlockExtent = 20;
    MakeArray((char**)&BlockTable,&BlockExtent,sizeof(bool));
  }
  BlockLevel = 0;
  indent = 0;
}

#define DoBlock() { if (!CurBlock) { CurBlock = true; WriteStr("{"); Indent(); NewLine(); }} 

void OpenBlock(bool b)
{
  if (BlockLevel>=BlockExtent) ExtendArray((char**)&BlockTable,&BlockExtent,sizeof(bool));

  BlockLevel++;
  CurBlock = b;
}

void CloseBlock()
{
  if (CurBlock)
  {
    Outdent();
    WriteStr("}");
    NewLine();
  }
  BlockLevel--;
}
/*}}}*/
/*{{{  static int CalcDepth(tSymbol ThisSym)*/
static int CalcDepth(tSymbol ThisSym)
{
  tSymbol S=CalcParent(SymbolKind(ThisSym));
  int D=0;
  if (S==NoSymbol) return 0;
  while (Symbol(S).Depth>0)
  {
    if (Tree_IsType(SymbolKind(S),kDefProc)) 
      S=SymbolKind(S)->DefProc.Parent;
    else if (Tree_IsType(SymbolKind(S),kPrototypeProc)) 
      S=SymbolKind(S)->PrototypeProc.Parent;
    else if (Tree_IsType(SymbolKind(S),kDefAFunc)) 
      S=SymbolKind(S)->DefAFunc.Parent;
    else
      Message("Parent is not PROC or FUNCTION",xxFatal,NoPosition);
    D++;
  }
  if ( Tree_IsType(SymbolKind(ThisSym),kDefProc) ||
       Tree_IsType(SymbolKind(ThisSym),kDefFunc) )
    D++;
  return D;
}
/*}}}*/
/*{{{  static void DoSubstitutions(FILE *inf,char *filename, tTree Root)*/
static void DoSubstitutions(FILE *inf,tTree Root)
{  
  DoNL();
  while(!feof(inf))
  {
    char *bp, buff[128];
    
    bp = fgets(buff,128,inf);
    if (bp == NULL) break;
    while(*bp)
    {
      if (strncmp(bp,M_MAIN,S_MAIN)==0)
        /*{{{  insert OuterProc name*/
        {
          bp += S_MAIN;
          if (!IS_Mode(xxLibrary))
          {
            WriteSym(TreeRoot->Start.OuterProc);
          }
        }
        /*}}}*/
      else if (strncmp(bp,M_PARAMETERS,S_PARAMETERS)==0)
        /*{{{  insert parameters to outermost proc*/
        {
          bp += S_PARAMETERS;
          if (!IS_Mode(xxLibrary))
          {
            Indent();
            CodeMainEntryParameters(SymbolKind(TreeRoot->Start.OuterProc));
            Outdent();
          }
        }
        /*}}}*/
      else if (strncmp(bp,M_SWITCHES,S_SWITCHES)==0)
        /*{{{  insert selected switches*/
        {
          int i;
          
          bp += S_SWITCHES;
        
          if (IS_Mode(xxLibrary)) { WriteStr("#define LIBRARY_UNIT"); NewLine(); }
          WriteStr("#define BYTES_PER_WORD 4"); NewLine();
        
          if (!IS_Mode(xxSupportINT64)) { WriteStr("#define NO_INT64"); NewLine(); }
        
          WriteStr("#define ");WriteStr(ERR_MODES[ErrorMode]);NewLine();
        
          for (i=xxCheckConversions;i<=xxCheckRanges;i++)
            if (IS_Mode(i)) { WriteStr("#define ");WriteStr(CHK_SWITCH[i-xxCheckConversions]); NewLine(); }
        
          if (!IS_Mode(xxOccamDebug)) { WriteStr("#define NO_DEBUG"); NewLine(); }
          if (IS_Mode(xxFasterGOTO)) { WriteStr("#define FASTGOTOS"); NewLine(); }
          if (IS_Mode(xxSimulatedServer) && !IS_Mode(xxLibrary)) { WriteStr("#define USE_SPOC_ISERVER"); NewLine(); }
          if (IS_Mode(xxLittleEndian)) { WriteStr("#define SOURCE LITTLE"); NewLine(); }
          if (IS_Mode(xxCallF90)) { WriteStr("#define CALL_NAG_F90"); NewLine(); }
        }
        /*}}}*/
      else if (strncmp(bp,M_NAME,S_NAME)==0)
        /*{{{  insert name*/
        {
          bp += S_NAME;
          WriteStr(outname);
        }
        /*}}}*/
      else if (strncmp(bp,M_HEADER,S_HEADER) == 0)
        /*{{{  insert structure declarations*/
        {
          tTree T;
        
          bp += S_HEADER;
          
          T = Root->Start.CGNext;
          while(T != NoTree)
            T = GenTypeDef(T);
        
          T = Root->Start.CGNext;
          while(T != NoTree)
          {
            InitSpec();
            T = GenDeclStruct(T);
          }
          GenStatics(Root);
        }        
        /*}}}*/
      else if (strncmp(bp,M_CODE,S_CODE) == 0)
        /*{{{  insert generated code*/
        {
          tTree T;
        
          bp += S_CODE;
          
          T = Root->Start.CGNext;
          while(T != NoTree)
            T = GenCode(T);
        }
        /*}}}*/
      else if (strncmp(bp,M_PROTOTYPES,S_PROTOTYPES)==0)
        /*{{{  insert prototypes*/
        { 
          tTree T;
                
          bp += S_PROTOTYPES;
          if (IS_Mode(xxLibrary))
          {
            Indent();
            T = Root->Start.CGNext;
            while(T != NoTree)
            {
              T = GenCPrototype(T);
            }
          }
          Outdent();
        }
        /*}}}*/
      else if (strncmp(bp,M_DEBUG,S_DEBUG)==0)
        /*{{{  insert debug*/
        {
          tSymbol S;
          bp+= S_DEBUG;
        
          if (IS_Mode(xxOccamDebug))
          {
            WriteStr("#ifndef NO_DEBUG");NewLine();
            WriteStr("#undef SETSCOPE");NewLine();
            WriteStr("#define NUMSYMS ");WriteInt(OccSymSize);NewLine();
            /*{{{  generate Symbols table*/
            WriteStr("static char *Symbols[NUMSYMS]={\"");
            for (S=1;S<=OccSymSize;S++) 
            {
              WriteOccSym(S);
              if (S==OccSymSize) 
                WriteStr("\"};")
              else
                WriteStr("\",\"");
            } NewLine();
            /*}}}*/
            /*{{{  generate Kinds table*/
            WriteStr("static int Kinds[NUMSYMS]={");
            for (S=1;S<=OccSymSize;S++) 
            {
             
              WriteInt(MapKinds(SymbolKind(S),SymbolType(S),S));
              if (S==OccSymSize) 
                WriteStr("};")
              else
                WriteStr(",");
            } NewLine();
            /*}}}*/
            /*{{{  generate Scopes table*/
            WriteStr("static int Scopes[NUMSYMS]={");
            for (S=1;S<=OccSymSize;S++) 
            {
              WriteInt(Symbol(S).Scope-1);
              if (S==OccSymSize) 
                WriteStr("};")
              else
                WriteStr(",");
            } NewLine();
            /*}}}*/
            /*{{{  generate Depths table*/
            WriteStr("static int Depths[NUMSYMS]={");
            for (S=1;S<=OccSymSize;S++) 
            {
              WriteInt(CalcDepth(S));
              if (S==OccSymSize) 
                WriteStr("};")
              else
                WriteStr(",");
            } NewLine();
            /*}}}*/
            /*{{{  generate Types table*/
            WriteStr("static char *Types[NUMSYMS]={\"");
            for (S=1;S<=OccSymSize;S++) 
            {
              OccCodeType(SymbolType(S));
              if (S==OccSymSize) 
                WriteStr("\"};")
              else
                WriteStr("\",\"");
            } NewLine();
            /*}}}*/
            WriteStr("#include \"Debug.h\"");NewLine();
            /*{{{  ShowValue function*/
            WriteStr("static void *ShowValue(void *FP, int S)"); NewLine();
            WriteStr("{ switch(S)");Indent();
            WriteStr("{"); Indent();
            for (S=1;S<=OccSymSize;S++) 
            {
              WriteStr("case "); WriteInt(S-1); WriteStr(": "); 
              if (MapKinds(SymbolKind(S),SymbolType(S),S)>0 && Symbol(S).Id!=NoIdent) GenShowValue(SymbolKind(S),SymbolType(S),S);
              WriteStr(" break;");
              NewLine();
            } 
            Outdent(); WriteStr("}");
            Outdent(); WriteStr("}"); NewLine();  
            /*}}}*/
            /*{{{  DEBUGOCCAM function*/
            WriteStr("static void DEBUGOCCAM()");NewLine();
            WriteStr("{");Indent();
            WriteStr("Show(MODE,CFP);");NewLine();
            WriteStr("DEBUGDONE();");Outdent();
            WriteStr("}");NewLine();
            /*}}}*/
            WriteStr("#endif");NewLine();
          }
        }
        /*}}}*/
      else
        do fputc(*bp++,yyf); while(*bp && *bp!='<');
    }
  }
  
  fclose(inf);
}
/*}}}*/
/*{{{  static FILE *OpenTemplate(char *name)*/
static FILE *OpenTemplate(char *name)
{
  return(fopenenv(name,"r",OSEARCH,ODEFAULT_LIB,NULL));
}
/*}}}*/
/*{{{  void OutputC(f,t,createc)*/
void OutputC(char *name,tTree Root)
{
  FILE *savef = yyf;
  FILE *inf;
  char *template="Occam2C.c";

  inf = OpenTemplate(template);
  if (inf == NULL) MessageI("Cannot open file ",xxFatal,NoPosition,xxString,template);
  
  yyf = stdout;
  if (strcmp(name,"-") != 0)
  {
    char *dot = strrchr(name,'.');
    char *slash = strrchr(name,'/');

    if (slash == NULL) slash = strrchr(name,'\\');

    if ((yyf=fopen(name,"w"))==NULL) MessageI("Cannot open file ",xxFatal,NoPosition,xxString,name);
    if (dot != NULL) *dot=0;
    if (slash == NULL) outname = name;
    else outname = ++slash;
  }
  else
    outname = "";

  if (!IS_Mode(xxLibrary))
  {
    if (Tree_IsType(Symbol(Root->Start.OuterProc).Kind,kDefProc))
      Symbol(Root->Start.OuterProc).Kind->DefProc.isPar = true;
    else
      Message("Outermost subroutine must be a PROC",xxFatal,Symbol(Root->Start.OuterProc).Kind->DefProc.Pos);
  }
  ResetIndent();
  DoSubstitutions(inf,Root);
  
  if (yyf != stdout) fclose(yyf);
  if (IS_Mode(xxLibrary))
  {
    tTree T;
    char *tname = (char *)malloc(strlen(outname)+10);

    if (!tname) Message("Out of Heap",xxFatal,NoPosition);
    strcpy(tname,outname); strcat(tname,".t");
    if ((yyf=fopen(tname,"w"))==NULL) MessageI("Cannot open file ",xxFatal,NoPosition,xxString,tname);

    SetPosition(NoPosition);
    ResetIndent();
    T = Root->Start.CGNext;
    while(T != NoTree)
    {
      T = GenOccPrototypes(T);
    }

    fclose(yyf);
  }
  yyf = savef;
}
/*}}}*/
/*{{{  void WriteCCode(tStringRef S, tPosition P, int scope)*/
void WriteCCode(tStringRef S, tPosition P, int scope)
{
  int l = LengthSt(S);
  int i=0;
  char *str = (char*) malloc(l);
  StGetString(S,str);
  while (i<l)
  {
    if (str[i]=='$')
    {
      tSymbol Sym;
      int start = ++i;
      while (isalnum(str[i])||(str[i]=='.')) i++;
      Sym = LookupSymbolInScope(MakeIdent(&str[start],i-start),P,scope);
      AddVUsage(Sym,xxLRead);
      CodeSymRef(Symbol(Sym).Kind,Sym,false);
    }
    else 
      WriteChar(str[i++]);
  }
  free(str);
}
/*}}}*/
/*{{{  void MarkCCodeUsage(tStringRef S, tPosition P, int scope)*/
void MarkCCodeUsage(tStringRef S, tPosition P, int scope)
{
  int l = LengthSt(S);
  int i=0;
  char *str = (char*) malloc(l);
  StGetString(S,str);
  while (i<l)
  {
    if (str[i]=='$')
    {
      tSymbol Sym;
      int start = ++i;
      while (isalnum(str[i])||(str[i]=='.')) i++;
      Sym = LookupSymbolInScope(MakeIdent(&str[start],i-start),P,scope);
      AddVUsage(Sym,xxLRead);
    }
    else ++i;
  }
  free(str);
}
/*}}}*/
/*{{{  Priority Defs.*/
#define HIPRI 0
#define LOPRI 1
/*}}}*/
/*{{{  static bool IsDuplicatedPrototype(tSymbol ThisSym)*/
static bool IsDuplicatedPrototype(tSymbol ThisSym)
{
  tSymbol S=1;
  tIdent M=CalcModule(SymbolKind(ThisSym));
  while (S<=ThisSym)
  {
    if ((M!=NoIdent) && 
        (Symbol(S).Id==Symbol(ThisSym).Id) && 
        (CalcModule(SymbolKind(S))==M) &&
        (CalcUsage(SymbolKind(S))==xxUsed))
      break;
    S++;
  }
  return (S!=ThisSym);
}

/*}}}*/
/*{{{  static bool IsDuplicatedHeader(tSymbol ThisSym)*/
static bool IsDuplicatedHeader(tSymbol ThisSym)
{
  tSymbol S=1;
  tStringRef H=CalcHeader(SymbolKind(ThisSym));
  while (S<=ThisSym)
  {
    if (IsPrototype(SymbolKind(S)) &&
        (CalcHeader(SymbolKind(S))==H) &&
        (CalcUsage(SymbolKind(S))==xxUsed))
      break;
    S++;
  }
  return (S!=ThisSym);
}

/*}}}*/
/*{{{  static void WriteModuleHeaderName(tStringRef St)*/
static void WriteModuleHeaderName(tStringRef St)
{
  int len = LengthSt(St);
  char *temp = (char*) malloc(len+4);

  if (temp==NULL)
      Message("Out of heap",xxFatal,NoPosition) ;
  else
  {
    int i = len-1;
    StGetString (St,temp);
    
    while(i>1 && temp[i]!='.') --i;
    if (i) temp[i] = 0;
    strcat(temp,".hdr");

    WriteStr(temp);
  }
}
/*}}}*/


static void yyExit () { Exit (1); }

void (* Cout_Exit) () = yyExit;

extern FILE *yyf;

static void yyAbort
# ifdef __cplusplus
 (char * yyFunction)
# else
 (yyFunction) char * yyFunction;
# endif
{
 (void) fprintf (stderr, "Error: module Cout, routine %s failed\n", yyFunction);
 Cout_Exit ();
}

tTree GenTypeDef ARGS((tTree T));
static void GenWS ARGS((tSymbol yyP1));
static void GenProtoFormals ARGS((tTree yyP3, int yyP2));
static void GenProtoArrayFormal ARGS((tTree yyP5, int yyP4));
tTree GenDeclStruct ARGS((tTree T));
static void GenParentRef ARGS((tTree yyP7, tSymbol yyP6));
static void GenDeclFormals ARGS((tTree yyP9, bool yyP8));
static void GenDeclArrayFormal ARGS((tTree yyP12, tSymbol yyP11, bool yyP10));
static void GenDeclProc ARGS((tTree P, bool yyP13));
static void GenDeclList ARGS((tTree T, bool yyP14));
static void GenDeclGuard ARGS((tTree yyP16, bool yyP15));
static void GenDeclAltTypeOuter ARGS((tTree yyP18, bool yyP17));
static void GenDeclAltTypeInner ARGS((tTree yyP19));
static void GenDeclAltList ARGS((tTree yyP20));
static void GenDeclAltRep ARGS((tTree yyP21));
static void GenNLRepState ARGS((tTree yyP22));
static void GenDeclSpecs ARGS((tTree yyP23));
static void GenDeclNLSpec ARGS((tTree yyP24));
static void GenDeclSym ARGS((tTree yyP27, tSymbol yyP26, bool yyP25));
static void GenDeclArraySym ARGS((tTree yyP29, tSymbol yyP28));
static bool IsZeroSizeType ARGS((tTree yyP30));
static bool NeedsSpecs ARGS((tTree yyP31));
static bool NeedsSplit ARGS((tTree yyP32));
static void GenDeclNLIdList ARGS((tTree yyP34, tTree yyP33));
static void GenSpecState ARGS((tTree yyP35));
int CountRepDecls ARGS((tTree yyP36));
int CountAltRepDecls ARGS((tTree yyP37));
static int CountAbbrev ARGS((tTree yyP38));
static int CountIdList ARGS((tTree yyP39));
static int CountDecl ARGS((tTree yyP40));
int CountSpec ARGS((tTree yyP41));
tTree GenCode ARGS((tTree T));
static void GenProcHead ARGS((tTree DP));
static void GenProcEntry ARGS((tTree DP));
static void GenProcTail ARGS((tTree DP));
static void GenFuncHead ARGS((tTree DF));
static void GenFuncEntry ARGS((tTree DF));
static void GenFuncExit ARGS((tTree DF));
static void GenFuncTail ARGS((tTree DF));
static bool GenFormals ARGS((tTree yyP43, bool yyP42));
static void GenArrayFormal ARGS((tTree yyP46, tSymbol yyP45, bool yyP44));
static void GenNLFormals ARGS((tTree yyP47));
static void GenNLArrayFormal ARGS((tTree yyP49, tSymbol yyP48));
static bool AnyNLFormals ARGS((tTree yyP50));
static void GenMVFormals ARGS((tTree yyP53, int yyP52, bool yyP51));
static void GenMVFResult ARGS((tTree yyP55, int yyP54));
static bool NeedsChain ARGS((tSymbol yyP56));
static void GenProcess ARGS((tTree yyP57));
static void GenProcList ARGS((tTree yyP58));
static void GenParList ARGS((tTree yyP60, int yyP59));
static void GenParProc ARGS((tTree yyP64, tSymbol yyP63, int yyP62, tTree yyP61));
static void GenPlacedList ARGS((tTree yyP67, tSymbol yyP66, tTree yyP65));
static void GenPlaced ARGS((tTree yyP70, tSymbol yyP69, tTree yyP68));
static void CodePlacedExpr ARGS((tTree EX, tSymbol yyP72, tTree yyP71));
static void GenParProcParam ARGS((tTree yyP77, tTree yyP76, tIdent yyP75, tSymbol yyP74, tTree yyP73));
static void GenEnableAltType ARGS((tTree yyP78));
static void GenEnableAltList ARGS((tTree yyP79));
static void GenEnableGuard ARGS((tTree yyP80));
static void GenDisableAltType ARGS((tTree yyP81));
static void GenDisableAltList ARGS((tTree yyP82));
static void GenDisableGuard ARGS((tTree yyP84, int yyP83));
static void GenAssignRepsAltType ARGS((tTree yyP85));
static void GenAssignRepsAltList ARGS((tTree yyP86));
static tTree BuildRevSpecList ARGS((tTree yyP88, tTree yyP87));
static void GenCodeAltType ARGS((tTree yyP91, int yyP90, tTree yyP89));
static void GenCodeAltList ARGS((tTree yyP94, int yyP93, tTree yyP92));
static void GenCodeGuard ARGS((tTree yyP95));
static void GenIfType ARGS((tTree yyP97, int yyP96));
static void GenIfList ARGS((tTree yyP99, int yyP98));
static void GenIfTypeAtomic ARGS((tTree yyP101, bool yyP100));
static void GenIfListAtomic ARGS((tTree yyP104, tTree yyP103, bool yyP102));
static void GenCaseSwitches ARGS((tTree yyP105));
static void GenCaseExprList ARGS((tTree yyP106));
static void GenCaseCode ARGS((tTree yyP108, int yyP107));
static void GenCaseAtomic ARGS((tTree yyP109));
static void GenCaseInSwitches ARGS((tTree yyP110));
static void GenCaseInCode ARGS((tTree yyP113, tTree yyP112, int yyP111));
static void GenSetScope ARGS((tSymbol yyP114));
static void GenSetListScope ARGS((tTree yyP115));
static void GenLocalSpecs ARGS((tTree yyP116));
static void GenLocalSpec ARGS((tTree SP));
static void GenLocalRep ARGS((tTree yyP117));
static void GenLocalIdList ARGS((tTree yyP119, tTree yyP118));
static void GenLocalInits ARGS((tTree yyP120));
static void GenLocalInit ARGS((tTree SP));
static void GenInitTable ARGS((tSymbol yyP123, int yyP122, tTree yyP121));
static void GenArrayTypeSize ARGS((tTree yyP124));
static void GenEmuRetype ARGS((tTree yyP128, tSymbol yyP127, tTree yyP126, tTree yyP125));
static void CodeRetypeSize ARGS((tTree yyP131, tSymbol yyP130, int yyP129));
static int RetypeSize ARGS((tTree yyP132));
static void GenInitChanList ARGS((tTree yyP133));
static void GenInitChanSubs ARGS((int yyP135, int yyP134));
static void GenInitChanArray ARGS((tTree yyP138, tSymbol yyP137, int yyP136));
static void GenInitChanArrayList ARGS((tTree yyP140, tTree yyP139));
static void GenInitIsArray ARGS((tSymbol yyP145, tTree yyP144, tTree yyP143, tSymbol yyP142, tTree yyP141));
static void GenInitReArray ARGS((tSymbol yyP150, tTree yyP149, tTree yyP148, tSymbol yyP147, tTree yyP146));
static void GenInitReArrayUnBoundSize ARGS((tTree yyP151));
static void GenResults ARGS((tTree yyP152));
static void GenResult ARGS((tTree yyP153));
static void GenResultTable ARGS((tSymbol yyP156, int yyP155, tTree yyP154));
static void GenEmuRetypeResult ARGS((tTree yyP160, tSymbol yyP159, tTree yyP158, tTree yyP157));
static int GenRepStart ARGS((tTree yyP161));
static void GenRepEnd ARGS((tTree yyP164, int yyP163, int yyP162));
static void GenAltIndex ARGS((tTree yyP165));
static void GenAltSelect ARGS((tTree yyP166));
static void GenForLoop ARGS((tTree yyP167));
static void GenForCheck ARGS((tTree yyP168));
static void CodeArrayExpr ARGS((tTree yyP170, bool yyP169));
static void CodeExpr ARGS((tTree yyP171));
static void CodeSizeOp ARGS((tTree yyP173, tTree yyP172));
static void CodeConstExpr ARGS((tTree yyP175, tValue yyP174));
static void CodeAssign ARGS((tTree yyP177, tTree yyP176));
static void CodeAssign2 ARGS((tTree yyP179, tTree yyP178));
static void GenChkDims ARGS((tTree yyP183, tTree yyP182, tTree yyP181, tTree yyP180));
static void GenInstance ARGS((tTree DP, tTree yyP185, tIdent yyP184));
static void GenAtomicInstance ARGS((tSymbol yyP188, tTree yyP187, tTree yyP186));
static void GenNonAtomicInstance ARGS((tSymbol yyP192, tTree yyP191, tTree yyP190, tIdent yyP189));
static void GenCInstance ARGS((tSymbol yyP195, tTree yyP194, tTree yyP193));
static void GenCTemps ARGS((tTree yyP198, tTree yyP197, bool yyP196));
static void GenCParams ARGS((tTree yyP201, tTree yyP200, bool yyP199));
static void GenCResults ARGS((tTree yyP204, tTree yyP203, bool yyP202));
static void GenF90Instance ARGS((tSymbol yyP207, tTree yyP206, tTree yyP205));
static void GenF90Temps ARGS((tTree yyP210, tTree yyP209, int yyP208));
static void GenF90Inits ARGS((tTree yyP213, tTree yyP212, int yyP211));
static void GenF90DopeInits ARGS((tTree yyP218, tTree yyP217, tTree yyP216, int yyP215, int yyP214));
static void GenF90Params ARGS((tTree yyP222, tTree yyP221, int yyP220, bool yyP219));
static void GenF90CharParams ARGS((tTree yyP225, tTree yyP224, int yyP223));
static void GenF90Results ARGS((tTree yyP228, tTree yyP227, int yyP226));
static void GenArrayDimSize ARGS((tTree yyP230, tTree yyP229));
static void GenExtParams ARGS((tTree yyP234, tTree yyP233, tIdent yyP232, int yyP231));
static void GenExtArrayParams ARGS((tTree yyP239, tTree yyP238, tTree yyP237, tIdent yyP236, int yyP235));
static void GenIntParams ARGS((tTree yyP243, tTree yyP242, tIdent yyP241, tSymbol yyP240));
static void GenChain ARGS((tIdent yyP246, tSymbol yyP245, bool yyP244));
static void GenIntArrayParams ARGS((tTree yyP252, tTree yyP251, tSymbol yyP250, tTree yyP249, tIdent yyP248, tSymbol yyP247));
static void GenFrameRef ARGS((tIdent yyP254, tSymbol yyP253));
static void GenFuncCall ARGS((tTree yyP257, tTree yyP256, tTree yyP255));
static void CodeMVFParams ARGS((tTree yyP259, bool yyP258));
static void GenParams ARGS((tTree yyP262, tTree yyP261, bool yyP260));
static void GenArrayParams ARGS((tTree yyP266, tTree yyP265, tTree yyP264, bool yyP263));
static void GenComma ARGS((bool yyP267));
static void GenTimerInput ARGS((tTree yyP268));
static void GenInput ARGS((tTree yyP270, tTree T, tTree yyP269));
static void GenInputToExpr ARGS((tTree yyP272, tTree yyP271));
static void GenOutput ARGS((tTree yyP275, tTree yyP274, tTree yyP273));
static void GenSeqProOutput ARGS((tTree yyP278, tTree yyP277, tTree yyP276));
static void GenSimpleOutput ARGS((tTree yyP281, tTree yyP280, tTree yyP279));
static void GenSimpleOutputOfExpr ARGS((tTree yyP284, tTree yyP283, tTree yyP282));
static void CodeElement ARGS((tTree yyP286, bool yyP285));
static void CodeChannelElement ARGS((tTree yyP288, bool yyP287));
static void GenArrayIndex ARGS((tSymbol yyP291, tTree yyP290, tTree yyP289));
static void GenElementSize ARGS((tTree yyP293, tTree yyP292));
static void GenArraySize ARGS((tSymbol yyP295, tTree yyP294));
static void CodeChkExpr ARGS((bool yyP300, bool yyP299, tTree yyP298, tSymbol yyP297, tTree yyP296));
static void CodeChkUBExpr ARGS((bool yyP306, bool yyP305, tTree yyP304, tTree yyP303, tSymbol yyP302, tTree yyP301));
static void CodeChkLBExpr ARGS((bool yyP308, tTree yyP307));
static tSymbol GetElementSymbol ARGS((tTree yyP309));
void CodeSymRef ARGS((tTree yyP312, tSymbol yyP311, bool yyP310));
static void CodeSym ARGS((tSymbol yyP313));
static void CodeIndirect ARGS((tSymbol yyP315, tTree yyP314));
static void CCodeTypeName ARGS((tTree yyP317, bool yyP316));
static void CCodeType ARGS((tTree yyP318));
static void CCodeTypeId ARGS((tTree yyP319));
static void CCodeTypeIdChkConst ARGS((tTree yyP321, tPosition yyP320));
void OccCodeType ARGS((tTree yyP322));
static void OccCodeProtocol ARGS((tTree yyP323));
static void CodeOp ARGS((tTree yyP324));
static int PrimTypeSize ARGS((tTree yyP325));
static tTree GetPrimType ARGS((tTree yyP326));
static bool IsPrimType ARGS((tTree yyP327));
bool IsScalarType ARGS((tTree yyP328));
static bool IsTimer ARGS((tTree yyP329));
static bool IsAtomicProcess ARGS((tTree yyP330));
bool IsAtomicProc ARGS((tTree yyP331));
bool IsParProc ARGS((tTree yyP332));
bool IsPrototype ARGS((tTree yyP333));
static bool IsBoundedType ARGS((tTree yyP334));
static bool IsByteArray ARGS((tTree yyP335));
static int CountArrayDims ARGS((tTree yyP336));
tTree GenOccPrototypes ARGS((tTree yyP337));
static void GenOccPrototypeFormals ARGS((tTree yyP338));
tTree GenCPrototype ARGS((tTree yyP339));
void CodeMainEntryParameters ARGS((tTree yyP340));
static bool IsSPChan ARGS((tTree yyP341));
void GenStatics ARGS((tTree yyP342));
static void GenStatic ARGS((tTree yyP343));
static void CodeConstArray ARGS((tTree yyP345, tConstArray yyP344));
static void GenStaticExpr ARGS((tTree yyP346));
static void GenStaticElement ARGS((tTree yyP348, int yyP347));
static void GenStaticExprList ARGS((tTree yyP349));
void GenShowValue ARGS((tTree yyP352, tTree yyP351, tSymbol yyP350));
static void GenShowSizes ARGS((tTree yyP355, tSymbol yyP354, int yyP353));
static void GenShowTests ARGS((tTree yyP358, tSymbol yyP357, int yyP356));
static void GenShowSymRef ARGS((tTree yyP360, tSymbol yyP359));
static void GenShowSym ARGS((tTree yyP362, tSymbol yyP361));
int MapKinds ARGS((tTree yyP365, tTree yyP364, tSymbol yyP363));
tSymbol CalcParent ARGS((tTree T));
tIdent CalcModule ARGS((tTree yyP366));
tStringRef CalcHeader ARGS((tTree yyP367));
tUsage CalcUsage ARGS((tTree yyP368));
bool IsLocal ARGS((tSymbol yyP369));
bool IsNonLocal ARGS((tSymbol yyP370));
bool IsAtomic ARGS((tTree yyP371));
static bool IsMVFunction ARGS((tTree yyP372));
static bool IsNewSymbol ARGS((tSymbol yyP373));
static void BeginBlock ARGS((tTree yyP374));
static void EndBlock ARGS((tTree yyP375));
static void BeginAtomicBlock ARGS((tTree yyP378, tTree yyP377, bool yyP376));
static void EndAtomicBlock ARGS((tTree yyP379));
void MarkRefParent ARGS((tSymbol yyP382, tTree yyP381, tVUsage yyP380));

tTree GenTypeDef
# if defined __STDC__ | defined __cplusplus
(register tTree T)
# else
(T)
 register tTree T;
# endif
{
  if (T->Kind == kStart) {
/* line 875 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoTree;

  }
  if (T->Kind == kDefProc) {
/* line 877 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 878 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("typedef struct SF_");
/* line 878 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (T->DefProc.Sym);
/* line 878 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" tSF_");
/* line 878 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (T->DefProc.Sym);
/* line 878 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 878 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 879 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((TreeRoot -> Start . OuterProc != T->DefProc.Sym))) goto yyL2;
  }
   return T -> DefProc . CGNext;
yyL2:;

/* line 882 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 883 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcHead (T);
/* line 883 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 883 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return T -> DefProc . CGNext;

  }
  if (T->Kind == kDefFunc) {
/* line 886 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 887 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("typedef struct SF_");
/* line 887 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (T->DefFunc.Sym);
/* line 887 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" tSF_");
/* line 887 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (T->DefFunc.Sym);
/* line 887 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 887 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 888 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((TreeRoot -> Start . OuterProc != T->DefFunc.Sym))) goto yyL4;
  }
   return T -> DefFunc . CGNext;
yyL4:;

/* line 891 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 892 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFuncHead (T);
/* line 892 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 892 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return T -> DefFunc . CGNext;

  }
  if (T->Kind == kPrototypeProc) {
/* line 895 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 895 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsDuplicatedPrototype (T->PrototypeProc.Sym) || CalcUsage (T) != xxUsed))) goto yyL6;
  }
   return T -> PrototypeProc . CGNext;
yyL6:;

/* line 897 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 897 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsDuplicatedHeader (T->PrototypeProc.Sym)))) goto yyL7;
  {
/* line 898 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("#include \"");
/* line 898 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteModuleHeaderName (T->PrototypeProc.Pos . File);
/* line 898 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\"");
/* line 898 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL7;
  }
  }
   return T -> PrototypeProc . CGNext;
yyL7:;

/* line 902 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 902 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((T -> DefAProc . U == xxUsed))) goto yyL8;
  {
/* line 902 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsAtomicProc (T)))) goto yyL8;
  {
/* line 903 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("struct SF_");
/* line 903 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (T->PrototypeProc.Sym);
/* line 903 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 904 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 904 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 905 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tHeader _Header;");
/* line 905 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 906 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("void *Chain;");
/* line 906 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProtoFormals (T->PrototypeProc.Formals, 0);
/* line 907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 908 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenWS (T->PrototypeProc.Sym);
/* line 908 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 909 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 909 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return T -> PrototypeProc . CGNext;
yyL8:;

/* line 912 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> PrototypeProc . CGNext;

  }
  if (T->Kind == kPrototypeFunc) {
/* line 914 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 914 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsDuplicatedPrototype (T->PrototypeFunc.Sym) || CalcUsage (T) != xxUsed))) goto yyL10;
  }
   return T -> PrototypeFunc . CGNext;
yyL10:;

/* line 916 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 916 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsDuplicatedHeader (T->PrototypeFunc.Sym)))) goto yyL11;
  {
/* line 917 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("#include \"");
/* line 917 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteModuleHeaderName (T->PrototypeFunc.Pos . File);
/* line 917 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\"");
/* line 917 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return T -> PrototypeFunc . CGNext;
yyL11:;

/* line 920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> PrototypeFunc . CGNext;

  }
  if (T->Kind == kHCode) {
/* line 922 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> HCode . CGNext;

  }
 yyAbort ("GenTypeDef");
}

static void GenWS
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP1)
# else
(yyP1)
 tSymbol yyP1;
# endif
{
  {tSymbol yyT; yyT = 0;
  if (equaltSymbol (yyP1, yyT)) {
/* line 925 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  }
/* line 926 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 926 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("char WS[WS_");
/* line 926 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP1);
/* line 926 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("];");
/* line 926 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenProtoFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP3, register int yyP2)
# else
(yyP3, yyP2)
 register tTree yyP3;
 register int yyP2;
# endif
{
  if (yyP3->Kind == kNoFormal) {
/* line 930 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP3->Kind == kAFormal) {
  if (yyP3->AFormal.Type->Kind == kArray) {
/* line 931 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 931 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProtoArrayFormal (yyP3->AFormal.Type, yyP2);
/* line 931 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProtoFormals (yyP3->AFormal.Next, yyP2 + 1);
  }
   return;

  }
  if (yyP3->AFormal.By->Kind == kByVal) {
/* line 932 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 932 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP3->AFormal.Type);
/* line 932 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 932 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 932 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP2);
/* line 932 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 932 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 932 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProtoFormals (yyP3->AFormal.Next, yyP2 + 1);
  }
   return;

  }
  if (yyP3->AFormal.By->Kind == kByRef) {
/* line 933 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 933 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP3->AFormal.Type);
/* line 933 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 933 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 933 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP2);
/* line 933 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 933 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 933 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProtoFormals (yyP3->AFormal.Next, yyP2 + 1);
  }
   return;

  }
  }
;
}

static void GenProtoArrayFormal
# if defined __STDC__ | defined __cplusplus
(register tTree yyP5, register int yyP4)
# else
(yyP5, yyP4)
 register tTree yyP5;
 register int yyP4;
# endif
{
  if (yyP5->Kind == kArray) {
  if (yyP5->Array.Expr->Kind == kUnBound) {
/* line 937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProtoArrayFormal (yyP5->Array.Type, yyP4);
/* line 937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP4);
/* line 937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP5));
/* line 937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
/* line 938 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 938 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProtoArrayFormal (yyP5->Array.Type, yyP4);
  }
   return;

  }
/* line 939 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 939 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP5)))) goto yyL3;
  {
/* line 939 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP5);
/* line 939 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" **");
/* line 939 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 939 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP4);
/* line 939 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 939 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL3:;

/* line 940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP5);
/* line 940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP4);
/* line 940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

tTree GenDeclStruct
# if defined __STDC__ | defined __cplusplus
(register tTree T)
# else
(T)
 register tTree T;
# endif
{
  if (T->Kind == kStart) {
/* line 947 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoTree;

  }
  if (T->Kind == kDefProc) {
/* line 949 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 950 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("struct SF_");
/* line 950 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (T->DefProc.Sym);
/* line 950 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 951 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 951 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 951 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 952 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tHeader _Header;");
/* line 952 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 953 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParentRef (T, T->DefProc.Sym);
/* line 953 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *Chain;");
/* line 953 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 954 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclFormals (T->DefProc.Formals, IsAtomicProc (T) && ! IsParProc (T));
/* line 955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (T->DefProc.Process, false);
/* line 956 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 956 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 956 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return T -> DefProc . CGNext;

  }
  if (T->Kind == kDefFunc) {
/* line 959 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 960 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("struct SF_");
/* line 960 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (T->DefFunc.Sym);
/* line 960 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 961 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 961 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 961 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 962 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tHeader _Header;");
/* line 962 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 963 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParentRef (T, T->DefFunc.Sym);
/* line 963 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *Chain;");
/* line 963 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 964 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclFormals (T->DefFunc.Formals, true);
/* line 965 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (T->DefFunc.Valof->Valof.SpecList);
/* line 966 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (T->DefFunc.Valof->Valof.Process, false);
/* line 967 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 967 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 967 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return T -> DefFunc . CGNext;

  }
  if (Tree_IsType (T, kDefAFunc)) {
/* line 970 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> DefAFunc . CGNext;

  }
  if (Tree_IsType (T, kDefAProc)) {
/* line 971 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> DefAProc . CGNext;

  }
  if (T->Kind == kHCode) {
/* line 972 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> HCode . CGNext;

  }
 yyAbort ("GenDeclStruct");
}

static void GenParentRef
# if defined __STDC__ | defined __cplusplus
(register tTree yyP7, tSymbol yyP6)
# else
(yyP7, yyP6)
 register tTree yyP7;
 tSymbol yyP6;
# endif
{
  if (yyP7->Kind == kDefProc) {
/* line 975 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 975 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsTopLevel (yyP6)))) goto yyL1;
  {
/* line 975 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 975 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP7 -> DefProc . Parent);
  }
  }
   return;
yyL1:;

  }
  if (yyP7->Kind == kDefFunc) {
/* line 976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsTopLevel (yyP6)))) goto yyL2;
  {
/* line 976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP7 -> DefFunc . Parent);
  }
  }
   return;
yyL2:;

  }
/* line 977 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 977 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("void");
  }
   return;

;
}

static void GenDeclFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP9, register bool yyP8)
# else
(yyP9, yyP8)
 register tTree yyP9;
 register bool yyP8;
# endif
{
  if (yyP9->Kind == kNoFormal) {
/* line 982 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP9->Kind == kAFormal) {
/* line 984 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 984 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP9->AFormal.Sym) && yyP8))) goto yyL2;
  {
/* line 985 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclFormals (yyP9->AFormal.Next, yyP8);
  }
  }
   return;
yyL2:;

  if (yyP9->AFormal.Type->Kind == kArray) {
/* line 988 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 989 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArrayFormal (yyP9->AFormal.Type, yyP9->AFormal.Sym, true);
/* line 990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclFormals (yyP9->AFormal.Next, yyP8);
  }
   return;

  }
  if (yyP9->AFormal.By->Kind == kByVal) {
/* line 993 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP9->AFormal.Type);
/* line 994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP9->AFormal.Sym);
/* line 994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 995 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclFormals (yyP9->AFormal.Next, yyP8);
  }
   return;

  }
  if (yyP9->AFormal.By->Kind == kByRef) {
/* line 998 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP9->AFormal.Type);
/* line 999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP9->AFormal.Sym);
/* line 999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1000 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclFormals (yyP9->AFormal.Next, yyP8);
  }
   return;

  }
  }
;
}

static void GenDeclArrayFormal
# if defined __STDC__ | defined __cplusplus
(register tTree yyP12, tSymbol yyP11, register bool yyP10)
# else
(yyP12, yyP11, yyP10)
 register tTree yyP12;
 tSymbol yyP11;
 register bool yyP10;
# endif
{
  if (yyP12->Kind == kArray) {
  if (yyP12->Array.Expr->Kind == kUnBound) {
  if (equalbool (yyP10, true)) {
/* line 1006 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArrayFormal (yyP12->Array.Type, yyP11, true);
/* line 1007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 1007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP11);
/* line 1007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 1007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP12));
/* line 1007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
/* line 1009 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1010 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArrayFormal (yyP12->Array.Type, yyP11, false);
  }
   return;

  }
/* line 1012 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1013 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArrayFormal (yyP12->Array.Type, yyP11, yyP10);
  }
   return;

  }
/* line 1015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP12)))) goto yyL4;
  {
/* line 1016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP12);
/* line 1016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" **");
/* line 1016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP11);
/* line 1016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL4:;

/* line 1018 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP12);
/* line 1019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 1019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP11);
/* line 1019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenDeclProc
# if defined __STDC__ | defined __cplusplus
(register tTree P, register bool yyP13)
# else
(P, yyP13)
 register tTree P;
 register bool yyP13;
# endif
{

  switch (P->Kind) {
  case kAlt:
/* line 1028 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1029 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->Alt.SpecList));
/* line 1030 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->Alt.SpecList);
/* line 1031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltTypeOuter (P, yyP13);
/* line 1032 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenUSpec (yyP13, NeedsSplit (P->Alt.AltList));
/* line 1033 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (P->Alt.AltList, yyP13);
/* line 1034 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1035 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kAltRep:
/* line 1037 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1038 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->AltRep.SpecList));
/* line 1039 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->AltRep.SpecList);
/* line 1040 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltTypeOuter (P, yyP13);
/* line 1041 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (P->AltRep.AltList, yyP13);
/* line 1042 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kCaseIn:
/* line 1044 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1045 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->CaseIn.SpecList));
/* line 1046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->CaseIn.SpecList);
/* line 1047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenUSpec (yyP13, NeedsSplit (P->CaseIn.CaseList));
/* line 1048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (P->CaseIn.CaseList, yyP13);
/* line 1049 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1050 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kSeq:
/* line 1054 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1055 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->Seq.SpecList));
/* line 1056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->Seq.SpecList);
/* line 1057 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenUSpec (yyP13, NeedsSplit (P->Seq.ProcList));
/* line 1058 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (P->Seq.ProcList, yyP13);
/* line 1059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1060 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kSeqRep:
/* line 1062 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->SeqRep.SpecList));
/* line 1064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->SeqRep.SpecList);
/* line 1065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLRepState (P->SeqRep.Replicator);
/* line 1066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (P->SeqRep.Process, yyP13);
/* line 1067 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kPar:
/* line 1069 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1070 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, (NeedsSpecs (P->Par.SpecList) || NeedsSplit (P->Par.ProcList)));
/* line 1071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->Par.SpecList);
/* line 1072 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (P->Par.ProcList, yyP13);
/* line 1073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kParRep:
/* line 1075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1076 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->ParRep.SpecList));
/* line 1077 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->ParRep.SpecList);
/* line 1078 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLRepState (P->ParRep.Replicator);
/* line 1079 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (P->ParRep.Process, yyP13);
/* line 1080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kProcessor:
/* line 1082 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1083 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->Processor.SpecList));
/* line 1084 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->Processor.SpecList);
/* line 1085 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (P->Processor.Process, yyP13);
/* line 1086 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kIf:
/* line 1092 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1093 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->If.SpecList));
/* line 1094 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->If.SpecList);
/* line 1095 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenUSpec (yyP13, NeedsSplit (P->If.ChoiceList));
/* line 1096 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (P->If.ChoiceList, yyP13);
/* line 1097 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1098 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kIfRep:
/* line 1100 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1101 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->IfRep.SpecList));
/* line 1102 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->IfRep.SpecList);
/* line 1103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLRepState (P->IfRep.Replicator);
/* line 1104 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (P->IfRep.ChoiceList, yyP13);
/* line 1105 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kCase:
/* line 1107 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->Case.SpecList));
/* line 1109 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->Case.SpecList);
/* line 1110 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenUSpec (yyP13, NeedsSplit (P->Case.ChoiceList));
/* line 1111 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (P->Case.ChoiceList, yyP13);
/* line 1112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1113 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kWhile:
/* line 1115 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1116 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, NeedsSpecs (P->While.SpecList));
/* line 1117 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->While.SpecList);
/* line 1118 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (P->While.Process, yyP13);
/* line 1119 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  case kInstance:
/* line 1132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1133 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, P->Instance.SpecList -> SpecList . DCL > 1);
/* line 1134 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->Instance.SpecList);
/* line 1135 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  }

/* line 1140 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1141 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP13 = OpenSSpec (yyP13, P->Process.SpecList -> SpecList . DCL > 1);
/* line 1142 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (P->Process.SpecList);
/* line 1143 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

;
}

static void GenDeclList
# if defined __STDC__ | defined __cplusplus
(register tTree T, register bool yyP14)
# else
(T, yyP14)
 register tTree T;
 register bool yyP14;
# endif
{
/* line 1151 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 bool S2; 

  switch (T->Kind) {
  case kNoProcess:
/* line 1154 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kAProcess:
/* line 1156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1157 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (T->AProcess.Process, yyP14);
/* line 1158 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (T->AProcess.Next, yyP14);
  }
   return;

  case kNoAlt:
/* line 1162 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kAnAlt:
/* line 1164 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1165 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   S2 = OpenSSpec (yyP14, NeedsSpecs (T->AnAlt.SpecList));
/* line 1166 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (T->AnAlt.SpecList);
/* line 1167 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclGuard (T->AnAlt.Guard, S2);
/* line 1168 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1169 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (T->AnAlt.Next, yyP14);
  }
   return;

  case kANewAlt:
/* line 1171 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1172 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   S2 = OpenSSpec (yyP14, NeedsSpecs (T->ANewAlt.SpecList));
/* line 1173 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (T->ANewAlt.SpecList);
/* line 1174 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (T->ANewAlt.AltType, S2);
/* line 1175 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1176 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (T->ANewAlt.Next, yyP14);
  }
   return;

  case kNoChoice:
/* line 1180 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kAChoice:
/* line 1182 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1183 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   S2 = OpenSSpec (yyP14, NeedsSpecs (T->AChoice.SpecList));
/* line 1184 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (T->AChoice.SpecList);
/* line 1185 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (T->AChoice.Process, S2);
/* line 1186 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1187 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (T->AChoice.Next, yyP14);
  }
   return;

  case kANewIf:
/* line 1189 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1190 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   S2 = OpenSSpec (yyP14, NeedsSpecs (T->ANewIf.SpecList));
/* line 1191 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (T->ANewIf.SpecList);
/* line 1192 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (T->ANewIf.IfType, S2);
/* line 1193 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1194 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (T->ANewIf.Next, yyP14);
  }
   return;

  case kNoCase:
/* line 1198 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kACase:
/* line 1200 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1201 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   S2 = OpenSSpec (yyP14, NeedsSpecs (T->ACase.SpecList));
/* line 1202 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (T->ACase.SpecList);
/* line 1203 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (T->ACase.Process, S2);
/* line 1204 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
/* line 1205 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclList (T->ACase.Next, yyP14);
  }
   return;

  }

;
}

static void GenDeclGuard
# if defined __STDC__ | defined __cplusplus
(register tTree yyP16, register bool yyP15)
# else
(yyP16, yyP15)
 register tTree yyP16;
 register bool yyP15;
# endif
{
  if (yyP16->Kind == kAltInput) {
/* line 1213 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1214 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP15 = OpenSSpec (yyP15, (NeedsSpecs (yyP16->AltInput.Input->Input.SpecList) || NeedsSplit (yyP16->AltInput.Process)));
/* line 1215 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (yyP16->AltInput.Input, yyP15);
/* line 1216 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (yyP16->AltInput.Process, yyP15);
/* line 1217 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  }
  if (yyP16->Kind == kAltTimer) {
/* line 1219 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1220 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP15 = OpenSSpec (yyP15, (NeedsSpecs (yyP16->AltTimer.After->After.SpecList) || NeedsSplit (yyP16->AltTimer.Process)));
/* line 1221 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (yyP16->AltTimer.After, yyP15);
/* line 1222 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (yyP16->AltTimer.Process, yyP15);
/* line 1223 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
   return;

  }
  if (yyP16->Kind == kAltCaseIn) {
/* line 1225 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (yyP16->AltCaseIn.CaseIn, yyP15);
  }
   return;

  }
  if (yyP16->Kind == kNoInput) {
/* line 1228 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1229 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclProc (yyP16->NoInput.Process, yyP15);
  }
   return;

  }
;
}

static void GenDeclAltTypeOuter
# if defined __STDC__ | defined __cplusplus
(register tTree yyP18, register bool yyP17)
# else
(yyP18, yyP17)
 register tTree yyP18;
 register bool yyP17;
# endif
{
/* line 1237 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1237 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP18 -> AltType . TLA))) goto yyL1;
  {
/* line 1238 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OpenSSpec (yyP17, (yyP18 -> AltType . ARC > 0));
/* line 1239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltTypeInner (yyP18);
/* line 1240 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseSpec ();
  }
  }
   return;
yyL1:;

;
}

static void GenDeclAltTypeInner
# if defined __STDC__ | defined __cplusplus
(register tTree yyP19)
# else
(yyP19)
 register tTree yyP19;
# endif
{
  if (yyP19->Kind == kAlt) {
/* line 1245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltList (yyP19->Alt.AltList);
  }
   return;

  }
  if (yyP19->Kind == kAltRep) {
/* line 1247 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1247 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltRep (yyP19->AltRep.Replicator);
/* line 1247 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltList (yyP19->AltRep.AltList);
  }
   return;

  }
;
}

static void GenDeclAltList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP20)
# else
(yyP20)
 register tTree yyP20;
# endif
{
  if (yyP20->Kind == kNoAlt) {
/* line 1252 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP20->Kind == kAnAlt) {
/* line 1254 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1254 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltList (yyP20->AnAlt.Next);
  }
   return;

  }
  if (yyP20->Kind == kANewAlt) {
/* line 1256 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1256 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltTypeInner (yyP20->ANewAlt.AltType);
/* line 1256 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclAltList (yyP20->ANewAlt.Next);
  }
   return;

  }
;
}

static void GenDeclAltRep
# if defined __STDC__ | defined __cplusplus
(register tTree yyP21)
# else
(yyP21)
 register tTree yyP21;
# endif
{
/* line 1263 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1264 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 1264 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP21->Replicator.Sym);
/* line 1264 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_Alt;");
/* line 1264 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1265 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLRepState (yyP21);
  }
   return;

;
}

static void GenNLRepState
# if defined __STDC__ | defined __cplusplus
(register tTree yyP22)
# else
(yyP22)
 register tTree yyP22;
# endif
{
/* line 1270 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1270 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsLocal (yyP22->Replicator.Sym)))) goto yyL1;
  {
/* line 1270 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP22->Replicator.From)))) goto yyL1;
  {
/* line 1270 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP22->Replicator.For)))) goto yyL1;
  {
/* line 1271 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 1271 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP22->Replicator.Sym);
/* line 1271 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1271 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1272 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP22->Replicator.Sym, PrefixId (CurSpec () . PrefixId, Symbol (yyP22->Replicator.Sym) . CId, '.'));
  }
  }
  }
  }
   return;
yyL1:;

/* line 1275 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1275 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsLocal (yyP22->Replicator.Sym)))) goto yyL2;
  {
/* line 1276 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 1276 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP22->Replicator.Sym);
/* line 1276 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1276 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1277 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 1277 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP22->Replicator.Sym);
/* line 1277 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_End;");
/* line 1277 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1278 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP22->Replicator.Sym, PrefixId (CurSpec () . PrefixId, Symbol (yyP22->Replicator.Sym) . CId, '.'));
  }
  }
   return;
yyL2:;

;
}

static void GenDeclSpecs
# if defined __STDC__ | defined __cplusplus
(register tTree yyP23)
# else
(yyP23)
 register tTree yyP23;
# endif
{
  if (yyP23->Kind == kNoSpec) {
/* line 1283 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP23->Kind == kASpec) {
/* line 1284 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1284 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclNLSpec (yyP23->ASpec.Spec);
/* line 1284 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSpecs (yyP23->ASpec.Next);
  }
   return;

  }
;
}

static void GenDeclNLSpec
# if defined __STDC__ | defined __cplusplus
(register tTree yyP24)
# else
(yyP24)
 register tTree yyP24;
# endif
{

  switch (yyP24->Kind) {
  case kDecl:
/* line 1291 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1291 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclNLIdList (yyP24->Decl.Type, yyP24->Decl.IdList);
  }
   return;

  case kVal:
/* line 1294 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1294 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP24->Val.Sym)))) goto yyL2;
  }
   return;
yyL2:;

  break;
  case kValRetypes:
/* line 1295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP24->ValRetypes.Sym)))) goto yyL3;
  }
   return;
yyL3:;

  break;
  case kRetypes:
/* line 1296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP24->Retypes.Sym)))) goto yyL4;
  }
   return;
yyL4:;

  break;
  case kIs:
/* line 1297 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1297 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP24->Is.Sym)))) goto yyL5;
  }
   return;
yyL5:;

  break;
  case kCallFrame:
/* line 1300 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1300 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProc (SymbolKind (yyP24->CallFrame.Sym))))) goto yyL6;
  }
   return;
yyL6:;

/* line 1301 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1302 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1302 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP24->CallFrame.Sym);
/* line 1302 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 1302 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP24->CallFrame.Id);
/* line 1302 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1302 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1302 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP24->CallFrame.Id = PrefixId (CurSpec () . PrefixId, yyP24->CallFrame.Id, '.');
  }
   return;

  case kParFrame:
/* line 1305 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1305 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP24->ParFrame.Rep > 0))) goto yyL8;
  {
/* line 1306 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tTask ");
/* line 1306 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP24->ParFrame.TId);
/* line 1306 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 1306 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP24->ParFrame.Rep);
/* line 1306 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 1306 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1306 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1307 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1307 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP24->ParFrame.Sym);
/* line 1307 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 1307 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP24->ParFrame.FId);
/* line 1307 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 1307 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP24->ParFrame.Rep);
/* line 1307 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 1307 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1307 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1308 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP24->ParFrame.TId = PrefixId (CurSpec () . PrefixId, yyP24->ParFrame.TId, '.');
/* line 1309 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP24->ParFrame.FId = PrefixId (CurSpec () . PrefixId, yyP24->ParFrame.FId, '.');
  }
  }
   return;
yyL8:;

/* line 1312 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1313 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tTask ");
/* line 1313 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP24->ParFrame.TId);
/* line 1313 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1313 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1314 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1314 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP24->ParFrame.Sym);
/* line 1314 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 1314 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP24->ParFrame.FId);
/* line 1314 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1314 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1315 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP24->ParFrame.TId = PrefixId (CurSpec () . PrefixId, yyP24->ParFrame.TId, '.');
/* line 1316 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP24->ParFrame.FId = PrefixId (CurSpec () . PrefixId, yyP24->ParFrame.FId, '.');
  }
   return;

  case kDefAProc:
  case kDefProc:
  case kPrototypeProc:
/* line 1319 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kDefAFunc:
  case kDefFunc:
  case kDefIsFunc:
  case kPrototypeFunc:
/* line 1320 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kDefAPro:
  case kDefSeqPro:
  case kDefTagPro:
/* line 1321 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kNullSpec:
/* line 1322 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }

/* line 1324 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1324 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSpecState (yyP24);
  }
   return;

;
}

static void GenDeclSym
# if defined __STDC__ | defined __cplusplus
(register tTree yyP27, tSymbol yyP26, register bool yyP25)
# else
(yyP27, yyP26, yyP25)
 register tTree yyP27;
 tSymbol yyP26;
 register bool yyP25;
# endif
{
/* line 1330 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1330 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP27)))) goto yyL1;
  }
   return;
yyL1:;

  if (equalbool (yyP25, false)) {
/* line 1333 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1333 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (SymbolType (yyP26))))) goto yyL2;
  {
/* line 1334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (SymbolType (yyP26));
/* line 1334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 1334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP26);
/* line 1334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_CHAN");
/* line 1334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (SymbolType (yyP26));
/* line 1334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1335 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (SymbolType (yyP26));
/* line 1335 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 1335 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP26);
/* line 1335 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (SymbolType (yyP26));
/* line 1335 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1335 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1336 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP26, PrefixId (CurSpec () . PrefixId, Symbol (yyP26) . CId, '.'));
  }
  }
   return;
yyL2:;

  }
  if (equalbool (yyP25, false)) {
/* line 1339 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1340 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (SymbolType (yyP26));
/* line 1340 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 1340 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP26);
/* line 1340 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (SymbolType (yyP26));
/* line 1340 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1340 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1341 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP26, PrefixId (CurSpec () . PrefixId, Symbol (yyP26) . CId, '.'));
  }
   return;

  }
/* line 1344 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1345 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (SymbolType (yyP26));
/* line 1345 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 1345 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP26);
/* line 1345 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (SymbolType (yyP26));
/* line 1345 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1345 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1346 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP26, PrefixId (CurSpec () . PrefixId, Symbol (yyP26) . CId, '.'));
  }
   return;

;
}

static void GenDeclArraySym
# if defined __STDC__ | defined __cplusplus
(register tTree yyP29, tSymbol yyP28)
# else
(yyP29, yyP28)
 register tTree yyP29;
 tSymbol yyP28;
# endif
{
/* line 1352 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1352 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP29)))) goto yyL1;
  }
   return;
yyL1:;

  if (yyP29->Kind == kArray) {
  if (yyP29->Array.Expr->Kind == kUnBound) {
/* line 1355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 1356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP28);
/* line 1356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 1356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP29));
/* line 1356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1357 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP29->Array.Type, yyP28);
  }
   return;

  }
/* line 1360 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1360 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP29->Array.Expr)))) goto yyL3;
  {
/* line 1361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 1361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP28);
/* line 1361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 1361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP29));
/* line 1361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("/*SMW*/");
/* line 1361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1362 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP29->Array.Type, yyP28);
  }
  }
   return;
yyL3:;

/* line 1365 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1366 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP29->Array.Type, yyP28);
  }
   return;

  }
/* line 1369 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1369 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (SymbolType (yyP28))))) goto yyL5;
  {
/* line 1370 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (SymbolType (yyP28));
/* line 1370 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" **");
/* line 1370 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP28);
/* line 1370 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1370 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1371 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP28, PrefixId (CurSpec () . PrefixId, Symbol (yyP28) . CId, '.'));
  }
  }
   return;
yyL5:;

/* line 1374 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1375 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (SymbolType (yyP28));
/* line 1375 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 1375 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP28);
/* line 1375 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1375 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1376 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP28, PrefixId (CurSpec () . PrefixId, Symbol (yyP28) . CId, '.'));
  }
   return;

;
}

static bool IsZeroSizeType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP30)
# else
(yyP30)
 register tTree yyP30;
# endif
{
  if (yyP30->Kind == kArray) {
/* line 1384 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1384 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (((IsConstExpr (yyP30->Array.Expr)) && (ValConstInt (yyP30->Array.Expr) == 0)))) goto yyL1;
  }
   return true;
yyL1:;

/* line 1386 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return IsZeroSizeType (yyP30->Array.Type);

  }
/* line 1388 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return false;

}

static bool NeedsSpecs
# if defined __STDC__ | defined __cplusplus
(register tTree yyP31)
# else
(yyP31)
 register tTree yyP31;
# endif
{
/* line 1393 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (yyP31 -> SpecList . DCL > 0);

}

static bool NeedsSplit
# if defined __STDC__ | defined __cplusplus
(register tTree yyP32)
# else
(yyP32)
 register tTree yyP32;
# endif
{
  if (Tree_IsType (yyP32, kProcess)) {
/* line 1397 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (yyP32 -> Process . SLC > 1);

  }
  if (Tree_IsType (yyP32, kProcList)) {
/* line 1398 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (yyP32 -> ProcList . SLC > 1);

  }
  if (Tree_IsType (yyP32, kChoiceList)) {
/* line 1399 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (yyP32 -> ChoiceList . SLC > 1);

  }
  if (Tree_IsType (yyP32, kAltList)) {
/* line 1400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (yyP32 -> AltList . SLC > 1);

  }
  if (Tree_IsType (yyP32, kGuard)) {
/* line 1401 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (yyP32 -> Guard . SLC > 1);

  }
  if (Tree_IsType (yyP32, kCaseList)) {
/* line 1402 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (yyP32 -> CaseList . SLC > 1);

  }
 yyAbort ("NeedsSplit");
}

static void GenDeclNLIdList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP34, register tTree yyP33)
# else
(yyP34, yyP33)
 register tTree yyP34;
 register tTree yyP33;
# endif
{
  if (yyP33->Kind == kAnId) {
/* line 1407 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1407 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP33->AnId.Sym)))) goto yyL1;
  {
/* line 1407 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclNLIdList (yyP34, yyP33->AnId.Next);
  }
  }
   return;
yyL1:;

/* line 1408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (yyP34, yyP33->AnId.Sym, false);
/* line 1408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclNLIdList (yyP34, yyP33->AnId.Next);
  }
   return;

  }
  if (yyP33->Kind == kNoId) {
/* line 1409 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenSpecState
# if defined __STDC__ | defined __cplusplus
(register tTree yyP35)
# else
(yyP35)
 register tTree yyP35;
# endif
{
  if (yyP35->Kind == kVal) {
  if (Tree_IsType (yyP35->Val.Expr, kStringElement)) {
/* line 1418 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1418 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP35->Val.Expr)))) goto yyL1;
  {
/* line 1418 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsArrayType (ExprType (yyP35->Val.Expr))))) goto yyL1;
  {
/* line 1419 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP35->Val.Type, yyP35->Val.Sym);
  }
  }
  }
   return;
yyL1:;

/* line 1437 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected string element", xxError, yyP35->Val.Pos);
  }
   return;

  }
  if (yyP35->Val.Expr->Kind == kElementalExpr) {
/* line 1421 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1421 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP35->Val.Expr)))) goto yyL2;
  {
/* line 1421 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsArrayType (ExprType (yyP35->Val.Expr))))) goto yyL2;
  {
/* line 1422 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP35->Val.Type, yyP35->Val.Sym);
  }
  }
  }
   return;
yyL2:;

  if (yyP35->Val.Expr->ElementalExpr.Elemental->Kind == kTable) {
/* line 1431 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1432 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (yyP35->Val.Type, yyP35->Val.Sym, false);
  }
   return;

  }
  if (Tree_IsType (yyP35->Val.Expr->ElementalExpr.Elemental, kTableElement)) {
/* line 1434 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1435 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected table element", xxError, yyP35->Val.Pos);
  }
   return;

  }
  }
/* line 1476 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1476 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP35->Val.Sym))))) goto yyL17;
  {
/* line 1476 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP35->Val.Expr)))) goto yyL17;
  {
/* line 1476 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsNewSymbol (yyP35->Val.Sym)))) goto yyL17;
  }
  }
  }
   return;
yyL17:;

/* line 1478 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1478 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP35->Val.Sym))))) goto yyL18;
  {
/* line 1479 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (SymbolType (yyP35->Val.Sym), yyP35->Val.Sym, false);
  }
  }
   return;
yyL18:;

/* line 1482 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1483 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (SymbolType (yyP35->Val.Sym), yyP35->Val.Sym);
  }
   return;

  }
  if (yyP35->Kind == kValRetypes) {
  if (Tree_IsType (yyP35->ValRetypes.Expr, kStringElement)) {
/* line 1424 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1424 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP35->ValRetypes.Expr)))) goto yyL3;
  {
/* line 1424 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsArrayType (yyP35->ValRetypes.Type)))) goto yyL3;
  {
/* line 1425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP35->ValRetypes.Type, yyP35->ValRetypes.Sym);
  }
  }
  }
   return;
yyL3:;

/* line 1443 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1444 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected string retypes", xxError, yyP35->ValRetypes.Pos);
  }
   return;

  }
  if (yyP35->ValRetypes.Expr->Kind == kElementalExpr) {
/* line 1427 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1427 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP35->ValRetypes.Expr)))) goto yyL4;
  {
/* line 1427 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsArrayType (yyP35->ValRetypes.Type)))) goto yyL4;
  {
/* line 1427 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IS_Mode (xxEmulate)))) goto yyL4;
  {
/* line 1428 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP35->ValRetypes.Type, yyP35->ValRetypes.Sym);
  }
  }
  }
  }
   return;
yyL4:;

  if (Tree_IsType (yyP35->ValRetypes.Expr->ElementalExpr.Elemental, kTableElement)) {
/* line 1440 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected table retypes", xxError, yyP35->ValRetypes.Pos);
  }
   return;

  }
  }
/* line 1486 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1486 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP35->ValRetypes.Type)))) goto yyL20;
  {
/* line 1487 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (yyP35->ValRetypes.Type, yyP35->ValRetypes.Sym, false);
  }
  }
   return;
yyL20:;

/* line 1490 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1490 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxEmulate)))) goto yyL21;
  {
/* line 1490 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((RetypeSize (yyP35->ValRetypes.Type) != RetypeSize (ExprType (yyP35->ValRetypes.Expr))))) goto yyL21;
  {
/* line 1490 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsBoundedType (yyP35->ValRetypes.Type)))) goto yyL21;
  {
/* line 1491 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (yyP35->ValRetypes.Type, yyP35->ValRetypes.Sym, false);
  }
  }
  }
  }
   return;
yyL21:;

/* line 1494 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1495 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP35->ValRetypes.Type, yyP35->ValRetypes.Sym);
  }
   return;

  }
  if (yyP35->Kind == kIs) {
  if (yyP35->Is.Elemental->Kind == kTable) {
/* line 1446 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1447 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (yyP35->Is.Type, yyP35->Is.Sym, false);
  }
   return;

  }
  if (Tree_IsType (yyP35->Is.Elemental, kTableElement)) {
/* line 1449 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1450 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected table element", xxError, yyP35->Is.Pos);
  }
   return;

  }
/* line 1454 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1454 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP35->Is.Sym))))) goto yyL12;
  {
/* line 1455 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (SymbolType (yyP35->Is.Sym), yyP35->Is.Sym, false);
  }
  }
   return;
yyL12:;

/* line 1458 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1459 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (SymbolType (yyP35->Is.Sym), yyP35->Is.Sym);
  }
   return;

  }
  if (yyP35->Kind == kRetypes) {
/* line 1462 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1462 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP35->Retypes.Type)))) goto yyL14;
  {
/* line 1463 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (yyP35->Retypes.Type, yyP35->Retypes.Sym, false);
  }
  }
   return;
yyL14:;

/* line 1466 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1466 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxEmulate)))) goto yyL15;
  {
/* line 1466 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((RetypeSize (yyP35->Retypes.Type) != RetypeSize (ElementType (yyP35->Retypes.Elemental))))) goto yyL15;
  {
/* line 1466 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsBoundedType (yyP35->Retypes.Type)))) goto yyL15;
  {
/* line 1467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (yyP35->Retypes.Type, yyP35->Retypes.Sym, false);
  }
  }
  }
  }
   return;
yyL15:;

/* line 1470 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1471 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclArraySym (yyP35->Retypes.Type, yyP35->Retypes.Sym);
  }
   return;

  }
/* line 1499 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1499 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP35, yyP35->Spec.Pos);
  }
   return;

;
}

int CountRepDecls
# if defined __STDC__ | defined __cplusplus
(register tTree yyP36)
# else
(yyP36)
 register tTree yyP36;
# endif
{
/* line 1509 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1509 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP36->Replicator.Sym)))) goto yyL1;
  }
   return 0;
yyL1:;

/* line 1510 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1510 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP36->Replicator.From)))) goto yyL2;
  {
/* line 1510 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP36->Replicator.For)))) goto yyL2;
  }
  }
   return 1;
yyL2:;

/* line 1511 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 2;

}

int CountAltRepDecls
# if defined __STDC__ | defined __cplusplus
(register tTree yyP37)
# else
(yyP37)
 register tTree yyP37;
# endif
{
/* line 1518 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return CountRepDecls (yyP37) + 1;

}

static int CountAbbrev
# if defined __STDC__ | defined __cplusplus
(register tTree yyP38)
# else
(yyP38)
 register tTree yyP38;
# endif
{
  if (yyP38->Kind == kArray) {
  if (yyP38->Array.Expr->Kind == kUnBound) {
/* line 1523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 1 + CountAbbrev (yyP38->Array.Type);

  }
/* line 1525 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1525 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP38->Array.Expr)))) goto yyL2;
  }
   return 1 + CountAbbrev (yyP38->Array.Type);
yyL2:;

/* line 1527 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return CountAbbrev (yyP38->Array.Type);

  }
/* line 1529 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 1;

}

static int CountIdList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP39)
# else
(yyP39)
 register tTree yyP39;
# endif
{
  if (yyP39->Kind == kNoId) {
/* line 1535 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

  }
  if (yyP39->Kind == kAnId) {
/* line 1536 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (IsNonLocal(yyP39->AnId.Sym)?CountIdList(yyP39->AnId.Next)+1:CountIdList(yyP39->AnId.Next));

  }
 yyAbort ("CountIdList");
}

static int CountDecl
# if defined __STDC__ | defined __cplusplus
(register tTree yyP40)
# else
(yyP40)
 register tTree yyP40;
# endif
{
/* line 1541 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1541 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP40->Decl.Type)))) goto yyL1;
  }
   return 0;
yyL1:;

/* line 1542 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1542 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP40->Decl.Type)))) goto yyL2;
  }
   return 2 * CountIdList (yyP40->Decl.IdList);
yyL2:;

/* line 1543 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return CountIdList (yyP40->Decl.IdList);

}

int CountSpec
# if defined __STDC__ | defined __cplusplus
(register tTree yyP41)
# else
(yyP41)
 register tTree yyP41;
# endif
{

  switch (yyP41->Kind) {
  case kDefAProc:
  case kDefProc:
  case kPrototypeProc:
/* line 1548 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

  case kDefAFunc:
  case kDefFunc:
  case kDefIsFunc:
  case kPrototypeFunc:
/* line 1549 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

  case kParFrame:
/* line 1551 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 2;

  case kCallFrame:
/* line 1552 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 1;

  case kDecl:
/* line 1554 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return CountDecl (yyP41);

  case kVal:
/* line 1556 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1556 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP41->Val.Sym))))) goto yyL6;
  {
/* line 1556 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP41->Val.Expr)))) goto yyL6;
  {
/* line 1556 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsNewSymbol (yyP41->Val.Sym)))) goto yyL6;
  }
  }
  }
   return 0;
yyL6:;

/* line 1560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return IsNonLocal(yyP41->Val.Sym)?CountAbbrev(SymbolType(yyP41->Val.Sym)):0;

  case kIs:
/* line 1558 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return IsNonLocal(yyP41->Is.Sym)?CountAbbrev(SymbolType(yyP41->Is.Sym)):0;

  case kRetypes:
/* line 1559 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return IsNonLocal(yyP41->Retypes.Sym)?CountAbbrev(SymbolType(yyP41->Retypes.Sym)):0;

  case kValRetypes:
/* line 1561 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return IsNonLocal(yyP41->ValRetypes.Sym)?CountAbbrev(SymbolType(yyP41->ValRetypes.Sym)):0;

  }

/* line 1563 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 1;

}

tTree GenCode
# if defined __STDC__ | defined __cplusplus
(register tTree T)
# else
(T)
 register tTree T;
# endif
{

  switch (T->Kind) {
  case kStart:
/* line 1573 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoTree;

  case kDefFunc:
/* line 1575 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1576 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (T->DefFunc.Pos);
/* line 1577 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CurProc = T;
/* line 1578 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   InitBlocks ();
/* line 1579 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFuncHead (T);
/* line 1579 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1580 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFuncEntry (T);
/* line 1581 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (T->DefFunc.Valof->Valof.SpecList, NoTree, false);
/* line 1582 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (T->DefFunc.Valof->Valof.Process);
/* line 1583 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFuncExit (T);
/* line 1584 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (T->DefFunc.Valof->Valof.SpecList);
/* line 1585 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFuncTail (T);
  }
   return T -> DefFunc . CGNext;

  case kDefProc:
/* line 1588 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1589 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (T->DefProc.Pos);
/* line 1590 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CurProc = T;
/* line 1591 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   InitBlocks ();
/* line 1592 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcHead (T);
/* line 1592 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1593 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcEntry (T);
/* line 1594 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (T->DefProc.Process);
/* line 1595 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcTail (T);
  }
   return T -> DefProc . CGNext;

  case kDefIsFunc:
/* line 1598 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1599 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (T, T->DefIsFunc.Pos);
  }
   return T -> DefIsFunc . CGNext;

  case kDefAFunc:
  case kPrototypeFunc:
/* line 1602 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> DefAFunc . CGNext;

  case kDefAProc:
  case kPrototypeProc:
/* line 1603 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> DefAProc . CGNext;

  case kHCode:
/* line 1604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1605 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteCCode (T->HCode.Code, T->HCode.Pos, T -> HCode . Scope);
/* line 1606 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return T -> HCode . CGNext;

  }

 yyAbort ("GenCode");
}

static void GenProcHead
# if defined __STDC__ | defined __cplusplus
(register tTree DP)
# else
(DP)
 register tTree DP;
# endif
{
/* line 1613 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 bool comma = false; 
/* line 1615 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1616 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (SymbolDepth (DP->DefProc.Sym) != 0, "static ");
/* line 1617 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("void ");
/* line 1617 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DP->DefProc.Sym);
/* line 1617 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" (");
/* line 1618 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
   return;
yyL1:;

/* line 1621 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1621 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsAtomicProc (DP) || IsParProc (DP)))) goto yyL2;
  {
/* line 1622 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1622 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DP->DefProc.Sym);
/* line 1622 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *FP)");
  }
  }
   return;
yyL2:;

/* line 1625 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1625 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((NeedsChain (DP->DefProc.Sym)))) goto yyL3;
  {
/* line 1626 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1626 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DP -> DefProc . Parent);
/* line 1626 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *PP");
/* line 1627 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   comma = true;
/* line 1628 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL3;
  }
  }
   return;
yyL3:;

/* line 1631 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1632 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   comma = GenFormals (DP->DefProc.Formals, comma);
/* line 1633 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (! comma, "void");
/* line 1634 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

;
}

static void GenProcEntry
# if defined __STDC__ | defined __cplusplus
(register tTree DP)
# else
(DP)
 register tTree DP;
# endif
{
/* line 1643 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1643 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsAtomicProc (DP)))) goto yyL1;
  {
/* line 1644 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 1644 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1644 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1645 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("while(true)");
/* line 1645 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1646 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 1646 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1646 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1647 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("switch(FP->_Header.IP)");
/* line 1647 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1648 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 1648 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1648 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1649 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CurrentLabel = - 1;
/* line 1649 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1650 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLabel ();
/* line 1650 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (DP->DefProc.Formals);
  }
  }
   return;
yyL1:;

/* line 1653 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1653 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsParProc (DP)))) goto yyL2;
  {
/* line 1654 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 1654 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1654 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1655 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (DP->DefProc.Formals);
  }
  }
   return;
yyL2:;

/* line 1658 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1659 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 1659 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1659 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1660 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1660 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DP->DefProc.Sym);
/* line 1660 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" SF;");
/* line 1660 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1661 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1661 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DP->DefProc.Sym);
/* line 1661 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *FP = &SF;");
/* line 1661 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1662 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (DP->DefProc.Formals);
/* line 1663 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLFormals (DP->DefProc.Formals);
/* line 1664 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((NeedsChain (DP->DefProc.Sym)))) goto yyL3;
  {
/* line 1665 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->Chain = PP;");
/* line 1665 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL3:;

;
}

static void GenProcTail
# if defined __STDC__ | defined __cplusplus
(register tTree DP)
# else
(DP)
 register tTree DP;
# endif
{
/* line 1679 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1679 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((DP -> DefProc . isPar))) goto yyL1;
  {
/* line 1680 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ENDP();");
/* line 1681 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
  }
   return;
yyL1:;

/* line 1684 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1684 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProc (DP)))) goto yyL2;
  {
/* line 1685 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 1685 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 1685 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1686 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BlankLine ();
  }
  }
   return;
yyL2:;

/* line 1689 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1689 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! DP -> DefProc . isPar))) goto yyL3;
  {
/* line 1690 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("RETURN();");
/* line 1691 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL3;
  }
  }
   return;
yyL3:;

/* line 1694 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1695 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 1696 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("default: SETERR(MSG_IP);");
/* line 1696 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1697 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 1697 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 1697 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1698 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 1698 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 1698 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1699 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 1699 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 1699 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1700 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BlankLine ();
  }
   return;

;
}

static void GenFuncHead
# if defined __STDC__ | defined __cplusplus
(register tTree DF)
# else
(DF)
 register tTree DF;
# endif
{
/* line 1707 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 bool comma = false; 
  if (DF->DefFunc.TypeList->Kind == kAType) {
  if (DF->DefFunc.TypeList->AType.Next->Kind == kNoType) {
/* line 1709 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1710 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (SymbolDepth (DF->DefFunc.Sym) != 0, "static ");
/* line 1711 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (DF->DefFunc.TypeList->AType.Type);
/* line 1711 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 1711 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DF->DefFunc.Sym);
/* line 1711 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 1712 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
   return;
yyL1:;

  }
  }
/* line 1715 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1715 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsMVFunction (DF)))) goto yyL2;
  {
/* line 1716 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (SymbolDepth (DF->DefFunc.Sym) != 0, "static ");
/* line 1717 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("void ");
/* line 1717 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DF->DefFunc.Sym);
/* line 1717 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 1718 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
  }
   return;
yyL2:;

/* line 1721 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1721 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (DF->DefFunc.Sym)))) goto yyL3;
  {
/* line 1722 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1722 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DF -> DefFunc . Parent);
/* line 1722 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *PP");
/* line 1723 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   comma = true;
/* line 1724 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL3;
  }
  }
   return;
yyL3:;

/* line 1727 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1728 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   comma = GenFormals (DF->DefFunc.Formals, comma);
/* line 1729 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL4;
  }
   return;
yyL4:;

/* line 1732 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1732 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsMVFunction (DF)))) goto yyL5;
  {
/* line 1733 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenMVFormals (DF->DefFunc.TypeList, 0, comma);
/* line 1734 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
  }
   return;
yyL5:;

/* line 1737 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1738 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CONDWrite (! comma, "void ");
/* line 1739 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

;
}

static void GenFuncEntry
# if defined __STDC__ | defined __cplusplus
(register tTree DF)
# else
(DF)
 register tTree DF;
# endif
{
/* line 1746 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1747 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 1747 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1747 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1748 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsMVFunction (DF)))) goto yyL1;
  {
/* line 1749 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (DF->DefFunc.TypeList -> AType . Type);
/* line 1749 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" _Result;");
/* line 1749 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1750 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
  }
   return;
yyL1:;

/* line 1753 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1754 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1754 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DF->DefFunc.Sym);
/* line 1754 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" SF;");
/* line 1754 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("tSF_");
/* line 1755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (DF->DefFunc.Sym);
/* line 1755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *FP = &SF;");
/* line 1755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1756 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (DF->DefFunc.Formals);
/* line 1757 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLFormals (DF->DefFunc.Formals);
/* line 1758 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((NeedsChain (DF->DefFunc.Sym)))) goto yyL2;
  {
/* line 1759 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->Chain = PP;");
/* line 1759 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL2:;

;
}

static void GenFuncExit
# if defined __STDC__ | defined __cplusplus
(register tTree DF)
# else
(DF)
 register tTree DF;
# endif
{
/* line 1767 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1767 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsMVFunction (DF)))) goto yyL1;
  {
/* line 1768 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenMVFResult (DF->DefFunc.Valof->Valof.ExprList, 0);
  }
  }
   return;
yyL1:;

  if (DF->DefFunc.Valof->Valof.ExprList->Kind == kAnExpr) {
  if (DF->DefFunc.Valof->Valof.ExprList->AnExpr.Next->Kind == kNoExpr) {
/* line 1771 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1772 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_Result = ");
/* line 1772 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (DF->DefFunc.Valof->Valof.ExprList->AnExpr.Expr);
/* line 1772 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1772 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
;
}

static void GenFuncTail
# if defined __STDC__ | defined __cplusplus
(register tTree DF)
# else
(DF)
 register tTree DF;
# endif
{
/* line 1779 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1779 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsMVFunction (DF)))) goto yyL1;
  {
/* line 1780 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("return _Result;");
/* line 1780 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1781 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
  }
   return;
yyL1:;

/* line 1784 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1785 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 1785 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 1785 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1786 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BlankLine ();
  }
   return;

;
}

static bool GenFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP43, register bool yyP42)
# else
(yyP43, yyP42)
 register tTree yyP43;
 register bool yyP42;
# endif
{
/* line 1793 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 bool comma; 
  if (yyP43->Kind == kNoFormal) {
/* line 1795 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP42;

  }
  if (yyP43->Kind == kAFormal) {
/* line 1797 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1797 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP43->AFormal.Type)))) goto yyL2;
  {
/* line 1798 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   comma = GenFormals (yyP43->AFormal.Next, false);
  }
  }
   return comma;
yyL2:;

  if (yyP43->AFormal.Type->Kind == kArray) {
/* line 1801 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1802 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayFormal (yyP43->AFormal.Type, yyP43->AFormal.Sym, yyP42);
/* line 1803 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (GenFormals (yyP43->AFormal.Next, true))) goto yyL3;
  }
   return true;
yyL3:;

  }
  if (yyP43->AFormal.By->Kind == kByVal) {
/* line 1806 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1807 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP42);
/* line 1808 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP43->AFormal.Type);
/* line 1808 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 1808 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP43->AFormal.Sym);
/* line 1809 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (GenFormals (yyP43->AFormal.Next, true))) goto yyL4;
  }
   return true;
yyL4:;

  }
  if (yyP43->AFormal.By->Kind == kByRef) {
/* line 1812 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1813 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP42);
/* line 1814 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP43->AFormal.Type);
/* line 1814 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 1814 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP43->AFormal.Sym);
/* line 1815 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (GenFormals (yyP43->AFormal.Next, true))) goto yyL5;
  }
   return true;
yyL5:;

  }
  }
 yyAbort ("GenFormals");
}

static void GenArrayFormal
# if defined __STDC__ | defined __cplusplus
(register tTree yyP46, tSymbol yyP45, register bool yyP44)
# else
(yyP46, yyP45, yyP44)
 register tTree yyP46;
 tSymbol yyP45;
 register bool yyP44;
# endif
{
  if (yyP46->Kind == kArray) {
  if (yyP46->Array.Expr->Kind == kUnBound) {
/* line 1822 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1823 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP44);
/* line 1824 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 1824 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP45);
/* line 1824 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 1824 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP46));
/* line 1825 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayFormal (yyP46->Array.Type, yyP45, true);
  }
   return;

  }
/* line 1828 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1829 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayFormal (yyP46->Array.Type, yyP45, yyP44);
  }
   return;

  }
/* line 1832 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1832 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP46)))) goto yyL3;
  {
/* line 1833 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP44);
/* line 1834 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP46);
/* line 1834 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" **");
/* line 1834 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP45);
  }
  }
   return;
yyL3:;

/* line 1837 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1838 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP44);
/* line 1839 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP46);
/* line 1839 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 1839 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP45);
  }
   return;

;
}

static void GenNLFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP47)
# else
(yyP47)
 register tTree yyP47;
# endif
{
  if (yyP47->Kind == kAFormal) {
/* line 1846 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1846 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP47->AFormal.Type)))) goto yyL1;
  {
/* line 1847 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLFormals (yyP47->AFormal.Next);
  }
  }
   return;
yyL1:;

  if (yyP47->AFormal.Type->Kind == kArray) {
/* line 1850 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1850 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP47->AFormal.Sym)))) goto yyL2;
  {
/* line 1851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLArrayFormal (yyP47->AFormal.Type, yyP47->AFormal.Sym);
/* line 1852 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLFormals (yyP47->AFormal.Next);
  }
  }
   return;
yyL2:;

  }
/* line 1855 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1855 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP47->AFormal.Sym)))) goto yyL3;
  {
/* line 1856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP47->AFormal.Sym);
/* line 1856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 1856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP47->AFormal.Sym);
/* line 1856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1857 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLFormals (yyP47->AFormal.Next);
  }
  }
   return;
yyL3:;

/* line 1860 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLFormals (yyP47->AFormal.Next);
  }
   return;

  }
  if (yyP47->Kind == kNoFormal) {
/* line 1864 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenNLArrayFormal
# if defined __STDC__ | defined __cplusplus
(register tTree yyP49, tSymbol yyP48)
# else
(yyP49, yyP48)
 register tTree yyP49;
 tSymbol yyP48;
# endif
{
  if (yyP49->Kind == kArray) {
  if (yyP49->Array.Expr->Kind == kUnBound) {
/* line 1870 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1871 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP48);
/* line 1871 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 1871 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP49));
/* line 1871 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 1872 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP48);
/* line 1872 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 1872 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP49));
/* line 1872 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1872 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1873 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLArrayFormal (yyP49->Array.Type, yyP48);
  }
   return;

  }
/* line 1875 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNLArrayFormal (yyP49->Array.Type, yyP48);
  }
   return;

  }
/* line 1878 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1879 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP48);
/* line 1879 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 1879 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP48);
/* line 1879 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1879 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static bool AnyNLFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP50)
# else
(yyP50)
 register tTree yyP50;
# endif
{
  if (yyP50->Kind == kAFormal) {
/* line 1884 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1884 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP50->AFormal.Sym)))) goto yyL1;
  }
   return true;
yyL1:;

/* line 1885 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1885 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((AnyNLFormals (yyP50->AFormal.Next)))) goto yyL2;
  }
   return true;
yyL2:;

  }
  return false;
}

static void GenMVFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP53, register int yyP52, register bool yyP51)
# else
(yyP53, yyP52, yyP51)
 register tTree yyP53;
 register int yyP52;
 register bool yyP51;
# endif
{
  if (yyP53->Kind == kNoType) {
/* line 1892 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP53->Kind == kAType) {
  if (equalbool (yyP51, true)) {
/* line 1894 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1895 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 1896 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
   return;
yyL2:;

  }
/* line 1899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1900 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP53->AType.Type);
/* line 1900 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 1900 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 1900 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP52);
/* line 1901 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenMVFormals (yyP53->AType.Next, yyP52 + 1, true);
  }
   return;

  }
;
}

static void GenMVFResult
# if defined __STDC__ | defined __cplusplus
(register tTree yyP55, register int yyP54)
# else
(yyP55, yyP54)
 register tTree yyP55;
 register int yyP54;
# endif
{
  if (yyP55->Kind == kNoExpr) {
/* line 1906 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP55->Kind == kAnExpr) {
/* line 1907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 1907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 1907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP54);
/* line 1907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 1907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP55->AnExpr.Expr);
/* line 1907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 1907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenMVFResult (yyP55->AnExpr.Next, yyP54 + 1);
  }
   return;

  }
;
}

static bool NeedsChain
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP56)
# else
(yyP56)
 tSymbol yyP56;
# endif
{
/* line 1912 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1912 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((SymbolDepth (yyP56) != 0))) goto yyL1;
  {
/* line 1912 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP56)))) goto yyL1;
  }
  }
   return true;
yyL1:;

  return false;
}

static void GenProcess
# if defined __STDC__ | defined __cplusplus
(register tTree yyP57)
# else
(yyP57)
 register tTree yyP57;
# endif
{
/* line 1920 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int le,ls,lab,endlab; 

  switch (yyP57->Kind) {
  case kAssign:
/* line 1923 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1925 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP57->Assign.SpecList, NoTree, false);
/* line 1926 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->Assign.Pos);
/* line 1927 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeAssign (yyP57->Assign.Lval, yyP57->Assign.Rval);
/* line 1928 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP57->Assign.SpecList);
/* line 1929 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  case kCCode:
/* line 1933 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1935 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP57->CCode.SpecList, NoTree, false);
/* line 1936 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->CCode.Pos);
/* line 1937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteCCode (yyP57->CCode.Code, yyP57->CCode.Pos, yyP57 -> CCode . Scope);
/* line 1938 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP57->CCode.SpecList);
/* line 1939 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  case kInstance:
/* line 1943 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1945 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP57->Instance.SpecList, NoTree, false);
/* line 1946 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->Instance.Pos);
/* line 1947 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInstance (SymbolKind (yyP57->Instance.Sym), yyP57->Instance.ExprList, yyP57 -> Instance . Frame -> CallFrame . Id);
/* line 1948 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP57->Instance.SpecList);
  }
   return;

  case kWhile:
/* line 1952 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1952 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProcess (yyP57)))) goto yyL4;
  {
/* line 1954 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP57->While.SpecList, NoTree, false);
/* line 1955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->While.Pos);
/* line 1956 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("while (");
/* line 1956 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP57->While.Expr);
/* line 1956 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
/* line 1956 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1957 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 1957 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1958 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP57->While.Process);
/* line 1959 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->While.Pos);
/* line 1960 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 1960 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 1961 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP57->While.SpecList);
/* line 1962 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL4:;

/* line 1966 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1968 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   le = NewLabel ();
/* line 1968 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ls = NewLabel ();
/* line 1969 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP57->While.SpecList);
/* line 1970 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->While.Pos);
/* line 1971 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO(");
/* line 1971 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (le);
/* line 1971 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 1971 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1972 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (ls);
/* line 1973 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP57->While.Process);
/* line 1974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->While.Pos);
/* line 1975 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (le);
/* line 1976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (");
/* line 1976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP57->While.Expr);
/* line 1976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
/* line 1976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1977 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 1977 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1978 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO(");
/* line 1978 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (ls);
/* line 1978 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 1979 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 1979 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 1979 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1980 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP57->While.SpecList);
  }
   return;

  case kCase:
/* line 1984 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1984 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProcess (yyP57)))) goto yyL6;
  {
/* line 1986 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP57->Case.SpecList, NoTree, false);
/* line 1987 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->Case.Pos);
/* line 1988 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("switch(");
/* line 1988 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP57->Case.Selector);
/* line 1988 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
/* line 1988 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1989 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 1989 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 1990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseAtomic (yyP57->Case.ChoiceList);
/* line 1991 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 1991 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 1991 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 1992 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP57->Case.SpecList);
  }
  }
   return;
yyL6:;

/* line 1996 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 1998 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 1999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP57->Case.SpecList);
/* line 2000 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->Case.Pos);
/* line 2001 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("switch(");
/* line 2001 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP57->Case.Selector);
/* line 2001 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
/* line 2001 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2002 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2002 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2003 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2003 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseSwitches (yyP57->Case.ChoiceList);
/* line 2004 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2004 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2004 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2005 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("break;");
/* line 2005 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2006 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseCode (yyP57->Case.ChoiceList, lab);
/* line 2007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2008 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP57->Case.SpecList);
  }
   return;

  case kIfType:
  case kIf:
  case kIfRep:
/* line 2012 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2012 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProcess (yyP57)))) goto yyL8;
  {
/* line 2014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BackIfType (yyP57) = NULL;
/* line 2015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfTypeAtomic (yyP57, false);
  }
  }
   return;
yyL8:;

/* line 2019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2021 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2022 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfType (yyP57, lab);
/* line 2023 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("SETERR(MSG_IF);");
/* line 2023 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2024 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
   return;

  case kSkip:
/* line 2028 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2030 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP57->Skip.SpecList, NoTree, false);
/* line 2031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->Skip.Pos);
/* line 2032 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP57->Skip.SpecList);
  }
   return;

  case kStop:
/* line 2036 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2038 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP57->Stop.SpecList, NoTree, false);
/* line 2039 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->Stop.Pos);
/* line 2040 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("SETERR(MSG_STOP);");
/* line 2041 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2042 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP57->Stop.SpecList);
  }
   return;

  case kSeq:
/* line 2046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProcess (yyP57)))) goto yyL12;
  {
/* line 2048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP57->Seq.SpecList, NoTree, false);
/* line 2049 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->Seq.Pos);
/* line 2050 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2050 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2050 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2051 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcList (yyP57->Seq.ProcList);
/* line 2052 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2052 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2052 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2053 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP57->Seq.SpecList);
  }
  }
   return;
yyL12:;

/* line 2057 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP57->Seq.SpecList);
/* line 2060 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->Seq.Pos);
/* line 2061 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcList (yyP57->Seq.ProcList);
/* line 2062 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP57->Seq.SpecList);
  }
   return;

  case kSeqRep:
/* line 2066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP57->SeqRep.Replicator->Replicator.For)))) goto yyL14;
  {
/* line 2066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((ValConstInt (yyP57->SeqRep.Replicator->Replicator.For) == 0))) goto yyL14;
  }
  }
   return;
yyL14:;

/* line 2069 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2069 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProcess (yyP57)))) goto yyL15;
  {
/* line 2071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP57->SeqRep.SpecList, yyP57->SeqRep.Replicator, false);
/* line 2072 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->SeqRep.Pos);
/* line 2073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenForLoop (yyP57->SeqRep.Replicator);
/* line 2074 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2074 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2074 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP57->SeqRep.Process);
/* line 2076 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2076 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2076 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2077 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->SeqRep.Pos);
/* line 2078 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP57->SeqRep.SpecList);
  }
  }
   return;
yyL15:;

/* line 2082 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2084 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP57->SeqRep.SpecList);
/* line 2085 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->SeqRep.Pos);
/* line 2086 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   le = GenRepStart (yyP57->SeqRep.Replicator);
/* line 2087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ls = NewLabel ();
/* line 2088 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (ls);
/* line 2089 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP57->SeqRep.Process);
/* line 2090 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->SeqRep.Pos);
/* line 2091 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenRepEnd (yyP57->SeqRep.Replicator, ls, le);
/* line 2092 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP57->SeqRep.SpecList);
  }
   return;

  case kInput:
/* line 2096 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2096 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (ElementType (yyP57->Input.Element))))) goto yyL17;
  {
/* line 2098 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP57->Input.SpecList, NoTree, false);
/* line 2099 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->Input.Pos);
/* line 2100 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenTimerInput (yyP57->Input.ExprList);
/* line 2101 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP57->Input.SpecList);
  }
  }
   return;
yyL17:;

/* line 2117 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2117 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP57->Input.SpecList);
/* line 2117 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->Input.Pos);
/* line 2117 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInput (yyP57->Input.Element, ElementType (yyP57->Input.Element), yyP57->Input.ExprList);
/* line 2117 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP57->Input.SpecList);
  }
   return;

  case kAfter:
/* line 2108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2109 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP57->After.SpecList);
/* line 2110 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->After.Pos);
/* line 2111 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("DELAY(");
/* line 2112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP57->After.Expr);
/* line 2112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 2112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2113 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2114 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP57->After.SpecList);
  }
   return;

  case kOutput:
/* line 2119 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2119 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP57->Output.SpecList);
/* line 2119 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->Output.Pos);
/* line 2119 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOutput (yyP57->Output.Element, ElementType (yyP57->Output.Element) -> Chan . Protocol, yyP57->Output.ExprList);
/* line 2119 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP57->Output.SpecList);
  }
   return;

  case kAltType:
  case kAlt:
  case kAltRep:
/* line 2121 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 {
  register tTree yyV1;
  {
/* line 2123 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP57->AltType.SpecList);
/* line 2124 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->AltType.Pos);
/* line 2125 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ALT();");
/* line 2125 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2126 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEnableAltType (yyP57);
/* line 2128 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2129 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ALTWT(");
/* line 2129 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 2129 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2129 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2130 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2133 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("BOOL OLDTMP=false, TMP = false;");
/* line 2133 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2134 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDisableAltType (yyP57);
/* line 2135 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAssignRepsAltType (yyP57);
/* line 2136 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2136 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2136 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2138 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ALTEND();");
/* line 2140 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   endlab = NewLabel ();
/* line 2141 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kNoSpec)
   GenCodeAltType (yyP57, endlab, yyV1);
/* line 2142 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (endlab);
/* line 2143 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP57->AltType.SpecList);
  }
   return;
 }

  case kCaseIn:
/* line 2147 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2149 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   le = NewLabel ();
/* line 2150 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP57->CaseIn.SpecList);
/* line 2151 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->CaseIn.Pos);
/* line 2152 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INPUT1(");
/* line 2152 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP57->CaseIn.Element, false);
/* line 2152 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->_Header.Temp.VBYTE,");
/* line 2152 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (le);
/* line 2152 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2152 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2154 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (le);
/* line 2155 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   le = NewLabel ();
/* line 2156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("switch(FP->_Header.Temp.VBYTE)");
/* line 2156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2157 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2157 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2158 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2158 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseInSwitches (yyP57->CaseIn.CaseList);
/* line 2159 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2159 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2159 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2160 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("break;");
/* line 2160 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2161 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseInCode (yyP57->CaseIn.CaseList, yyP57->CaseIn.Element, le);
/* line 2162 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (le);
/* line 2163 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP57->CaseIn.SpecList);
  }
   return;

  case kPar:
  if (yyP57->Par.ProcList->Kind == kNoProcess) {
/* line 2167 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2169 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP57->Par.SpecList);
/* line 2170 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->Par.Pos);
/* line 2171 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP57->Par.SpecList);
  }
   return;

  }
/* line 2174 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2174 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP57->Par.PType == xxPlacedPar))) goto yyL24;
  {
/* line 2176 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2177 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP57->Par.SpecList);
/* line 2178 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->Par.Pos);
/* line 2179 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenPlacedList (yyP57->Par.ProcList, NoSymbol, NoTree);
/* line 2180 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("WAITP(");
/* line 2180 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 2180 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2180 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2181 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2182 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP57->Par.SpecList);
  }
  }
   return;
yyL24:;

/* line 2206 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2208 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2209 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP57->Par.SpecList);
/* line 2210 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->Par.Pos);
/* line 2211 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParList (yyP57->Par.ProcList, yyP57->Par.PType ? HIPRI : LOPRI);
/* line 2212 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("WAITP(");
/* line 2212 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 2212 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2212 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2213 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2214 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP57->Par.SpecList);
  }
   return;

  case kParRep:
/* line 2186 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2186 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP57->ParRep.Replicator->Replicator.For)))) goto yyL25;
  {
/* line 2186 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((ValConstInt (yyP57->ParRep.Replicator->Replicator.For) == 0))) goto yyL25;
  }
  }
   return;
yyL25:;

/* line 2189 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2189 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP57->ParRep.PType == xxPlacedPar))) goto yyL26;
  {
/* line 2191 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2192 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP57->ParRep.SpecList, yyP57->ParRep.Replicator, false);
/* line 2193 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->ParRep.Pos);
/* line 2194 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenForLoop (yyP57->ParRep.Replicator);
/* line 2195 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2195 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2195 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2196 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenPlaced (yyP57->ParRep.Process, yyP57->ParRep.Replicator->Replicator.Sym, yyP57->ParRep.Replicator->Replicator.From);
/* line 2197 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->ParRep.Pos);
/* line 2198 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2198 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2198 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2199 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP57->ParRep.SpecList);
/* line 2200 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("WAITP(");
/* line 2200 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 2200 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2200 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2201 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2202 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP57->ParRep.SpecList);
  }
  }
   return;
yyL26:;

  if (yyP57->ParRep.Process->Kind == kInstance) {
/* line 2218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2220 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2221 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP57->ParRep.SpecList, yyP57->ParRep.Replicator, false);
/* line 2222 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->ParRep.Pos);
/* line 2223 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenForLoop (yyP57->ParRep.Replicator);
/* line 2224 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2224 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2225 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP57->ParRep.PType == xxPriPar))) goto yyL28;
  {
/* line 2226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (");
/* line 2226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP57->ParRep.Replicator->Replicator.Sym);
/* line 2226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("==");
/* line 2226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (ValConstInt (yyP57->ParRep.Replicator->Replicator.From));
/* line 2226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (") ");
/* line 2226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2227 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2227 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2227 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2228 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParProc (yyP57->ParRep.Process, yyP57->ParRep.Replicator->Replicator.Sym, HIPRI, yyP57->ParRep.Replicator->Replicator.From);
/* line 2229 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2229 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2229 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2230 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->ParRep.Pos);
/* line 2231 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("else ");
/* line 2231 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2232 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL28;
  }
  }
   return;
yyL28:;

/* line 2236 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2238 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2238 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2238 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParProc (yyP57->ParRep.Process, yyP57->ParRep.Replicator->Replicator.Sym, LOPRI, yyP57->ParRep.Replicator->Replicator.From);
/* line 2240 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP57->ParRep.Pos);
/* line 2241 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2241 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2241 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2242 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP57->ParRep.SpecList);
/* line 2243 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("WAITP(");
/* line 2243 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 2243 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2243 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2244 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP57->ParRep.SpecList);
  }
   return;

  }
  break;
  }

/* line 2252 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2252 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP57, yyP57->Process.Pos);
  }
   return;

;
}

static void GenProcList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP58)
# else
(yyP58)
 register tTree yyP58;
# endif
{
  if (yyP58->Kind == kAProcess) {
/* line 2256 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2256 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP58->AProcess.Process);
/* line 2256 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcList (yyP58->AProcess.Next);
  }
   return;

  }
  if (yyP58->Kind == kNoProcess) {
/* line 2257 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenParList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP60, register int yyP59)
# else
(yyP60, yyP59)
 register tTree yyP60;
 register int yyP59;
# endif
{
  if (yyP60->Kind == kAProcess) {
  if (yyP60->AProcess.Process->Kind == kInstance) {
/* line 2261 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2262 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParProc (yyP60->AProcess.Process, NoSymbol, yyP59, NoTree);
/* line 2263 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParList (yyP60->AProcess.Next, LOPRI);
  }
   return;

  }
  }
  if (yyP60->Kind == kNoProcess) {
/* line 2266 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenParProc
# if defined __STDC__ | defined __cplusplus
(register tTree yyP64, tSymbol yyP63, register int yyP62, register tTree yyP61)
# else
(yyP64, yyP63, yyP62, yyP61)
 register tTree yyP64;
 tSymbol yyP63;
 register int yyP62;
 register tTree yyP61;
# endif
{
/* line 2271 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 tTree Frame; 
/* line 2273 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2273 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP63 != NoSymbol))) goto yyL1;
  {
/* line 2274 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParProcParam (Symbol (yyP64->Instance.Sym) . Kind -> DefProc . Formals, yyP64->Instance.ExprList, yyP64 -> Instance . Frame -> ParFrame . FId, yyP63, yyP61);
/* line 2275 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
  }
   return;
yyL1:;

/* line 2278 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2279 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Frame = yyP64 -> Instance . Frame;
/* line 2280 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP64->Instance.Pos);
/* line 2281 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("STARTP(");
/* line 2282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
   return;
yyL2:;

/* line 2285 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2285 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP63 == NoSymbol))) goto yyL3;
  {
/* line 2286 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&FP->");
/* line 2286 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Frame -> ParFrame . TId);
/* line 2286 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2286 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP64->Instance.Sym);
/* line 2287 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->");
/* line 2287 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Frame -> ParFrame . FId);
/* line 2287 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",\"");
/* line 2287 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (Frame -> CallFrame . Sym);
/* line 2287 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\",");
/* line 2287 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP62);
/* line 2287 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2287 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL3:;

/* line 2290 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2291 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&FP->");
/* line 2291 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Frame -> ParFrame . TId);
/* line 2292 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 2292 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP63) . Kind, yyP63, false);
/* line 2292 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("-");
/* line 2292 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP61);
/* line 2292 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 2292 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2292 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP64->Instance.Sym);
/* line 2293 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->");
/* line 2293 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Frame -> ParFrame . FId);
/* line 2294 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 2294 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP63) . Kind, yyP63, false);
/* line 2294 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("-");
/* line 2294 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP61);
/* line 2294 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 2295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",\"");
/* line 2295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (Frame -> CallFrame . Sym);
/* line 2295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\",");
/* line 2295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP62);
/* line 2295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenPlacedList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP67, tSymbol yyP66, register tTree yyP65)
# else
(yyP67, yyP66, yyP65)
 register tTree yyP67;
 tSymbol yyP66;
 register tTree yyP65;
# endif
{
  if (yyP67->Kind == kAProcess) {
/* line 2302 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2302 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenPlaced (yyP67->AProcess.Process, yyP66, yyP65);
/* line 2302 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenPlacedList (yyP67->AProcess.Next, yyP66, yyP65);
  }
   return;

  }
  if (yyP67->Kind == kNoProcess) {
/* line 2303 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenPlaced
# if defined __STDC__ | defined __cplusplus
(register tTree yyP70, tSymbol yyP69, register tTree yyP68)
# else
(yyP70, yyP69, yyP68)
 register tTree yyP70;
 tSymbol yyP69;
 register tTree yyP68;
# endif
{
/* line 2307 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 tFrame Frame; 
  if (yyP70->Kind == kPar) {
/* line 2309 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2311 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP70->Par.SpecList);
/* line 2312 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP70->Par.Pos);
/* line 2313 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenPlacedList (yyP70->Par.ProcList, yyP69, yyP68);
/* line 2314 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP70->Par.SpecList);
  }
   return;

  }
  if (yyP70->Kind == kParRep) {
/* line 2318 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2318 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP69 == NoSymbol))) goto yyL2;
  {
/* line 2320 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP70->ParRep.SpecList, yyP70->ParRep.Replicator, false);
/* line 2321 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP70->ParRep.Pos);
/* line 2322 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenForLoop (yyP70->ParRep.Replicator);
/* line 2323 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2323 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2323 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2324 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenPlaced (yyP70->ParRep.Process, yyP70->ParRep.Replicator->Replicator.Sym, yyP70->ParRep.Replicator->Replicator.From);
/* line 2325 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP70->ParRep.Pos);
/* line 2326 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2326 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2326 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2327 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP70->ParRep.SpecList);
  }
  }
   return;
yyL2:;

/* line 2331 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2332 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP70, yyP70->ParRep.Pos);
  }
   return;

  }
  if (yyP70->Kind == kProcessor) {
  if (yyP70->Processor.Process->Kind == kInstance) {
/* line 2335 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2335 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP69 != NoSymbol))) goto yyL4;
  {
/* line 2336 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParProcParam (Symbol (yyP70->Processor.Process->Instance.Sym) . Kind -> DefProc . Formals, yyP70->Processor.Process->Instance.ExprList, yyP70->Processor.Process -> Instance . Frame -> ParFrame . FId, yyP69, yyP68);
/* line 2337 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL4;
  }
  }
   return;
yyL4:;

/* line 2340 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2341 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Frame = yyP70->Processor.Process -> Instance . Frame;
/* line 2342 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP70->Processor.Process->Instance.Pos);
/* line 2343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("PLACED_STARTP(");
/* line 2344 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodePlacedExpr (yyP70->Processor.Expr, yyP69, yyP68);
/* line 2344 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2345 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL5;
  }
   return;
yyL5:;

/* line 2348 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2348 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP69 == NoSymbol))) goto yyL6;
  {
/* line 2349 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&FP->");
/* line 2349 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Frame -> ParFrame . TId);
/* line 2349 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2349 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP70->Processor.Process->Instance.Sym);
/* line 2350 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->");
/* line 2350 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Frame -> ParFrame . FId);
/* line 2350 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",\"");
/* line 2350 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (Frame -> CallFrame . Sym);
/* line 2350 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\");");
/* line 2350 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL6:;

/* line 2353 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&FP->");
/* line 2354 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Frame -> ParFrame . TId);
/* line 2355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 2355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP69);
/* line 2355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("-");
/* line 2355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP68);
/* line 2355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 2355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2355 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP70->Processor.Process->Instance.Sym);
/* line 2356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->");
/* line 2356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Frame -> ParFrame . FId);
/* line 2357 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 2357 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP69);
/* line 2357 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("-");
/* line 2357 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP68);
/* line 2357 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 2358 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",\"");
/* line 2358 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (Frame -> CallFrame . Sym);
/* line 2358 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\");");
/* line 2358 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
/* line 2361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP70, yyP70->Process.Pos);
  }
   return;

;
}

static void CodePlacedExpr
# if defined __STDC__ | defined __cplusplus
(register tTree EX, tSymbol yyP72, register tTree yyP71)
# else
(EX, yyP72, yyP71)
 register tTree EX;
 tSymbol yyP72;
 register tTree yyP71;
# endif
{
  if (EX->Kind == kElementalExpr) {
  if (EX->ElementalExpr.Elemental->Kind == kIdentifier) {
/* line 2366 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2367 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP72);
/* line 2367 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("-");
/* line 2367 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP71);
  }
   return;

  }
  }
  if (EX->Kind == kConst) {
/* line 2370 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2371 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (EX);
  }
   return;

  }
/* line 2374 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2375 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (EX, EX->Expr.Pos);
  }
   return;

;
}

static void GenParProcParam
# if defined __STDC__ | defined __cplusplus
(register tTree yyP77, register tTree yyP76, register tIdent yyP75, tSymbol yyP74, register tTree yyP73)
# else
(yyP77, yyP76, yyP75, yyP74, yyP73)
 register tTree yyP77;
 register tTree yyP76;
 register tIdent yyP75;
 tSymbol yyP74;
 register tTree yyP73;
# endif
{
  if (yyP77->Kind == kAFormal) {
  if (yyP77->AFormal.By->Kind == kByVal) {
  if (yyP76->Kind == kAnExpr) {
/* line 2382 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 2383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP75);
/* line 2383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 2383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP74) . Kind, yyP74, false);
/* line 2383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("-");
/* line 2383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP73);
/* line 2383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 2384 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 2384 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP77->AFormal.Sym);
/* line 2384 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 2384 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP76->AnExpr.Expr);
/* line 2384 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 2384 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
  }
;
}

static void GenEnableAltType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP78)
# else
(yyP78)
 register tTree yyP78;
# endif
{
  if (yyP78->Kind == kAlt) {
/* line 2392 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2392 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEnableAltList (yyP78->Alt.AltList);
  }
   return;

  }
  if (yyP78->Kind == kAltRep) {
/* line 2394 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2395 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP78->AltRep.Pos);
/* line 2396 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenForLoop (yyP78->AltRep.Replicator);
/* line 2397 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2397 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2397 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2398 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEnableAltList (yyP78->AltRep.AltList);
/* line 2399 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP78->AltRep.Pos);
/* line 2400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenEnableAltList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP79)
# else
(yyP79)
 register tTree yyP79;
# endif
{
  if (yyP79->Kind == kNoAlt) {
/* line 2406 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP79->Kind == kAnAlt) {
/* line 2408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2409 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP79->AnAlt.SpecList);
/* line 2410 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEnableGuard (yyP79->AnAlt.Guard);
/* line 2411 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEnableAltList (yyP79->AnAlt.Next);
/* line 2412 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP79->AnAlt.SpecList);
  }
   return;

  }
  if (yyP79->Kind == kANewAlt) {
/* line 2415 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2416 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP79->ANewAlt.SpecList);
/* line 2417 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalInits (yyP79->ANewAlt.AltType->AltType.SpecList);
/* line 2418 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEnableAltType (yyP79->ANewAlt.AltType);
/* line 2419 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEnableAltList (yyP79->ANewAlt.Next);
/* line 2420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResults (yyP79->ANewAlt.AltType->AltType.SpecList);
/* line 2421 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP79->ANewAlt.SpecList);
  }
   return;

  }
;
}

static void GenEnableGuard
# if defined __STDC__ | defined __cplusplus
(register tTree yyP80)
# else
(yyP80)
 register tTree yyP80;
# endif
{
  if (yyP80->Kind == kAltInput) {
/* line 2427 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2427 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimer (yyP80->AltInput.Input->Input.Element)))) goto yyL1;
  {
/* line 2428 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ENBS(");
/* line 2428 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP80->AltInput.Expr);
/* line 2429 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2429 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL1:;

/* line 2432 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2433 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ENBC(");
/* line 2433 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP80->AltInput.Expr);
/* line 2434 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2434 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP80->AltInput.Input->Input.Element, false);
/* line 2435 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2435 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP80->Kind == kAltTimer) {
/* line 2438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2439 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ENBT(");
/* line 2439 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP80->AltTimer.Expr);
/* line 2440 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2440 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP80->AltTimer.After->After.Expr);
/* line 2441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP80->Kind == kAltCaseIn) {
/* line 2444 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2445 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ENBC(");
/* line 2445 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP80->AltCaseIn.Expr);
/* line 2446 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2446 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP80->AltCaseIn.CaseIn->CaseIn.Element, false);
/* line 2447 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2447 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP80->Kind == kNoInput) {
/* line 2450 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2451 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ENBS(");
/* line 2451 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP80->NoInput.Expr);
/* line 2452 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2452 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenDisableAltType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP81)
# else
(yyP81)
 register tTree yyP81;
# endif
{
  if (yyP81->Kind == kAlt) {
/* line 2459 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2459 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDisableAltList (yyP81->Alt.AltList);
  }
   return;

  }
  if (yyP81->Kind == kAltRep) {
/* line 2461 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2462 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2462 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2462 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2463 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("BOOL OLDTMP = TMP;");
/* line 2463 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2464 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenForLoop (yyP81->AltRep.Replicator);
/* line 2465 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2465 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2465 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2466 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDisableAltList (yyP81->AltRep.AltList);
/* line 2467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (TMP && (!OLDTMP))");
/* line 2467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAltSelect (yyP81->AltRep.Replicator);
/* line 2467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 2467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAltIndex (yyP81->AltRep.Replicator);
/* line 2467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 2467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2468 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OLDTMP=TMP;");
/* line 2468 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2470 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2470 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2470 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenDisableAltList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP82)
# else
(yyP82)
 register tTree yyP82;
# endif
{
  if (yyP82->Kind == kNoAlt) {
/* line 2477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP82->Kind == kAnAlt) {
/* line 2479 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2480 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP82->AnAlt.SpecList);
/* line 2481 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP82 -> AnAlt . Label = NewLabel ();
/* line 2482 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDisableGuard (yyP82->AnAlt.Guard, yyP82 -> AnAlt . Label);
/* line 2483 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDisableAltList (yyP82->AnAlt.Next);
/* line 2484 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP82->AnAlt.SpecList);
  }
   return;

  }
  if (yyP82->Kind == kANewAlt) {
/* line 2487 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2488 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP82->ANewAlt.SpecList);
/* line 2489 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalInits (yyP82->ANewAlt.AltType->AltType.SpecList);
/* line 2490 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDisableAltType (yyP82->ANewAlt.AltType);
/* line 2491 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDisableAltList (yyP82->ANewAlt.Next);
/* line 2492 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResults (yyP82->ANewAlt.AltType->AltType.SpecList);
/* line 2493 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP82->ANewAlt.SpecList);
  }
   return;

  }
;
}

static void GenDisableGuard
# if defined __STDC__ | defined __cplusplus
(register tTree yyP84, register int yyP83)
# else
(yyP84, yyP83)
 register tTree yyP84;
 register int yyP83;
# endif
{
  if (yyP84->Kind == kAltInput) {
/* line 2499 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2499 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimer (yyP84->AltInput.Input->Input.Element)))) goto yyL1;
  {
/* line 2500 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OLDTMP=TMP; TMP |= ");
/* line 2501 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("DISS(");
/* line 2501 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP83);
/* line 2502 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2502 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP84->AltInput.Expr);
/* line 2503 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2503 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL1:;

/* line 2506 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2507 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OLDTMP=TMP; TMP |= ");
/* line 2508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("DISC(");
/* line 2508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP83);
/* line 2509 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2509 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP84->AltInput.Expr);
/* line 2510 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2510 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP84->AltInput.Input->Input.Element, false);
/* line 2511 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2511 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP84->Kind == kAltTimer) {
/* line 2514 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2515 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OLDTMP=TMP; TMP |= ");
/* line 2516 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("DIST(");
/* line 2516 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP83);
/* line 2517 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2517 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP84->AltTimer.Expr);
/* line 2518 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2518 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP84->AltTimer.After->After.Expr);
/* line 2519 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2519 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP84->Kind == kAltCaseIn) {
/* line 2522 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OLDTMP=TMP; TMP |= ");
/* line 2524 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("DISC(");
/* line 2524 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP83);
/* line 2525 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2525 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP84->AltCaseIn.Expr);
/* line 2526 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2526 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP84->AltCaseIn.CaseIn->CaseIn.Element, false);
/* line 2527 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2527 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP84->Kind == kNoInput) {
/* line 2530 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2531 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OLDTMP=TMP; TMP |= ");
/* line 2532 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("DISS(");
/* line 2532 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP83);
/* line 2533 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 2533 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP84->NoInput.Expr);
/* line 2534 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2534 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenAssignRepsAltType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP85)
# else
(yyP85)
 register tTree yyP85;
# endif
{
  if (yyP85->Kind == kAlt) {
/* line 2541 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2541 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAssignRepsAltList (yyP85->Alt.AltList);
  }
   return;

  }
  if (yyP85->Kind == kAltRep) {
/* line 2543 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2544 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAltIndex (yyP85->AltRep.Replicator);
/* line 2544 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 2544 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAltSelect (yyP85->AltRep.Replicator);
/* line 2544 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 2544 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2545 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAssignRepsAltList (yyP85->AltRep.AltList);
  }
   return;

  }
;
}

static void GenAssignRepsAltList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP86)
# else
(yyP86)
 register tTree yyP86;
# endif
{
  if (yyP86->Kind == kNoAlt) {
/* line 2551 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP86->Kind == kAnAlt) {
/* line 2553 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2554 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAssignRepsAltList (yyP86->AnAlt.Next);
  }
   return;

  }
  if (yyP86->Kind == kANewAlt) {
/* line 2557 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2558 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAssignRepsAltType (yyP86->ANewAlt.AltType);
/* line 2559 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAssignRepsAltList (yyP86->ANewAlt.Next);
  }
   return;

  }
;
}

static tTree BuildRevSpecList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP88, register tTree yyP87)
# else
(yyP88, yyP87)
 register tTree yyP88;
 register tTree yyP87;
# endif
{
  if (yyP87->Kind == kNoSpec) {
/* line 2569 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP88;

  }
  if (yyP87->Kind == kASpec) {
/* line 2570 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kASpec)
    yyV1->ASpec.Spec = yyP87->ASpec.Spec;
    yyV1->ASpec.Next = yyP88;
   return BuildRevSpecList (yyV1, yyP87->ASpec.Next);
  }
 }

  }
 yyAbort ("BuildRevSpecList");
}

static void GenCodeAltType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP91, register int yyP90, register tTree yyP89)
# else
(yyP91, yyP90, yyP89)
 register tTree yyP91;
 register int yyP90;
 register tTree yyP89;
# endif
{
  if (yyP91->Kind == kAlt) {
/* line 2576 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2576 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCodeAltList (yyP91->Alt.AltList, yyP90, yyP89);
  }
   return;

  }
  if (yyP91->Kind == kAltRep) {
/* line 2578 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2579 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCodeAltList (yyP91->AltRep.AltList, yyP90, yyP89);
  }
   return;

  }
;
}

static void GenCodeAltList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP94, register int yyP93, register tTree yyP92)
# else
(yyP94, yyP93, yyP92)
 register tTree yyP94;
 register int yyP93;
 register tTree yyP92;
# endif
{
/* line 2590 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 tTree UnreversedSL; 
  if (yyP94->Kind == kNoAlt) {
/* line 2592 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP94->Kind == kAnAlt) {
/* line 2594 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2595 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (yyP94 -> AnAlt . Label);
/* line 2596 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   UnreversedSL = ReverseTree (yyP92);
/* line 2597 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalInits (UnreversedSL);
/* line 2598 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP94->AnAlt.SpecList);
/* line 2599 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCodeGuard (yyP94->AnAlt.Guard);
/* line 2600 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP94->AnAlt.SpecList);
/* line 2601 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResults (UnreversedSL);
/* line 2602 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO(");
/* line 2602 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP93);
/* line 2602 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2603 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReverseTree (UnreversedSL);
/* line 2604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCodeAltList (yyP94->AnAlt.Next, yyP93, yyP92);
  }
   return;

  }
  if (yyP94->Kind == kANewAlt) {
/* line 2607 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2608 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCodeAltType (yyP94->ANewAlt.AltType, yyP93, BuildRevSpecList (BuildRevSpecList (yyP92, yyP94->ANewAlt.SpecList), yyP94->ANewAlt.AltType->AltType.SpecList));
/* line 2609 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCodeAltList (yyP94->ANewAlt.Next, yyP93, yyP92);
  }
   return;

  }
;
}

static void GenCodeGuard
# if defined __STDC__ | defined __cplusplus
(register tTree yyP95)
# else
(yyP95)
 register tTree yyP95;
# endif
{
/* line 2614 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int lab; 
  if (yyP95->Kind == kAltInput) {
/* line 2616 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2617 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP95->AltInput.Input->Input.SpecList);
/* line 2618 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInput (yyP95->AltInput.Input->Input.Element, ElementType (yyP95->AltInput.Input->Input.Element), yyP95->AltInput.Input->Input.ExprList);
/* line 2619 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP95->AltInput.Process);
/* line 2620 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP95->AltInput.Input->Input.SpecList);
  }
   return;

  }
  if (yyP95->Kind == kAltTimer) {
/* line 2622 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2623 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP95->AltTimer.After->After.SpecList);
/* line 2624 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP95->AltTimer.Process);
/* line 2625 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP95->AltTimer.After->After.SpecList);
  }
   return;

  }
  if (yyP95->Kind == kAltCaseIn) {
/* line 2627 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2628 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2629 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP95->AltCaseIn.CaseIn->CaseIn.SpecList);
/* line 2630 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INPUT1(");
/* line 2630 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP95->AltCaseIn.CaseIn->CaseIn.Element, false);
/* line 2630 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->_Header.Temp.VBYTE,");
/* line 2630 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 2630 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2630 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2632 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2633 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 2634 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("switch(FP->_Header.Temp.VBYTE)");
/* line 2634 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2635 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2635 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2636 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2636 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseInSwitches (yyP95->AltCaseIn.CaseIn->CaseIn.CaseList);
/* line 2637 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2637 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2637 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2638 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("break;");
/* line 2638 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2639 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseInCode (yyP95->AltCaseIn.CaseIn->CaseIn.CaseList, yyP95->AltCaseIn.CaseIn->CaseIn.Element, lab);
/* line 2640 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 2641 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP95->AltCaseIn.CaseIn->CaseIn.SpecList);
  }
   return;

  }
  if (yyP95->Kind == kNoInput) {
/* line 2643 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2644 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP95->NoInput.Process);
  }
   return;

  }
;
}

static void GenIfType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP97, register int yyP96)
# else
(yyP97, yyP96)
 register tTree yyP97;
 register int yyP96;
# endif
{
/* line 2653 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int le,ls; 
  if (yyP97->Kind == kIf) {
/* line 2655 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2656 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP97->If.SpecList);
/* line 2657 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP97->If.Pos);
/* line 2658 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfList (yyP97->If.ChoiceList, yyP96);
/* line 2659 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP97->If.SpecList);
  }
   return;

  }
  if (yyP97->Kind == kIfRep) {
/* line 2662 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2663 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   le = GenRepStart (yyP97->IfRep.Replicator);
/* line 2664 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ls = NewLabel ();
/* line 2665 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (ls);
/* line 2666 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP97->IfRep.SpecList);
/* line 2667 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP97->IfRep.Pos);
/* line 2668 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfList (yyP97->IfRep.ChoiceList, yyP96);
/* line 2669 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenRepEnd (yyP97->IfRep.Replicator, ls, le);
/* line 2670 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP97->IfRep.SpecList);
  }
   return;

  }
;
}

static void GenIfList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP99, register int yyP98)
# else
(yyP99, yyP98)
 register tTree yyP99;
 register int yyP98;
# endif
{
/* line 2675 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int nlab; 
  if (yyP99->Kind == kAChoice) {
  if (yyP99->AChoice.ExprList->Kind == kAnExpr) {
  if (yyP99->AChoice.ExprList->AnExpr.Next->Kind == kNoExpr) {
/* line 2677 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2678 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   nlab = NewLabel ();
/* line 2679 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP99->AChoice.SpecList);
/* line 2680 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP99->AChoice.ExprList->AnExpr.Expr->Expr.Pos);
/* line 2681 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (!");
/* line 2681 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP99->AChoice.ExprList->AnExpr.Expr);
/* line 2681 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (") GOTO(");
/* line 2681 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (nlab);
/* line 2681 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2681 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2682 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP99->AChoice.Process);
/* line 2683 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP99->AChoice.SpecList);
/* line 2684 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO(");
/* line 2684 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP98);
/* line 2684 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2684 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2685 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (nlab);
/* line 2686 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfList (yyP99->AChoice.Next, yyP98);
  }
   return;

  }
  }
  }
  if (yyP99->Kind == kANewIf) {
/* line 2689 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2690 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP99->ANewIf.SpecList);
/* line 2691 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfType (yyP99->ANewIf.IfType, yyP98);
/* line 2692 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfList (yyP99->ANewIf.Next, yyP98);
/* line 2693 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP99->ANewIf.SpecList);
  }
   return;

  }
  if (yyP99->Kind == kNoChoice) {
/* line 2696 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenIfTypeAtomic
# if defined __STDC__ | defined __cplusplus
(register tTree yyP101, register bool yyP100)
# else
(yyP101, yyP100)
 register tTree yyP101;
 register bool yyP100;
# endif
{
  if (yyP101->Kind == kIf) {
/* line 2705 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2706 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP101->If.SpecList, NoTree, false);
/* line 2707 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP101->If.Pos);
/* line 2708 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfListAtomic (yyP101, yyP101->If.ChoiceList, yyP100);
/* line 2709 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP101->If.SpecList);
  }
   return;

  }
  if (yyP101->Kind == kIfRep) {
/* line 2712 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2713 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP101->IfRep.SpecList, yyP101->IfRep.Replicator, false);
/* line 2714 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP101->IfRep.Pos);
/* line 2715 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenForLoop (yyP101->IfRep.Replicator);
/* line 2716 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2716 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2717 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfListAtomic (yyP101, yyP101->IfRep.ChoiceList, true);
/* line 2718 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("break;");
/* line 2718 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2719 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2719 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2719 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2720 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenForCheck (yyP101->IfRep.Replicator);
/* line 2721 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
   return;
yyL2:;

/* line 2723 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2723 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((BackIfType (yyP101) != NULL))) goto yyL3;
  {
/* line 2724 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfListAtomic (BackIfType (yyP101), BackChoiceList (yyP101), yyP100);
/* line 2725 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP101->IfRep.SpecList);
  }
  }
   return;
yyL3:;

  if (equalbool (yyP100, false)) {
/* line 2728 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2729 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2729 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2729 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("SETERR(MSG_IF);");
/* line 2729 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2729 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2729 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2730 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP101->IfRep.SpecList);
  }
   return;

  }
  if (equalbool (yyP100, true)) {
/* line 2733 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2734 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2734 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2734 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("continue;");
/* line 2734 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2734 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2734 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2735 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP101->IfRep.SpecList);
  }
   return;

  }
  }
;
}

static void GenIfListAtomic
# if defined __STDC__ | defined __cplusplus
(register tTree yyP104, register tTree yyP103, register bool yyP102)
# else
(yyP104, yyP103, yyP102)
 register tTree yyP104;
 register tTree yyP103;
 register bool yyP102;
# endif
{
  if (yyP103->Kind == kAChoice) {
  if (yyP103->AChoice.ExprList->Kind == kAnExpr) {
  if (yyP103->AChoice.ExprList->AnExpr.Next->Kind == kNoExpr) {
/* line 2744 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2745 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP103->AChoice.SpecList, NoTree, false);
/* line 2746 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP103->AChoice.ExprList->AnExpr.Expr->Expr.Pos);
/* line 2747 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (");
/* line 2747 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP103->AChoice.ExprList->AnExpr.Expr);
/* line 2747 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
/* line 2747 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2748 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2748 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2748 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP103->AChoice.Process);
/* line 2748 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2748 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2748 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2749 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("else");
/* line 2749 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2750 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfListAtomic (yyP104, yyP103->AChoice.Next, yyP102);
/* line 2751 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP103->AChoice.SpecList);
  }
   return;

  }
  }
  }
  if (yyP103->Kind == kANewIf) {
  if (yyP103->ANewIf.IfType->Kind == kIf) {
/* line 2754 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP103->ANewIf.SpecList, NoTree, false);
/* line 2756 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP103->ANewIf.IfType->If.Pos);
/* line 2757 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BackIfType (yyP103->ANewIf.IfType) = yyP104;
/* line 2758 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BackChoiceList (yyP103->ANewIf.IfType) = yyP103->ANewIf.Next;
/* line 2759 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfTypeAtomic (yyP103->ANewIf.IfType, yyP102);
/* line 2760 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP103->ANewIf.SpecList);
  }
   return;

  }
  if (yyP103->ANewIf.IfType->Kind == kIfRep) {
/* line 2763 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2764 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP103->ANewIf.SpecList, NoTree, false);
/* line 2765 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP103->ANewIf.IfType->IfRep.Pos);
/* line 2766 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BackIfType (yyP103->ANewIf.IfType) = yyP104;
/* line 2767 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BackChoiceList (yyP103->ANewIf.IfType) = yyP103->ANewIf.Next;
/* line 2768 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfTypeAtomic (yyP103->ANewIf.IfType, yyP102);
/* line 2769 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP103->ANewIf.SpecList);
  }
   return;

  }
  }
  if (yyP103->Kind == kNoChoice) {
/* line 2772 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2772 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((BackIfType (yyP104) != NULL))) goto yyL4;
  {
/* line 2772 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (yyP104, kIf)))) goto yyL4;
  {
/* line 2773 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIfListAtomic (BackIfType (yyP104), BackChoiceList (yyP104), yyP102);
  }
  }
  }
   return;
yyL4:;

  if (equalbool (yyP102, false)) {
/* line 2776 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2777 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2777 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2777 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("SETERR(MSG_IF);");
/* line 2777 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2777 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2777 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (equalbool (yyP102, true)) {
/* line 2780 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2781 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 2781 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 2781 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("continue;");
/* line 2781 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 2781 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 2781 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
;
}

static void GenCaseSwitches
# if defined __STDC__ | defined __cplusplus
(register tTree yyP105)
# else
(yyP105)
 register tTree yyP105;
# endif
{
/* line 2788 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int nlab; 
  if (yyP105->Kind == kAChoice) {
  if (yyP105->AChoice.Next->Kind == kNoChoice) {
  if (yyP105->AChoice.ExprList->Kind == kAnExpr) {
  if (yyP105->AChoice.ExprList->AnExpr.Expr->Kind == kDefault) {
/* line 2790 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2791 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   nlab = NewLabel ();
/* line 2792 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("default: GOTO(");
/* line 2792 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (nlab);
/* line 2792 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2792 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2793 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP105 -> AChoice . Label = nlab;
  }
   return;

  }
  }
  }
/* line 2796 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2797 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   nlab = NewLabel ();
/* line 2798 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseExprList (yyP105->AChoice.ExprList);
/* line 2799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO (");
/* line 2799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (nlab);
/* line 2799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2800 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP105 -> AChoice . Label = nlab;
/* line 2801 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseSwitches (yyP105->AChoice.Next);
  }
   return;

  }
  if (yyP105->Kind == kNoChoice) {
/* line 2804 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2805 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("default: SETERR(MSG_CASE);");
/* line 2805 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenCaseExprList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP106)
# else
(yyP106)
 register tTree yyP106;
# endif
{
  if (yyP106->Kind == kAnExpr) {
/* line 2811 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2812 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("case ");
/* line 2812 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP106->AnExpr.Expr);
/* line 2812 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (": ");
/* line 2813 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseExprList (yyP106->AnExpr.Next);
  }
   return;

  }
;
}

static void GenCaseCode
# if defined __STDC__ | defined __cplusplus
(register tTree yyP108, register int yyP107)
# else
(yyP108, yyP107)
 register tTree yyP108;
 register int yyP107;
# endif
{
  if (yyP108->Kind == kAChoice) {
/* line 2819 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2820 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (yyP108 -> AChoice . Label);
/* line 2821 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP108->AChoice.SpecList);
/* line 2822 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP108->AChoice.Process);
/* line 2823 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP108->AChoice.SpecList);
/* line 2824 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO(");
/* line 2824 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP107);
/* line 2824 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2824 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2825 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseCode (yyP108->AChoice.Next, yyP107);
  }
   return;

  }
  if (yyP108->Kind == kNoChoice) {
/* line 2828 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenCaseAtomic
# if defined __STDC__ | defined __cplusplus
(register tTree yyP109)
# else
(yyP109)
 register tTree yyP109;
# endif
{
  if (yyP109->Kind == kAChoice) {
  if (yyP109->AChoice.Next->Kind == kNoChoice) {
  if (yyP109->AChoice.ExprList->Kind == kAnExpr) {
  if (yyP109->AChoice.ExprList->AnExpr.Expr->Kind == kDefault) {
/* line 2833 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2834 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("default: ");
/* line 2834 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2835 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP109->AChoice.SpecList, NoTree, false);
/* line 2836 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP109->AChoice.Process);
/* line 2837 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP109->AChoice.SpecList);
  }
   return;

  }
  }
  }
/* line 2840 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2841 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseExprList (yyP109->AChoice.ExprList);
/* line 2841 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2842 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginAtomicBlock (yyP109->AChoice.SpecList, NoTree, false);
/* line 2843 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP109->AChoice.Process);
/* line 2844 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndAtomicBlock (yyP109->AChoice.SpecList);
/* line 2845 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("break; ");
/* line 2845 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2846 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseAtomic (yyP109->AChoice.Next);
  }
   return;

  }
  if (yyP109->Kind == kNoChoice) {
/* line 2849 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenCaseInSwitches
# if defined __STDC__ | defined __cplusplus
(register tTree yyP110)
# else
(yyP110)
 register tTree yyP110;
# endif
{
/* line 2854 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int nlab; 
  if (yyP110->Kind == kACase) {
  if (yyP110->ACase.Next->Kind == kNoCase) {
  if (yyP110->ACase.ExprList->Kind == kAnExpr) {
  if (yyP110->ACase.ExprList->AnExpr.Expr->Kind == kDefault) {
/* line 2859 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2860 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   nlab = NewLabel ();
/* line 2861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("default: GOTO(");
/* line 2861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (nlab);
/* line 2861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2862 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP110 -> ACase . Label = nlab;
  }
   return;

  }
  }
  }
  if (yyP110->ACase.ExprList->Kind == kAnExpr) {
  if (yyP110->ACase.ExprList->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP110->ACase.ExprList->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 2865 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2866 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   nlab = NewLabel ();
/* line 2867 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("case ");
/* line 2867 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP110->ACase.ExprList->AnExpr.Expr->ElementalExpr.Elemental, false);
/* line 2867 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (": ");
/* line 2868 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO (");
/* line 2868 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (nlab);
/* line 2868 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2868 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2869 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyP110 -> ACase . Label = nlab;
/* line 2870 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseInSwitches (yyP110->ACase.Next);
  }
   return;

  }
  }
  }
  }
  if (yyP110->Kind == kNoCase) {
/* line 2873 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2874 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("default: SETERR(MSG_CASEIN);");
/* line 2874 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenCaseInCode
# if defined __STDC__ | defined __cplusplus
(register tTree yyP113, register tTree yyP112, register int yyP111)
# else
(yyP113, yyP112, yyP111)
 register tTree yyP113;
 register tTree yyP112;
 register int yyP111;
# endif
{
  if (yyP113->Kind == kACase) {
  if (yyP113->ACase.ExprList->Kind == kAnExpr) {
/* line 2880 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2881 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (yyP113 -> ACase . Label);
/* line 2882 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   BeginBlock (yyP113->ACase.SpecList);
/* line 2883 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP113->ACase.ExprList->AnExpr.Expr->Expr.Pos);
/* line 2884 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInput (yyP112, ElementType (yyP112), yyP113->ACase.ExprList->AnExpr.Next);
/* line 2885 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcess (yyP113->ACase.Process);
/* line 2886 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   EndBlock (yyP113->ACase.SpecList);
/* line 2887 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO(");
/* line 2887 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP111);
/* line 2887 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2887 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2888 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCaseInCode (yyP113->ACase.Next, yyP112, yyP111);
  }
   return;

  }
  }
  if (yyP113->Kind == kNoCase) {
/* line 2891 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenSetScope
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP114)
# else
(yyP114)
 tSymbol yyP114;
# endif
{
/* line 2898 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2898 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxOccamDebug)))) goto yyL1;
  {
/* line 2898 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP114 <= OccSymSize))) goto yyL1;
  {
/* line 2899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr ("SETSCOPE(");
/* line 2899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP114 - 1);
/* line 2899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 2899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL1:;

;
}

static void GenSetListScope
# if defined __STDC__ | defined __cplusplus
(register tTree yyP115)
# else
(yyP115)
 register tTree yyP115;
# endif
{
  if (yyP115->Kind == kAnId) {
  if (yyP115->AnId.Next->Kind == kNoId) {
/* line 2904 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2904 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (yyP115->AnId.Sym);
  }
   return;

  }
/* line 2905 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2905 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (yyP115->AnId.Next);
  }
   return;

  }
  if (yyP115->Kind == kAFormal) {
  if (yyP115->AFormal.Next->Kind == kNoFormal) {
/* line 2906 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2906 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (yyP115->AFormal.Sym);
  }
   return;

  }
/* line 2907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (yyP115->AFormal.Next);
  }
   return;

  }
;
}

static void GenLocalSpecs
# if defined __STDC__ | defined __cplusplus
(register tTree yyP116)
# else
(yyP116)
 register tTree yyP116;
# endif
{
  if (yyP116->Kind == kASpec) {
/* line 2912 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2912 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP116->ASpec.Spec->Spec.Pos);
/* line 2912 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalSpec (yyP116->ASpec.Spec);
/* line 2912 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalSpecs (yyP116->ASpec.Next);
  }
   return;

  }
  if (yyP116->Kind == kNoSpec) {
/* line 2913 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenLocalSpec
# if defined __STDC__ | defined __cplusplus
(register tTree SP)
# else
(SP)
 register tTree SP;
# endif
{
  if (SP->Kind == kDecl) {
/* line 2919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalIdList (SP->Decl.Type, SP->Decl.IdList);
/* line 2919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
   return;
yyL1:;

  }
  if (SP->Kind == kVal) {
/* line 2921 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2921 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (SP->Val.Sym)))) goto yyL2;
  {
/* line 2921 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   DoBlock ();
/* line 2921 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSpecState (SP);
  }
  }
   return;
yyL2:;

  }
  if (SP->Kind == kValRetypes) {
/* line 2922 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2922 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (SP->ValRetypes.Sym)))) goto yyL3;
  {
/* line 2922 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   DoBlock ();
/* line 2922 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSpecState (SP);
  }
  }
   return;
yyL3:;

  }
  if (SP->Kind == kRetypes) {
/* line 2923 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2923 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (SP->Retypes.Sym)))) goto yyL4;
  {
/* line 2923 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   DoBlock ();
/* line 2923 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSpecState (SP);
  }
  }
   return;
yyL4:;

  }
  if (SP->Kind == kIs) {
/* line 2924 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2924 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (SP->Is.Sym)))) goto yyL5;
  {
/* line 2924 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   DoBlock ();
/* line 2924 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSpecState (SP);
  }
  }
   return;
yyL5:;

  }
/* line 2927 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

;
}

static void GenLocalRep
# if defined __STDC__ | defined __cplusplus
(register tTree yyP117)
# else
(yyP117)
 register tTree yyP117;
# endif
{
/* line 2932 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2932 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP117->Replicator.Sym)))) goto yyL1;
  {
/* line 2932 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP117->Replicator.From)))) goto yyL1;
  {
/* line 2932 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP117->Replicator.For)))) goto yyL1;
  {
/* line 2933 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   DoBlock ();
/* line 2934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 2934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP117->Replicator.Sym);
/* line 2934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 2934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2935 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP117->Replicator.Sym, PrefixId (CurSpec () . PrefixId, Symbol (yyP117->Replicator.Sym) . CId, '.'));
  }
  }
  }
  }
   return;
yyL1:;

/* line 2938 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2938 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP117->Replicator.Sym)))) goto yyL2;
  {
/* line 2939 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   DoBlock ();
/* line 2940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 2940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP117->Replicator.Sym);
/* line 2940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 2940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2941 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT ");
/* line 2941 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP117->Replicator.Sym);
/* line 2941 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_End;");
/* line 2941 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2942 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   ReplaceSymId (yyP117->Replicator.Sym, PrefixId (CurSpec () . PrefixId, Symbol (yyP117->Replicator.Sym) . CId, '.'));
  }
  }
   return;
yyL2:;

;
}

static void GenLocalIdList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP119, register tTree yyP118)
# else
(yyP119, yyP118)
 register tTree yyP119;
 register tTree yyP118;
# endif
{
  if (yyP118->Kind == kAnId) {
/* line 2947 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2947 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP118->AnId.Sym)))) goto yyL1;
  {
/* line 2947 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   DoBlock ();
/* line 2947 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenDeclSym (yyP119, yyP118->AnId.Sym, false);
/* line 2947 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalIdList (yyP119, yyP118->AnId.Next);
  }
  }
   return;
yyL1:;

/* line 2948 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2948 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalIdList (yyP119, yyP118->AnId.Next);
  }
   return;

  }
  if (yyP118->Kind == kNoId) {
/* line 2949 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenLocalInits
# if defined __STDC__ | defined __cplusplus
(register tTree yyP120)
# else
(yyP120)
 register tTree yyP120;
# endif
{
  if (yyP120->Kind == kASpec) {
/* line 2955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   SetPosition (yyP120->ASpec.Spec->Spec.Pos);
/* line 2955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalInit (yyP120->ASpec.Spec);
/* line 2955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalInits (yyP120->ASpec.Next);
  }
   return;

  }
  if (yyP120->Kind == kNoSpec) {
/* line 2956 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenLocalInit
# if defined __STDC__ | defined __cplusplus
(register tTree SP)
# else
(SP)
 register tTree SP;
# endif
{
  if (SP->Kind == kDecl) {
  if (SP->Decl.Type->Kind == kChan) {
/* line 2961 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2961 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (SP->Decl.IdList);
/* line 2961 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanList (SP->Decl.IdList);
  }
   return;

  }
  if (SP->Decl.Type->Kind == kArray) {
/* line 2963 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2963 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (SP->Decl.Type)))) goto yyL2;
  {
/* line 2963 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (SP->Decl.IdList);
/* line 2963 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanArrayList (SP->Decl.Type, SP->Decl.IdList);
  }
  }
   return;
yyL2:;

  }
/* line 2965 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2965 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetListScope (SP->Decl.IdList);
  }
   return;

  }
  if (Tree_IsType (SP, kAVal)) {
/* line 2968 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2968 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsZeroSizeType (ExprType (SP->AVal.Expr))))) goto yyL4;
  {
/* line 2969 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->AVal.Sym);
/* line 2970 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->AVal.Sym);
/* line 2970 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = NULL;");
/* line 2970 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL4:;

  }

  switch (SP->Kind) {
  case kIs:
/* line 2972 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2972 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsZeroSizeType (ExprType (SP->Is.Elemental))))) goto yyL5;
  {
/* line 2973 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Is.Sym);
/* line 2974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Is.Sym);
/* line 2974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = NULL;");
/* line 2974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL5:;

  if (SP->Is.Elemental->Kind == kTable) {
/* line 3088 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3089 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Is.Sym);
/* line 3090 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitTable (SP->Is.Sym, 0, SP->Is.Elemental->Table.ExprList);
  }
   return;

  }
  if (Tree_IsType (SP->Is.Elemental, kElement)) {
/* line 3092 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3092 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (SP->Is.Sym))))) goto yyL25;
  {
/* line 3092 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (SymbolType (SP->Is.Sym))))) goto yyL25;
  {
/* line 3093 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Is.Sym);
/* line 3094 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Is.Sym);
/* line 3094 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3094 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SymbolType (SP->Is.Sym), false);
/* line 3094 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (SP->Is.Elemental, false);
/* line 3094 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3094 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL25:;

/* line 3096 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3096 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (SymbolType (SP->Is.Sym))))) goto yyL26;
  {
/* line 3097 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Is.Sym);
/* line 3098 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Is.Sym);
/* line 3098 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3098 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SymbolType (SP->Is.Sym), true);
/* line 3098 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (SP->Is.Elemental, true);
/* line 3098 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3098 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3099 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitIsArray (SP->Is.Sym, SymbolType (SP->Is.Sym), SP->Is.Elemental, GetElementSymbol (SP->Is.Elemental), ElementType (SP->Is.Elemental));
  }
  }
   return;
yyL26:;

/* line 3101 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3101 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (SP->Is.Sym))))) goto yyL27;
  {
/* line 3102 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Is.Sym);
/* line 3103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Is.Sym);
/* line 3103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (SP->Is.Elemental, false);
/* line 3103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL27:;

/* line 3105 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3106 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Is.Sym);
/* line 3107 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Is.Sym);
/* line 3107 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3107 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SymbolType (SP->Is.Sym), true);
/* line 3107 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (SP->Is.Elemental, true);
/* line 3107 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3107 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitIsArray (SP->Is.Sym, SymbolType (SP->Is.Sym), SP->Is.Elemental, GetElementSymbol (SP->Is.Elemental), ElementType (SP->Is.Elemental));
  }
   return;

  }
  break;
  case kRetypes:
/* line 2976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsZeroSizeType (SP->Retypes.Type)))) goto yyL6;
  {
/* line 2977 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Retypes.Sym);
/* line 2978 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Retypes.Sym);
/* line 2978 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = NULL;");
/* line 2978 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL6:;

  if (Tree_IsType (SP->Retypes.Elemental, kElement)) {
/* line 2983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SP->Retypes.Type)))) goto yyL7;
  {
/* line 2983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (SP->Retypes.Type)))) goto yyL7;
  {
/* line 2984 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Retypes.Sym);
/* line 2985 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Retypes.Sym);
/* line 2985 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 2985 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SP->Retypes.Type, false);
/* line 2985 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (SP->Retypes.Elemental, false);
/* line 2985 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 2985 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL7:;

/* line 2988 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2988 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (SP->Retypes.Type)))) goto yyL8;
  {
/* line 2989 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Retypes.Sym);
/* line 2990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Retypes.Sym);
/* line 2990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 2990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SP->Retypes.Type, true);
/* line 2990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (SP->Retypes.Elemental, true);
/* line 2990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 2990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 2991 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitReArray (SP->Retypes.Sym, SP->Retypes.Type, SP->Retypes.Elemental, GetElementSymbol (SP->Retypes.Elemental), ElementType (SP->Retypes.Elemental));
  }
  }
   return;
yyL8:;

/* line 2994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxEmulate)))) goto yyL9;
  {
/* line 2995 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEmuRetype (SP->Retypes.Type, SP->Retypes.Sym, ElementType (SP->Retypes.Elemental), SP->Retypes.Elemental);
  }
  }
   return;
yyL9:;

/* line 2998 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 2998 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SP->Retypes.Type)))) goto yyL10;
  {
/* line 2999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Retypes.Sym);
/* line 3000 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Retypes.Sym);
/* line 3000 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = *");
/* line 3000 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SP->Retypes.Type, true);
/* line 3000 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (SP->Retypes.Elemental, true);
/* line 3000 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3000 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL10:;

/* line 3003 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3004 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Retypes.Sym);
/* line 3005 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Retypes.Sym);
/* line 3005 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3005 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SP->Retypes.Type, true);
/* line 3005 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (SP->Retypes.Elemental, true);
/* line 3005 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3005 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3006 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitReArray (SP->Retypes.Sym, SP->Retypes.Type, SP->Retypes.Elemental, GetElementSymbol (SP->Retypes.Elemental), ElementType (SP->Retypes.Elemental));
  }
   return;

  }
  break;
  case kValRetypes:
/* line 3011 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3011 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxEmulate)))) goto yyL12;
  {
/* line 3011 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (ExprType (SP->ValRetypes.Expr))))) goto yyL12;
  {
/* line 3011 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (SP->ValRetypes.Expr)))) goto yyL12;
  {
/* line 3012 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3012 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3013 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 3013 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (SP->ValRetypes.Expr));
/* line 3013 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP; TMP = ");
/* line 3013 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (SP->ValRetypes.Expr);
/* line 3013 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3013 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->ValRetypes.Sym);
/* line 3015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("RETYPE(");
/* line 3015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (RetypeSize (SP->ValRetypes.Type));
/* line 3015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("^");
/* line 3015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (RetypeSize (ExprType (SP->ValRetypes.Expr)));
/* line 3015 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeRetypeSize (SP->ValRetypes.Type, SP->ValRetypes.Sym, 1);
/* line 3016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3017 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (SymbolKind (SP->ValRetypes.Sym), SP->ValRetypes.Sym, true);
/* line 3017 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3018 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&TMP);");
/* line 3018 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
  }
   return;
yyL12:;

  if (SP->ValRetypes.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (SP->ValRetypes.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3022 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3022 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxEmulate)))) goto yyL13;
  {
/* line 3023 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEmuRetype (SP->ValRetypes.Type, SP->ValRetypes.Sym, ExprType (SP->ValRetypes.Expr), SP->ValRetypes.Expr->ElementalExpr.Elemental);
  }
  }
   return;
yyL13:;

  }
  }
/* line 3026 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3026 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SP->ValRetypes.Type)))) goto yyL14;
  {
/* line 3026 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (ExprType (SP->ValRetypes.Expr))))) goto yyL14;
  {
/* line 3027 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->ValRetypes.Sym);
/* line 3028 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*(");
/* line 3028 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (ExprType (SP->ValRetypes.Expr), true);
/* line 3028 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (SymbolKind (SP->ValRetypes.Sym), SP->ValRetypes.Sym, true);
/* line 3028 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (") = ");
/* line 3028 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (SP->ValRetypes.Expr);
/* line 3028 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3028 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL14:;

/* line 3031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (ExprType (SP->ValRetypes.Expr))))) goto yyL15;
  {
/* line 3031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (SP->ValRetypes.Expr)))) goto yyL15;
  {
/* line 3032 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3032 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3033 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 3033 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (SP->ValRetypes.Expr));
/* line 3033 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP; TMP = ");
/* line 3033 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (SP->ValRetypes.Expr);
/* line 3033 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3033 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3034 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->ValRetypes.Sym);
/* line 3035 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->ValRetypes.Sym);
/* line 3035 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3035 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SP->ValRetypes.Type, true);
/* line 3035 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&TMP;");
/* line 3035 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3036 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3036 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3036 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL15:;

  if (SP->ValRetypes.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (SP->ValRetypes.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3039 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3039 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SP->ValRetypes.Type)))) goto yyL16;
  {
/* line 3040 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->ValRetypes.Sym);
/* line 3041 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->ValRetypes.Sym);
/* line 3041 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = *(");
/* line 3041 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SP->ValRetypes.Type, true);
/* line 3041 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeArrayExpr (SP->ValRetypes.Expr, true);
/* line 3041 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3041 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3042 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitReArray (SP->ValRetypes.Sym, SP->ValRetypes.Type, SP->ValRetypes.Expr->ElementalExpr.Elemental, GetElementSymbol (SP->ValRetypes.Expr->ElementalExpr.Elemental), ExprType (SP->ValRetypes.Expr->ElementalExpr.Elemental));
  }
  }
   return;
yyL16:;

/* line 3045 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3046 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->ValRetypes.Sym);
/* line 3047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->ValRetypes.Sym);
/* line 3047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SP->ValRetypes.Type, true);
/* line 3047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeArrayExpr (SP->ValRetypes.Expr, true);
/* line 3047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitReArray (SP->ValRetypes.Sym, SP->ValRetypes.Type, SP->ValRetypes.Expr->ElementalExpr.Elemental, GetElementSymbol (SP->ValRetypes.Expr->ElementalExpr.Elemental), ExprType (SP->ValRetypes.Expr->ElementalExpr.Elemental));
  }
   return;

  }
  }
  break;
  case kVal:
  if (SP->Val.Expr->Kind == kElementalExpr) {
/* line 3055 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3055 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (SP->Val.Expr)))) goto yyL18;
  {
/* line 3055 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsArrayType (ExprType (SP->Val.Expr))))) goto yyL18;
  {
/* line 3056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3057 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 3057 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (SP->Val.Expr));
/* line 3057 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP");
/* line 3057 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (ExprType (SP->Val.Expr));
/* line 3057 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = {");
/* line 3057 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstArray (ExprType (SP->Val.Expr->ElementalExpr.Elemental), SP->Val.Expr->ElementalExpr.Elemental -> Elemental . CA);
/* line 3057 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 3057 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3058 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Val.Sym);
/* line 3059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Val.Sym);
/* line 3059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = (");
/* line 3059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (SP->Val.Expr));
/* line 3059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)TMP;");
/* line 3059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3060 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3060 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3060 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL18:;

  }
  if (Tree_IsType (SP->Val.Expr, kStringElement)) {
/* line 3062 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3062 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (SP->Val.Expr)))) goto yyL19;
  {
/* line 3062 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsArrayType (ExprType (SP->Val.Expr))))) goto yyL19;
  {
/* line 3063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 3064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (SP->Val.Expr));
/* line 3064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP");
/* line 3064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (ExprType (SP->Val.Expr));
/* line 3064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = {");
/* line 3064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstArray (ExprType (SP->Val.Expr), SP->Val.Expr -> StringElement . CA);
/* line 3064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 3064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Val.Sym);
/* line 3066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Val.Sym);
/* line 3066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = TMP;");
/* line 3066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3067 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3067 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3067 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL19:;

  }
/* line 3069 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3069 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (SP->Val.Expr)))) goto yyL20;
  {
/* line 3069 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsNewSymbol (SP->Val.Sym)))) goto yyL20;
  }
  }
   return;
yyL20:;

  if (SP->Val.Expr->Kind == kElementalExpr) {
  if (SP->Val.Expr->ElementalExpr.Elemental->Kind == kTable) {
/* line 3071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3072 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitTable (SP->Val.Sym, 0, SP->Val.Expr->ElementalExpr.Elemental->Table.ExprList);
/* line 3073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Val.Sym);
  }
   return;

  }
  }
/* line 3075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (SP->Val.Sym))))) goto yyL22;
  {
/* line 3076 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Val.Sym);
/* line 3077 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Val.Sym);
/* line 3077 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3077 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SymbolType (SP->Val.Sym), false);
/* line 3077 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (SP->Val.Expr);
/* line 3077 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3077 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL22:;

  if (SP->Val.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (SP->Val.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3079 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (SP->Val.Sym);
/* line 3081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (SP->Val.Sym);
/* line 3081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (SymbolType (SP->Val.Sym), true);
/* line 3081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeArrayExpr (SP->Val.Expr, true);
/* line 3081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3082 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitIsArray (SP->Val.Sym, SymbolType (SP->Val.Sym), SP->Val.Expr->ElementalExpr.Elemental, GetElementSymbol (SP->Val.Expr->ElementalExpr.Elemental), ExprType (SP->Val.Expr));
  }
   return;

  }
  }
  break;
  case kCallFrame:
/* line 3112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kParFrame:
/* line 3113 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kDefAProc:
  case kDefProc:
  case kPrototypeProc:
/* line 3114 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kDefAFunc:
  case kDefFunc:
  case kDefIsFunc:
  case kPrototypeFunc:
/* line 3115 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kDefAPro:
  case kDefSeqPro:
  case kDefTagPro:
/* line 3116 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kNullSpec:
/* line 3117 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }

/* line 3119 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3119 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (SP, SP->Spec.Pos);
  }
   return;

;
}

static void GenInitTable
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP123, register int yyP122, register tTree yyP121)
# else
(yyP123, yyP122, yyP121)
 tSymbol yyP123;
 register int yyP122;
 register tTree yyP121;
# endif
{
  if (yyP121->Kind == kAnExpr) {
/* line 3125 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3125 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (ExprType (yyP121->AnExpr.Expr))))) goto yyL1;
  {
/* line 3126 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP123);
/* line 3126 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 3126 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP122);
/* line 3126 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("] = ");
/* line 3126 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP121->AnExpr.Expr);
/* line 3126 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3126 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3127 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitTable (yyP123, yyP122 + 1, yyP121->AnExpr.Next);
  }
  }
   return;
yyL1:;

/* line 3129 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3130 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (ASSIGN);
/* line 3130 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3131 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP123);
/* line 3131 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 3131 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP122);
/* line 3131 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("],");
/* line 3132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeArrayExpr (yyP121->AnExpr.Expr, true);
/* line 3132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3133 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayTypeSize (ExprType (yyP121->AnExpr.Expr));
/* line 3133 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("); ");
/* line 3133 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3134 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitTable (yyP123, yyP122 + 1, yyP121->AnExpr.Next);
  }
   return;

  }
;
}

static void GenArrayTypeSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP124)
# else
(yyP124)
 register tTree yyP124;
# endif
{
  if (yyP124->Kind == kArray) {
/* line 3139 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3140 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3140 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP124->Array.Expr);
/* line 3140 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 3140 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayTypeSize (yyP124->Array.Type);
/* line 3140 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
/* line 3143 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3143 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP124)))) goto yyL2;
  {
/* line 3144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("sizeof(");
/* line 3144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP124);
/* line 3144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *)");
  }
  }
   return;
yyL2:;

/* line 3147 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3148 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("sizeof(");
/* line 3148 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP124);
/* line 3148 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

;
}

static void GenEmuRetype
# if defined __STDC__ | defined __cplusplus
(register tTree yyP128, tSymbol yyP127, register tTree yyP126, register tTree yyP125)
# else
(yyP128, yyP127, yyP126, yyP125)
 register tTree yyP128;
 tSymbol yyP127;
 register tTree yyP126;
 register tTree yyP125;
# endif
{
/* line 3156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((RetypeSize (yyP128) == RetypeSize (yyP126)))) goto yyL1;
  {
/* line 3156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsScalarType (yyP128)))) goto yyL1;
  {
/* line 3157 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP127);
/* line 3157 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3158 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (yyP128, true);
/* line 3158 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP125, true);
/* line 3158 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3158 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3159 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitReArray (yyP127, SymbolType (yyP127), yyP125, GetElementSymbol (yyP125), yyP126);
  }
  }
  }
   return;
yyL1:;

/* line 3162 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3162 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsBoundedType (yyP128)))) goto yyL2;
  {
/* line 3163 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitReArray (yyP127, SymbolType (yyP127), yyP125, GetElementSymbol (yyP125), yyP126);
/* line 3164 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ALLOCRETYPE(");
/* line 3164 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP127);
/* line 3164 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3164 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP128);
/* line 3164 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*,");
/* line 3164 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeRetypeSize (yyP128, yyP127, 1);
/* line 3164 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3164 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3165 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
  }
   return;
yyL2:;

/* line 3168 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3169 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (yyP127);
/* line 3170 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("RETYPE(");
/* line 3171 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (RetypeSize (yyP128));
/* line 3171 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("^");
/* line 3171 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (RetypeSize (yyP126));
/* line 3171 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3172 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeRetypeSize (yyP128, yyP127, 1);
/* line 3172 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3173 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (SymbolKind (yyP127), yyP127, true);
/* line 3174 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3175 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP125, true);
/* line 3176 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3176 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void CodeRetypeSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP131, tSymbol yyP130, register int yyP129)
# else
(yyP131, yyP130, yyP129)
 register tTree yyP131;
 tSymbol yyP130;
 register int yyP129;
# endif
{
  if (yyP131->Kind == kArray) {
  if (yyP131->Array.Expr->Kind == kUnBound) {
/* line 3183 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3184 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP130);
/* line 3184 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_Dim");
/* line 3184 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP131));
/* line 3184 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 3185 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeRetypeSize (yyP131->Array.Type, yyP130, yyP129);
  }
   return;

  }
/* line 3187 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3188 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeRetypeSize (yyP131->Array.Type, yyP130, yyP129 * ValConstInt (yyP131->Array.Expr));
  }
   return;

  }
/* line 3191 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3192 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP129 * PrimTypeSize (yyP131));
  }
   return;

;
}

static int RetypeSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP132)
# else
(yyP132)
 register tTree yyP132;
# endif
{
  if (yyP132->Kind == kArray) {
/* line 3197 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return RetypeSize (yyP132->Array.Type);

  }
/* line 3198 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return PrimTypeSize (yyP132) - 1;

}

static void GenInitChanList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP133)
# else
(yyP133)
 register tTree yyP133;
# endif
{
  if (yyP133->Kind == kAnId) {
/* line 3204 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3205 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP133->AnId.Sym);
/* line 3205 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = &");
/* line 3205 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP133->AnId.Sym);
/* line 3205 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_CHAN");
/* line 3205 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3205 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3206 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INITCH(");
/* line 3206 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP133->AnId.Sym);
/* line 3206 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3206 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3207 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanList (yyP133->AnId.Next);
  }
   return;

  }
;
}

static void GenInitChanSubs
# if defined __STDC__ | defined __cplusplus
(register int yyP135, register int yyP134)
# else
(yyP135, yyP134)
 register int yyP135;
 register int yyP134;
# endif
{
/* line 3211 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3211 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP135 < yyP134))) goto yyL1;
  {
/* line 3211 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[TMP");
/* line 3211 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP135);
/* line 3211 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 3211 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanSubs (yyP135 + 1, yyP134);
  }
  }
   return;
yyL1:;

;
}

static void GenInitChanArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP138, tSymbol yyP137, register int yyP136)
# else
(yyP138, yyP137, yyP136)
 register tTree yyP138;
 tSymbol yyP137;
 register int yyP136;
# endif
{
  if (yyP138->Kind == kArray) {
/* line 3216 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3217 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3217 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3217 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("int TMP");
/* line 3218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP136);
/* line 3218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3219 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("for (TMP");
/* line 3219 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP136);
/* line 3219 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=0;TMP");
/* line 3219 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP136);
/* line 3219 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("<");
/* line 3219 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP138->Array.Expr);
/* line 3219 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";TMP");
/* line 3219 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP136);
/* line 3219 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("++)");
/* line 3219 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3220 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3220 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3220 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3221 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanArray (yyP138->Array.Type, yyP137, yyP136 + 1);
/* line 3222 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3222 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3222 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3223 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3223 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3223 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP138->Kind == kChan) {
/* line 3225 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP137);
/* line 3226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanSubs (0, yyP136);
/* line 3226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = &");
/* line 3226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP137);
/* line 3226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_CHAN");
/* line 3226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanSubs (0, yyP136);
/* line 3226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3227 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INITCH(");
/* line 3227 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP137);
/* line 3227 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanSubs (0, yyP136);
/* line 3227 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3227 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenInitChanArrayList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP140, register tTree yyP139)
# else
(yyP140, yyP139)
 register tTree yyP140;
 register tTree yyP139;
# endif
{
  if (yyP139->Kind == kAnId) {
/* line 3231 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3231 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanArray (yyP140, yyP139->AnId.Sym, 0);
/* line 3231 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitChanArrayList (yyP140, yyP139->AnId.Next);
  }
   return;

  }
;
}

static void GenInitIsArray
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP145, register tTree yyP144, register tTree yyP143, tSymbol yyP142, register tTree yyP141)
# else
(yyP145, yyP144, yyP143, yyP142, yyP141)
 tSymbol yyP145;
 register tTree yyP144;
 register tTree yyP143;
 tSymbol yyP142;
 register tTree yyP141;
# endif
{
  if (yyP144->Kind == kArray) {
  if (yyP143->Kind == kRange) {
  if (yyP141->Kind == kArray) {
/* line 3237 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3237 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP144->Array.Expr)))) goto yyL1;
  {
/* line 3238 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitIsArray (yyP145, yyP144->Array.Type, yyP143->Range.Next, yyP142, yyP141->Array.Type);
/* line 3239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP145);
/* line 3239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP144));
/* line 3239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP143->Range.For);
/* line 3239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3240 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL1:;

/* line 3243 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3244 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitIsArray (yyP145, yyP144->Array.Type, yyP143->Range.Next, yyP142, yyP141->Array.Type);
/* line 3245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 3245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3246 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP144->Array.Expr);
/* line 3246 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" == ");
/* line 3247 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP143->Range.For);
/* line 3248 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3248 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_AIM);
/* line 3248 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3249 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
  if (yyP141->Kind == kArray) {
/* line 3252 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3252 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP144->Array.Expr)))) goto yyL3;
  {
/* line 3253 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitIsArray (yyP145, yyP144->Array.Type, yyP143, yyP142, yyP141->Array.Type);
/* line 3254 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP145);
/* line 3254 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3254 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP144));
/* line 3254 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3254 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSizeOp (yyP143, yyP141);
/* line 3254 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("; ");
/* line 3255 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL3:;

/* line 3258 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3258 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP141->Array.Expr)))) goto yyL4;
  {
/* line 3259 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitIsArray (yyP145, yyP144->Array.Type, yyP143, yyP142, yyP141->Array.Type);
/* line 3260 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 3260 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3261 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP144->Array.Expr);
/* line 3261 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" == ");
/* line 3262 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP142);
/* line 3262 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3262 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP141));
/* line 3263 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3263 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_AIM);
/* line 3263 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3264 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL4:;

/* line 3267 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3268 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitIsArray (yyP145, yyP144->Array.Type, yyP143, yyP142, yyP141->Array.Type);
  }
   return;

  }
  }
;
}

static void GenInitReArray
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP150, register tTree yyP149, register tTree yyP148, tSymbol yyP147, register tTree yyP146)
# else
(yyP150, yyP149, yyP148, yyP147, yyP146)
 tSymbol yyP150;
 register tTree yyP149;
 register tTree yyP148;
 tSymbol yyP147;
 register tTree yyP146;
# endif
{
  if (yyP149->Kind == kArray) {
  if (yyP149->Array.Expr->Kind == kUnBound) {
  if (yyP146->Kind == kArray) {
/* line 3274 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3275 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3275 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3276 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT _TMP_RSIZE = ");
/* line 3276 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenElementSize (yyP148, yyP146);
/* line 3276 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3276 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3277 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 3277 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(_TMP_RSIZE % ");
/* line 3277 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (yyP150, yyP149->Array.Type);
/* line 3277 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" == 0,");
/* line 3277 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ARM);
/* line 3277 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3277 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3278 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP150);
/* line 3278 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3278 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP149));
/* line 3278 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3278 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(_TMP_RSIZE / ");
/* line 3278 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (yyP150, yyP149->Array.Type);
/* line 3278 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3278 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3279 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3279 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3279 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
  }
/* line 3281 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3281 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsBoundedType (yyP146)))) goto yyL2;
  {
/* line 3282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 3282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (yyP150, yyP149);
/* line 3282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" == ");
/* line 3282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenElementSize (yyP148, yyP146);
/* line 3283 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3283 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ARM);
/* line 3283 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3283 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL2:;

;
}

static void GenInitReArrayUnBoundSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP151)
# else
(yyP151)
 register tTree yyP151;
# endif
{
  if (yyP151->Kind == kArray) {
  if (yyP151->Array.Expr->Kind == kUnBound) {
/* line 3288 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3289 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitReArrayUnBoundSize (yyP151->Array.Type);
  }
   return;

  }
/* line 3292 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3293 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP151->Array.Expr);
/* line 3294 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" * ");
/* line 3295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInitReArrayUnBoundSize (yyP151->Array.Type);
  }
   return;

  }
/* line 3298 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3299 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("sizeof(");
/* line 3299 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP151);
/* line 3299 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

;
}

static void GenResults
# if defined __STDC__ | defined __cplusplus
(register tTree yyP152)
# else
(yyP152)
 register tTree yyP152;
# endif
{
  if (yyP152->Kind == kASpec) {
/* line 3305 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3305 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResults (yyP152->ASpec.Next);
/* line 3305 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResult (yyP152->ASpec.Spec);
  }
   return;

  }
  if (yyP152->Kind == kNoSpec) {
/* line 3306 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
;
}

static void GenResult
# if defined __STDC__ | defined __cplusplus
(register tTree yyP153)
# else
(yyP153)
 register tTree yyP153;
# endif
{
  if (yyP153->Kind == kIs) {
/* line 3311 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3311 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanOrTimerType (SymbolType (yyP153->Is.Sym))))) goto yyL1;
  }
   return;
yyL1:;

  if (yyP153->Is.Elemental->Kind == kTable) {
/* line 3317 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3318 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResultTable (yyP153->Is.Sym, 0, yyP153->Is.Elemental->Table.ExprList);
  }
   return;

  }
  if (Tree_IsType (yyP153->Is.Elemental, kElement)) {
/* line 3321 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3321 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP153->Is.Sym))))) goto yyL4;
  {
/* line 3322 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP153->Is.Elemental, false);
/* line 3322 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3322 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP153->Is.Sym);
/* line 3322 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3322 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL4:;

  }
  }
  if (yyP153->Kind == kRetypes) {
/* line 3314 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3314 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanOrTimerType (SymbolType (yyP153->Retypes.Sym))))) goto yyL2;
  }
   return;
yyL2:;

/* line 3329 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3329 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxEmulate)))) goto yyL6;
  {
/* line 3330 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenEmuRetypeResult (yyP153->Retypes.Type, yyP153->Retypes.Sym, ElementType (yyP153->Retypes.Elemental), yyP153->Retypes.Elemental);
  }
  }
   return;
yyL6:;

  if (Tree_IsType (yyP153->Retypes.Elemental, kElement)) {
/* line 3333 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3333 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP153->Retypes.Type)))) goto yyL7;
  {
/* line 3334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 3334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (yyP153->Retypes.Type, true);
/* line 3334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP153->Retypes.Elemental, true);
/* line 3334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP153->Retypes.Sym);
/* line 3334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL7:;

  }
  }
  if (yyP153->Kind == kValRetypes) {
  if (yyP153->ValRetypes.Expr->Kind == kElementalExpr) {
/* line 3325 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3325 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IS_Mode (xxEmulate)))) goto yyL5;
  {
/* line 3325 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((RetypeSize (yyP153->ValRetypes.Type) != RetypeSize (ElementType (yyP153->ValRetypes.Expr->ElementalExpr.Elemental))))) goto yyL5;
  {
/* line 3325 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsBoundedType (yyP153->ValRetypes.Type)))) goto yyL5;
  {
/* line 3325 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsScalarType (yyP153->ValRetypes.Type)))) goto yyL5;
  {
/* line 3326 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FREERETYPE(");
/* line 3326 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP153->ValRetypes.Sym);
/* line 3326 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3326 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
  }
  }
   return;
yyL5:;

  }
  }
;
}

static void GenResultTable
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP156, register int yyP155, register tTree yyP154)
# else
(yyP156, yyP155, yyP154)
 tSymbol yyP156;
 register int yyP155;
 register tTree yyP154;
# endif
{
  if (yyP154->Kind == kAnExpr) {
/* line 3342 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3342 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (ExprType (yyP154->AnExpr.Expr))))) goto yyL1;
  {
/* line 3343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP154->AnExpr.Expr);
/* line 3343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP156);
/* line 3343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 3343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP155);
/* line 3343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("];");
/* line 3343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3344 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResultTable (yyP156, yyP155 + 1, yyP154->AnExpr.Next);
  }
  }
   return;
yyL1:;

/* line 3346 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3347 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (ASSIGN);
/* line 3347 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3348 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeArrayExpr (yyP154->AnExpr.Expr, true);
/* line 3348 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3349 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP156);
/* line 3349 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 3349 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP155);
/* line 3349 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("],");
/* line 3350 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayTypeSize (ExprType (yyP154->AnExpr.Expr));
/* line 3350 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("); ");
/* line 3350 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3351 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResultTable (yyP156, yyP155 + 1, yyP154->AnExpr.Next);
  }
   return;

  }
;
}

static void GenEmuRetypeResult
# if defined __STDC__ | defined __cplusplus
(register tTree yyP160, tSymbol yyP159, register tTree yyP158, register tTree yyP157)
# else
(yyP160, yyP159, yyP158, yyP157)
 register tTree yyP160;
 tSymbol yyP159;
 register tTree yyP158;
 register tTree yyP157;
# endif
{
/* line 3356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3356 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP160)))) goto yyL1;
  }
   return;
yyL1:;

  if (Tree_IsType (yyP157, kElement)) {
/* line 3358 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3359 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (yyP159);
/* line 3360 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("RETYPE(");
/* line 3361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (RetypeSize (yyP160));
/* line 3361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("^");
/* line 3361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (RetypeSize (yyP158));
/* line 3361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3362 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeRetypeSize (yyP160, yyP159, 1);
/* line 3362 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3363 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP157, true);
/* line 3364 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3365 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (SymbolKind (yyP159), yyP159, true);
/* line 3366 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3366 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3367 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
   return;
yyL2:;

/* line 3370 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3370 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((RetypeSize (yyP160) != RetypeSize (ElementType (yyP157))))) goto yyL3;
  {
/* line 3370 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsBoundedType (yyP160)))) goto yyL3;
  {
/* line 3370 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsScalarType (yyP160)))) goto yyL3;
  {
/* line 3371 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FREERETYPE(");
/* line 3371 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP159);
/* line 3371 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3371 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
  }
   return;
yyL3:;

  }
;
}

static int GenRepStart
# if defined __STDC__ | defined __cplusplus
(register tTree yyP161)
# else
(yyP161)
 register tTree yyP161;
# endif
{
/* line 3380 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int lab; 
/* line 3381 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3381 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP161->Replicator.From)))) goto yyL1;
  {
/* line 3381 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP161->Replicator.For)))) goto yyL1;
  {
/* line 3382 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 3383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (yyP161->Replicator.Sym);
/* line 3384 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP161->Replicator.Sym) . Kind, yyP161->Replicator.Sym, false);
/* line 3384 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3384 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP161->Replicator.From);
/* line 3384 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3384 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3385 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO(");
/* line 3385 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 3385 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3385 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return lab;
yyL1:;

/* line 3387 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3388 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 3389 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (yyP161->Replicator.Sym);
/* line 3390 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP161->Replicator.Sym) . Kind, yyP161->Replicator.Sym, false);
/* line 3390 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3390 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP161->Replicator.From);
/* line 3390 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3390 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3391 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP161->Replicator.Sym) . Kind, yyP161->Replicator.Sym, false);
/* line 3391 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_End = ");
/* line 3391 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP161->Replicator.Sym) . Kind, yyP161->Replicator.Sym, false);
/* line 3391 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" + ");
/* line 3391 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP161->Replicator.For);
/* line 3391 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3391 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3392 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("GOTO(");
/* line 3392 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 3392 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3392 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return lab;

}

static void GenRepEnd
# if defined __STDC__ | defined __cplusplus
(register tTree yyP164, register int yyP163, register int yyP162)
# else
(yyP164, yyP163, yyP162)
 register tTree yyP164;
 register int yyP163;
 register int yyP162;
# endif
{
/* line 3397 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3397 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP164->Replicator.From)))) goto yyL1;
  {
/* line 3397 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP164->Replicator.For)))) goto yyL1;
  {
/* line 3398 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP164->Replicator.Sym) . Kind, yyP164->Replicator.Sym, false);
/* line 3398 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("++;");
/* line 3398 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3399 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (yyP162);
/* line 3400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (");
/* line 3400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP164->Replicator.Sym) . Kind, yyP164->Replicator.Sym, false);
/* line 3400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" < (");
/* line 3400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP164->Replicator.From);
/* line 3400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("+");
/* line 3400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP164->Replicator.For);
/* line 3400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")) GOTO(");
/* line 3400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP163);
/* line 3400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL1:;

/* line 3402 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP164->Replicator.Sym) . Kind, yyP164->Replicator.Sym, false);
/* line 3403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("++;");
/* line 3403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3404 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (yyP162);
/* line 3405 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (");
/* line 3405 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP164->Replicator.Sym) . Kind, yyP164->Replicator.Sym, false);
/* line 3405 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" < ");
/* line 3405 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP164->Replicator.Sym) . Kind, yyP164->Replicator.Sym, false);
/* line 3405 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_End) GOTO(");
/* line 3405 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (yyP163);
/* line 3405 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3405 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenAltIndex
# if defined __STDC__ | defined __cplusplus
(register tTree yyP165)
# else
(yyP165)
 register tTree yyP165;
# endif
{
/* line 3411 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3412 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP165->Replicator.Sym) . Kind, yyP165->Replicator.Sym, false);
  }
   return;

;
}

static void GenAltSelect
# if defined __STDC__ | defined __cplusplus
(register tTree yyP166)
# else
(yyP166)
 register tTree yyP166;
# endif
{
/* line 3416 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3417 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP166->Replicator.Sym) . Kind, yyP166->Replicator.Sym, false);
/* line 3417 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_Alt");
  }
   return;

;
}

static void GenForLoop
# if defined __STDC__ | defined __cplusplus
(register tTree yyP167)
# else
(yyP167)
 register tTree yyP167;
# endif
{
/* line 3422 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3422 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP167->Replicator.From)))) goto yyL1;
  {
/* line 3422 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP167->Replicator.For)))) goto yyL1;
  {
/* line 3423 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (yyP167->Replicator.Sym);
/* line 3424 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("for (");
/* line 3424 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP167->Replicator.Sym) . Kind, yyP167->Replicator.Sym, false);
/* line 3424 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3424 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP167->Replicator.From);
/* line 3424 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("; ");
/* line 3425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP167->Replicator.Sym) . Kind, yyP167->Replicator.Sym, false);
/* line 3425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" < ");
/* line 3425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP167->Replicator.From);
/* line 3425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" + ");
/* line 3425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP167->Replicator.For);
/* line 3425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("; ");
/* line 3425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP167->Replicator.Sym) . Kind, yyP167->Replicator.Sym, false);
/* line 3425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("++)");
/* line 3425 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL1:;

/* line 3428 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3429 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSetScope (yyP167->Replicator.Sym);
/* line 3430 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP167->Replicator.Sym) . Kind, yyP167->Replicator.Sym, false);
/* line 3430 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3430 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP167->Replicator.From);
/* line 3430 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3431 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP167->Replicator.Sym) . Kind, yyP167->Replicator.Sym, false);
/* line 3431 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_End = ");
/* line 3431 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP167->Replicator.Sym) . Kind, yyP167->Replicator.Sym, false);
/* line 3431 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" + ");
/* line 3431 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP167->Replicator.For);
/* line 3431 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3431 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3432 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("for (; ");
/* line 3432 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP167->Replicator.Sym) . Kind, yyP167->Replicator.Sym, false);
/* line 3432 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" < ");
/* line 3432 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP167->Replicator.Sym) . Kind, yyP167->Replicator.Sym, false);
/* line 3432 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_End; ");
/* line 3432 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP167->Replicator.Sym) . Kind, yyP167->Replicator.Sym, false);
/* line 3432 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("++)");
/* line 3432 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenForCheck
# if defined __STDC__ | defined __cplusplus
(register tTree yyP168)
# else
(yyP168)
 register tTree yyP168;
# endif
{
/* line 3437 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3437 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP168->Replicator.From)))) goto yyL1;
  {
/* line 3437 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP168->Replicator.For)))) goto yyL1;
  {
/* line 3438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (");
/* line 3438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP168->Replicator.Sym) . Kind, yyP168->Replicator.Sym, false);
/* line 3438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" == (");
/* line 3438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP168->Replicator.From);
/* line 3438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" + ");
/* line 3438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP168->Replicator.For);
/* line 3438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("))");
/* line 3438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL1:;

/* line 3440 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (");
/* line 3441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP168->Replicator.Sym) . Kind, yyP168->Replicator.Sym, false);
/* line 3441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" == ");
/* line 3441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP168->Replicator.Sym) . Kind, yyP168->Replicator.Sym, false);
/* line 3441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_End) ");
/* line 3441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void CodeArrayExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP170, register bool yyP169)
# else
(yyP170, yyP169)
 register tTree yyP170;
 register bool yyP169;
# endif
{
  if (yyP170->Kind == kElementalExpr) {
  if (Tree_IsType (yyP170->ElementalExpr.Elemental, kElement)) {
/* line 3450 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3450 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ElementType (yyP170->ElementalExpr.Elemental))))) goto yyL1;
  {
/* line 3451 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP170->ElementalExpr.Elemental, yyP169);
  }
  }
   return;
yyL1:;

/* line 3453 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3454 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP170->ElementalExpr.Elemental, yyP169);
  }
   return;

  }
  if (Tree_IsType (yyP170->ElementalExpr.Elemental, kTableElement)) {
/* line 3456 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3457 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected table element", xxError, yyP170->ElementalExpr.Elemental->TableElement.Pos);
  }
   return;

  }
  }
  if (Tree_IsType (yyP170, kStringElement)) {
/* line 3459 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3460 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected string element", xxError, yyP170->StringElement.Pos);
  }
   return;

  }
;
}

static void CodeExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP171)
# else
(yyP171)
 register tTree yyP171;
# endif
{
/* line 3466 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3466 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP171)))) goto yyL1;
  {
/* line 3466 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (ExprType (yyP171))))) goto yyL1;
  {
/* line 3466 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstExpr (ExprType (yyP171), ValConstExpr (yyP171));
  }
  }
  }
   return;
yyL1:;


  switch (yyP171->Kind) {
  case kBinary:
  if (yyP171->Binary.Op->Kind == kLeftShift) {
/* line 3468 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("LOGSHIFTLEFT(");
/* line 3469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (yyP171->Binary.Lop));
/* line 3469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP171->Binary.Lop);
/* line 3469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP171->Binary.Rop);
/* line 3469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  if (yyP171->Binary.Op->Kind == kRightShift) {
/* line 3471 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3472 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("LOGSHIFTRIGHT(");
/* line 3472 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (yyP171->Binary.Lop));
/* line 3472 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3472 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP171->Binary.Lop);
/* line 3472 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3472 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP171->Binary.Rop);
/* line 3472 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  if (yyP171->Binary.Op->Kind == kAfterOp) {
/* line 3474 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3475 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("AFTER(");
/* line 3475 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP171->Binary.Lop);
/* line 3475 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3475 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP171->Binary.Rop);
/* line 3475 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  if (yyP171->Binary.Op->Kind == kRem) {
/* line 3477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (ExprType (yyP171), kReal)))) goto yyL5;
  {
/* line 3478 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("( fmod((");
/* line 3478 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP171->Binary.Lop);
/* line 3478 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("),(");
/* line 3478 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP171->Binary.Rop);
/* line 3478 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")))");
  }
  }
   return;
yyL5:;

  }
/* line 3481 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3481 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3481 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP171->Binary.Lop);
/* line 3481 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeOp (yyP171->Binary.Op);
/* line 3481 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP171->Binary.Rop);
/* line 3481 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  case kUnary:
  if (yyP171->Unary.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP171->Unary.Expr->ElementalExpr.Elemental, kElement)) {
  if (yyP171->Unary.Op->Kind == kSize) {
/* line 3482 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3482 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3482 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSizeOp (yyP171->Unary.Expr->ElementalExpr.Elemental, ExprType (yyP171->Unary.Expr));
/* line 3482 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  }
  }
/* line 3483 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3483 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3483 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeOp (yyP171->Unary.Op);
/* line 3483 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP171->Unary.Expr);
/* line 3483 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  case kElementalExpr:
  if (Tree_IsType (yyP171->ElementalExpr.Elemental, kElement)) {
/* line 3486 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3486 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ElementType (yyP171->ElementalExpr.Elemental))))) goto yyL9;
  {
/* line 3486 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (ElementType (yyP171->ElementalExpr.Elemental))))) goto yyL9;
  {
/* line 3486 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP171->ElementalExpr.Elemental, false);
  }
  }
  }
   return;
yyL9:;

/* line 3488 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3488 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ElementType (yyP171->ElementalExpr.Elemental))))) goto yyL10;
  {
/* line 3488 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP171->ElementalExpr.Elemental, true);
  }
  }
   return;
yyL10:;

/* line 3490 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3490 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP171->ElementalExpr.Elemental, false);
  }
   return;

  }
  break;
  case kConvert:
/* line 3492 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3492 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP171->Convert.Type);
/* line 3492 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (yyP171->Convert.Expr));
/* line 3492 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3492 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP171->Convert.Expr);
/* line 3492 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  case kRound:
/* line 3493 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3493 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP171->Round.Type);
/* line 3493 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (yyP171->Round.Expr));
/* line 3493 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ROUND(");
/* line 3493 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP171->Round.Expr);
/* line 3493 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  case kTrunc:
/* line 3494 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3494 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP171->Trunc.Type);
/* line 3494 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (yyP171->Trunc.Expr));
/* line 3494 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TRUNC(");
/* line 3494 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP171->Trunc.Expr);
/* line 3494 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  case kMostPos:
/* line 3495 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3495 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MOSTPOS");
/* line 3495 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP171->MostPos.Type);
  }
   return;

  case kMostNeg:
/* line 3496 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3496 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MOSTNEG");
/* line 3496 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP171->MostNeg.Type);
  }
   return;

  case kFuncCall:
/* line 3497 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3497 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFuncCall (SymbolKind (yyP171->FuncCall.Sym), yyP171, NoTree);
  }
   return;

  }

/* line 3499 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3499 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP171, yyP171->Expr.Pos);
  }
   return;

;
}

static void CodeSizeOp
# if defined __STDC__ | defined __cplusplus
(register tTree yyP173, register tTree yyP172)
# else
(yyP173, yyP172)
 register tTree yyP173;
 register tTree yyP172;
# endif
{
  if (yyP173->Kind == kRange) {
  if (yyP172->Kind == kArray) {
/* line 3504 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3504 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP172->Array.Expr)))) goto yyL1;
  {
/* line 3505 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP173->Range.For);
  }
  }
   return;
yyL1:;

  }
  }
  if (yyP172->Kind == kArray) {
/* line 3508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP172->Array.Expr)))) goto yyL2;
  {
/* line 3509 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP173));
/* line 3509 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3509 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP172));
  }
  }
   return;
yyL2:;

/* line 3512 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3513 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP172->Array.Expr);
  }
   return;

  }
;
}

static void CodeConstExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP175, tValue yyP174)
# else
(yyP175, yyP174)
 register tTree yyP175;
 tValue yyP174;
# endif
{
  if (yyP175->Kind == kInt64) {
/* line 3520 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3520 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 WritetInt(yyP174.Number,true); 
  }
   return;

  }
  if (Tree_IsType (yyP175, kInteger)) {
/* line 3521 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3521 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 WritetInt(yyP174.Number,false); 
  }
   return;

  }
  if (yyP175->Kind == kByte) {
/* line 3522 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3522 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
WriteInt((unsigned char)yyP174.Number);
  }
   return;

  }
  if (yyP175->Kind == kBool) {
/* line 3523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP174 . Number))) goto yyL4;
  {
/* line 3523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("true");
  }
  }
   return;
yyL4:;

/* line 3524 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3524 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("false");
  }
   return;

  }
  if (Tree_IsType (yyP175, kReal)) {
/* line 3526 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3526 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteReal (yyP174);
  }
   return;

  }
/* line 3527 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3527 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP175, NoPosition);
  }
   return;

;
}

static void CodeAssign
# if defined __STDC__ | defined __cplusplus
(register tTree yyP177, register tTree yyP176)
# else
(yyP177, yyP176)
 register tTree yyP177;
 register tTree yyP176;
# endif
{
  if (yyP177->Kind == kNoExpr) {
  if (yyP176->Kind == kNoExpr) {
/* line 3534 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  }
  if (yyP177->Kind == kAnExpr) {
  if (yyP177->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP177->AnExpr.Expr->ElementalExpr.Elemental, kTableElement)) {
/* line 3536 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3537 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected table elements on LHS of assign", xxError, yyP177->AnExpr.Expr->ElementalExpr.Pos);
  }
   return;

  }
  }
  if (yyP177->AnExpr.Next->Kind == kAnExpr) {
  if (yyP176->Kind == kAnExpr) {
  if (yyP176->AnExpr.Next->Kind == kNoExpr) {
  if (yyP176->AnExpr.Expr->Kind == kFuncCall) {
/* line 3539 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3540 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFuncCall (SymbolKind (yyP176->AnExpr.Expr->FuncCall.Sym), yyP176->AnExpr.Expr, yyP177);
/* line 3541 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3541 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
  }
  }
  }
/* line 3544 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3545 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeAssign2 (yyP177, yyP176);
  }
   return;

;
}

static void CodeAssign2
# if defined __STDC__ | defined __cplusplus
(register tTree yyP179, register tTree yyP178)
# else
(yyP179, yyP178)
 register tTree yyP179;
 register tTree yyP178;
# endif
{
/* line 3550 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 tTree T;
  if (yyP179->Kind == kAnExpr) {
  if (yyP179->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP179->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
  if (yyP178->Kind == kAnExpr) {
/* line 3552 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3552 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((TempRequired (yyP179)))) goto yyL1;
  {
/* line 3552 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (T = ElementType (yyP179->AnExpr.Expr->ElementalExpr.Elemental), kArray)))) goto yyL1;
  {
/* line 3553 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3553 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3554 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ElementType (yyP179->AnExpr.Expr->ElementalExpr.Elemental));
/* line 3554 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP");
/* line 3554 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeIdChkConst (ElementType (yyP179->AnExpr.Expr->ElementalExpr.Elemental), yyP179->AnExpr.Expr->ElementalExpr.Pos);
/* line 3554 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3554 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3555 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT len = ");
/* line 3555 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenElementSize (yyP179->AnExpr.Expr->ElementalExpr.Elemental, T);
/* line 3555 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("; ");
/* line 3555 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3556 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenChkDims (yyP179->AnExpr.Expr->ElementalExpr.Elemental, T, yyP178->AnExpr.Expr, ExprType (yyP178->AnExpr.Expr));
/* line 3557 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (ASSIGN);
/* line 3557 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(TMP,");
/* line 3557 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeArrayExpr (yyP178->AnExpr.Expr, true);
/* line 3557 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",len); ");
/* line 3557 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3558 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeAssign (yyP179->AnExpr.Next, yyP178->AnExpr.Next);
/* line 3559 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (ASSIGN);
/* line 3559 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3559 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP179->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3559 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",TMP,len); ");
/* line 3559 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL1:;

/* line 3562 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3562 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (T = ElementType (yyP179->AnExpr.Expr->ElementalExpr.Elemental), kArray)))) goto yyL2;
  {
/* line 3563 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenChkDims (yyP179->AnExpr.Expr->ElementalExpr.Elemental, T, yyP178->AnExpr.Expr, ExprType (yyP178->AnExpr.Expr));
/* line 3564 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (ASSIGN);
/* line 3564 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3564 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP179->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3564 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3564 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeArrayExpr (yyP178->AnExpr.Expr, true);
/* line 3564 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3565 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenElementSize (yyP179->AnExpr.Expr->ElementalExpr.Elemental, T);
/* line 3565 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("); ");
/* line 3565 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3566 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeAssign (yyP179->AnExpr.Next, yyP178->AnExpr.Next);
  }
  }
   return;
yyL2:;

/* line 3568 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3568 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! TempRequired (yyP179)))) goto yyL3;
  {
/* line 3569 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeAssign (yyP179->AnExpr.Next, yyP178->AnExpr.Next);
/* line 3569 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP179->AnExpr.Expr->ElementalExpr.Elemental, false);
/* line 3569 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3569 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP178->AnExpr.Expr);
/* line 3569 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("; ");
/* line 3569 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL3:;

  if (yyP178->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP178->AnExpr.Expr->ElementalExpr.Elemental->Kind == kIdentifier) {
/* line 3571 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3571 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP178->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym), kAVal)))) goto yyL4;
  {
/* line 3572 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeAssign (yyP179->AnExpr.Next, yyP178->AnExpr.Next);
/* line 3572 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP179->AnExpr.Expr->ElementalExpr.Elemental, false);
/* line 3572 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3572 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP178->AnExpr.Expr);
/* line 3572 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("; ");
/* line 3572 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL4:;

  }
  }
/* line 3574 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3575 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3575 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3576 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ElementType (yyP179->AnExpr.Expr->ElementalExpr.Elemental));
/* line 3576 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP = ");
/* line 3576 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP178->AnExpr.Expr);
/* line 3576 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("; ");
/* line 3576 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3577 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeAssign (yyP179->AnExpr.Next, yyP178->AnExpr.Next);
/* line 3578 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP179->AnExpr.Expr->ElementalExpr.Elemental, false);
/* line 3578 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = TMP;");
/* line 3578 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3579 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3579 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
  }
  }
/* line 3581 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3581 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyAbort ("Unbalanced assignment list");
  }
   return;

;
}

static void GenChkDims
# if defined __STDC__ | defined __cplusplus
(register tTree yyP183, register tTree yyP182, register tTree yyP181, register tTree yyP180)
# else
(yyP183, yyP182, yyP181, yyP180)
 register tTree yyP183;
 register tTree yyP182;
 register tTree yyP181;
 register tTree yyP180;
# endif
{
  if (yyP182->Kind == kArray) {
  if (yyP182->Array.Expr->Kind == kUnBound) {
  if (yyP181->Kind == kElementalExpr) {
  if (Tree_IsType (yyP181->ElementalExpr.Elemental, kElement)) {
  if (yyP180->Kind == kArray) {
  if (yyP180->Array.Expr->Kind == kUnBound) {
/* line 3585 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3586 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 3586 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3586 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP183));
/* line 3586 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3586 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP182));
/* line 3586 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("==");
/* line 3587 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP181->ElementalExpr.Elemental));
/* line 3587 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3587 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP180));
/* line 3587 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3587 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ASM);
/* line 3587 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3587 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3588 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenChkDims (yyP183, yyP182->Array.Type, yyP181, yyP180->Array.Type);
  }
   return;

  }
  }
  }
  }
  if (yyP180->Kind == kArray) {
/* line 3595 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3596 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 3596 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3596 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP180->Array.Expr);
/* line 3596 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("==");
/* line 3597 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP183));
/* line 3597 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3597 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP182));
/* line 3597 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3597 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ASM);
/* line 3597 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3597 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3598 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenChkDims (yyP183, yyP182->Array.Type, yyP181, yyP180->Array.Type);
  }
   return;

  }
  }
  if (yyP181->Kind == kElementalExpr) {
  if (Tree_IsType (yyP181->ElementalExpr.Elemental, kElement)) {
  if (yyP180->Kind == kArray) {
  if (yyP180->Array.Expr->Kind == kUnBound) {
/* line 3590 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3591 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 3591 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3591 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP182->Array.Expr);
/* line 3591 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("==");
/* line 3592 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP181->ElementalExpr.Elemental));
/* line 3592 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3592 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP180));
/* line 3592 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3592 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ASM);
/* line 3592 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3592 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3593 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenChkDims (yyP183, yyP182->Array.Type, yyP181, yyP180->Array.Type);
  }
   return;

  }
  }
  }
  }
  if (yyP180->Kind == kArray) {
/* line 3600 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3600 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP182->Array.Expr)))) goto yyL4;
  {
/* line 3600 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP180->Array.Expr)))) goto yyL4;
  {
/* line 3601 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenChkDims (yyP183, yyP182->Array.Type, yyP181, yyP180->Array.Type);
  }
  }
  }
   return;
yyL4:;

/* line 3603 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 3604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP182->Array.Expr);
/* line 3604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("==");
/* line 3604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP180->Array.Expr);
/* line 3604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ASM);
/* line 3604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3604 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3605 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenChkDims (yyP183, yyP182->Array.Type, yyP181, yyP180->Array.Type);
  }
   return;

  }
  }
;
}

static void GenInstance
# if defined __STDC__ | defined __cplusplus
(register tTree DP, register tTree yyP185, register tIdent yyP184)
# else
(DP, yyP185, yyP184)
 register tTree DP;
 register tTree yyP185;
 register tIdent yyP184;
# endif
{
/* line 3616 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 bool comma = false; int lab; 
  if (DP->Kind == kDefProc) {
/* line 3618 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3618 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProc (DP)))) goto yyL1;
  {
/* line 3619 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAtomicInstance (DP->DefProc.Sym, DP->DefProc.Formals, yyP185);
  }
  }
   return;
yyL1:;

/* line 3622 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3623 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNonAtomicInstance (DP->DefProc.Sym, DP->DefProc.Formals, yyP185, yyP184);
  }
   return;

  }
  if (DP->Kind == kPrototypeProc) {
/* line 3626 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3626 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((DP->PrototypeProc.Lang == xxOccam))) goto yyL3;
  {
/* line 3627 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenNonAtomicInstance (DP->PrototypeProc.Sym, DP->PrototypeProc.Formals, yyP185, yyP184);
  }
  }
   return;
yyL3:;

/* line 3630 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3630 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((DP->PrototypeProc.Lang == xxAtomicOccam))) goto yyL4;
  {
/* line 3631 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenAtomicInstance (DP->PrototypeProc.Sym, DP->PrototypeProc.Formals, yyP185);
  }
  }
   return;
yyL4:;

/* line 3634 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3634 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((DP->PrototypeProc.Lang == xxC))) goto yyL5;
  {
/* line 3635 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCInstance (DP->PrototypeProc.Sym, DP->PrototypeProc.Formals, yyP185);
  }
  }
   return;
yyL5:;

/* line 3638 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3638 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((DP->PrototypeProc.Lang == xxF90))) goto yyL6;
  {
/* line 3639 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Instance (DP->PrototypeProc.Sym, DP->PrototypeProc.Formals, yyP185);
  }
  }
   return;
yyL6:;

/* line 3642 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3642 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((DP->PrototypeProc.Lang == xxF77))) goto yyL7;
  {
/* line 3643 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Fortran 77 interface not yet implemented", xxError, DP->PrototypeProc.Pos);
  }
  }
   return;
yyL7:;

  }
;
}

static void GenAtomicInstance
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP188, register tTree yyP187, register tTree yyP186)
# else
(yyP188, yyP187, yyP186)
 tSymbol yyP188;
 register tTree yyP187;
 register tTree yyP186;
# endif
{
/* line 3649 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 bool comma = false; 
/* line 3651 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3652 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP188);
/* line 3652 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3653 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((NeedsChain (yyP188)))) goto yyL1;
  {
/* line 3654 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP");
/* line 3654 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeIndirect (yyP188, CurProc);
/* line 3655 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   comma = true;
/* line 3656 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
  }
   return;
yyL1:;

/* line 3659 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3660 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP187, yyP186, comma);
/* line 3661 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3661 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenNonAtomicInstance
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP192, register tTree yyP191, register tTree yyP190, register tIdent yyP189)
# else
(yyP192, yyP191, yyP190, yyP189)
 tSymbol yyP192;
 register tTree yyP191;
 register tTree yyP190;
 register tIdent yyP189;
# endif
{
/* line 3666 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int lab; 
/* line 3668 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3668 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrototype (SymbolKind (yyP192))))) goto yyL1;
  {
/* line 3669 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtParams (yyP191, yyP190, yyP189, 0);
/* line 3670 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenChain (yyP189, yyP192, true);
/* line 3671 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
  }
   return;
yyL1:;

/* line 3674 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3674 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsPrototype (SymbolKind (yyP192))))) goto yyL2;
  {
/* line 3675 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntParams (yyP191, yyP190, yyP189, NoSymbol);
/* line 3676 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenChain (yyP189, yyP192, (IsTopLevel (yyP192)));
/* line 3677 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
  }
   return;
yyL2:;

/* line 3680 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3681 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 3682 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("CALL(");
/* line 3682 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP192);
/* line 3682 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->");
/* line 3682 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP189);
/* line 3682 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 3682 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (lab);
/* line 3682 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",\"");
/* line 3682 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP192);
/* line 3682 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\");");
/* line 3682 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3683 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
   return;

;
}

static void GenCInstance
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP195, register tTree yyP194, register tTree yyP193)
# else
(yyP195, yyP194, yyP193)
 tSymbol yyP195;
 register tTree yyP194;
 register tTree yyP193;
# endif
{
/* line 3689 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3690 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCTemps (yyP194, yyP193, 0);
/* line 3691 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Symbol (yyP195) . Id);
/* line 3691 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3692 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCParams (yyP194, yyP193, false);
/* line 3693 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3693 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3694 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCResults (yyP194, yyP193, 0);
  }
   return;

;
}

static void GenCTemps
# if defined __STDC__ | defined __cplusplus
(register tTree yyP198, register tTree yyP197, register bool yyP196)
# else
(yyP198, yyP197, yyP196)
 register tTree yyP198;
 register tTree yyP197;
 register bool yyP196;
# endif
{
  if (yyP197->Kind == kNoExpr) {
/* line 3701 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP198->Kind == kAFormal) {
  if (yyP197->Kind == kAnExpr) {
  if (yyP197->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP197->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3703 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3703 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsByteArray (yyP198->AFormal.Type)))) goto yyL2;
  {
/* line 3704 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCTemps (yyP198->AFormal.Next, yyP197->AnExpr.Next, yyP196 + 1);
  }
  }
   return;
yyL2:;

  }
  }
/* line 3707 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3708 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCTemps (yyP198->AFormal.Next, yyP197->AnExpr.Next, yyP196 + 1);
  }
   return;

  }
  }
;
}

static void GenCParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP201, register tTree yyP200, register bool yyP199)
# else
(yyP201, yyP200, yyP199)
 register tTree yyP201;
 register tTree yyP200;
 register bool yyP199;
# endif
{
  if (yyP200->Kind == kNoExpr) {
/* line 3714 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP201->Kind == kAFormal) {
  if (yyP201->AFormal.Type->Kind == kArray) {
  if (yyP200->Kind == kAnExpr) {
  if (yyP200->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP200->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3716 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3716 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ArrayPrimType (yyP201->AFormal.Type))))) goto yyL2;
  {
/* line 3717 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3717 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ArrayPrimType (yyP201->AFormal.Type));
/* line 3717 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
/* line 3717 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP200->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3718 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCParams (yyP201->AFormal.Next, yyP200->AnExpr.Next, true);
  }
  }
   return;
yyL2:;

/* line 3721 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3722 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP199);
/* line 3723 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3723 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP201->AFormal.Type);
/* line 3723 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 3723 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP200->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3724 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCParams (yyP201->AFormal.Next, yyP200->AnExpr.Next, true);
  }
   return;

  }
  }
  }
  }
  if (yyP201->AFormal.By->Kind == kByRef) {
  if (yyP200->Kind == kAnExpr) {
  if (yyP200->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP200->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3727 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3727 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ElementType (yyP200->AnExpr.Expr->ElementalExpr.Elemental))))) goto yyL4;
  {
/* line 3728 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP199);
/* line 3729 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP200->AnExpr.Expr->ElementalExpr.Elemental, false);
/* line 3730 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCParams (yyP201->AFormal.Next, yyP200->AnExpr.Next, true);
  }
  }
   return;
yyL4:;

/* line 3733 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3734 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP199);
/* line 3735 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP200->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3736 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP201->AFormal.Next, yyP200->AnExpr.Next, true);
  }
   return;

  }
  }
  }
  }
  if (yyP201->AFormal.By->Kind == kByVal) {
  if (yyP200->Kind == kAnExpr) {
/* line 3739 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3740 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP199);
/* line 3741 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP200->AnExpr.Expr);
/* line 3742 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP201->AFormal.Next, yyP200->AnExpr.Next, true);
  }
   return;

  }
  }
  }
;
}

static void GenCResults
# if defined __STDC__ | defined __cplusplus
(register tTree yyP204, register tTree yyP203, register bool yyP202)
# else
(yyP204, yyP203, yyP202)
 register tTree yyP204;
 register tTree yyP203;
 register bool yyP202;
# endif
{
  if (yyP203->Kind == kNoExpr) {
/* line 3748 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP204->Kind == kAFormal) {
  if (yyP204->AFormal.By->Kind == kByRef) {
  if (yyP203->Kind == kAnExpr) {
  if (yyP203->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP203->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3750 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3750 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsByteArray (yyP204->AFormal.Type)))) goto yyL2;
  {
/* line 3751 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCResults (yyP204->AFormal.Next, yyP203->AnExpr.Next, yyP202 + 1);
  }
  }
   return;
yyL2:;

  }
  }
  }
  }
  if (yyP203->Kind == kAnExpr) {
/* line 3754 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3755 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenCResults (yyP204->AFormal.Next, yyP203->AnExpr.Next, yyP202 + 1);
  }
   return;

  }
  }
;
}

static void GenF90Instance
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP207, register tTree yyP206, register tTree yyP205)
# else
(yyP207, yyP206, yyP205)
 tSymbol yyP207;
 register tTree yyP206;
 register tTree yyP205;
# endif
{
/* line 3761 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3762 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 3762 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 3762 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3763 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Temps (yyP206, yyP205, 0);
/* line 3764 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Inits (yyP206, yyP205, 0);
/* line 3765 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (CalcModule (SymbolKind (yyP207)));
/* line 3765 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_MP_");
/* line 3765 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (Symbol (yyP207) . Id);
/* line 3765 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3766 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Params (yyP206, yyP205, 0, false);
/* line 3767 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90CharParams (yyP206, yyP205, 0);
/* line 3768 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3768 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3769 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Results (yyP206, yyP205, 0);
/* line 3770 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 3770 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 3770 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenF90Temps
# if defined __STDC__ | defined __cplusplus
(register tTree yyP210, register tTree yyP209, register int yyP208)
# else
(yyP210, yyP209, yyP208)
 register tTree yyP210;
 register tTree yyP209;
 register int yyP208;
# endif
{
  if (yyP209->Kind == kNoExpr) {
/* line 3777 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP210->Kind == kAFormal) {
  if (yyP210->AFormal.Type->Kind == kArray) {
  if (yyP210->AFormal.Type->Array.Type->Kind == kByte) {
  if (yyP209->Kind == kAnExpr) {
  if (yyP209->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP209->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3779 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3780 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Temps (yyP210->AFormal.Next, yyP209->AnExpr.Next, yyP208 + 1);
  }
   return;

  }
  }
  }
  }
  if (yyP209->Kind == kAnExpr) {
  if (yyP209->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP209->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3783 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3783 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsBoundedType (yyP210->AFormal.Type)))) goto yyL3;
  {
/* line 3783 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsByteArray (yyP210->AFormal.Type)))) goto yyL3;
  {
/* line 3784 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ChDope");
/* line 3784 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (CountArrayDims (yyP210->AFormal.Type) - 1);
/* line 3784 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP");
/* line 3784 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP208);
/* line 3784 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3784 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3785 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Temps (yyP210->AFormal.Next, yyP209->AnExpr.Next, yyP208 + 1);
  }
  }
  }
   return;
yyL3:;

/* line 3788 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3788 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsBoundedType (yyP210->AFormal.Type)))) goto yyL4;
  {
/* line 3789 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("Dope");
/* line 3789 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (CountArrayDims (yyP210->AFormal.Type));
/* line 3789 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP");
/* line 3789 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP208);
/* line 3789 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3789 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3790 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Temps (yyP210->AFormal.Next, yyP209->AnExpr.Next, yyP208 + 1);
  }
  }
   return;
yyL4:;

  }
  }
  }
  }
  if (yyP209->Kind == kAnExpr) {
  if (yyP209->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP209->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3793 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3793 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP210->AFormal.Type)))) goto yyL5;
  {
/* line 3793 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP209->AnExpr.Expr)))) goto yyL5;
  {
/* line 3794 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP210->AFormal.Type);
/* line 3794 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP");
/* line 3794 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP208);
/* line 3794 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3794 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP209->AnExpr.Expr);
/* line 3794 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3794 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3795 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Temps (yyP210->AFormal.Next, yyP209->AnExpr.Next, yyP208 + 1);
  }
  }
  }
   return;
yyL5:;

/* line 3798 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Temps (yyP210->AFormal.Next, yyP209->AnExpr.Next, yyP208 + 1);
  }
   return;

  }
  }
/* line 3802 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3803 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP210->AFormal.Type);
/* line 3803 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" TMP");
/* line 3803 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP208);
/* line 3803 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 3803 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP209->AnExpr.Expr);
/* line 3803 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3804 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Temps (yyP210->AFormal.Next, yyP209->AnExpr.Next, yyP208 + 1);
  }
   return;

  }
  }
;
}

static void GenF90Inits
# if defined __STDC__ | defined __cplusplus
(register tTree yyP213, register tTree yyP212, register int yyP211)
# else
(yyP213, yyP212, yyP211)
 register tTree yyP213;
 register tTree yyP212;
 register int yyP211;
# endif
{
/* line 3809 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int tmp; 
  if (yyP212->Kind == kNoExpr) {
/* line 3811 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP213->Kind == kAFormal) {
  if (yyP213->AFormal.Type->Kind == kArray) {
  if (yyP213->AFormal.Type->Array.Type->Kind == kByte) {
  if (yyP212->Kind == kAnExpr) {
/* line 3813 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3814 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Inits (yyP213->AFormal.Next, yyP212->AnExpr.Next, yyP211 + 1);
  }
   return;

  }
  }
  if (yyP212->Kind == kAnExpr) {
  if (yyP212->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP212->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3817 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3817 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsBoundedType (yyP213->AFormal.Type)))) goto yyL3;
  {
/* line 3817 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsByteArray (yyP213->AFormal.Type)))) goto yyL3;
  {
/* line 3818 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3818 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP211);
/* line 3818 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".offset = 0; ");
/* line 3818 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3819 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3819 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP211);
/* line 3819 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".addr = (Pointer)");
/* line 3819 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP212->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3819 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3819 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3820 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90DopeInits (yyP213->AFormal.Type, ExprType (yyP212->AnExpr.Expr), yyP212->AnExpr.Expr->ElementalExpr.Elemental, yyP211, CountArrayDims (yyP213->AFormal.Type) - 2);
/* line 3821 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Inits (yyP213->AFormal.Next, yyP212->AnExpr.Next, yyP211 + 1);
  }
  }
  }
   return;
yyL3:;

/* line 3824 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3824 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsBoundedType (yyP213->AFormal.Type)))) goto yyL4;
  {
/* line 3825 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3825 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP211);
/* line 3825 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".offset = 0; ");
/* line 3825 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3826 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3826 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP211);
/* line 3826 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".addr = (Pointer)");
/* line 3826 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP212->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3826 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3826 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3827 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90DopeInits (yyP213->AFormal.Type, ExprType (yyP212->AnExpr.Expr), yyP212->AnExpr.Expr->ElementalExpr.Elemental, yyP211, CountArrayDims (yyP213->AFormal.Type) - 1);
/* line 3828 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Inits (yyP213->AFormal.Next, yyP212->AnExpr.Next, yyP211 + 1);
  }
  }
   return;
yyL4:;

  }
  }
  }
  }
  if (yyP212->Kind == kAnExpr) {
/* line 3831 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3832 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Inits (yyP213->AFormal.Next, yyP212->AnExpr.Next, yyP211 + 1);
  }
   return;

  }
  }
;
}

static void GenF90DopeInits
# if defined __STDC__ | defined __cplusplus
(register tTree yyP218, register tTree yyP217, register tTree yyP216, register int yyP215, register int yyP214)
# else
(yyP218, yyP217, yyP216, yyP215, yyP214)
 register tTree yyP218;
 register tTree yyP217;
 register tTree yyP216;
 register int yyP215;
 register int yyP214;
# endif
{
/* line 3837 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int extent; 
/* line 3839 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3840 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3840 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP215);
/* line 3840 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".dim[");
/* line 3840 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP214);
/* line 3840 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("].lower = 0;");
/* line 3841 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3841 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP215);
/* line 3841 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".dim[");
/* line 3841 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP214);
/* line 3841 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("].extent = ");
/* line 3841 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayDimSize (yyP217, yyP216);
/* line 3841 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3842 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
   return;
yyL1:;

  if (yyP217->Kind == kArray) {
/* line 3845 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3845 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP214 == 0))) goto yyL2;
  {
/* line 3845 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsByteArray (yyP217->Array.Type)))) goto yyL2;
  {
/* line 3846 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3846 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP215);
/* line 3846 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".len = ");
/* line 3846 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayDimSize (yyP217->Array.Type, yyP216);
/* line 3846 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3846 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3847 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3847 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP215);
/* line 3847 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".dim[0].mult = ");
/* line 3847 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayDimSize (yyP217->Array.Type, yyP216);
/* line 3847 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3847 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return;
yyL2:;

/* line 3850 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3850 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP214 > 0))) goto yyL3;
  {
/* line 3851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90DopeInits (yyP218, yyP217->Array.Type, yyP216, yyP215, yyP214 - 1);
/* line 3852 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL3;
  }
  }
   return;
yyL3:;

/* line 3855 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3855 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP214 > 0))) goto yyL4;
  {
/* line 3856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP215);
/* line 3856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".dim[");
/* line 3856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP214);
/* line 3856 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("].mult = ");
/* line 3857 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3857 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP215);
/* line 3857 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".dim[");
/* line 3857 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP214 - 1);
/* line 3857 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("].mult * ");
/* line 3857 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayDimSize (yyP217->Array.Type, yyP216);
/* line 3857 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3857 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL4:;

/* line 3860 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP215);
/* line 3861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".dim[");
/* line 3861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP214);
/* line 3861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("].mult = sizeof(");
/* line 3861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP217->Array.Type);
/* line 3861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 3861 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
/* line 3864 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

;
}

static void GenF90Params
# if defined __STDC__ | defined __cplusplus
(register tTree yyP222, register tTree yyP221, register int yyP220, register bool yyP219)
# else
(yyP222, yyP221, yyP220, yyP219)
 register tTree yyP222;
 register tTree yyP221;
 register int yyP220;
 register bool yyP219;
# endif
{
  if (yyP221->Kind == kNoExpr) {
/* line 3872 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP222->Kind == kAFormal) {
  if (yyP222->AFormal.Type->Kind == kArray) {
  if (yyP222->AFormal.Type->Array.Type->Kind == kByte) {
  if (yyP221->Kind == kAnExpr) {
  if (yyP221->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP221->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3874 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3875 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP219);
/* line 3876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ArrayPrimType (yyP222->AFormal.Type));
/* line 3876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 3876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP221->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3877 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Params (yyP222->AFormal.Next, yyP221->AnExpr.Next, yyP220 + 1, true);
  }
   return;

  }
  }
  }
  }
  if (yyP221->Kind == kAnExpr) {
  if (yyP221->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP221->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3880 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3880 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsBoundedType (yyP222->AFormal.Type)))) goto yyL3;
  {
/* line 3881 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP219);
/* line 3882 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3882 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ArrayPrimType (yyP222->AFormal.Type));
/* line 3882 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 3882 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP221->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3883 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Params (yyP222->AFormal.Next, yyP221->AnExpr.Next, yyP220 + 1, true);
  }
  }
   return;
yyL3:;

/* line 3886 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3887 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP219);
/* line 3888 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&TMP");
/* line 3888 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP220);
/* line 3889 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Params (yyP222->AFormal.Next, yyP221->AnExpr.Next, yyP220 + 1, true);
  }
   return;

  }
  }
  }
  }
  if (yyP221->Kind == kAnExpr) {
  if (yyP221->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP221->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3892 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3892 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP222->AFormal.Type)))) goto yyL5;
  {
/* line 3892 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP221->AnExpr.Expr)))) goto yyL5;
  {
/* line 3893 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP219);
/* line 3894 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&TMP");
/* line 3894 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP220);
/* line 3895 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Params (yyP222->AFormal.Next, yyP221->AnExpr.Next, yyP220 + 1, true);
  }
  }
  }
   return;
yyL5:;

/* line 3898 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP219);
/* line 3900 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP221->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3901 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Params (yyP222->AFormal.Next, yyP221->AnExpr.Next, yyP220 + 1, true);
  }
   return;

  }
  }
/* line 3904 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3905 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP219);
/* line 3906 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&TMP");
/* line 3906 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP220);
/* line 3907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Params (yyP222->AFormal.Next, yyP221->AnExpr.Next, yyP220 + 1, true);
  }
   return;

  }
  }
;
}

static void GenF90CharParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP225, register tTree yyP224, register int yyP223)
# else
(yyP225, yyP224, yyP223)
 register tTree yyP225;
 register tTree yyP224;
 register int yyP223;
# endif
{
  if (yyP224->Kind == kNoExpr) {
/* line 3913 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP225->Kind == kAFormal) {
  if (yyP225->AFormal.Type->Kind == kArray) {
  if (yyP225->AFormal.Type->Array.Type->Kind == kByte) {
  if (yyP224->Kind == kAnExpr) {
  if (yyP224->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP224->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3915 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3916 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (true);
/* line 3917 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayDimSize (ExprType (yyP224->AnExpr.Expr), yyP224->AnExpr.Expr->ElementalExpr.Elemental);
/* line 3918 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90CharParams (yyP225->AFormal.Next, yyP224->AnExpr.Next, yyP223 + 1);
  }
   return;

  }
  }
  }
  }
  if (yyP224->Kind == kAnExpr) {
  if (yyP224->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP224->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3921 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3921 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsByteArray (yyP225->AFormal.Type)))) goto yyL3;
  {
/* line 3922 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (true);
/* line 3923 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TMP");
/* line 3923 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP223);
/* line 3923 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".len");
/* line 3924 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90CharParams (yyP225->AFormal.Next, yyP224->AnExpr.Next, yyP223 + 1);
  }
  }
   return;
yyL3:;

  }
  }
  }
  }
  if (yyP224->Kind == kAnExpr) {
/* line 3927 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3928 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90CharParams (yyP225->AFormal.Next, yyP224->AnExpr.Next, yyP223 + 1);
  }
   return;

  }
  }
;
}

static void GenF90Results
# if defined __STDC__ | defined __cplusplus
(register tTree yyP228, register tTree yyP227, register int yyP226)
# else
(yyP228, yyP227, yyP226)
 register tTree yyP228;
 register tTree yyP227;
 register int yyP226;
# endif
{
  if (yyP227->Kind == kNoExpr) {
/* line 3934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP228->Kind == kAFormal) {
  if (yyP227->Kind == kAnExpr) {
  if (yyP227->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP227->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3936 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3936 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsBoundedType (yyP228->AFormal.Type)))) goto yyL2;
  {
/* line 3937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Results (yyP228->AFormal.Next, yyP227->AnExpr.Next, yyP226 + 1);
  }
  }
   return;
yyL2:;

  }
  }
/* line 3944 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3945 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Results (yyP228->AFormal.Next, yyP227->AnExpr.Next, yyP226 + 1);
  }
   return;

  }
  if (yyP228->AFormal.Type->Kind == kArray) {
  if (yyP227->Kind == kAnExpr) {
  if (yyP227->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP227->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3940 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3941 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenF90Results (yyP228->AFormal.Next, yyP227->AnExpr.Next, yyP226 + 1);
  }
   return;

  }
  }
  }
  }
  }
;
}

static void GenArrayDimSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP230, register tTree yyP229)
# else
(yyP230, yyP229)
 register tTree yyP230;
 register tTree yyP229;
# endif
{
  if (yyP230->Kind == kArray) {
  if (yyP230->Array.Expr->Kind == kUnBound) {
/* line 3950 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3951 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP229));
/* line 3951 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3951 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP230));
  }
   return;

  }
/* line 3954 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3955 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (ValConstInt (yyP230->Array.Expr));
  }
   return;

  }
;
}

static void GenExtParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP234, register tTree yyP233, register tIdent yyP232, register int yyP231)
# else
(yyP234, yyP233, yyP232, yyP231)
 register tTree yyP234;
 register tTree yyP233;
 register tIdent yyP232;
 register int yyP231;
# endif
{
  if (yyP234->Kind == kNoFormal) {
  if (yyP233->Kind == kNoExpr) {
/* line 3963 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  }
  if (yyP234->Kind == kAFormal) {
  if (yyP233->Kind == kAnExpr) {
/* line 3965 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3965 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP234->AFormal.Type)))) goto yyL2;
  {
/* line 3966 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtParams (yyP234->AFormal.Next, yyP233->AnExpr.Next, yyP232, yyP231);
  }
  }
   return;
yyL2:;

  }
  if (yyP234->AFormal.Type->Kind == kArray) {
  if (yyP233->Kind == kAnExpr) {
/* line 3968 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3969 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtArrayParams (yyP234->AFormal.Type, ExprType (yyP233->AnExpr.Expr), yyP233->AnExpr.Expr, yyP232, yyP231);
/* line 3970 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtParams (yyP234->AFormal.Next, yyP233->AnExpr.Next, yyP232, yyP231 + 1);
  }
   return;

  }
  }
  if (yyP234->AFormal.By->Kind == kByRef) {
  if (yyP233->Kind == kAnExpr) {
  if (yyP233->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP233->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 3972 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3972 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ElementType (yyP233->AnExpr.Expr->ElementalExpr.Elemental))))) goto yyL4;
  {
/* line 3973 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 3973 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP232);
/* line 3973 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 3973 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 3973 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP231);
/* line 3974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 3974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP233->AnExpr.Expr->ElementalExpr.Elemental, false);
/* line 3974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3975 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtParams (yyP234->AFormal.Next, yyP233->AnExpr.Next, yyP232, yyP231 + 1);
  }
  }
   return;
yyL4:;

/* line 3977 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3978 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 3978 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP232);
/* line 3978 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 3978 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 3978 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP231);
/* line 3979 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 3979 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP233->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 3979 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3979 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3980 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtParams (yyP234->AFormal.Next, yyP233->AnExpr.Next, yyP232, yyP231 + 1);
  }
   return;

  }
  }
  }
  }
  if (yyP234->AFormal.By->Kind == kByVal) {
  if (yyP233->Kind == kAnExpr) {
/* line 3982 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 3983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP232);
/* line 3983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 3983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 3983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP231);
/* line 3983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 3983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP233->AnExpr.Expr);
/* line 3983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3983 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3984 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtParams (yyP234->AFormal.Next, yyP233->AnExpr.Next, yyP232, yyP231 + 1);
  }
   return;

  }
  }
  }
;
}

static void GenExtArrayParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP239, register tTree yyP238, register tTree yyP237, register tIdent yyP236, register int yyP235)
# else
(yyP239, yyP238, yyP237, yyP236, yyP235)
 register tTree yyP239;
 register tTree yyP238;
 register tTree yyP237;
 register tIdent yyP236;
 register int yyP235;
# endif
{
  if (yyP239->Kind == kArray) {
  if (yyP239->Array.Expr->Kind == kUnBound) {
  if (yyP238->Kind == kArray) {
  if (yyP238->Array.Expr->Kind == kUnBound) {
  if (yyP237->Kind == kElementalExpr) {
  if (Tree_IsType (yyP237->ElementalExpr.Elemental, kElement)) {
/* line 3989 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 3990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP236);
/* line 3990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 3990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 3990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP235);
/* line 3990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP239));
/* line 3990 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 3991 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP237->ElementalExpr.Elemental));
/* line 3991 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3991 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP238));
/* line 3991 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3991 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3992 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtArrayParams (yyP239->Array.Type, yyP238->Array.Type, yyP237, yyP236, yyP235);
  }
   return;

  }
  }
  }
/* line 3994 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3995 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 3995 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP236);
/* line 3995 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 3995 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 3995 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP235);
/* line 3995 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 3995 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP239));
/* line 3995 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 3995 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP238->Array.Expr);
/* line 3995 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 3995 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 3996 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtArrayParams (yyP239->Array.Type, yyP238->Array.Type, yyP237, yyP236, yyP235);
  }
   return;

  }
  }
  if (yyP238->Kind == kArray) {
  if (yyP238->Array.Expr->Kind == kUnBound) {
  if (yyP237->Kind == kElementalExpr) {
  if (Tree_IsType (yyP237->ElementalExpr.Elemental, kElement)) {
/* line 3998 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 3999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 3999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 3999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP239->Array.Expr);
/* line 3999 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("==");
/* line 4000 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP237->ElementalExpr.Elemental));
/* line 4000 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4000 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP238));
/* line 4000 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4000 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ASM);
/* line 4000 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4000 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4001 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtArrayParams (yyP239->Array.Type, yyP238->Array.Type, yyP237, yyP236, yyP235);
  }
   return;

  }
  }
  }
/* line 4003 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4003 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP239->Array.Expr)))) goto yyL4;
  {
/* line 4003 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP238->Array.Expr)))) goto yyL4;
  {
/* line 4004 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtArrayParams (yyP239->Array.Type, yyP238->Array.Type, yyP237, yyP236, yyP235);
  }
  }
  }
   return;
yyL4:;

/* line 4006 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 4007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP239->Array.Expr);
/* line 4007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("==");
/* line 4007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP238->Array.Expr);
/* line 4007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ASM);
/* line 4007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4007 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4008 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenExtArrayParams (yyP239->Array.Type, yyP238->Array.Type, yyP237, yyP236, yyP235);
  }
   return;

  }
  }
  if (yyP237->Kind == kElementalExpr) {
  if (Tree_IsType (yyP237->ElementalExpr.Elemental, kElement)) {
/* line 4010 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4010 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP239)))) goto yyL6;
  {
/* line 4011 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 4011 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP236);
/* line 4011 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4011 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 4011 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP235);
/* line 4011 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("= (");
/* line 4011 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP239);
/* line 4011 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
/* line 4011 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP237->ElementalExpr.Elemental, true);
/* line 4011 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4011 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL6:;

/* line 4013 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 4014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP236);
/* line 4014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (PRM);
/* line 4014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP235);
/* line 4014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("= (");
/* line 4014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP239);
/* line 4014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 4014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP237->ElementalExpr.Elemental, true);
/* line 4014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4014 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
/* line 4016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4016 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP237, yyP237->Expr.Pos);
  }
   return;

;
}

static void GenIntParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP243, register tTree yyP242, register tIdent yyP241, tSymbol yyP240)
# else
(yyP243, yyP242, yyP241, yyP240)
 register tTree yyP243;
 register tTree yyP242;
 register tIdent yyP241;
 tSymbol yyP240;
# endif
{
  if (yyP243->Kind == kNoFormal) {
  if (yyP242->Kind == kNoExpr) {
/* line 4021 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  }
  if (yyP243->Kind == kAFormal) {
  if (yyP242->Kind == kAnExpr) {
/* line 4023 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4023 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP243->AFormal.Type)))) goto yyL2;
  {
/* line 4024 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntParams (yyP243->AFormal.Next, yyP242->AnExpr.Next, yyP241, yyP240);
  }
  }
   return;
yyL2:;

  }
  if (yyP243->AFormal.Type->Kind == kArray) {
  if (yyP242->Kind == kAnExpr) {
/* line 4026 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4027 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntArrayParams (yyP243->AFormal.Type, ExprType (yyP242->AnExpr.Expr), yyP243->AFormal.Sym, yyP242->AnExpr.Expr, yyP241, yyP240);
/* line 4028 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntParams (yyP243->AFormal.Next, yyP242->AnExpr.Next, yyP241, yyP240);
  }
   return;

  }
  }
  if (yyP243->AFormal.By->Kind == kByRef) {
  if (yyP242->Kind == kAnExpr) {
  if (yyP242->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP242->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 4030 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4030 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ElementType (yyP242->AnExpr.Expr->ElementalExpr.Elemental))))) goto yyL4;
  {
/* line 4031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFrameRef (yyP241, yyP240);
/* line 4031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP243->AFormal.Sym);
/* line 4031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 4031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP242->AnExpr.Expr->ElementalExpr.Elemental, false);
/* line 4031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4032 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntParams (yyP243->AFormal.Next, yyP242->AnExpr.Next, yyP241, yyP240);
  }
  }
   return;
yyL4:;

/* line 4034 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4035 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFrameRef (yyP241, yyP240);
/* line 4035 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4035 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP243->AFormal.Sym);
/* line 4035 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 4035 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP242->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 4035 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4035 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4036 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntParams (yyP243->AFormal.Next, yyP242->AnExpr.Next, yyP241, yyP240);
  }
   return;

  }
  }
  }
  }
  if (yyP243->AFormal.By->Kind == kByVal) {
  if (yyP242->Kind == kAnExpr) {
/* line 4038 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4039 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFrameRef (yyP241, yyP240);
/* line 4039 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4039 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP243->AFormal.Sym);
/* line 4039 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 4039 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP242->AnExpr.Expr);
/* line 4039 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4039 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4040 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntParams (yyP243->AFormal.Next, yyP242->AnExpr.Next, yyP241, yyP240);
  }
   return;

  }
  }
  }
;
}

static void GenChain
# if defined __STDC__ | defined __cplusplus
(register tIdent yyP246, tSymbol yyP245, register bool yyP244)
# else
(yyP246, yyP245, yyP244)
 register tIdent yyP246;
 tSymbol yyP245;
 register bool yyP244;
# endif
{
  if (equalbool (yyP244, true)) {
/* line 4047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 4047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP246);
/* line 4047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".Chain = NULL;");
/* line 4047 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
/* line 4048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 4048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP246);
/* line 4048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".Chain = ");
/* line 4048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP");
/* line 4048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeIndirect (yyP245, CurProc);
/* line 4048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenIntArrayParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP252, register tTree yyP251, tSymbol yyP250, register tTree yyP249, register tIdent yyP248, tSymbol yyP247)
# else
(yyP252, yyP251, yyP250, yyP249, yyP248, yyP247)
 register tTree yyP252;
 register tTree yyP251;
 tSymbol yyP250;
 register tTree yyP249;
 register tIdent yyP248;
 tSymbol yyP247;
# endif
{
  if (yyP252->Kind == kArray) {
  if (yyP252->Array.Expr->Kind == kUnBound) {
  if (yyP251->Kind == kArray) {
  if (yyP251->Array.Expr->Kind == kUnBound) {
  if (yyP249->Kind == kElementalExpr) {
  if (Tree_IsType (yyP249->ElementalExpr.Elemental, kElement)) {
/* line 4053 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4054 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFrameRef (yyP248, yyP247);
/* line 4054 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4054 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP250);
/* line 4054 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4054 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP252));
/* line 4054 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 4055 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP249->ElementalExpr.Elemental));
/* line 4055 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4055 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP251));
/* line 4055 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4055 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntArrayParams (yyP252->Array.Type, yyP251->Array.Type, yyP250, yyP249, yyP248, yyP247);
  }
   return;

  }
  }
  }
/* line 4058 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFrameRef (yyP248, yyP247);
/* line 4059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP250);
/* line 4059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP252));
/* line 4059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 4059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP251->Array.Expr);
/* line 4059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4060 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntArrayParams (yyP252->Array.Type, yyP251->Array.Type, yyP250, yyP249, yyP248, yyP247);
  }
   return;

  }
  }
  if (yyP251->Kind == kArray) {
  if (yyP251->Array.Expr->Kind == kUnBound) {
  if (yyP249->Kind == kElementalExpr) {
  if (Tree_IsType (yyP249->ElementalExpr.Elemental, kElement)) {
/* line 4062 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 4063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP252->Array.Expr);
/* line 4063 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("==");
/* line 4064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP249->ElementalExpr.Elemental));
/* line 4064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP251));
/* line 4064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ASM);
/* line 4064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4064 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntArrayParams (yyP252->Array.Type, yyP251->Array.Type, yyP250, yyP249, yyP248, yyP247);
  }
   return;

  }
  }
  }
/* line 4067 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4067 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP252->Array.Expr)))) goto yyL4;
  {
/* line 4067 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP251->Array.Expr)))) goto yyL4;
  {
/* line 4068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntArrayParams (yyP252->Array.Type, yyP251->Array.Type, yyP250, yyP249, yyP248, yyP247);
  }
  }
  }
   return;
yyL4:;

/* line 4070 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 4071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP252->Array.Expr);
/* line 4071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("==");
/* line 4071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP251->Array.Expr);
/* line 4071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_ASM);
/* line 4071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4072 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenIntArrayParams (yyP252->Array.Type, yyP251->Array.Type, yyP250, yyP249, yyP248, yyP247);
  }
   return;

  }
  }
  if (yyP249->Kind == kElementalExpr) {
  if (Tree_IsType (yyP249->ElementalExpr.Elemental, kElement)) {
/* line 4074 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4074 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP252)))) goto yyL6;
  {
/* line 4075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFrameRef (yyP248, yyP247);
/* line 4075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP250);
/* line 4075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("= (");
/* line 4075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP252);
/* line 4075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
/* line 4075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP249->ElementalExpr.Elemental, true);
/* line 4075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4075 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL6:;

/* line 4077 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4078 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFrameRef (yyP248, yyP247);
/* line 4078 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (".");
/* line 4078 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP250);
/* line 4078 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("= (");
/* line 4078 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP252);
/* line 4078 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 4078 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP249->ElementalExpr.Elemental, true);
/* line 4078 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4078 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
/* line 4080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP249, yyP249->Expr.Pos);
  }
   return;

;
}

static void GenFrameRef
# if defined __STDC__ | defined __cplusplus
(register tIdent yyP254, tSymbol yyP253)
# else
(yyP254, yyP253)
 register tIdent yyP254;
 tSymbol yyP253;
# endif
{
  {tSymbol yyT; yyT = NoSymbol;
  if (equaltSymbol (yyP253, yyT)) {
/* line 4085 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4085 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 4085 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP254);
  }
   return;

  }
  }
/* line 4086 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4086 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->");
/* line 4086 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteId (yyP254);
/* line 4086 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 4086 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP253) . Kind, yyP253, false);
/* line 4086 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
  }
   return;

;
}

static void GenFuncCall
# if defined __STDC__ | defined __cplusplus
(register tTree yyP257, register tTree yyP256, register tTree yyP255)
# else
(yyP257, yyP256, yyP255)
 register tTree yyP257;
 register tTree yyP256;
 register tTree yyP255;
# endif
{
/* line 4091 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 bool comma = false; 
/* line 4093 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4094 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP256->FuncCall.Sym);
/* line 4094 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4095 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((NeedsChain (yyP256->FuncCall.Sym)))) goto yyL1;
  {
/* line 4096 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP");
/* line 4096 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeIndirect (yyP256->FuncCall.Sym, CurProc);
/* line 4097 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   comma = true;
/* line 4098 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
  }
   return;
yyL1:;

  if (yyP257->DefFunc.Formals->Kind == kAFormal) {
/* line 4101 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4102 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP257->DefFunc.Formals, yyP256->FuncCall.ExprList, comma);
/* line 4103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   comma = true;
/* line 4104 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
   return;
yyL2:;

  }
/* line 4107 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4107 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsMVFunction (yyP257)))) goto yyL3;
  {
/* line 4108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeMVFParams (yyP255, comma);
/* line 4109 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL3;
  }
  }
   return;
yyL3:;

/* line 4112 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4113 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

;
}

static void CodeMVFParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP259, register bool yyP258)
# else
(yyP259, yyP258)
 register tTree yyP259;
 register bool yyP258;
# endif
{
  if (yyP259->Kind == kNoExpr) {
/* line 4121 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP259->Kind == kAnExpr) {
  if (yyP259->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP259->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 4123 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4124 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP258);
/* line 4125 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP259->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 4126 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeMVFParams (yyP259->AnExpr.Next, true);
  }
   return;

  }
  }
  }
;
}

static void GenParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP262, register tTree yyP261, register bool yyP260)
# else
(yyP262, yyP261, yyP260)
 register tTree yyP262;
 register tTree yyP261;
 register bool yyP260;
# endif
{
  if (yyP261->Kind == kNoExpr) {
/* line 4133 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP262->Kind == kAFormal) {
  if (yyP261->Kind == kAnExpr) {
/* line 4135 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4135 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTimerType (yyP262->AFormal.Type)))) goto yyL2;
  {
/* line 4136 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP262->AFormal.Next, yyP261->AnExpr.Next, yyP260);
  }
  }
   return;
yyL2:;

  }
  if (yyP262->AFormal.Type->Kind == kArray) {
  if (yyP261->Kind == kAnExpr) {
/* line 4139 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4140 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayParams (yyP262->AFormal.Type, ExprType (yyP261->AnExpr.Expr), yyP261->AnExpr.Expr, yyP260);
/* line 4141 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP262->AFormal.Next, yyP261->AnExpr.Next, true);
  }
   return;

  }
  }
  if (yyP262->AFormal.By->Kind == kByRef) {
  if (yyP261->Kind == kAnExpr) {
  if (yyP261->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP261->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 4144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4144 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ElementType (yyP261->AnExpr.Expr->ElementalExpr.Elemental))))) goto yyL4;
  {
/* line 4145 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP260);
/* line 4146 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP261->AnExpr.Expr->ElementalExpr.Elemental, false);
/* line 4147 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP262->AFormal.Next, yyP261->AnExpr.Next, true);
  }
  }
   return;
yyL4:;

/* line 4149 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4150 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP260);
/* line 4151 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP261->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 4152 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP262->AFormal.Next, yyP261->AnExpr.Next, true);
  }
   return;

  }
  }
  }
  }
  if (yyP262->AFormal.By->Kind == kByVal) {
  if (yyP261->Kind == kAnExpr) {
/* line 4154 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4155 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP260);
/* line 4156 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP261->AnExpr.Expr);
/* line 4157 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenParams (yyP262->AFormal.Next, yyP261->AnExpr.Next, true);
  }
   return;

  }
  }
  }
;
}

static void GenArrayParams
# if defined __STDC__ | defined __cplusplus
(register tTree yyP266, register tTree yyP265, register tTree yyP264, register bool yyP263)
# else
(yyP266, yyP265, yyP264, yyP263)
 register tTree yyP266;
 register tTree yyP265;
 register tTree yyP264;
 register bool yyP263;
# endif
{
  if (yyP266->Kind == kArray) {
  if (yyP266->Array.Expr->Kind == kUnBound) {
  if (yyP265->Kind == kArray) {
  if (yyP265->Array.Expr->Kind == kUnBound) {
  if (yyP264->Kind == kElementalExpr) {
  if (Tree_IsType (yyP264->ElementalExpr.Elemental, kElement)) {
/* line 4166 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4167 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP263);
/* line 4168 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (GetElementSymbol (yyP264->ElementalExpr.Elemental));
/* line 4168 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4168 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP265));
/* line 4169 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayParams (yyP266->Array.Type, yyP265->Array.Type, yyP264, true);
  }
   return;

  }
  }
  }
/* line 4171 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4172 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP263);
/* line 4173 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP265->Array.Expr);
/* line 4174 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayParams (yyP266->Array.Type, yyP265->Array.Type, yyP264, true);
  }
   return;

  }
  }
  if (yyP265->Kind == kArray) {
/* line 4177 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4177 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP266->Array.Expr)))) goto yyL3;
  {
/* line 4177 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP265->Array.Expr)))) goto yyL3;
  {
/* line 4178 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayParams (yyP266->Array.Type, yyP265->Array.Type, yyP264, yyP263);
  }
  }
  }
   return;
yyL3:;

  if (yyP265->Array.Expr->Kind == kUnBound) {
  if (yyP264->Kind == kElementalExpr) {
  if (Tree_IsType (yyP264->ElementalExpr.Elemental, kElement)) {
/* line 4181 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4183 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayParams (yyP266->Array.Type, yyP265->Array.Type, yyP264, yyP263);
  }
   return;

  }
  }
  }
/* line 4185 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4187 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayParams (yyP266->Array.Type, yyP265->Array.Type, yyP264, yyP263);
  }
   return;

  }
  }
  if (yyP264->Kind == kElementalExpr) {
  if (Tree_IsType (yyP264->ElementalExpr.Elemental, kElement)) {
/* line 4190 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4190 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP266)))) goto yyL6;
  {
/* line 4191 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP263);
/* line 4192 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4192 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP266);
/* line 4192 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
/* line 4192 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP264->ElementalExpr.Elemental, true);
  }
  }
   return;
yyL6:;

/* line 4195 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4196 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenComma (yyP263);
/* line 4197 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4197 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP266);
/* line 4197 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 4197 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP264->ElementalExpr.Elemental, true);
  }
   return;

  }
  }
/* line 4200 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4200 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP264, yyP264->Expr.Pos);
  }
   return;

;
}

static void GenComma
# if defined __STDC__ | defined __cplusplus
(register bool yyP267)
# else
(yyP267)
 register bool yyP267;
# endif
{
  if (equalbool (yyP267, true)) {
/* line 4205 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4206 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
  }
   return;

  }
/* line 4209 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

;
}

static void GenTimerInput
# if defined __STDC__ | defined __cplusplus
(register tTree yyP268)
# else
(yyP268)
 register tTree yyP268;
# endif
{
  if (yyP268->Kind == kAnExpr) {
/* line 4219 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4220 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP268->AnExpr.Expr);
/* line 4220 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ReadTimer();");
/* line 4220 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenInput
# if defined __STDC__ | defined __cplusplus
(register tTree yyP270, register tTree T, register tTree yyP269)
# else
(yyP270, T, yyP269)
 register tTree yyP270;
 register tTree T;
 register tTree yyP269;
# endif
{
/* line 4226 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int lab; 
  if (yyP269->Kind == kNoExpr) {
/* line 4227 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP269->Kind == kAnExpr) {
  if (yyP269->AnExpr.Expr->Kind == kCountArray) {
  if (yyP269->AnExpr.Expr->CountArray.Length->Kind == kElementalExpr) {
  if (yyP269->AnExpr.Expr->CountArray.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP269->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental, kElement)) {
/* line 4229 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4230 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInputToExpr (yyP270, yyP269->AnExpr.Expr->CountArray.Length);
/* line 4231 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (CHK);
/* line 4231 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4231 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP269->AnExpr.Expr->CountArray.Length);
/* line 4231 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("<=");
/* line 4231 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSizeOp (yyP269->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental, ExprType (yyP269->AnExpr.Expr->CountArray.Expr));
/* line 4231 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4231 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (MSG_CITL);
/* line 4231 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4231 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4232 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4232 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INPUT");
/* line 4233 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4233 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP270, false);
/* line 4233 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4233 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP269->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental, true);
/* line 4233 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4234 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4234 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP269->AnExpr.Expr->CountArray.Length);
/* line 4234 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")*(");
/* line 4234 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (GetElementSymbol (yyP269->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental), ExprType (yyP269->AnExpr.Expr->CountArray.Expr) -> Array . Type);
/* line 4234 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("),");
/* line 4235 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4235 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4235 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4235 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 4236 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInput (yyP270, T, yyP269->AnExpr.Next);
  }
   return;

  }
  }
  }
  }
/* line 4238 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4238 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (ExprType (yyP269->AnExpr.Expr))))) goto yyL3;
  {
/* line 4239 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInputToExpr (yyP270, yyP269->AnExpr.Expr);
/* line 4240 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInput (yyP270, T, yyP269->AnExpr.Next);
  }
  }
   return;
yyL3:;

  if (yyP269->AnExpr.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP269->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 4242 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4243 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4243 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INPUT");
/* line 4244 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4244 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP270, false);
/* line 4244 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4244 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP269->AnExpr.Expr->ElementalExpr.Elemental, true);
/* line 4244 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenElementSize (yyP269->AnExpr.Expr->ElementalExpr.Elemental, ExprType (yyP269->AnExpr.Expr));
/* line 4245 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4246 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4246 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4246 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4246 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 4247 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenInput (yyP270, T, yyP269->AnExpr.Next);
  }
   return;

  }
  }
  }
/* line 4249 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4249 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP270, yyP270->Element.Pos);
  }
   return;

;
}

static void GenInputToExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP272, register tTree yyP271)
# else
(yyP272, yyP271)
 register tTree yyP272;
 register tTree yyP271;
# endif
{
/* line 4252 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int lab; 
  if (yyP271->Kind == kElementalExpr) {
  if (Tree_IsType (yyP271->ElementalExpr.Elemental, kElement)) {
/* line 4253 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4253 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (ExprType (yyP271))))) goto yyL1;
  {
/* line 4254 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4254 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INPUT");
/* line 4254 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (PrimTypeSize (ExprType (yyP271)));
/* line 4255 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4255 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP272, false);
/* line 4255 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4255 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP271->ElementalExpr.Elemental, true);
/* line 4256 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4256 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4256 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4256 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4256 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
  }
   return;
yyL1:;

  }
  }
;
}

static void GenOutput
# if defined __STDC__ | defined __cplusplus
(register tTree yyP275, register tTree yyP274, register tTree yyP273)
# else
(yyP275, yyP274, yyP273)
 register tTree yyP275;
 register tTree yyP274;
 register tTree yyP273;
# endif
{
  if (yyP273->Kind == kNoExpr) {
/* line 4263 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP274->Kind == kNamed) {
/* line 4265 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4265 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP274->Named.Sym), kDefSeqPro)))) goto yyL2;
  {
/* line 4266 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSeqProOutput (yyP275, SymbolKind (yyP274->Named.Sym) -> DefSeqPro . SeqProList, yyP273);
  }
  }
   return;
yyL2:;

  if (yyP273->Kind == kAnExpr) {
  if (yyP273->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP273->AnExpr.Expr->ElementalExpr.Elemental->Kind == kIdentifier) {
/* line 4268 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4268 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP274->Named.Sym), kDefTagPro)))) goto yyL3;
  {
/* line 4269 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSimpleOutputOfExpr (yyP275, yyP273->AnExpr.Expr, ExprType (yyP273->AnExpr.Expr));
/* line 4270 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSeqProOutput (yyP275, SymbolKind (yyP273->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym) -> ATagPro . SeqProList, yyP273->AnExpr.Next);
  }
  }
   return;
yyL3:;

  }
  }
  }
  }
  if (yyP274->Kind == kAny) {
  if (yyP273->Kind == kAnExpr) {
/* line 4272 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4272 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSimpleOutput (yyP275, yyP274, yyP273->AnExpr.Expr);
/* line 4272 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOutput (yyP275, yyP274, yyP273->AnExpr.Next);
  }
   return;

  }
  if (yyP273->Kind == kNoExpr) {
/* line 4273 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  }
  if (yyP274->Kind == kSimple) {
  if (yyP273->Kind == kAnExpr) {
  if (yyP273->AnExpr.Next->Kind == kNoExpr) {
/* line 4275 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4275 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSimpleOutput (yyP275, yyP274, yyP273->AnExpr.Expr);
  }
   return;

  }
  }
  }
  if (yyP274->Kind == kCounted) {
  if (yyP273->Kind == kAnExpr) {
  if (yyP273->AnExpr.Next->Kind == kNoExpr) {
/* line 4277 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4277 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSimpleOutput (yyP275, yyP274, yyP273->AnExpr.Expr);
  }
   return;

  }
  }
  }
  if (yyP273->Kind == kAnExpr) {
/* line 4279 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4279 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP273->AnExpr.Expr, yyP273->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
;
}

static void GenSeqProOutput
# if defined __STDC__ | defined __cplusplus
(register tTree yyP278, register tTree yyP277, register tTree yyP276)
# else
(yyP278, yyP277, yyP276)
 register tTree yyP278;
 register tTree yyP277;
 register tTree yyP276;
# endif
{
  if (yyP277->Kind == kASeqPro) {
  if (yyP276->Kind == kAnExpr) {
/* line 4282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSimpleOutput (yyP278, yyP277->ASeqPro.Protocol, yyP276->AnExpr.Expr);
/* line 4282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSeqProOutput (yyP278, yyP277->ASeqPro.Next, yyP276->AnExpr.Next);
  }
   return;

  }
  }
;
}

static void GenSimpleOutput
# if defined __STDC__ | defined __cplusplus
(register tTree yyP281, register tTree yyP280, register tTree yyP279)
# else
(yyP281, yyP280, yyP279)
 register tTree yyP281;
 register tTree yyP280;
 register tTree yyP279;
# endif
{
/* line 4285 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int lab; 
  if (yyP280->Kind == kCounted) {
  if (yyP279->Kind == kCountArray) {
  if (yyP279->CountArray.Expr->Kind == kElementalExpr) {
  if (Tree_IsType (yyP279->CountArray.Expr->ElementalExpr.Elemental, kElement)) {
/* line 4287 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4288 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSimpleOutputOfExpr (yyP281, yyP279->CountArray.Length, ExprType (yyP279->CountArray.Length));
/* line 4289 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4289 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OUTPUT");
/* line 4290 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4290 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP281, false);
/* line 4290 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4290 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP279->CountArray.Expr->ElementalExpr.Elemental, true);
/* line 4290 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4291 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4291 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP279->CountArray.Length);
/* line 4291 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")*(");
/* line 4291 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (GetElementSymbol (yyP279->CountArray.Expr->ElementalExpr.Elemental), ExprType (yyP279->CountArray.Expr) -> Array . Type);
/* line 4291 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("),");
/* line 4292 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4292 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4292 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4292 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
   return;

  }
  }
  }
  if (yyP279->Kind == kElementalExpr) {
  if (Tree_IsType (yyP279->ElementalExpr.Elemental, kElement)) {
/* line 4295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4297 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->_Header.Temp.V");
/* line 4297 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP280->Counted.Type);
/* line 4297 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 4297 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSizeOp (yyP279->ElementalExpr.Elemental, ExprType (yyP279));
/* line 4297 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4297 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4298 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OUTPUT");
/* line 4298 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (PrimTypeSize (yyP280->Counted.Type));
/* line 4299 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4299 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP281, false);
/* line 4299 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->_Header.Temp.V");
/* line 4299 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP280->Counted.Type);
/* line 4300 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4300 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4300 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4300 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4300 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
/* line 4301 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4301 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OUTPUT");
/* line 4302 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4302 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP281, false);
/* line 4302 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4302 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP279->ElementalExpr.Elemental, true);
/* line 4302 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4303 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenElementSize (yyP279->ElementalExpr.Elemental, ExprType (yyP279));
/* line 4303 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("),");
/* line 4304 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4304 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4304 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4304 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
   return;

  }
  }
  }
/* line 4307 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4307 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (ExprType (yyP279))))) goto yyL3;
  {
/* line 4308 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenSimpleOutputOfExpr (yyP281, yyP279, ExprType (yyP279));
  }
  }
   return;
yyL3:;

  if (yyP279->Kind == kElementalExpr) {
  if (Tree_IsType (yyP279->ElementalExpr.Elemental, kElement)) {
/* line 4311 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4312 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4312 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OUTPUT");
/* line 4313 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4313 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP281, false);
/* line 4313 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4313 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP279->ElementalExpr.Elemental, true);
/* line 4313 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4314 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenElementSize (yyP279->ElementalExpr.Elemental, ExprType (yyP279));
/* line 4314 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4315 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4315 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4315 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4315 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
   return;

  }
  }
/* line 4317 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4317 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP279, yyP279->Expr.Pos);
  }
   return;

;
}

static void GenSimpleOutputOfExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP284, register tTree yyP283, register tTree yyP282)
# else
(yyP284, yyP283, yyP282)
 register tTree yyP284;
 register tTree yyP283;
 register tTree yyP282;
# endif
{
/* line 4320 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 int lab; 
/* line 4322 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4322 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (ExprType (yyP283))))) goto yyL1;
  {
/* line 4322 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP283)))) goto yyL1;
  {
/* line 4323 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4324 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->_Header.Temp.V");
/* line 4324 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP282);
/* line 4324 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 4325 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP283);
/* line 4325 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4325 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4326 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OUTPUT");
/* line 4326 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (PrimTypeSize (yyP282));
/* line 4327 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4327 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP284, false);
/* line 4327 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->_Header.Temp.V");
/* line 4327 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP282);
/* line 4328 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4328 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4328 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4328 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4328 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
  }
  }
   return;
yyL1:;

  if (yyP283->Kind == kElementalExpr) {
  if (Tree_IsType (yyP283->ElementalExpr.Elemental, kElement)) {
/* line 4331 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4331 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (ExprType (yyP283))))) goto yyL2;
  {
/* line 4332 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4333 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OUTPUT");
/* line 4333 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (PrimTypeSize (yyP282));
/* line 4334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP284, false);
/* line 4334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4334 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP283->ElementalExpr.Elemental, true);
/* line 4335 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4335 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4335 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4335 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4335 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
  }
   return;
yyL2:;

  }
  }
/* line 4338 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4338 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (ExprType (yyP283))))) goto yyL3;
  {
/* line 4339 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   lab = NewLabel ();
/* line 4340 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP->_Header.Temp.V");
/* line 4340 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP282);
/* line 4340 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = ");
/* line 4341 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP283);
/* line 4341 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 4341 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4342 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("OUTPUT");
/* line 4342 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (PrimTypeSize (yyP282));
/* line 4343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChannelElement (yyP284, false);
/* line 4343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",&FP->_Header.Temp.V");
/* line 4343 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP282);
/* line 4344 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4344 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabelValue (lab);
/* line 4344 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 4344 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4344 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteLabel (lab);
  }
  }
   return;
yyL3:;

/* line 4348 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4348 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP283, yyP283->Expr.Pos);
  }
   return;

;
}

static void CodeElement
# if defined __STDC__ | defined __cplusplus
(register tTree yyP286, register bool yyP285)
# else
(yyP286, yyP285)
 register tTree yyP286;
 register bool yyP285;
# endif
{
/* line 4358 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 tSymbol Sym; 
/* line 4360 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4360 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (ElementType (yyP286))))) goto yyL1;
  {
/* line 4361 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Unexpected channel element", xxError, yyP286->Element.Pos);
  }
  }
   return;
yyL1:;

  if (yyP286->Kind == kIdentifier) {
  if (equalbool (yyP285, false)) {
/* line 4363 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4363 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((ConstFlag (yyP286 -> Element)))) goto yyL2;
  {
/* line 4364 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstExpr (ElementType (yyP286), yyP286 -> Element . CV);
  }
  }
   return;
yyL2:;

  }
/* line 4366 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4366 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (SymbolType (yyP286->Identifier.Sym), kArray)))) goto yyL3;
  {
/* line 4367 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP286->Identifier.Sym);
  }
  }
   return;
yyL3:;

/* line 4369 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4370 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSymRef (Symbol (yyP286->Identifier.Sym) . Kind, yyP286->Identifier.Sym, yyP285);
  }
   return;

  }
  if (yyP286->Kind == kSubscript) {
/* line 4372 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4372 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! yyP285))) goto yyL5;
  {
/* line 4372 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! Tree_IsType (ElementType (yyP286), kArray)))) goto yyL5;
  {
/* line 4373 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4374 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeElement (yyP286, true);
  }
  }
  }
   return;
yyL5:;

/* line 4376 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4377 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Sym = GetElementSymbol (yyP286);
/* line 4378 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(((");
/* line 4378 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ElementType (yyP286));
/* line 4378 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 4378 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (Sym);
/* line 4378 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")+");
/* line 4379 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (Sym, ElementType (yyP286), yyP286);
/* line 4379 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  if (yyP286->Kind == kRange) {
/* line 4381 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4382 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Sym = GetElementSymbol (yyP286);
/* line 4383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(((");
/* line 4383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ElementType (yyP286));
/* line 4383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 4383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (Sym);
/* line 4383 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")+");
/* line 4384 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (Sym, ElementType (yyP286) -> Array . Type, yyP286);
/* line 4384 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
/* line 4386 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4386 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP286, yyP286->Element.Pos);
  }
   return;

;
}

static void CodeChannelElement
# if defined __STDC__ | defined __cplusplus
(register tTree yyP288, register bool yyP287)
# else
(yyP288, yyP287)
 register tTree yyP288;
 register bool yyP287;
# endif
{
/* line 4391 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
 tSymbol Sym; 
/* line 4393 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4393 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsChanType (ElementType (yyP288))))) goto yyL1;
  {
/* line 4394 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Expected channel element", xxError, yyP288->Element.Pos);
  }
  }
   return;
yyL1:;

  if (yyP288->Kind == kIdentifier) {
  if (equalbool (yyP287, false)) {
/* line 4396 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4396 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (SymbolType (yyP288->Identifier.Sym), kArray)))) goto yyL2;
  {
/* line 4397 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Can only take reference to channel arrays", xxError, yyP288->Identifier.Pos);
  }
  }
   return;
yyL2:;

  }
  if (equalbool (yyP287, true)) {
/* line 4399 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4399 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (SymbolType (yyP288->Identifier.Sym), kArray)))) goto yyL3;
  {
/* line 4400 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP288->Identifier.Sym);
  }
  }
   return;
yyL3:;

  }
  if (equalbool (yyP287, true)) {
/* line 4402 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(&");
/* line 4403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP288->Identifier.Sym);
/* line 4403 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
/* line 4405 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4406 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP288->Identifier.Sym);
  }
   return;

  }
  if (yyP288->Kind == kSubscript) {
  if (equalbool (yyP287, false)) {
/* line 4408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4408 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! Tree_IsType (ElementType (yyP288), kArray)))) goto yyL6;
  {
/* line 4409 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Sym = GetElementSymbol (yyP288);
/* line 4410 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*(((");
/* line 4410 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ElementType (yyP288));
/* line 4410 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
/* line 4410 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (Sym);
/* line 4410 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")+");
/* line 4411 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (Sym, ElementType (yyP288), yyP288);
/* line 4411 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
  }
   return;
yyL6:;

  }
/* line 4413 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4414 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Sym = GetElementSymbol (yyP288);
/* line 4415 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(((");
/* line 4415 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ElementType (yyP288));
/* line 4415 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
/* line 4415 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (Sym);
/* line 4415 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")+");
/* line 4416 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (Sym, ElementType (yyP288), yyP288);
/* line 4416 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  if (yyP288->Kind == kRange) {
  if (equalbool (yyP287, true)) {
/* line 4418 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4419 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Sym = GetElementSymbol (yyP288);
/* line 4420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(((");
/* line 4420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ElementType (yyP288));
/* line 4420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
/* line 4420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (Sym);
/* line 4420 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")+");
/* line 4421 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (Sym, ElementType (yyP288) -> Array . Type, yyP288);
/* line 4421 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
/* line 4423 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4424 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Can only take reference to channel arrays", xxError, yyP288->Range.Pos);
  }
   return;

  }
/* line 4426 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4426 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP288, yyP288->Element.Pos);
  }
   return;

;
}

static void GenArrayIndex
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP291, register tTree yyP290, register tTree yyP289)
# else
(yyP291, yyP290, yyP289)
 tSymbol yyP291;
 register tTree yyP290;
 register tTree yyP289;
# endif
{
  if (yyP290->Kind == kArray) {
/* line 4437 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4437 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP290->Array.Expr)))) goto yyL1;
  {
/* line 4438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP291);
/* line 4438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP290));
/* line 4438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (yyP291, yyP290->Array.Type, yyP289);
/* line 4438 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
  }
   return;
yyL1:;

/* line 4440 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP290->Array.Expr);
/* line 4441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (yyP291, yyP290->Array.Type, yyP289);
/* line 4441 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  if (yyP289->Kind == kSubscript) {
  if (yyP289->Subscript.Next->Kind == kIdentifier) {
/* line 4444 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4444 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (ElementType (yyP289->Subscript.Next) -> Array . Expr)))) goto yyL3;
  {
/* line 4445 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkExpr (DoBndChk (yyP289), true, yyP289->Subscript.Expr, yyP291, ElementType (yyP289->Subscript.Next));
  }
  }
   return;
yyL3:;

/* line 4447 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4448 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkExpr (DoBndChk (yyP289), false, yyP289->Subscript.Expr, yyP291, ElementType (yyP289->Subscript.Next));
  }
   return;

  }
/* line 4451 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4451 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (ElementType (yyP289->Subscript.Next) -> Array . Expr, kUnBound)))) goto yyL5;
  {
/* line 4452 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4452 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkExpr (DoBndChk (yyP289), true, yyP289->Subscript.Expr, yyP291, ElementType (yyP289->Subscript.Next));
/* line 4452 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("+");
/* line 4452 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP291);
/* line 4452 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4452 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (ElementType (yyP289->Subscript.Next)));
/* line 4452 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4452 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (yyP291, yyP290, yyP289->Subscript.Next);
/* line 4452 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
  }
   return;
yyL5:;

/* line 4454 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4455 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4455 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkExpr (DoBndChk (yyP289), false, yyP289->Subscript.Expr, yyP291, ElementType (yyP289->Subscript.Next));
/* line 4455 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("+");
/* line 4455 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (ElementType (yyP289->Subscript.Next) -> Array . Expr);
/* line 4455 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4455 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (yyP291, yyP290, yyP289->Subscript.Next);
/* line 4455 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  if (yyP289->Kind == kRange) {
  if (yyP289->Range.Next->Kind == kIdentifier) {
/* line 4458 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4458 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (ElementType (yyP289->Range.Next) -> Array . Expr)))) goto yyL7;
  {
/* line 4459 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4459 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkUBExpr (DoUprBndChk (yyP289), true, yyP289->Range.From, yyP289->Range.For, yyP291, ElementType (yyP289->Range.Next));
/* line 4460 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkLBExpr (DoLwrBndChk (yyP289), yyP289->Range.From);
/* line 4460 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
  }
   return;
yyL7:;

/* line 4462 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4463 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4463 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkUBExpr (DoUprBndChk (yyP289), false, yyP289->Range.From, yyP289->Range.For, yyP291, ElementType (yyP289->Range.Next));
/* line 4464 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkLBExpr (DoLwrBndChk (yyP289), yyP289->Range.From);
/* line 4464 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
/* line 4467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4467 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (ElementType (yyP289->Range.Next) -> Array . Expr, kUnBound)))) goto yyL9;
  {
/* line 4468 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4469 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkUBExpr (DoUprBndChk (yyP289), true, yyP289->Range.From, yyP289->Range.For, yyP291, ElementType (yyP289->Range.Next));
/* line 4470 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkLBExpr (DoLwrBndChk (yyP289), yyP289->Range.From);
/* line 4470 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
/* line 4471 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("+");
/* line 4471 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP291);
/* line 4471 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4471 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (ElementType (yyP289->Range.Next)));
/* line 4471 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4471 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (yyP291, yyP290, yyP289->Range.Next);
/* line 4471 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
  }
   return;
yyL9:;

/* line 4473 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4474 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4475 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4475 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkUBExpr (DoUprBndChk (yyP289), false, yyP289->Range.From, yyP289->Range.For, yyP291, ElementType (yyP289->Range.Next));
/* line 4476 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeChkLBExpr (DoLwrBndChk (yyP289), yyP289->Range.From);
/* line 4476 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
/* line 4477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("+");
/* line 4477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (ElementType (yyP289->Range.Next) -> Array . Expr);
/* line 4477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArrayIndex (yyP291, yyP290, yyP289->Range.Next);
/* line 4477 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
;
}

static void GenElementSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP293, register tTree yyP292)
# else
(yyP293, yyP292)
 register tTree yyP293;
 register tTree yyP292;
# endif
{
  if (yyP293->Kind == kRange) {
  if (yyP292->Kind == kArray) {
/* line 4490 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4491 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4491 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP293->Range.For);
/* line 4491 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4491 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (GetElementSymbol (yyP293), yyP292->Array.Type);
/* line 4491 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  }
/* line 4494 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4495 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (GetElementSymbol (yyP293), yyP292);
  }
   return;

;
}

static void GenArraySize
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP295, register tTree yyP294)
# else
(yyP295, yyP294)
 tSymbol yyP295;
 register tTree yyP294;
# endif
{
  if (yyP294->Kind == kArray) {
/* line 4504 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4504 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstExpr (yyP294->Array.Expr)))) goto yyL1;
  {
/* line 4505 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4505 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP295);
/* line 4505 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4505 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP294));
/* line 4505 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4505 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (yyP295, yyP294->Array.Type);
/* line 4505 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
  }
   return;
yyL1:;

/* line 4507 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP294->Array.Expr);
/* line 4508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenArraySize (yyP295, yyP294->Array.Type);
/* line 4508 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
/* line 4510 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4510 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP294)))) goto yyL3;
  {
/* line 4511 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("sizeof(");
/* line 4511 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP294);
/* line 4511 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *)");
  }
  }
   return;
yyL3:;

/* line 4513 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4514 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("sizeof(");
/* line 4514 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP294);
/* line 4514 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

;
}

static void CodeChkExpr
# if defined __STDC__ | defined __cplusplus
(register bool yyP300, register bool yyP299, register tTree yyP298, tSymbol yyP297, register tTree yyP296)
# else
(yyP300, yyP299, yyP298, yyP297, yyP296)
 register bool yyP300;
 register bool yyP299;
 register tTree yyP298;
 tSymbol yyP297;
 register tTree yyP296;
# endif
{
  if (equalbool (yyP300, true)) {
  if (equalbool (yyP299, true)) {
/* line 4522 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (RNGCHK);
/* line 4523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP298);
/* line 4523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP297);
/* line 4523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP296));
/* line 4523 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  }
  if (equalbool (yyP300, true)) {
  if (yyP296->Kind == kArray) {
/* line 4525 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4526 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (RNGCHK);
/* line 4526 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4526 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP298);
/* line 4526 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4526 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP296->Array.Expr);
/* line 4526 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
  }
/* line 4528 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4528 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP298);
  }
   return;

;
}

static void CodeChkUBExpr
# if defined __STDC__ | defined __cplusplus
(register bool yyP306, register bool yyP305, register tTree yyP304, register tTree yyP303, tSymbol yyP302, register tTree yyP301)
# else
(yyP306, yyP305, yyP304, yyP303, yyP302, yyP301)
 register bool yyP306;
 register bool yyP305;
 register tTree yyP304;
 register tTree yyP303;
 tSymbol yyP302;
 register tTree yyP301;
# endif
{
  if (equalbool (yyP306, true)) {
  if (equalbool (yyP305, true)) {
  if (yyP301->Kind == kArray) {
/* line 4534 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4535 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (RNGCHKUB);
/* line 4535 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4535 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP304);
/* line 4535 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4535 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP303);
/* line 4535 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4535 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP302);
/* line 4535 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 4535 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP301));
/* line 4535 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("),");
  }
   return;

  }
  }
  }
  if (equalbool (yyP306, true)) {
  if (yyP301->Kind == kArray) {
/* line 4538 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4539 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (RNGCHKUB);
/* line 4539 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4539 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP304);
/* line 4539 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4539 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP303);
/* line 4539 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4539 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP301->Array.Expr);
/* line 4539 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("),");
  }
   return;

  }
  }
/* line 4542 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

;
}

static void CodeChkLBExpr
# if defined __STDC__ | defined __cplusplus
(register bool yyP308, register tTree yyP307)
# else
(yyP308, yyP307)
 register bool yyP308;
 register tTree yyP307;
# endif
{
  if (equalbool (yyP308, true)) {
/* line 4547 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4547 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (RNGCHKLB);
/* line 4547 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4547 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP307);
/* line 4547 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

  }
/* line 4548 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4548 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP307);
  }
   return;

;
}

static tSymbol GetElementSymbol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP309)
# else
(yyP309)
 register tTree yyP309;
# endif
{
  if (yyP309->Kind == kIdentifier) {
/* line 4552 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP309->Identifier.Sym;

  }
  if (yyP309->Kind == kSubscript) {
/* line 4553 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return GetElementSymbol (yyP309->Subscript.Next);

  }
  if (yyP309->Kind == kRange) {
/* line 4554 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return GetElementSymbol (yyP309->Range.Next);

  }
 yyAbort ("GetElementSymbol");
}

void CodeSymRef
# if defined __STDC__ | defined __cplusplus
(register tTree yyP312, tSymbol yyP311, register bool yyP310)
# else
(yyP312, yyP311, yyP310)
 register tTree yyP312;
 tSymbol yyP311;
 register bool yyP310;
# endif
{

  switch (yyP312->Kind) {
  case kAFormal:
  if (yyP312->AFormal.By->Kind == kByRef) {
  if (equalbool (yyP310, true)) {
/* line 4559 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4559 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
   return;

  }
/* line 4560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4560 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
   return;

  }
  if (yyP312->AFormal.By->Kind == kByVal) {
  if (equalbool (yyP310, true)) {
/* line 4562 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4562 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&");
/* line 4562 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
   return;

  }
/* line 4563 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4563 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
   return;

  }
  break;
  case kAnId:
  if (equalbool (yyP310, true)) {
/* line 4565 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4565 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&");
/* line 4565 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
   return;

  }
/* line 4566 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4566 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
   return;

  case kReplicator:
  if (equalbool (yyP310, true)) {
/* line 4568 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4568 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&");
/* line 4568 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
   return;

  }
/* line 4569 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4569 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
   return;

  case kIs:
  if (equalbool (yyP310, true)) {
/* line 4571 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4571 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP311))))) goto yyL9;
  {
/* line 4571 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&");
/* line 4571 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
  }
   return;
yyL9:;

  }
/* line 4572 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4572 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP311))))) goto yyL10;
  {
/* line 4572 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
  }
   return;
yyL10:;

  if (equalbool (yyP310, true)) {
/* line 4573 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4573 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
   return;

  }
/* line 4574 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4574 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4574 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
   return;

  case kRetypes:
  if (equalbool (yyP310, true)) {
/* line 4576 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4576 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP312->Retypes.Type)))) goto yyL13;
  {
/* line 4576 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&");
/* line 4576 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
  }
   return;
yyL13:;

  }
/* line 4577 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4577 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP312->Retypes.Type)))) goto yyL14;
  {
/* line 4577 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
  }
   return;
yyL14:;

  if (equalbool (yyP310, true)) {
/* line 4578 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4578 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
   return;

  }
/* line 4579 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4579 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4579 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
   return;

  case kVal:
  if (equalbool (yyP310, true)) {
/* line 4581 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4581 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP311))))) goto yyL17;
  {
/* line 4581 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&");
/* line 4581 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
  }
   return;
yyL17:;

  }
/* line 4582 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4582 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (SymbolType (yyP311))))) goto yyL18;
  {
/* line 4582 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
  }
   return;
yyL18:;

  if (equalbool (yyP310, true)) {
/* line 4583 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4583 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
   return;

  }
/* line 4584 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4584 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4584 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
   return;

  case kValRetypes:
  if (equalbool (yyP310, true)) {
/* line 4586 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4586 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP312->ValRetypes.Type)))) goto yyL21;
  {
/* line 4586 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&");
/* line 4586 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
  }
   return;
yyL21:;

  }
/* line 4587 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4587 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsScalarType (yyP312->ValRetypes.Type)))) goto yyL22;
  {
/* line 4587 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
  }
   return;
yyL22:;

  if (equalbool (yyP310, true)) {
/* line 4588 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4588 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
   return;

  }
/* line 4589 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4589 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 4589 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeSym (yyP311);
  }
   return;

  }

  if (Tree_IsType (yyP312, kSpec)) {
/* line 4591 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4591 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WNYI (yyP312, yyP312->Spec.Pos);
  }
   return;

  }
;
}

static void CodeSym
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP313)
# else
(yyP313)
 tSymbol yyP313;
# endif
{
/* line 4596 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4596 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Symbol (yyP313) . Depth == 0))) goto yyL1;
  {
/* line 4597 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP313);
  }
  }
   return;
yyL1:;

/* line 4599 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4599 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP313)))) goto yyL2;
  {
/* line 4599 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP313);
  }
  }
   return;
yyL2:;

/* line 4601 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4601 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("FP");
/* line 4601 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeIndirect (yyP313, CurProc);
/* line 4601 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("->");
/* line 4601 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP313);
  }
   return;

;
}

static void CodeIndirect
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP315, register tTree yyP314)
# else
(yyP315, yyP314)
 tSymbol yyP315;
 register tTree yyP314;
# endif
{
  if (yyP314->Kind == kDefProc) {
/* line 4605 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4605 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Symbol (yyP315) . Depth <= Symbol (yyP314->DefProc.Sym) . Depth))) goto yyL1;
  {
/* line 4605 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("->Chain");
/* line 4605 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeIndirect (yyP315, Symbol (yyP314 -> DefProc . Parent) . Kind);
  }
  }
   return;
yyL1:;

  }
  if (yyP314->Kind == kDefFunc) {
/* line 4606 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4606 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Symbol (yyP315) . Depth <= Symbol (yyP314->DefFunc.Sym) . Depth))) goto yyL2;
  {
/* line 4606 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("->Chain");
/* line 4606 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeIndirect (yyP315, Symbol (yyP314 -> DefFunc . Parent) . Kind);
  }
  }
   return;
yyL2:;

  }
;
}

static void CCodeTypeName
# if defined __STDC__ | defined __cplusplus
(register tTree yyP317, register bool yyP316)
# else
(yyP317, yyP316)
 register tTree yyP317;
 register bool yyP316;
# endif
{
  if (equalbool (yyP316, true)) {
/* line 4612 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4612 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP317)))) goto yyL1;
  {
/* line 4612 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4612 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP317);
/* line 4612 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
  }
  }
   return;
yyL1:;

  }
/* line 4613 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4613 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (yyP317)))) goto yyL2;
  {
/* line 4613 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4613 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP317);
/* line 4613 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
  }
  }
   return;
yyL2:;

  if (equalbool (yyP316, true)) {
/* line 4615 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4615 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4615 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP317);
/* line 4615 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
  }
   return;

  }
/* line 4616 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4616 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4616 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP317);
/* line 4616 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")");
  }
   return;

;
}

static void CCodeType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP318)
# else
(yyP318)
 register tTree yyP318;
# endif
{

  switch (yyP318->Kind) {
  case kInt:
/* line 4620 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4620 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT");
  }
   return;

  case kInt64:
/* line 4621 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4621 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT64");
  }
   return;

  case kInt32:
/* line 4622 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4622 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT32");
  }
   return;

  case kInt16:
/* line 4623 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4623 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT16");
  }
   return;

  case kReal32:
/* line 4624 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4624 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("REAL32");
  }
   return;

  case kReal64:
/* line 4625 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4625 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("REAL64");
  }
   return;

  case kBool:
/* line 4626 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4626 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("BOOL");
  }
   return;

  case kByte:
/* line 4627 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4627 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("BYTE");
  }
   return;

  case kArray:
/* line 4628 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4628 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP318->Array.Type);
  }
   return;

  case kChan:
/* line 4629 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4629 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("CHAN");
  }
   return;

  }

;
}

static void CCodeTypeId
# if defined __STDC__ | defined __cplusplus
(register tTree yyP319)
# else
(yyP319)
 register tTree yyP319;
# endif
{
  if (yyP319->Kind == kArray) {
/* line 4633 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4633 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 4633 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP319->Array.Expr);
/* line 4633 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 4633 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (yyP319->Array.Type);
  }
   return;

  }
;
}

static void CCodeTypeIdChkConst
# if defined __STDC__ | defined __cplusplus
(register tTree yyP321, register tPosition yyP320)
# else
(yyP321, yyP320)
 register tTree yyP321;
 register tPosition yyP320;
# endif
{
  if (yyP321->Kind == kArray) {
/* line 4637 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4637 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsConstInt (yyP321->Array.Expr)))) goto yyL1;
  {
/* line 4638 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[]");
/* line 4638 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (yyP321->Array.Type);
/* line 4639 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Implementation restriction: arrays may not be unknown size", xxError, yyP320);
  }
  }
   return;
yyL1:;

/* line 4641 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4641 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 4641 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP321->Array.Expr);
/* line 4641 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 4641 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (yyP321->Array.Type);
  }
   return;

  }
;
}

void OccCodeType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP322)
# else
(yyP322)
 register tTree yyP322;
# endif
{
  if (yyP322 == NULL) {
/* line 4646 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }

  switch (yyP322->Kind) {
  case kAType:
  if (yyP322->AType.Next->Kind == kNoType) {
/* line 4647 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4647 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP322->AType.Type);
  }
   return;

  }
/* line 4648 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4648 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP322->AType.Type);
/* line 4648 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4648 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP322->AType.Next);
  }
   return;

  case kInt:
/* line 4649 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4649 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT");
  }
   return;

  case kInt16:
/* line 4650 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4650 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT16");
  }
   return;

  case kInt32:
/* line 4651 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4651 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT32");
  }
   return;

  case kInt64:
/* line 4652 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4652 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("INT64");
  }
   return;

  case kReal32:
/* line 4653 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4653 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("REAL32");
  }
   return;

  case kReal64:
/* line 4654 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4654 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("REAL64");
  }
   return;

  case kBool:
/* line 4655 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4655 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("BOOL");
  }
   return;

  case kByte:
/* line 4656 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4656 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("BYTE");
  }
   return;

  case kArray:
/* line 4657 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4657 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstInt (yyP322->Array.Expr)))) goto yyL12;
  {
/* line 4657 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 4657 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (ValConstInt (yyP322->Array.Expr));
/* line 4657 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
/* line 4657 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP322->Array.Type);
  }
  }
   return;
yyL12:;

/* line 4658 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4658 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[]");
/* line 4658 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP322->Array.Type);
  }
   return;

  case kChan:
/* line 4659 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4659 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("CHAN OF ");
/* line 4659 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeProtocol (yyP322->Chan.Protocol);
  }
   return;

  case kTimer:
/* line 4660 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4660 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("TIMER");
  }
   return;

  }

;
}

static void OccCodeProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP323)
# else
(yyP323)
 register tTree yyP323;
# endif
{
  if (yyP323->Kind == kAny) {
/* line 4664 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4664 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ANY");
  }
   return;

  }
  if (yyP323->Kind == kNamed) {
/* line 4665 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4665 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteOccSym (yyP323->Named.Sym);
  }
   return;

  }
  if (yyP323->Kind == kSimple) {
/* line 4666 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4666 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP323->Simple.Type);
  }
   return;

  }
  if (yyP323->Kind == kCounted) {
/* line 4667 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4667 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP323->Counted.Length);
/* line 4667 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (":: ");
/* line 4667 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP323->Counted.Type);
  }
   return;

  }
;
}

static void CodeOp
# if defined __STDC__ | defined __cplusplus
(register tTree yyP324)
# else
(yyP324)
 register tTree yyP324;
# endif
{

  switch (yyP324->Kind) {
  case kLess:
/* line 4672 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4672 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" < ");
  }
   return;

  case kGreater:
/* line 4673 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4673 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" > ");
  }
   return;

  case kLessEqual:
/* line 4674 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4674 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" <= ");
  }
   return;

  case kGreaterEqual:
/* line 4675 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4675 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" >= ");
  }
   return;

  case kEqual:
/* line 4676 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4676 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" == ");
  }
   return;

  case kNotEqual:
/* line 4677 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4677 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" != ");
  }
   return;

  case kAdd:
/* line 4678 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4678 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" + ");
  }
   return;

  case kSubtract:
/* line 4679 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4679 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" - ");
  }
   return;

  case kMultiply:
/* line 4680 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4680 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" * ");
  }
   return;

  case kDivide:
/* line 4681 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4681 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" / ");
  }
   return;

  case kRem:
/* line 4683 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4683 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" % ");
  }
   return;

  case kBitAnd:
/* line 4685 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4685 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" & ");
  }
   return;

  case kBitOr:
/* line 4686 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4686 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" | ");
  }
   return;

  case kBitEor:
/* line 4687 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4687 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ^ ");
  }
   return;

  case kBitNot:
/* line 4688 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4688 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ~ ");
  }
   return;

  case kSize:
/* line 4690 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4690 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" sizeof ");
  }
   return;

  case kPlus:
/* line 4691 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4691 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" + ");
  }
   return;

  case kMinus:
/* line 4692 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4692 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" - ");
  }
   return;

  case kTimes:
/* line 4693 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4693 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" * ");
  }
   return;

  case kAnd:
/* line 4694 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4694 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" && ");
  }
   return;

  case kOr:
/* line 4695 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4695 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" || ");
  }
   return;

  case kNot:
/* line 4696 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4696 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ! ");
  }
   return;

  }

;
}

static int PrimTypeSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP325)
# else
(yyP325)
 register tTree yyP325;
# endif
{

  switch (yyP325->Kind) {
  case kInt:
/* line 4704 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return  (IS_Mode(xx16bitINT)) ? 2 : 4;

  case kInt16:
/* line 4705 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 2;

  case kInt32:
/* line 4706 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 4;

  case kInt64:
/* line 4707 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 8;

  case kReal32:
/* line 4708 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 4;

  case kReal64:
/* line 4709 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 8;

  case kByte:
/* line 4710 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 1;

  case kBool:
/* line 4711 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 1;

  }

 yyAbort ("PrimTypeSize");
}

static tTree GetPrimType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP326)
# else
(yyP326)
 register tTree yyP326;
# endif
{
  if (yyP326->Kind == kArray) {
/* line 4716 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return GetPrimType (yyP326->Array.Type);

  }
/* line 4717 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP326;

}

static bool IsPrimType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP327)
# else
(yyP327)
 register tTree yyP327;
# endif
{
  if (Tree_IsType (yyP327, kPrimitive)) {
/* line 4721 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return true;

  }
  return false;
}

bool IsScalarType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP328)
# else
(yyP328)
 register tTree yyP328;
# endif
{
  if (yyP328->Kind == kArray) {
/* line 4725 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return false;

  }
/* line 4726 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return true;

}

static bool IsTimer
# if defined __STDC__ | defined __cplusplus
(register tTree yyP329)
# else
(yyP329)
 register tTree yyP329;
# endif
{
  if (yyP329->Kind == kIdentifier) {
/* line 4730 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return Tree_IsType (SymbolType (yyP329->Identifier.Sym), kTimer);

  }
  if (yyP329->Kind == kSubscript) {
/* line 4731 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return IsTimer (yyP329->Subscript.Next);

  }
  if (yyP329->Kind == kRange) {
/* line 4732 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return IsTimer (yyP329->Range.Next);

  }
 yyAbort ("IsTimer");
}

static bool IsAtomicProcess
# if defined __STDC__ | defined __cplusplus
(register tTree yyP330)
# else
(yyP330)
 register tTree yyP330;
# endif
{
/* line 4737 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return (yyP330 -> Process . ATOMIC);

}

bool IsAtomicProc
# if defined __STDC__ | defined __cplusplus
(register tTree yyP331)
# else
(yyP331)
 register tTree yyP331;
# endif
{
  if (yyP331->Kind == kPrototypeProc) {
/* line 4741 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4741 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP331 -> PrototypeProc . Lang != xxOccam))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP331->Kind == kDefProc) {
/* line 4742 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4742 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP331 -> DefProc . ATOMIC))) goto yyL2;
  }
   return true;
yyL2:;

  }
  if (Tree_IsType (yyP331, kDefAFunc)) {
/* line 4743 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return true;

  }
  return false;
}

bool IsParProc
# if defined __STDC__ | defined __cplusplus
(register tTree yyP332)
# else
(yyP332)
 register tTree yyP332;
# endif
{
  if (yyP332->Kind == kDefProc) {
/* line 4748 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4748 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP332 -> DefProc . isPar || (yyP332->DefProc.Sym == TreeRoot -> Start . OuterProc && ! IS_Mode (xxLibrary))))) goto yyL1;
  }
   return true;
yyL1:;

  }
  return false;
}

bool IsPrototype
# if defined __STDC__ | defined __cplusplus
(register tTree yyP333)
# else
(yyP333)
 register tTree yyP333;
# endif
{
  if (yyP333->Kind == kPrototypeProc) {
/* line 4753 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return true;

  }
  if (yyP333->Kind == kPrototypeFunc) {
/* line 4754 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return true;

  }
  return false;
}

static bool IsBoundedType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP334)
# else
(yyP334)
 register tTree yyP334;
# endif
{
  if (yyP334->Kind == kArray) {
  if (yyP334->Array.Expr->Kind == kUnBound) {
/* line 4760 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return false;

  }
/* line 4762 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return IsBoundedType (yyP334->Array.Type);

  }
/* line 4764 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return true;

}

static bool IsByteArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP335)
# else
(yyP335)
 register tTree yyP335;
# endif
{
  if (yyP335->Kind == kArray) {
  if (yyP335->Array.Type->Kind == kByte) {
/* line 4769 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return true;

  }
/* line 4770 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4770 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsByteArray (yyP335->Array.Type)))) goto yyL2;
  }
   return true;
yyL2:;

  }
  return false;
}

static int CountArrayDims
# if defined __STDC__ | defined __cplusplus
(register tTree yyP336)
# else
(yyP336)
 register tTree yyP336;
# endif
{
  if (yyP336->Kind == kArray) {
/* line 4775 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 1 + CountArrayDims (yyP336->Array.Type);

  }
/* line 4776 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

}

tTree GenOccPrototypes
# if defined __STDC__ | defined __cplusplus
(register tTree yyP337)
# else
(yyP337)
 register tTree yyP337;
# endif
{
  if (yyP337->Kind == kStart) {
/* line 4785 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoTree;

  }
  if (yyP337->Kind == kPrototypeProc) {
/* line 4787 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP337 -> PrototypeProc . CGNext;

  }
  if (yyP337->Kind == kPrototypeFunc) {
/* line 4789 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP337 -> PrototypeFunc . CGNext;

  }
  if (yyP337->Kind == kDefProc) {
/* line 4791 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4791 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTopLevel (yyP337->DefProc.Sym)))) goto yyL4;
  {
/* line 4791 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (IsAtomicProc (yyP337))) goto yyL4;
  {
/* line 4792 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("EXTERN_ATOMIC PROC ");
/* line 4792 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteOccSym (yyP337->DefProc.Sym);
/* line 4792 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4792 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOccPrototypeFormals (yyP337->DefProc.Formals);
/* line 4792 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (") : ");
/* line 4792 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (outname);
/* line 4792 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return yyP337 -> DefProc . CGNext;
yyL4:;

/* line 4794 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4794 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTopLevel (yyP337->DefProc.Sym)))) goto yyL5;
  {
/* line 4795 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("EXTERN_OCCAM PROC ");
/* line 4795 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteOccSym (yyP337->DefProc.Sym);
/* line 4795 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4795 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOccPrototypeFormals (yyP337->DefProc.Formals);
/* line 4795 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (") : ");
/* line 4795 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (outname);
/* line 4795 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return yyP337 -> DefProc . CGNext;
yyL5:;

/* line 4796 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP337 -> DefProc . CGNext;

  }
  if (Tree_IsType (yyP337, kDefAFunc)) {
/* line 4798 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4798 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTopLevel (yyP337->DefAFunc.Sym)))) goto yyL7;
  {
/* line 4799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("EXTERN_ATOMIC ");
/* line 4799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (yyP337->DefAFunc.TypeList);
/* line 4799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" FUNCTION ");
/* line 4799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteOccSym (yyP337->DefAFunc.Sym);
/* line 4799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 4799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOccPrototypeFormals (yyP337->DefAFunc.Formals);
/* line 4799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (") : ");
/* line 4799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (outname);
/* line 4799 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return yyP337 -> DefAFunc . CGNext;
yyL7:;

/* line 4800 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP337 -> DefAFunc . CGNext;

  }
  if (yyP337->Kind == kHCode) {
/* line 4801 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP337 -> HCode . CGNext;

  }
 yyAbort ("GenOccPrototypes");
}

static void GenOccPrototypeFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP338)
# else
(yyP338)
 register tTree yyP338;
# endif
{
  if (yyP338->Kind == kAFormal) {
  if (yyP338->AFormal.Next->Kind == kNoFormal) {
/* line 4805 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4805 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP338 -> AFormal . U == xxOutput))) goto yyL1;
  {
/* line 4806 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (SymbolType (yyP338->AFormal.Sym));
/* line 4806 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" out");
  }
  }
   return;
yyL1:;

/* line 4808 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4808 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP338 -> AFormal . U == xxInput))) goto yyL2;
  {
/* line 4809 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (SymbolType (yyP338->AFormal.Sym));
/* line 4809 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" in");
  }
  }
   return;
yyL2:;

  if (yyP338->AFormal.By->Kind == kByRef) {
/* line 4811 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4812 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (SymbolType (yyP338->AFormal.Sym));
  }
   return;

  }
  if (yyP338->AFormal.By->Kind == kByVal) {
/* line 4814 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4815 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("VAL ");
/* line 4815 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (SymbolType (yyP338->AFormal.Sym));
  }
   return;

  }
  }
/* line 4817 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4817 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP338 -> AFormal . U == xxOutput))) goto yyL5;
  {
/* line 4818 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (SymbolType (yyP338->AFormal.Sym));
/* line 4818 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" out,");
/* line 4819 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOccPrototypeFormals (yyP338->AFormal.Next);
  }
  }
   return;
yyL5:;

/* line 4821 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4821 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP338 -> AFormal . U == xxInput))) goto yyL6;
  {
/* line 4822 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (SymbolType (yyP338->AFormal.Sym));
/* line 4822 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" in,");
/* line 4823 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOccPrototypeFormals (yyP338->AFormal.Next);
  }
  }
   return;
yyL6:;

  if (yyP338->AFormal.By->Kind == kByRef) {
/* line 4825 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4826 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (SymbolType (yyP338->AFormal.Sym));
/* line 4826 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4827 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOccPrototypeFormals (yyP338->AFormal.Next);
  }
   return;

  }
  if (yyP338->AFormal.By->Kind == kByVal) {
/* line 4829 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4830 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("VAL ");
/* line 4830 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OccCodeType (SymbolType (yyP338->AFormal.Sym));
/* line 4830 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 4831 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenOccPrototypeFormals (yyP338->AFormal.Next);
  }
   return;

  }
  }
;
}

tTree GenCPrototype
# if defined __STDC__ | defined __cplusplus
(register tTree yyP339)
# else
(yyP339)
 register tTree yyP339;
# endif
{
  if (yyP339->Kind == kStart) {
/* line 4836 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoTree;

  }
  if (yyP339->Kind == kPrototypeProc) {
/* line 4838 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP339 -> PrototypeProc . CGNext;

  }
  if (yyP339->Kind == kPrototypeFunc) {
/* line 4840 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP339 -> PrototypeFunc . CGNext;

  }
  if (yyP339->Kind == kDefFunc) {
/* line 4842 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4842 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTopLevel (yyP339->DefFunc.Sym)))) goto yyL4;
  {
/* line 4843 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{\"");
/* line 4843 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenFuncHead (yyP339);
/* line 4843 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";\",NULL,0},");
/* line 4843 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return yyP339 -> DefFunc . CGNext;
yyL4:;

  }
  if (yyP339->Kind == kDefProc) {
/* line 4846 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4846 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTopLevel (yyP339->DefProc.Sym)))) goto yyL5;
  {
/* line 4846 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsAtomicProc (yyP339)))) goto yyL5;
  {
/* line 4847 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{\"");
/* line 4847 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcHead (yyP339);
/* line 4847 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";\",NULL,0},");
/* line 4847 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
   return yyP339 -> DefProc . CGNext;
yyL5:;

/* line 4850 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4850 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsTopLevel (yyP339->DefProc.Sym)))) goto yyL6;
  {
/* line 4851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{\"");
/* line 4851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenProcHead (yyP339);
/* line 4851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";\",\"");
/* line 4851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP339->DefProc.Sym);
/* line 4851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\",sizeof(tSF_");
/* line 4851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP339->DefProc.Sym);
/* line 4851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")},");
/* line 4851 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return yyP339 -> DefProc . CGNext;
yyL6:;

/* line 4855 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP339 -> DefProc . CGNext;

  }
  if (Tree_IsType (yyP339, kDefAFunc)) {
/* line 4854 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP339 -> DefAFunc . CGNext;

  }
  if (yyP339->Kind == kHCode) {
/* line 4857 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP339 -> HCode . CGNext;

  }
 yyAbort ("GenCPrototype");
}

void CodeMainEntryParameters
# if defined __STDC__ | defined __cplusplus
(register tTree yyP340)
# else
(yyP340)
 register tTree yyP340;
# endif
{
  if (yyP340->Kind == kDefProc) {
  if (yyP340->DefProc.Formals->Kind == kNoFormal) {
/* line 4864 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP340->DefProc.Formals->Kind == kAFormal) {
  if (yyP340->DefProc.Formals->AFormal.Next->Kind == kAFormal) {
  if (yyP340->DefProc.Formals->AFormal.Next->AFormal.Next->Kind == kNoFormal) {
/* line 4866 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4867 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (IsSPChan (SymbolType (yyP340->DefProc.Formals->AFormal.Sym)))) goto yyL2;
  {
/* line 4867 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (IsSPChan (SymbolType (yyP340->DefProc.Formals->AFormal.Next->AFormal.Sym)))) goto yyL2;
  {
/* line 4868 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP340->DefProc.Formals -> AFormal . U != xxOutput))) goto yyL2;
  {
/* line 4868 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP340->DefProc.Formals->AFormal.Next -> AFormal . U != xxInput))) goto yyL2;
  {
/* line 4869 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MAINFP->");
/* line 4869 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP340->DefProc.Formals->AFormal.Sym);
/* line 4869 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=&fs;");
/* line 4869 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4870 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MAINFP->");
/* line 4870 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP340->DefProc.Formals->AFormal.Next->AFormal.Sym);
/* line 4870 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=&ts;");
/* line 4870 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
  }
  }
   return;
yyL2:;

  }
  if (yyP340->DefProc.Formals->AFormal.Next->AFormal.Next->Kind == kAFormal) {
  if (yyP340->DefProc.Formals->AFormal.Next->AFormal.Next->AFormal.Next->Kind == kNoFormal) {
  if (yyP340->DefProc.Formals->AFormal.Next->AFormal.Next->AFormal.Type->Kind == kArray) {
  if (yyP340->DefProc.Formals->AFormal.Next->AFormal.Next->AFormal.Type->Array.Expr->Kind == kUnBound) {
  if (yyP340->DefProc.Formals->AFormal.Next->AFormal.Next->AFormal.Type->Array.Type->Kind == kInt) {
/* line 4873 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4874 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (IsSPChan (SymbolType (yyP340->DefProc.Formals->AFormal.Sym)))) goto yyL3;
  {
/* line 4874 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (IsSPChan (SymbolType (yyP340->DefProc.Formals->AFormal.Next->AFormal.Sym)))) goto yyL3;
  {
/* line 4875 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP340->DefProc.Formals -> AFormal . U != xxOutput))) goto yyL3;
  {
/* line 4875 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP340->DefProc.Formals->AFormal.Next -> AFormal . U != xxInput))) goto yyL3;
  {
/* line 4876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MAINFP->");
/* line 4876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP340->DefProc.Formals->AFormal.Sym);
/* line 4876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=&fs;");
/* line 4876 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4877 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MAINFP->");
/* line 4877 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP340->DefProc.Formals->AFormal.Next->AFormal.Sym);
/* line 4877 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=&ts;");
/* line 4877 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4878 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MAINFP->");
/* line 4878 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP340->DefProc.Formals->AFormal.Next->AFormal.Next->AFormal.Sym);
/* line 4878 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=mem;");
/* line 4878 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4879 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MAINFP->");
/* line 4879 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP340->DefProc.Formals->AFormal.Next->AFormal.Next->AFormal.Sym);
/* line 4879 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_Dim0=mem_size;");
/* line 4879 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
  }
  }
  }
   return;
yyL3:;

  }
  }
  }
  }
  }
  }
  if (yyP340->DefProc.Formals->AFormal.Next->Kind == kNoFormal) {
  if (yyP340->DefProc.Formals->AFormal.Type->Kind == kArray) {
  if (yyP340->DefProc.Formals->AFormal.Type->Array.Expr->Kind == kUnBound) {
  if (yyP340->DefProc.Formals->AFormal.Type->Array.Type->Kind == kInt) {
/* line 4882 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4883 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MAINFP->");
/* line 4883 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP340->DefProc.Formals->AFormal.Sym);
/* line 4883 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=mem;");
/* line 4883 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 4884 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("MAINFP->");
/* line 4884 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP340->DefProc.Formals->AFormal.Sym);
/* line 4884 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("_Dim0=mem_size;");
/* line 4884 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
  }
  }
  }
/* line 4887 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4887 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Main entry point does not have acceptable parameter list", xxError, yyP340->DefProc.Pos);
  }
   return;

  }
/* line 4889 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4889 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("Main Entry Point must be a PROC", xxError, yyP340->Spec.Pos);
  }
   return;

;
}

static bool IsSPChan
# if defined __STDC__ | defined __cplusplus
(register tTree yyP341)
# else
(yyP341)
 register tTree yyP341;
# endif
{
  if (yyP341->Kind == kChan) {
  if (yyP341->Chan.Protocol->Kind == kNamed) {
/* line 4894 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4894 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Symbol (yyP341->Chan.Protocol->Named.Sym) . Id == MakeIdent ("SP", 2)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  }
  return false;
}

void GenStatics
# if defined __STDC__ | defined __cplusplus
(register tTree yyP342)
# else
(yyP342)
 register tTree yyP342;
# endif
{
  if (yyP342->Kind == kStart) {
/* line 4899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4899 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStatics (yyP342->Start.Process);
  }
   return;

  }
  if (yyP342->Kind == kNullProcess) {
/* line 4901 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4901 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStatics (yyP342->NullProcess.SpecList);
  }
   return;

  }
  if (yyP342->Kind == kNoSpec) {
/* line 4903 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP342->Kind == kASpec) {
/* line 4905 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4905 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStatic (yyP342->ASpec.Spec);
/* line 4905 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStatics (yyP342->ASpec.Next);
  }
   return;

  }
/* line 4907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("Error in GenStatics - ");
/* line 4907 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteTreeNode (yyf, yyP342);
  }
   return;

;
}

static void GenStatic
# if defined __STDC__ | defined __cplusplus
(register tTree yyP343)
# else
(yyP343)
 register tTree yyP343;
# endif
{
  if (yyP343->Kind == kVal) {
/* line 4913 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4913 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (ExprType (yyP343->Val.Expr))))) goto yyL1;
  }
   return;
yyL1:;

/* line 4915 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4915 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsZeroSizeType (ExprType (yyP343->Val.Expr))))) goto yyL2;
  {
/* line 4916 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 4916 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (yyP343->Val.Expr));
/* line 4916 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 4916 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP343->Val.Sym);
/* line 4916 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = NULL;");
/* line 4916 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL2:;

  if (Tree_IsType (yyP343->Val.Expr, kStringElement)) {
/* line 4918 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static BYTE ");
/* line 4919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP343->Val.Sym);
/* line 4919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[] = {");
/* line 4919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstArray (ExprType (yyP343->Val.Expr), yyP343->Val.Expr -> StringElement . CA);
/* line 4919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 4919 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP343->Val.Expr->Kind == kElementalExpr) {
/* line 4921 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4922 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 4922 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (ExprType (yyP343->Val.Expr));
/* line 4922 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 4922 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP343->Val.Sym);
/* line 4922 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (ExprType (yyP343->Val.Expr));
/* line 4922 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = {");
/* line 4922 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstArray (ExprType (yyP343->Val.Expr->ElementalExpr.Elemental), yyP343->Val.Expr->ElementalExpr.Elemental -> Elemental . CA);
/* line 4922 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 4922 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
  if (yyP343->Kind == kValRetypes) {
/* line 4925 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4925 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (yyP343->ValRetypes.Type)))) goto yyL5;
  }
   return;
yyL5:;

/* line 4927 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4927 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsZeroSizeType (ExprType (yyP343->ValRetypes.Expr))))) goto yyL6;
  {
/* line 4928 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 4928 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP343->ValRetypes.Type);
/* line 4928 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *");
/* line 4928 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP343->ValRetypes.Sym);
/* line 4928 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = NULL;");
/* line 4928 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL6:;

  if (Tree_IsType (yyP343->ValRetypes.Expr, kStringElement)) {
/* line 4930 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4931 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 4931 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP343->ValRetypes.Type);
/* line 4931 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 4931 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP343->ValRetypes.Sym);
/* line 4931 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (yyP343->ValRetypes.Type);
/* line 4931 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = {");
/* line 4931 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstArray (yyP343->ValRetypes.Type, yyP343->ValRetypes.Expr -> StringElement . CA);
/* line 4931 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 4931 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP343->ValRetypes.Expr->Kind == kElementalExpr) {
/* line 4933 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 4934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP343->ValRetypes.Type);
/* line 4934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 4934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP343->ValRetypes.Sym);
/* line 4934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (yyP343->ValRetypes.Type);
/* line 4934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = {");
/* line 4934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstArray (yyP343->ValRetypes.Type, yyP343->ValRetypes.Expr->ElementalExpr.Elemental -> Elemental . CA);
/* line 4934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 4934 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
/* line 4937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4937 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! (IsPrimType (ExprType (yyP343->ValRetypes.Expr)))) goto yyL9;
  {
/* line 4938 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("static ");
/* line 4938 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP343->ValRetypes.Type);
/* line 4938 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" ");
/* line 4938 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP343->ValRetypes.Sym);
/* line 4938 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeId (yyP343->ValRetypes.Type);
/* line 4938 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" = {");
/* line 4939 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
{
      unsigned char tmp[8];
      tConstArray CA = (tConstArray)tmp;

      WriteConstArray(ExprType(yyP343->ValRetypes.Expr),ValConstExpr(yyP343->ValRetypes.Expr),CA);
      RetypeConst(PrimTypeSize(ExprType(yyP343->ValRetypes.Expr)),CA,PrimTypeSize(ArrayPrimType(yyP343->ValRetypes.Type)),CA);
      CodeConstArray(yyP343->ValRetypes.Type,CA);
    }
/* line 4947 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("};");
/* line 4947 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
  }
   return;
yyL9:;

  }
  if (Tree_IsType (yyP343, kAVal)) {
/* line 4950 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4951 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("VAL constant cannot be calculated at compile time", xxError, yyP343->AVal.Pos);
  }
   return;

  }
  if (Tree_IsType (yyP343, kDefAProc)) {
/* line 4974 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (Tree_IsType (yyP343, kDefAFunc)) {
/* line 4975 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP343->Kind == kHCode) {
/* line 4976 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP343->Kind == kNullSpec) {
/* line 4977 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (Tree_IsType (yyP343, kDefAPro)) {
/* line 4978 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
/* line 4980 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4980 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("Error in GenStatic - ");
/* line 4980 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteTreeNode (yyf, yyP343);
  }
   return;

;
}

static void CodeConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP345, tConstArray yyP344)
# else
(yyP345, yyP344)
 register tTree yyP345;
 tConstArray yyP344;
# endif
{
  if (yyP345->Kind == kArray) {
  if (yyP345->Array.Type->Kind == kArray) {
/* line 4985 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 4986 "/home/ringwood/smw/occam/source/gmd/c.trafo" */

      { int i,sz;
        sz = CalcTypeSize(yyP345->Array.Type);
        for(i = 0; i < ValConstInt(yyP345->Array.Expr); ++i)
        {
          if (i) WriteChar(',');
          WriteStr("{");
          CodeConstArray(yyP345->Array.Type,yyP344+i*sz);
          WriteStr("}");
        }
      }
    
  }
   return;

  }
/* line 5000 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5001 "/home/ringwood/smw/occam/source/gmd/c.trafo" */

      { int i;
        int sz = PrimTypeSize(yyP345->Array.Type);

        for(i = 0; i < ValConstInt(yyP345->Array.Expr); ++i)
        {
          if (i) WriteChar(',');
          CodeConstExpr(yyP345->Array.Type,ReadConstArray(yyP345->Array.Type,yyP344+(sz*i)));
        }
      }
    
  }
   return;

  }
;
}

static void GenStaticExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP346)
# else
(yyP346)
 register tTree yyP346;
# endif
{
  if (yyP346->Kind == kElementalExpr) {
  if (yyP346->ElementalExpr.Elemental->Kind == kTable) {
/* line 5019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{ ");
/* line 5019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStaticExprList (yyP346->ElementalExpr.Elemental->Table.ExprList);
/* line 5019 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" }");
  }
   return;

  }
  }
  if (yyP346->Kind == kString) {
/* line 5021 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5021 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\"");
/* line 5021 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStrRef (yyP346->String.Value);
/* line 5021 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\"");
  }
   return;

  }
/* line 5023 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5023 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP346)))) goto yyL3;
  {
/* line 5023 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP346);
  }
  }
   return;
yyL3:;

/* line 5025 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5025 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Message ("VAL constant cannot be calculated at compile time", xxError, yyP346->Expr.Pos);
  }
   return;

;
}

static void GenStaticElement
# if defined __STDC__ | defined __cplusplus
(register tTree yyP348, register int yyP347)
# else
(yyP348, yyP347)
 register tTree yyP348;
 register int yyP347;
# endif
{
  if (yyP348->Kind == kIdentifier) {
/* line 5029 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5029 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("&");
/* line 5029 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStaticSym (yyP348->Identifier.Sym);
/* line 5029 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 5029 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP347);
/* line 5029 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
  }
   return;

  }
  if (yyP348->Kind == kSubscript) {
/* line 5030 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5030 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStaticElement (yyP348->Subscript.Next, ValConstInt (yyP348->Subscript.Expr));
/* line 5030 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("[");
/* line 5030 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP347);
/* line 5030 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("]");
  }
   return;

  }
  if (yyP348->Kind == kRange) {
/* line 5031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5031 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStaticElement (yyP348->Range.Next, ValConstInt (yyP348->Range.From) + yyP347);
  }
   return;

  }
;
}

static void GenStaticExprList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP349)
# else
(yyP349)
 register tTree yyP349;
# endif
{
  if (yyP349->Kind == kAnExpr) {
  if (yyP349->AnExpr.Next->Kind == kNoExpr) {
/* line 5036 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5036 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStaticExpr (yyP349->AnExpr.Expr);
  }
   return;

  }
/* line 5037 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5037 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStaticExpr (yyP349->AnExpr.Expr);
/* line 5037 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (", ");
/* line 5037 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenStaticExprList (yyP349->AnExpr.Next);
  }
   return;

  }
;
}

void GenShowValue
# if defined __STDC__ | defined __cplusplus
(register tTree yyP352, register tTree yyP351, tSymbol yyP350)
# else
(yyP352, yyP351, yyP350)
 register tTree yyP352;
 register tTree yyP351;
 tSymbol yyP350;
# endif
{
  if (yyP352->Kind == kATagPro) {
/* line 5042 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP352->Kind == kDefTagPro) {
/* line 5043 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
/* line 5044 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5045 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Tree_IsType (yyP352, kAFormal) && (Tree_IsType (SymbolKind (CalcParent (SymbolKind (yyP350))), kPrototypeProc) || Tree_IsType (SymbolKind (CalcParent (SymbolKind (yyP350))), kPrototypeFunc))))) goto yyL3;
  }
   return;
yyL3:;

  if (Tree_IsType (yyP352, kDefAProc)) {
/* line 5048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("printf(\"");
/* line 5048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP350);
/* line 5048 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\");");
  }
   return;

  }
  if (Tree_IsType (yyP352, kDefAFunc)) {
/* line 5049 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5049 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("printf(\"");
/* line 5049 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP350);
/* line 5049 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("\");");
  }
   return;

  }
  if (yyP351 == NULL) {
/* line 5051 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP351->Kind == kArray) {
  if (yyP351->Array.Type->Kind == kArray) {
/* line 5053 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5054 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 5055 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{ int i;");
/* line 5055 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 5056 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSizes (yyP351, yyP350, 0);
/* line 5057 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("for(i=0;i<s0;i++)");
/* line 5057 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 5058 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("{");
/* line 5058 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Indent ();
/* line 5059 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowTests (yyP351, yyP350, 0);
/* line 5060 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("else putchar(',');");
/* line 5061 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 5061 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
/* line 5062 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   Outdent ();
/* line 5062 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("}");
  }
   return;

  }
  if (yyP351->Array.Expr->Kind == kUnBound) {
/* line 5065 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ShowArray");
/* line 5066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP351->Array.Type);
/* line 5066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("((");
/* line 5066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeTypeName (yyP351->Array.Type, true);
/* line 5066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSym (Symbol (yyP350) . Kind, yyP350);
/* line 5066 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("),");
/* line 5067 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSym (Symbol (yyP350) . Kind, yyP350);
/* line 5067 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 5067 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP351));
/* line 5068 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
  }
   return;

  }
/* line 5070 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5070 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsConstExpr (yyP351->Array.Expr)))) goto yyL9;
  {
/* line 5070 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ShowArray");
/* line 5070 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP351->Array.Type);
/* line 5070 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 5070 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSym (Symbol (yyP350) . Kind, yyP350);
/* line 5070 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (",");
/* line 5070 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP351->Array.Expr);
/* line 5070 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
  }
  }
   return;
yyL9:;

/* line 5071 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  if (yyP351->Kind == kTimer) {
/* line 5072 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
/* line 5073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("Show");
/* line 5073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP351);
/* line 5073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(");
/* line 5073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSym (Symbol (yyP350) . Kind, yyP350);
/* line 5073 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
  }
   return;

;
}

static void GenShowSizes
# if defined __STDC__ | defined __cplusplus
(register tTree yyP355, tSymbol yyP354, register int yyP353)
# else
(yyP355, yyP354, yyP353)
 register tTree yyP355;
 tSymbol yyP354;
 register int yyP353;
# endif
{
  if (yyP355->Kind == kArray) {
  if (yyP355->Array.Expr->Kind == kUnBound) {
  if (yyP355->Array.Type->Kind == kArray) {
  if (yyP355->Array.Type->Array.Type->Kind == kArray) {
/* line 5079 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5080 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSizes (yyP355->Array.Type, yyP354, yyP353 + 1);
/* line 5081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("int s");
/* line 5081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP353);
/* line 5081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("= s");
/* line 5081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP353 + 1);
/* line 5081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 5081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSym (Symbol (yyP354) . Kind, yyP354);
/* line 5081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 5081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP355));
/* line 5081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 5081 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
/* line 5087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSizes (yyP355->Array.Type, yyP354, yyP353 + 1);
/* line 5087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("int s");
/* line 5087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP353);
/* line 5087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 5087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSym (Symbol (yyP354) . Kind, yyP354);
/* line 5087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteStr (DIM);
/* line 5087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (TypeDepth (yyP355));
/* line 5087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 5087 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  if (yyP355->Array.Type->Kind == kArray) {
  if (yyP355->Array.Type->Array.Type->Kind == kArray) {
/* line 5083 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5084 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSizes (yyP355->Array.Type, yyP354, yyP353 + 1);
/* line 5085 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("int s");
/* line 5085 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP353);
/* line 5085 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("= s");
/* line 5085 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP353 + 1);
/* line 5085 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
/* line 5085 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP355->Array.Expr);
/* line 5085 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 5085 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
  }
/* line 5089 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5089 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSizes (yyP355->Array.Type, yyP354, yyP353 + 1);
/* line 5089 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("int s");
/* line 5089 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP353);
/* line 5089 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("=");
/* line 5089 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeExpr (yyP355->Array.Expr);
/* line 5089 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (";");
/* line 5089 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenShowTests
# if defined __STDC__ | defined __cplusplus
(register tTree yyP358, tSymbol yyP357, register int yyP356)
# else
(yyP358, yyP357, yyP356)
 register tTree yyP358;
 tSymbol yyP357;
 register int yyP356;
# endif
{
  if (yyP358->Kind == kArray) {
  if (yyP358->Array.Type->Kind == kArray) {
/* line 5094 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5095 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if ((i%s");
/* line 5095 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP356);
/* line 5095 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")==0) LP; ");
/* line 5096 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowTests (yyP358->Array.Type, yyP357, yyP356 + 1);
/* line 5097 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("if (((i+1)%s");
/* line 5097 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP356);
/* line 5097 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")==0) RP; ");
  }
   return;

  }
  if (yyP358->Array.Type->Kind == kChan) {
/* line 5100 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5101 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 5102 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ShowArray");
/* line 5102 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP358->Array.Type);
/* line 5102 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(((");
/* line 5102 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP358->Array.Type);
/* line 5102 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("**)");
/* line 5102 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSym (Symbol (yyP357) . Kind, yyP357);
/* line 5102 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")+(i*s");
/* line 5102 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP356);
/* line 5102 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("), s");
/* line 5102 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP356);
/* line 5102 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 5103 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
/* line 5106 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5107 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
/* line 5108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("ShowArray");
/* line 5108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP358->Array.Type);
/* line 5108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("(((");
/* line 5108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CCodeType (yyP358->Array.Type);
/* line 5108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*)");
/* line 5108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSym (Symbol (yyP357) . Kind, yyP357);
/* line 5108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (")+(i*s");
/* line 5108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP356);
/* line 5108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("), s");
/* line 5108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteInt (yyP356);
/* line 5108 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (");");
/* line 5109 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

  }
;
}

static void GenShowSymRef
# if defined __STDC__ | defined __cplusplus
(register tTree yyP360, tSymbol yyP359)
# else
(yyP360, yyP359)
 register tTree yyP360;
 tSymbol yyP359;
# endif
{
/* line 5116 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5116 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsScalarType (SymbolType (yyP359))))) goto yyL1;
  }
   return;
yyL1:;

/* line 5118 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5118 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsChanType (SymbolType (yyP359))))) goto yyL2;
  }
   return;
yyL2:;


  switch (yyP360->Kind) {
  case kAFormal:
  if (yyP360->AFormal.By->Kind == kByRef) {
/* line 5120 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5120 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("*");
  }
   return;

  }
  if (yyP360->AFormal.By->Kind == kByVal) {
/* line 5122 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }
  break;
  case kAnId:
/* line 5124 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kReplicator:
/* line 5126 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kIs:
/* line 5128 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kRetypes:
/* line 5130 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kVal:
/* line 5132 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  case kValRetypes:
/* line 5134 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return;

  }

/* line 5136 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5136 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("** Error in GenShowSymRef -");
/* line 5136 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteTreeNode (yyf, yyP360);
/* line 5136 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" **");
/* line 5136 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   NewLine ();
  }
   return;

;
}

static void GenShowSym
# if defined __STDC__ | defined __cplusplus
(register tTree yyP362, tSymbol yyP361)
# else
(yyP362, yyP361)
 register tTree yyP362;
 tSymbol yyP361;
# endif
{
  if (yyP362->Kind == kVal) {
/* line 5142 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5142 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (ExprType (yyP362->Val.Expr)) && IsConstExpr (yyP362->Val.Expr)))) goto yyL1;
  {
/* line 5143 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstExpr (ExprType (yyP362->Val.Expr), ValConstExpr (yyP362->Val.Expr));
  }
  }
   return;
yyL1:;

  }
  if (yyP362->Kind == kValRetypes) {
/* line 5145 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5145 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsPrimType (yyP362->ValRetypes.Type) && IsConstExpr (yyP362->ValRetypes.Expr)))) goto yyL2;
  {
/* line 5146 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CodeConstExpr (yyP362->ValRetypes.Type, EvalConstId (yyP362));
  }
  }
   return;
yyL2:;

  }
/* line 5148 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5148 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((Symbol (yyP361) . Depth == 0))) goto yyL3;
  {
/* line 5149 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP361);
  }
  }
   return;
yyL3:;

/* line 5151 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5151 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsLocal (yyP361)))) goto yyL4;
  }
   return;
yyL4:;

/* line 5153 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5153 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenShowSymRef (yyP362, yyP361);
/* line 5153 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite ("((tSF_");
/* line 5153 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (CalcParent (SymbolKind (yyP361)));
/* line 5153 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   yyWrite (" *)FP)->");
/* line 5153 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteSym (yyP361);
  }
   return;

;
}

int MapKinds
# if defined __STDC__ | defined __cplusplus
(register tTree yyP365, register tTree yyP364, tSymbol yyP363)
# else
(yyP365, yyP364, yyP363)
 register tTree yyP365;
 register tTree yyP364;
 tSymbol yyP363;
# endif
{
  if (yyP365 == NULL) {
/* line 5158 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

  }
  if (yyP365->Kind == kDefProc) {
/* line 5160 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 3;

  }
  if (yyP365->Kind == kPrototypeProc) {
/* line 5161 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5161 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP365 -> DefAProc . U == xxUsed))) goto yyL3;
  }
   return 10;
yyL3:;

/* line 5162 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

  }
  if (yyP364 == NULL) {
/* line 5164 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

  }

  switch (yyP365->Kind) {
  case kDefFunc:
/* line 5166 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 2;

  case kPrototypeFunc:
/* line 5167 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5167 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP365 -> DefAFunc . U == xxUsed))) goto yyL7;
  }
   return 10;
yyL7:;

/* line 5168 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

  case kAFormal:
/* line 5170 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5170 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP363)))) goto yyL9;
  }
   return 1;
yyL9:;

  break;
  case kAnId:
/* line 5171 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5171 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP363)))) goto yyL10;
  }
   return 4;
yyL10:;

  break;
  case kVal:
/* line 5172 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5172 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP363)))) goto yyL11;
  }
   return 5;
yyL11:;

  break;
  case kValRetypes:
/* line 5173 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5173 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP363)))) goto yyL12;
  }
   return 6;
yyL12:;

  break;
  case kIs:
/* line 5174 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5174 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP363)))) goto yyL13;
  }
   return 7;
yyL13:;

  break;
  case kRetypes:
/* line 5175 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5175 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP363)))) goto yyL14;
  }
   return 8;
yyL14:;

  break;
  case kReplicator:
/* line 5176 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5176 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((IsNonLocal (yyP363)))) goto yyL15;
  }
   return 9;
yyL15:;

  break;
  }

/* line 5177 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return 0;

}

tSymbol CalcParent
# if defined __STDC__ | defined __cplusplus
(register tTree T)
# else
(T)
 register tTree T;
# endif
{
  if (T == NULL) {
/* line 5182 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoSymbol;

  }

  switch (T->Kind) {
  case kATagPro:
/* line 5183 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoSymbol;

  case kDefTagPro:
/* line 5184 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoSymbol;

  case kDefSeqPro:
/* line 5185 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoSymbol;

  case kAnId:
/* line 5187 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> AnId . Parent;

  case kAVal:
  case kVal:
  case kValRetypes:
/* line 5188 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> AVal . Parent;

  case kIs:
/* line 5189 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> Is . Parent;

  case kReplicator:
/* line 5190 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> Replicator . Parent;

  case kRetypes:
/* line 5191 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> Retypes . Parent;

  case kAFormal:
/* line 5192 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> AFormal . Parent;

  case kValof:
/* line 5193 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> Valof . Parent;

  case kDefProc:
/* line 5195 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> DefProc . Parent;

  case kDefFunc:
/* line 5196 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> DefFunc . Parent;

  case kPrototypeProc:
/* line 5198 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> PrototypeProc . Parent;

  case kPrototypeFunc:
/* line 5199 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return T -> PrototypeFunc . Parent;

  }

/* line 5201 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5201 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   fprintf (stderr, "Fell through CalcParent with\n");
/* line 5201 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   WriteTreeNode (stderr, T);
  }
   return 0;

}

tIdent CalcModule
# if defined __STDC__ | defined __cplusplus
(register tTree yyP366)
# else
(yyP366)
 register tTree yyP366;
# endif
{
  if (yyP366->Kind == kPrototypeFunc) {
/* line 5205 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP366 -> PrototypeFunc . Module;

  }
  if (yyP366->Kind == kPrototypeProc) {
/* line 5206 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP366 -> PrototypeProc . Module;

  }
/* line 5207 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NoIdent;

}

tStringRef CalcHeader
# if defined __STDC__ | defined __cplusplus
(register tTree yyP367)
# else
(yyP367)
 register tTree yyP367;
# endif
{
  if (yyP367->Kind == kPrototypeFunc) {
/* line 5211 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP367->PrototypeFunc.Pos . File;

  }
  if (yyP367->Kind == kPrototypeProc) {
/* line 5212 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP367->PrototypeProc.Pos . File;

  }
/* line 5213 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return NULL;

}

tUsage CalcUsage
# if defined __STDC__ | defined __cplusplus
(register tTree yyP368)
# else
(yyP368)
 register tTree yyP368;
# endif
{
  if (yyP368->Kind == kPrototypeFunc) {
/* line 5217 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP368 -> PrototypeFunc . U;

  }
  if (yyP368->Kind == kPrototypeProc) {
/* line 5218 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return yyP368 -> PrototypeProc . U;

  }
 yyAbort ("CalcUsage");
}

bool IsLocal
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP369)
# else
(yyP369)
 tSymbol yyP369;
# endif
{
/* line 5223 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5223 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! IsNonLocal (yyP369)))) goto yyL1;
  }
   return true;
yyL1:;

  return false;
}

bool IsNonLocal
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP370)
# else
(yyP370)
 tSymbol yyP370;
# endif
{
/* line 5228 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5228 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((SymbolUsage (yyP370) & (xxNLRead | xxNLWrite)))) goto yyL1;
  }
   return true;
yyL1:;

/* line 5229 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5229 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((! (SymbolUsage (yyP370) & xxAtomic)))) goto yyL2;
  }
   return true;
yyL2:;

  return false;
}

bool IsAtomic
# if defined __STDC__ | defined __cplusplus
(register tTree yyP371)
# else
(yyP371)
 register tTree yyP371;
# endif
{
  if (Tree_IsType (yyP371, kProcess)) {
/* line 5234 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5234 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP371 -> Process . ATOMIC))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (Tree_IsType (yyP371, kAChoices)) {
/* line 5235 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5235 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP371 -> AChoices . ATOMIC))) goto yyL2;
  }
   return true;
yyL2:;

  }
  if (yyP371->Kind == kReplicator) {
/* line 5236 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5236 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP371 -> Replicator . AtomicSpec))) goto yyL3;
  }
   return true;
yyL3:;

  }
  return false;
}

static bool IsMVFunction
# if defined __STDC__ | defined __cplusplus
(register tTree yyP372)
# else
(yyP372)
 register tTree yyP372;
# endif
{
  if (yyP372->DefFunc.TypeList->Kind == kAType) {
  if (yyP372->DefFunc.TypeList->AType.Next->Kind == kAType) {
/* line 5240 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   return true;

  }
  }
  return false;
}

static bool IsNewSymbol
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP373)
# else
(yyP373)
 tSymbol yyP373;
# endif
{
/* line 5244 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5244 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((SymTable[yyP373].Id == NoIdent))) goto yyL1;
  }
   return true;
yyL1:;

  return false;
}

static void BeginBlock
# if defined __STDC__ | defined __cplusplus
(register tTree yyP374)
# else
(yyP374)
 register tTree yyP374;
# endif
{
/* line 5250 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5251 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalInits (yyP374);
  }
   return;

;
}

static void EndBlock
# if defined __STDC__ | defined __cplusplus
(register tTree yyP375)
# else
(yyP375)
 register tTree yyP375;
# endif
{
/* line 5256 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5257 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResults (yyP375);
  }
   return;

;
}

static void BeginAtomicBlock
# if defined __STDC__ | defined __cplusplus
(register tTree yyP378, register tTree yyP377, register bool yyP376)
# else
(yyP378, yyP377, yyP376)
 register tTree yyP378;
 register tTree yyP377;
 register bool yyP376;
# endif
{
/* line 5263 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5264 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   OpenBlock (yyP376);
/* line 5265 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalSpecs (yyP378);
/* line 5266 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL1;
  }
   return;
yyL1:;

/* line 5269 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5269 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((yyP377 != NoTree))) goto yyL2;
  {
/* line 5270 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalRep (yyP377);
/* line 5271 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((false))) goto yyL2;
  }
  }
   return;
yyL2:;

/* line 5274 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5275 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenLocalInits (yyP378);
  }
   return;

;
}

static void EndAtomicBlock
# if defined __STDC__ | defined __cplusplus
(register tTree yyP379)
# else
(yyP379)
 register tTree yyP379;
# endif
{
/* line 5280 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5281 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   GenResults (yyP379);
/* line 5282 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   CloseBlock ();
  }
   return;

;
}

void MarkRefParent
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP382, register tTree yyP381, tVUsage yyP380)
# else
(yyP382, yyP381, yyP380)
 tSymbol yyP382;
 register tTree yyP381;
 tVUsage yyP380;
# endif
{
/* line 5288 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5288 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((SymbolDepth (yyP382) == 0))) goto yyL1;
  }
   return;
yyL1:;

  if (yyP381->Kind == kDefProc) {
/* line 5290 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5290 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((SymbolDepth (yyP382) <= SymbolDepth (yyP381->DefProc.Sym)))) goto yyL2;
  {
/* line 5291 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   AddVUsage (yyP381->DefProc.Sym, yyP380);
/* line 5292 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   MarkRefParent (yyP382, SymbolKind (yyP381 -> DefProc . Parent), yyP380);
  }
  }
   return;
yyL2:;

  }
  if (yyP381->Kind == kDefFunc) {
/* line 5295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
  {
/* line 5295 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   if (! ((SymbolDepth (yyP382) <= SymbolDepth (yyP381->DefFunc.Sym)))) goto yyL3;
  {
/* line 5296 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   AddVUsage (yyP381->DefFunc.Sym, yyP380);
/* line 5297 "/home/ringwood/smw/occam/source/gmd/c.trafo" */
   MarkRefParent (yyP382, SymbolKind (yyP381 -> DefFunc . Parent), yyP380);
  }
  }
   return;
yyL3:;

  }
;
}

void BeginCout ()
{
}

void CloseCout ()
{
}
