# include "TypeChk.h"
# include "yyTypeChk.w"
# include "System.h"
# include <stdio.h>
# include "Tree.h"

# define yyInline
# ifndef NULL
# define NULL 0L
# endif
# ifndef false
# define false 0
# endif
# ifndef true
# define true 1
# endif

# ifdef yyInline
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) \
  if ((ptr = (tree) free) >= (tree) max) ptr = alloc (); \
  free += nodesize [kind]; \
  ptr->yyHead.yyMark = 0; \
  ptr->Kind = kind;
# else
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) ptr = make (kind);
# endif

# define yyWrite(s) (void) fputs (s, yyf)
# define yyWriteNl (void) fputc ('\n', yyf)

/* line 52 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */


  #include "Positions.h"
  #include <stdlib.h>
  #include <math.h>

  #undef MAX
  #define MAX(a,b) ((a > b) ? a : b)

  /*{{{  static void RetypeConst(int ss,tConstArray src, int ds, tConstArray dest)*/
  /* Retype a ConstArray section -
  
     ConstArray values are stored in compiler-endianness, to allow direct
     casting for constant folding/output
  
     To retype, is the endianness of the compiler/target architectures differ,
     we must perform two stages.
  
     1. Copy source to temporary, performing source type endianness swap
        This leaves temporary in target machine endianness
     2. Copy temporary to destination, performing destination type endianness swap
        This converts temporary into correct types, in compiler endianness
  */
  
  void RetypeConst(int ss,tConstArray src, int ds, tConstArray dest)
  {
    int sz = (ds > ss) ? ds : ss;
    int i;
    int val = 1;
    bool Compiler_is_LittleEndian = (((char *)&val)[0]) == 1;
    unsigned char tmp[8];
  
    if ((!IS_Mode(xxLittleEndian) && Compiler_is_LittleEndian)
        ||(IS_Mode(xxLittleEndian) && !Compiler_is_LittleEndian))
    {
      switch(ss)
      {
        case 8: for(i = 0; i < sz; ++i) tmp[i] = src[i ^ 7]; break;
        case 4: for(i = 0; i < sz; ++i) tmp[i] = src[i ^ 3]; break;
        case 2: for(i = 0; i < sz; ++i) tmp[i] = src[i ^ 1]; break;
        case 1: for(i = 0; i < sz; ++i) tmp[i] = src[i    ]; break;
      }
  
      switch(ds)
      {
        case 8: for(i = 0; i < sz; ++i) dest[i] = tmp[i ^ 7]; break;
        case 4: for(i = 0; i < sz; ++i) dest[i] = tmp[i ^ 3]; break;
        case 2: for(i = 0; i < sz; ++i) dest[i] = tmp[i ^ 1]; break;
        case 1: for(i = 0; i < sz; ++i) dest[i] = tmp[i    ]; break;
      }
    }
    else
    {
      for(i = 0; i < sz; ++i) dest[i] = src[i];
    }
  }
  
  /*}}}*/


static void yyExit () { Exit (1); }

void (* TypeChk_Exit) () = yyExit;

extern FILE *yyf;

static void yyAbort
# ifdef __cplusplus
 (char * yyFunction)
# else
 (yyFunction) char * yyFunction;
# endif
{
 (void) fprintf (stderr, "Error: module TypeChk, routine %s failed\n", yyFunction);
 TypeChk_Exit ();
}

void TypeFormals ARGS((tTree yyP1));
void TypeDecl ARGS((tTree yyP3, tTree yyP2));
tTree TypeAbbrev ARGS((tTree yyP6, tTree yyP5, tPosition yyP4));
tTree TypeSubscript ARGS((tTree yyP9, tTree yyP8, tPosition yyP7));
tTree TypeRange ARGS((tTree yyP13, tTree yyP12, tTree yyP11, tPosition yyP10));
tTree TypeBinary ARGS((tTree yyP17, tTree yyP16, tTree yyP15, tPosition yyP14));
tTree TypeUnary ARGS((tTree yyP20, tTree yyP19, tPosition yyP18));
static tTree TypeExprSubList ARGS((tTree yyP21));
tTree TypeExprList ARGS((tTree yyP22));
tTree TypeTable ARGS((tTree yyP24, tTree yyP23));
tTree StripTypeList ARGS((tTree yyP25));
void TypeCheckAssign ARGS((tTree yyP28, tTree yyP27, tPosition yyP26));
static void TypeCheckAssignList ARGS((tTree yyP31, tTree yyP30, tPosition yyP29));
static void TypeCheckAssignFn ARGS((tTree yyP34, tTree yyP33, tPosition yyP32));
void TypeCheckResults ARGS((tTree yyP37, tTree yyP36, tPosition yyP35));
void TypeCheckParameters ARGS((tTree yyP41, tTree yyP40, tPosition yyP39, int yyP38));
void UpdateElementalUsage ARGS((tTree yyP43, tUsage yyP42));
void TypeCheckIfList ARGS((tTree yyP44));
void TypeCheckTimerInput ARGS((tTree yyP46, tPosition yyP45));
void TypeCheckInputProtocol ARGS((tTree yyP49, tTree yyP48, tPosition yyP47));
static void TypeCheckSimpleProtocol ARGS((tTree yyP51, tTree yyP50));
void TypeCheckOutputProtocol ARGS((tTree yyP54, tTree yyP53, tPosition yyP52));
void TypeCheckCaseInputs ARGS((tTree yyP57, tTree yyP56, tPosition yyP55));
static void TypeCheckCaseOutput ARGS((tTree yyP60, tTree yyP59, tPosition yyP58));
static void TypeCheckInputSeqProtocol ARGS((tTree yyP63, tTree yyP62, tPosition yyP61));
static void TypeCheckOutputSeqProtocol ARGS((tTree yyP66, tTree yyP65, tPosition yyP64));
void TypeCheckCaseList ARGS((tTree yyP68, tTree yyP67));
void TypeCheckRetypes ARGS((tTree yyP71, tTree yyP70, tPosition yyP69));
static void DoTypeCheckRetypes ARGS((int yyP76, tTree yyP75, int yyP74, tTree yyP73, tPosition yyP72));
static bool SameType ARGS((tTree yyP78, tTree yyP77));
static bool CheckValidTag ARGS((tTree yyP80, tSymbol yyP79));
static bool SameProtocol ARGS((tTree yyP82, tTree yyP81));
bool CheckWritable ARGS((tTree yyP83));
bool CheckWritableExprList ARGS((tTree yyP84));
bool CheckForVals ARGS((tTree yyP85));
bool CheckValofScope ARGS((tTree yyP87, int yyP86));
bool CheckIsType ARGS((tTree yyP89, Tree_tKind yyP88));
bool IsChanOrTimerType ARGS((tTree yyP90));
bool IsChanType ARGS((tTree yyP91));
bool IsTimerType ARGS((tTree yyP92));
bool IsArrayType ARGS((tTree yyP93));
static bool CheckChoicesDiffer ARGS((tTree yyP95, tTree yyP94));
static bool CheckExprDiffers ARGS((tTree yyP98, tTree yyP97, tTree yyP96));
bool CheckValidDeclType ARGS((tTree yyP99));
bool CheckEvalBiOp ARGS((tTree yyP101, tTree yyP100));
static bool CheckEvalBiIntOp ARGS((tTree yyP102));
static bool CheckEvalBiRealOp ARGS((tTree yyP103));
bool CheckEvalUniOp ARGS((tTree yyP106, tTree yyP105, tTree yyP104));
tValue EvalBiExpr ARGS((tPosition yyP111, tTree yyP110, tValue yyP109, tTree yyP108, tValue yyP107));
static tInt EvalBiIntOp ARGS((tPosition yyP116, tTree yyP115, tInt yyP114, tTree yyP113, tInt yyP112));
static int EvalBiBoolOp ARGS((tPosition yyP121, tTree yyP120, tInt yyP119, tTree yyP118, tInt yyP117));
static double EvalBiRealMathsOp ARGS((tPosition yyP126, tTree yyP125, double yyP124, tTree yyP123, double yyP122));
static int EvalBiRealRelOp ARGS((tPosition yyP131, tTree yyP130, double yyP129, tTree yyP128, double yyP127));
tValue EvalUniExpr ARGS((tTree yyP134, tTree yyP133, tTree yyP132));
bool CheckConstConvert ARGS((tTree yyP135));
tValue EvalConstConvert ARGS((tPosition yyP138, tTree yyP137, tTree yyP136));
tValue CheckConst ARGS((tPosition yyP142, tTree yyP141, tInt yyP140, bool yyP139));
bool CheckConstRoundTrunc ARGS((tTree yyP144, tTree yyP143));
tValue EvalConstTrunc ARGS((tPosition yyP148, tTree yyP147, tTree yyP146, tValue yyP145));
tValue EvalConstRound ARGS((tPosition yyP152, tTree yyP151, tTree yyP150, tValue yyP149));
bool CheckConstId ARGS((tTree yyP153));
tValue EvalConstId ARGS((tTree yyP154));
tInt TestIntOVF ARGS((tPosition yyP157, tTree yyP156, tInt yyP155));
tInt SignExtendInt ARGS((tTree yyP159, tInt yyP158));
static int CountTags ARGS((tSymbol yyP160));
static tInt EvalIntBits ARGS((tTree yyP161));
static tInt EvalIntMask ARGS((tTree yyP162));
tInt EvalMostPos ARGS((tTree yyP163));
tInt EvalMostNeg ARGS((tTree yyP164));
tValue EvalConstSubscript ARGS((tTree yyP167, int yyP166, tConstArray yyP165));
tConstArray ConstArrayFromString ARGS((tTree yyP169, tStringRef yyP168));
tConstArray ConstArrayFromExprList ARGS((tTree yyP171, tTree yyP170));
tConstArray ConstArrayFromDecl ARGS((tTree yyP173, tTree yyP172));
static void FillConstArray ARGS((tTree yyP176, tTree yyP175, tConstArray yyP174));
tConstArray RangeConstArray ARGS((tTree yyP179, tConstArray yyP178, int yyP177));
tConstArray SubscriptConstArray ARGS((tTree yyP182, tConstArray yyP181, int yyP180));
static tConstArray GetConstArray ARGS((tTree EX));
tValue ReadConstArray ARGS((tTree yyP184, tConstArray yyP183));
void WriteConstArray ARGS((tTree yyP187, tValue yyP186, tConstArray yyP185));
static tConstArray NewConstArray ARGS((int yyP188));
static void RangeCheckSubscript ARGS((tTree yyP190, tTree yyP189));
static void RangeCheckSlice ARGS((tTree yyP193, tTree yyP192, tTree yyP191));
tTree MakeConstInt ARGS((int yyP195, tPosition yyP194));
static tTree MakeAddExpr ARGS((tTree yyP197, tTree yyP196));
static int CountList ARGS((tTree yyP199, tTree yyP198));
static int SizeType ARGS((tTree yyP202, tPosition yyP201, bool yyP200, tTree * yyP203));
int CalcTypeSize ARGS((tTree yyP204));
tTree ReduceElement ARGS((tTree yyP206, tTree yyP205));
tTree ReduceElemental ARGS((tTree yyP207));
tTree ArrayPrimType ARGS((tTree yyP208));
void MarkNonAtomicIf ARGS((tTree IF));
static void MarkNonAtomicIfList ARGS((tTree IF));

void TypeFormals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP1)
# else
(yyP1)
 register tTree yyP1;
# endif
{
/* line 149 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 static tTree by=NULL; static tTree type=NULL; 
  if (yyP1->Kind == kNoFormal) {
/* line 150 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
  if (yyP1->Kind == kAFormal) {
  if (yyP1->AFormal.By->Kind == kByUndef) {
  if (yyP1->AFormal.Type->Kind == kUntyped) {
/* line 151 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 151 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP1->AFormal.By = by;
/* line 151 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP1->AFormal.Type = type;
/* line 151 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   SymbolType (yyP1->AFormal.Sym) = type;
/* line 151 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeFormals (yyP1->AFormal.Next);
  }
   return;

  }
  }
/* line 152 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 152 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   by = yyP1->AFormal.By;
/* line 152 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   type = yyP1->AFormal.Type;
/* line 152 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   SymbolType (yyP1->AFormal.Sym) = yyP1->AFormal.Type;
/* line 152 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeFormals (yyP1->AFormal.Next);
  }
   return;

  }
;
}

void TypeDecl
# if defined __STDC__ | defined __cplusplus
(register tTree yyP3, register tTree yyP2)
# else
(yyP3, yyP2)
 register tTree yyP3;
 register tTree yyP2;
# endif
{
  if (yyP2->Kind == kNoId) {
/* line 156 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
  if (yyP2->Kind == kAnId) {
/* line 157 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 157 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   SymbolType (yyP2->AnId.Sym) = yyP3;
/* line 157 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeDecl (yyP3, yyP2->AnId.Next);
  }
   return;

  }
;
}

tTree TypeAbbrev
# if defined __STDC__ | defined __cplusplus
(register tTree yyP6, register tTree yyP5, register tPosition yyP4)
# else
(yyP6, yyP5, yyP4)
 register tTree yyP6;
 register tTree yyP5;
 register tPosition yyP4;
# endif
{
  if (yyP6->Kind == kUntyped) {
/* line 161 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP5;

  }
  if (Tree_IsType (yyP6, kPrimitive)) {
  if (Tree_IsType (yyP5, kPrimitive)) {
/* line 162 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 162 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP6 -> Kind == yyP5 -> Kind))) goto yyL2;
  }
   return yyP6;
yyL2:;

  }
  }
  if (yyP6->Kind == kByte) {
  if (yyP5->Kind == kByte) {
/* line 163 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP6;

  }
  }
  if (yyP6->Kind == kBool) {
  if (yyP5->Kind == kBool) {
/* line 164 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP6;

  }
  }
  if (yyP6->Kind == kChan) {
  if (yyP5->Kind == kChan) {
/* line 165 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 165 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameProtocol (yyP6->Chan.Protocol, yyP5->Chan.Protocol))) goto yyL5;
  }
   return yyP6;
yyL5:;

  }
  }
  if (yyP6->Kind == kArray) {
  if (yyP6->Array.Expr->Kind == kUnBound) {
  if (yyP5->Kind == kArray) {
  if (yyP5->Array.Expr->Kind == kUnBound) {
/* line 166 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 166 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP6->Array.Type = TypeAbbrev (yyP6->Array.Type, yyP5->Array.Type, yyP4);
  }
   return yyP6;

  }
  }
  }
  if (yyP5->Kind == kArray) {
/* line 167 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 167 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (yyP6->Array.Expr, kUnBound)))) goto yyL7;
  {
/* line 167 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP6->Array.Expr = yyP5->Array.Expr;
/* line 167 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP6->Array.Type = TypeAbbrev (yyP6->Array.Type, yyP5->Array.Type, yyP4);
  }
  }
   return yyP6;
yyL7:;

/* line 168 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 168 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP6->Array.Expr)))) goto yyL8;
  {
/* line 168 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP5->Array.Expr)))) goto yyL8;
  {
/* line 168 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP6->Array.Expr) == ValConstInt (yyP5->Array.Expr)))) goto yyL8;
  {
/* line 168 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP6->Array.Type = TypeAbbrev (yyP6->Array.Type, yyP5->Array.Type, yyP4);
  }
  }
  }
  }
   return yyP6;
yyL8:;

/* line 169 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 169 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP6->Array.Expr)))) goto yyL9;
  {
/* line 169 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP5->Array.Expr)))) goto yyL9;
  {
/* line 169 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Array size mismatch in abbreviation", xxError, yyP4);
/* line 169 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP6->Array.Type = TypeAbbrev (yyP6->Array.Type, yyP5->Array.Type, yyP4);
  }
  }
  }
   return yyP6;
yyL9:;

/* line 170 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 170 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP6->Array.Type = TypeAbbrev (yyP6->Array.Type, yyP5->Array.Type, yyP4);
  }
   return yyP6;

  }
  }
/* line 171 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 171 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Type mismatch in abbreviation", xxError, yyP4);
  }
   return yyP6;

}

tTree TypeSubscript
# if defined __STDC__ | defined __cplusplus
(register tTree yyP9, register tTree yyP8, register tPosition yyP7)
# else
(yyP9, yyP8, yyP7)
 register tTree yyP9;
 register tTree yyP8;
 register tPosition yyP7;
# endif
{
  if (yyP8->Kind == kArray) {
/* line 176 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 176 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   RangeCheckSubscript (yyP9, yyP8->Array.Expr);
  }
   return yyP8->Array.Type;

  }
/* line 177 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 177 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Subscripted non-array type", xxError, yyP7);
  }
   return yyP8;

}

tTree TypeRange
# if defined __STDC__ | defined __cplusplus
(register tTree yyP13, register tTree yyP12, register tTree yyP11, register tPosition yyP10)
# else
(yyP13, yyP12, yyP11, yyP10)
 register tTree yyP13;
 register tTree yyP12;
 register tTree yyP11;
 register tPosition yyP10;
# endif
{
  if (yyP11->Kind == kArray) {
/* line 181 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
/* line 181 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   RangeCheckSlice (yyP13, yyP12, yyP11->Array.Expr);
  }
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kArray)
    yyV1->Array.Expr = yyP12;
    yyV1->Array.Type = yyP11->Array.Type;
   return yyV1;
  }
 }

  }
/* line 182 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 182 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Took slice of non-array type", xxError, yyP10);
  }
   return yyP11;

}

tTree TypeBinary
# if defined __STDC__ | defined __cplusplus
(register tTree yyP17, register tTree yyP16, register tTree yyP15, register tPosition yyP14)
# else
(yyP17, yyP16, yyP15, yyP14)
 register tTree yyP17;
 register tTree yyP16;
 register tTree yyP15;
 register tPosition yyP14;
# endif
{
  if (yyP17->Kind == kBool) {
  if (Tree_IsType (yyP16, kLogOp)) {
  if (yyP15->Kind == kBool) {
/* line 186 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kBool)
   return yyV1;
  }
 }

  }
  }
  if (Tree_IsType (yyP16, kRelOp)) {
  if (yyP15->Kind == kBool) {
/* line 187 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kBool)
   return yyV1;
  }
 }

  }
  }
  }
  if (yyP17->Kind == kByte) {
  if (Tree_IsType (yyP16, kRelOp)) {
  if (yyP15->Kind == kByte) {
/* line 188 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kBool)
   return yyV1;
  }
 }

  }
  }
  }
  if (Tree_IsType (yyP17, kInteger)) {
  if (yyP16->Kind == kAfterOp) {
  if (Tree_IsType (yyP15, kInteger)) {
/* line 189 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
/* line 189 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP17 -> Kind == yyP15 -> Kind))) goto yyL4;
  }
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kBool)
   return yyV1;
  }
 }
yyL4:;

  }
  }
  }
  if (Tree_IsType (yyP17, kNumeric)) {
  if (Tree_IsType (yyP16, kRelOp)) {
  if (Tree_IsType (yyP15, kNumeric)) {
/* line 190 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
/* line 190 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP17 -> Kind == yyP15 -> Kind))) goto yyL5;
  }
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kBool)
   return yyV1;
  }
 }
yyL5:;

  }
  }
  if (Tree_IsType (yyP16, kMathsOp)) {
  if (Tree_IsType (yyP15, kNumeric)) {
/* line 191 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 191 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP17 -> Kind == yyP15 -> Kind))) goto yyL6;
  }
   return yyP17;
yyL6:;

  }
  }
  }
  if (Tree_IsType (yyP17, kInteger)) {
  if (Tree_IsType (yyP16, kBitOp)) {
  if (Tree_IsType (yyP15, kInteger)) {
/* line 192 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 192 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP17 -> Kind == yyP15 -> Kind))) goto yyL7;
  }
   return yyP17;
yyL7:;

  }
  }
  if (Tree_IsType (yyP16, kClockOp)) {
  if (Tree_IsType (yyP15, kInteger)) {
/* line 193 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 193 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP17 -> Kind == yyP15 -> Kind))) goto yyL8;
  }
   return yyP17;
yyL8:;

  }
  }
  if (Tree_IsType (yyP16, kShiftOp)) {
  if (yyP15->Kind == kInt) {
/* line 194 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP17;

  }
  }
  }
/* line 196 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 196 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Type mismatch in binary operation", xxError, yyP14);
  }
   return yyP17;

}

tTree TypeUnary
# if defined __STDC__ | defined __cplusplus
(register tTree yyP20, register tTree yyP19, register tPosition yyP18)
# else
(yyP20, yyP19, yyP18)
 register tTree yyP20;
 register tTree yyP19;
 register tPosition yyP18;
# endif
{

  switch (yyP20->Kind) {
  case kSubtract:
  if (Tree_IsType (yyP19, kNumeric)) {
/* line 200 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP19;

  }
  break;
  case kMinus:
  if (Tree_IsType (yyP19, kNumeric)) {
/* line 201 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP19;

  }
  break;
  case kAdd:
  if (Tree_IsType (yyP19, kNumeric)) {
/* line 202 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP19;

  }
  break;
  case kPlus:
  if (Tree_IsType (yyP19, kNumeric)) {
/* line 203 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP19;

  }
  break;
  case kNot:
  if (yyP19->Kind == kBool) {
/* line 204 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP19;

  }
  break;
  case kSize:
  if (yyP19->Kind == kArray) {
/* line 205 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kInt)
   return yyV1;
  }
 }

  }
  break;
  case kBitNot:
  if (Tree_IsType (yyP19, kInteger)) {
/* line 206 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP19;

  }
  break;
  }

/* line 208 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 208 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Type mismatch in unary operation", xxError, yyP18);
  }
   return yyP19;

}

static tTree TypeExprSubList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP21)
# else
(yyP21)
 register tTree yyP21;
# endif
{
  if (yyP21->Kind == kNoExpr) {
/* line 212 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kNoType)
   return yyV1;
  }
 }

  }
  if (yyP21->Kind == kAnExpr) {
/* line 213 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kAType)
    yyV1->AType.Next = TypeExprSubList (yyP21->AnExpr.Next);
    yyV1->AType.Type = ExprType (yyP21->AnExpr.Expr);
   return yyV1;
  }
 }

  }
 yyAbort ("TypeExprSubList");
}

tTree TypeExprList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP22)
# else
(yyP22)
 register tTree yyP22;
# endif
{
  if (yyP22->Kind == kNoExpr) {
/* line 217 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kNoType)
   return yyV1;
  }
 }

  }
  if (yyP22->Kind == kAnExpr) {
  if (yyP22->AnExpr.Next->Kind == kNoExpr) {
/* line 218 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return ExprType (yyP22->AnExpr.Expr);

  }
/* line 219 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kAType)
    yyV1->AType.Next = TypeExprSubList (yyP22->AnExpr.Next);
    yyV1->AType.Type = ExprType (yyP22->AnExpr.Expr);
   return yyV1;
  }
 }

  }
 yyAbort ("TypeExprList");
}

tTree TypeTable
# if defined __STDC__ | defined __cplusplus
(register tTree yyP24, register tTree yyP23)
# else
(yyP24, yyP23)
 register tTree yyP24;
 register tTree yyP23;
# endif
{
  if (yyP24->Kind == kAnExpr) {
/* line 223 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  {
  register tTree yyV1;
   yyALLOC (tTree,Tree_PoolFreePtr,Tree_PoolMaxPtr,Tree_Alloc,Tree_NodeSize,MakeTree,yyV1,kArray)
    yyV1->Array.Expr = MakeConstInt (CountList (yyP24->AnExpr.Next, yyP23), yyP24->AnExpr.Expr->Expr.Pos);
    yyV1->Array.Type = yyP23;
   return yyV1;
  }
 }

  }
 yyAbort ("TypeTable");
}

tTree StripTypeList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP25)
# else
(yyP25)
 register tTree yyP25;
# endif
{
  if (yyP25->Kind == kAType) {
  if (yyP25->AType.Next->Kind == kNoType) {
/* line 228 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP25->AType.Type;

  }
  }
/* line 229 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP25;

}

void TypeCheckAssign
# if defined __STDC__ | defined __cplusplus
(register tTree yyP28, register tTree yyP27, register tPosition yyP26)
# else
(yyP28, yyP27, yyP26)
 register tTree yyP28;
 register tTree yyP27;
 register tPosition yyP26;
# endif
{
  if (yyP28->Kind == kAnExpr) {
  if (yyP28->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP27->Kind == kAnExpr) {
/* line 235 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 235 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (ExprType (yyP27->AnExpr.Expr), kAType)))) goto yyL1;
  {
/* line 236 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignFn (yyP28, ExprType (yyP27->AnExpr.Expr), yyP28->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL1:;

  }
  }
  }
/* line 237 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 237 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP28, yyP27, yyP26);
  }
   return;

;
}

static void TypeCheckAssignList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP31, register tTree yyP30, register tPosition yyP29)
# else
(yyP31, yyP30, yyP29)
 register tTree yyP31;
 register tTree yyP30;
 register tPosition yyP29;
# endif
{
  if (yyP31->Kind == kNoExpr) {
  if (yyP30->Kind == kNoExpr) {
/* line 241 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
/* line 242 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 242 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too many expressions on assignment RHS", xxError, yyP29);
  }
   return;

  }
  if (yyP30->Kind == kNoExpr) {
/* line 243 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 243 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too few expressions on assignment RHS", xxError, yyP29);
  }
   return;

  }
  if (yyP31->Kind == kAnExpr) {
  if (yyP31->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP30->Kind == kAnExpr) {
/* line 244 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 244 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsChanOrTimerType (ElementType (yyP31->AnExpr.Expr))))) goto yyL4;
  {
/* line 245 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Cannot assign to channel or timer", xxError, yyP31->AnExpr.Expr->ElementalExpr.Pos);
/* line 246 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP31->AnExpr.Next, yyP30->AnExpr.Next, yyP31->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL4:;

/* line 247 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 247 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP31->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL5;
  {
/* line 247 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((SameType (ExprType (yyP31->AnExpr.Expr), ExprType (yyP30->AnExpr.Expr))))) goto yyL5;
  {
/* line 248 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP31->AnExpr.Next, yyP30->AnExpr.Next, yyP31->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
  }
   return;
yyL5:;

/* line 249 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 249 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP31->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL6;
  {
/* line 250 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Type mismatch during assignment", xxError, yyP31->AnExpr.Expr->ElementalExpr.Pos);
/* line 251 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP31->AnExpr.Next, yyP30->AnExpr.Next, yyP31->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL6:;

/* line 252 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 253 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Cannot make assignment to variable", xxError, yyP31->AnExpr.Expr->ElementalExpr.Pos);
/* line 254 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP31->AnExpr.Next, yyP30->AnExpr.Next, yyP31->AnExpr.Expr->ElementalExpr.Pos);
  }
   return;

  }
  }
  if (yyP30->Kind == kAnExpr) {
/* line 255 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 256 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("LHS must be an assignable variable", xxError, yyP29);
/* line 257 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignList (yyP31->AnExpr.Next, yyP30->AnExpr.Next, yyP29);
  }
   return;

  }
  }
;
}

static void TypeCheckAssignFn
# if defined __STDC__ | defined __cplusplus
(register tTree yyP34, register tTree yyP33, register tPosition yyP32)
# else
(yyP34, yyP33, yyP32)
 register tTree yyP34;
 register tTree yyP33;
 register tPosition yyP32;
# endif
{
  if (yyP34->Kind == kNoExpr) {
  if (yyP33->Kind == kNoType) {
/* line 261 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
/* line 262 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 262 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too few variables to assign to from function", xxError, yyP32);
  }
   return;

  }
  if (yyP33->Kind == kNoType) {
/* line 263 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 263 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too many variables to assign to from function", xxError, yyP32);
  }
   return;

  }
  if (yyP34->Kind == kAnExpr) {
  if (yyP34->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP33->Kind == kAType) {
/* line 264 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 264 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP34->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL4;
  {
/* line 264 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (ExprType (yyP34->AnExpr.Expr), yyP33->AType.Type))) goto yyL4;
  {
/* line 265 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignFn (yyP34->AnExpr.Next, yyP33->AType.Next, yyP34->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
  }
   return;
yyL4:;

/* line 266 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 266 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP34->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL5;
  {
/* line 267 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Type mismatch during function assignment", xxError, yyP34->AnExpr.Expr->ElementalExpr.Pos);
/* line 268 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignFn (yyP34->AnExpr.Next, yyP33->AType.Next, yyP34->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL5:;

/* line 269 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 270 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Cannot make assignment to variable", xxError, yyP34->AnExpr.Expr->ElementalExpr.Pos);
/* line 271 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckAssignFn (yyP34->AnExpr.Next, yyP33->AType.Next, yyP34->AnExpr.Expr->ElementalExpr.Pos);
  }
   return;

  }
  }
  }
;
}

void TypeCheckResults
# if defined __STDC__ | defined __cplusplus
(register tTree yyP37, register tTree yyP36, register tPosition yyP35)
# else
(yyP37, yyP36, yyP35)
 register tTree yyP37;
 register tTree yyP36;
 register tPosition yyP35;
# endif
{
  if (yyP37->Kind == kNoType) {
  if (yyP36->Kind == kNoExpr) {
/* line 275 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
/* line 276 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 276 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too many expressions in result list", xxError, yyP35);
  }
   return;

  }
  if (yyP36->Kind == kNoExpr) {
/* line 277 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 277 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too few expressions in result list", xxError, yyP35);
  }
   return;

  }
  if (yyP37->Kind == kAType) {
  if (yyP36->Kind == kAnExpr) {
/* line 278 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 278 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((SameType (yyP37->AType.Type, ExprType (yyP36->AnExpr.Expr))))) goto yyL4;
  {
/* line 278 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckResults (yyP37->AType.Next, yyP36->AnExpr.Next, yyP36->AnExpr.Expr->Expr.Pos);
  }
  }
   return;
yyL4:;

/* line 279 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 279 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Type mismatch in result list", xxError, yyP36->AnExpr.Expr->Expr.Pos);
/* line 279 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckResults (yyP37->AType.Next, yyP36->AnExpr.Next, yyP36->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
;
}

void TypeCheckParameters
# if defined __STDC__ | defined __cplusplus
(register tTree yyP41, register tTree yyP40, register tPosition yyP39, register int yyP38)
# else
(yyP41, yyP40, yyP39, yyP38)
 register tTree yyP41;
 register tTree yyP40;
 register tPosition yyP39;
 register int yyP38;
# endif
{
  if (yyP41->Kind == kNoFormal) {
  if (yyP40->Kind == kNoExpr) {
/* line 283 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
/* line 284 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 284 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too many parameters", xxError, yyP39);
  }
   return;

  }
  if (yyP40->Kind == kNoExpr) {
/* line 285 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 285 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too few parameters", xxError, yyP39);
  }
   return;

  }
  if (yyP41->Kind == kAFormal) {
  if (yyP41->AFormal.By->Kind == kByRef) {
  if (yyP40->Kind == kAnExpr) {
  if (yyP40->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP40->AnExpr.Expr->ElementalExpr.Elemental->Kind == kTable) {
/* line 286 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 286 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP40->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL4;
  {
/* line 286 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP41->AFormal.Type, ExprType (yyP40->AnExpr.Expr)))) goto yyL4;
  {
/* line 287 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP40->AnExpr.Expr->ElementalExpr.Elemental, yyP41 -> AFormal . U);
/* line 288 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckParameters (yyP41->AFormal.Next, yyP40->AnExpr.Next, yyP39, yyP38);
  }
  }
  }
   return;
yyL4:;

  }
  if (Tree_IsType (yyP40->AnExpr.Expr->ElementalExpr.Elemental, kElement)) {
/* line 290 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 290 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP40->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL5;
  {
/* line 290 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP41->AFormal.Type, ExprType (yyP40->AnExpr.Expr)))) goto yyL5;
  {
/* line 291 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 if (!CheckValofScope(yyP40->AnExpr.Expr->ElementalExpr.Elemental,yyP38)) Message("Attempted to pass free variable by reference within VALOF",xxError,yyP39); 
/* line 292 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP40->AnExpr.Expr->ElementalExpr.Elemental, yyP41 -> AFormal . U);
/* line 293 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckParameters (yyP41->AFormal.Next, yyP40->AnExpr.Next, yyP39, yyP38);
  }
  }
  }
   return;
yyL5:;

  }
  }
/* line 298 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 298 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP41->AFormal.Type, ExprType (yyP40->AnExpr.Expr)))) goto yyL7;
  {
/* line 299 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Actual parameter cannot be passed by reference", xxError, yyP39);
/* line 300 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckParameters (yyP41->AFormal.Next, yyP40->AnExpr.Next, yyP39, yyP38);
  }
  }
   return;
yyL7:;

  }
  }
  if (yyP41->AFormal.By->Kind == kByVal) {
  if (yyP40->Kind == kAnExpr) {
/* line 295 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 295 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP41->AFormal.Type, ExprType (yyP40->AnExpr.Expr)))) goto yyL6;
  {
/* line 296 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckParameters (yyP41->AFormal.Next, yyP40->AnExpr.Next, yyP39, yyP38);
  }
  }
   return;
yyL6:;

  }
  }
  if (yyP40->Kind == kAnExpr) {
/* line 302 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 303 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Actual parameter does not match formal description", xxError, yyP40->AnExpr.Expr->Expr.Pos);
/* line 304 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckParameters (yyP41->AFormal.Next, yyP40->AnExpr.Next, yyP39, yyP38);
  }
   return;

  }
  }
;
}

void UpdateElementalUsage
# if defined __STDC__ | defined __cplusplus
(register tTree yyP43, tUsage yyP42)
# else
(yyP43, yyP42)
 register tTree yyP43;
 tUsage yyP42;
# endif
{
/* line 309 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tUsage tmp; 

  switch (yyP43->Kind) {
  case kIdentifier:
/* line 310 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 310 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP43->Identifier.Sym), kAFormal)))) goto yyL1;
  {
/* line 311 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP43 -> Identifier . U = yyP42;
/* line 312 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   SymbolKind (yyP43->Identifier.Sym) -> AFormal . U = UpdateUsage (SymbolKind (yyP43->Identifier.Sym) -> AFormal . U, yyP42);
/* line 313 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 if (SymbolKind(yyP43->Identifier.Sym)->AFormal.U==xxInOut) Message("Passed channel used for both input and output",xxError,yyP43->Identifier.Pos); 
  }
  }
   return;
yyL1:;

/* line 315 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 315 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP43->Identifier.Sym), kIs)))) goto yyL2;
  {
/* line 316 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP43 -> Identifier . U = yyP42;
/* line 317 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   SymbolKind (yyP43->Identifier.Sym) -> Is . U = UpdateUsage (SymbolKind (yyP43->Identifier.Sym) -> Is . U, yyP42);
/* line 318 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   tmp = SymbolKind (yyP43->Identifier.Sym) -> Is . U;
/* line 319 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 if (tmp==xxInput||tmp==xxOutput||tmp==xxInOut) UpdateElementalUsage(SymbolKind(yyP43->Identifier.Sym)->Is.Elemental,yyP42);
/* line 320 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 if (SymbolKind(yyP43->Identifier.Sym)->Is.U==xxInOut) Message("Abbreviated channel used for both input and output",xxError,yyP43->Identifier.Pos); 
  }
  }
   return;
yyL2:;

/* line 322 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 322 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP43->Identifier.Sym), kAnId)))) goto yyL3;
  {
/* line 323 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP43 -> Identifier . U = yyP42;
/* line 324 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   SymbolKind (yyP43->Identifier.Sym) -> AnId . U = UpdateUsage (SymbolKind (yyP43->Identifier.Sym) -> AnId . U, yyP42);
  }
  }
   return;
yyL3:;

  break;
  case kRange:
/* line 326 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 326 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP43 -> Range . U = yyP42;
/* line 326 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP43->Range.Next, yyP42);
  }
   return;

  case kSubscript:
/* line 327 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 327 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP43 -> Subscript . U = yyP42;
/* line 327 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP43->Subscript.Next, yyP42);
  }
   return;

  case kTableRange:
/* line 328 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 328 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP43 -> TableRange . U = yyP42;
/* line 328 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP43->TableRange.Next, yyP42);
  }
   return;

  case kTableSubscript:
/* line 329 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 329 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP43 -> TableSubscript . U = yyP42;
/* line 329 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP43->TableSubscript.Next, yyP42);
  }
   return;

  case kTable:
/* line 330 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 330 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP43 -> Table . U = yyP42;
/* line 330 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP43->Table.ExprList, yyP42);
  }
   return;

  case kAnExpr:
  if (yyP43->AnExpr.Expr->Kind == kElementalExpr) {
/* line 331 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 331 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP43->AnExpr.Expr->ElementalExpr.Elemental, yyP42);
/* line 331 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP43->AnExpr.Next, yyP42);
  }
   return;

  }
/* line 332 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 332 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   UpdateElementalUsage (yyP43->AnExpr.Next, yyP42);
  }
   return;

  }

;
}

void TypeCheckIfList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP44)
# else
(yyP44)
 register tTree yyP44;
# endif
{
  if (yyP44->Kind == kNoChoice) {
/* line 336 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
  if (yyP44->Kind == kAChoice) {
  if (yyP44->AChoice.ExprList->Kind == kAnExpr) {
  if (yyP44->AChoice.ExprList->AnExpr.Next->Kind == kNoExpr) {
/* line 337 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 337 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (ExprType (yyP44->AChoice.ExprList->AnExpr.Expr), kBool)))) goto yyL2;
  {
/* line 337 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP44->AChoice.Next);
  }
  }
   return;
yyL2:;

/* line 338 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 338 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Conditional not of type BOOL", xxError, yyP44->AChoice.ExprList->AnExpr.Expr->Expr.Pos);
/* line 338 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP44->AChoice.Next);
  }
   return;

  }
  }
  }
  if (yyP44->Kind == kANewIf) {
  if (yyP44->ANewIf.IfType->Kind == kIf) {
/* line 339 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 339 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP44->ANewIf.IfType->If.ChoiceList);
/* line 339 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP44->ANewIf.Next);
  }
   return;

  }
  if (yyP44->ANewIf.IfType->Kind == kIfRep) {
/* line 340 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 340 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP44->ANewIf.IfType->IfRep.ChoiceList);
/* line 340 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckIfList (yyP44->ANewIf.Next);
  }
   return;

  }
  }
;
}

void TypeCheckTimerInput
# if defined __STDC__ | defined __cplusplus
(register tTree yyP46, register tPosition yyP45)
# else
(yyP46, yyP45)
 register tTree yyP46;
 register tPosition yyP45;
# endif
{
  if (yyP46->Kind == kAnExpr) {
  if (yyP46->AnExpr.Next->Kind == kNoExpr) {
  if (yyP46->AnExpr.Expr->Kind == kElementalExpr) {
/* line 344 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 344 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP46->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL1;
  {
/* line 344 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (ExprType (yyP46->AnExpr.Expr), kInt)))) goto yyL1;
  }
  }
   return;
yyL1:;

  }
/* line 345 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 345 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Timer input not to writable INT variable", xxError, yyP46->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
/* line 346 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 346 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Only single input allowed from TIMER", xxError, yyP45);
  }
   return;

  }
  if (yyP46->Kind == kNoExpr) {
/* line 347 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 347 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Missing variable for timer input", xxError, yyP45);
  }
   return;

  }
;
}

void TypeCheckInputProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP49, register tTree yyP48, register tPosition yyP47)
# else
(yyP49, yyP48, yyP47)
 register tTree yyP49;
 register tTree yyP48;
 register tPosition yyP47;
# endif
{
  if (yyP49->Kind == kAny) {
  if (yyP48->Kind == kAnExpr) {
  if (yyP48->AnExpr.Next->Kind == kNoExpr) {
  if (yyP48->AnExpr.Expr->Kind == kElementalExpr) {
/* line 351 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 351 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL1;
  }
   return;
yyL1:;

  }
  if (yyP48->AnExpr.Expr->Kind == kCountArray) {
  if (yyP48->AnExpr.Expr->CountArray.Length->Kind == kElementalExpr) {
  if (yyP48->AnExpr.Expr->CountArray.Expr->Kind == kElementalExpr) {
/* line 353 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 354 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->CountArray.Length->ElementalExpr.Elemental)))) goto yyL3;
  {
/* line 354 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental)))) goto yyL3;
  {
/* line 354 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP48->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental -> Element . SynType -> Kind == kArray))) goto yyL3;
  }
  }
  }
   return;
yyL3:;

  }
  }
  }
/* line 357 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 357 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Input variable not writable", xxError, yyP48->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  if (yyP48->AnExpr.Expr->Kind == kElementalExpr) {
/* line 352 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 352 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL2;
  {
/* line 352 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckInputProtocol (yyP49, yyP48->AnExpr.Next, yyP48->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL2:;

  }
  if (yyP48->AnExpr.Expr->Kind == kCountArray) {
  if (yyP48->AnExpr.Expr->CountArray.Length->Kind == kElementalExpr) {
  if (yyP48->AnExpr.Expr->CountArray.Expr->Kind == kElementalExpr) {
/* line 355 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 356 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->CountArray.Length->ElementalExpr.Elemental)))) goto yyL4;
  {
/* line 356 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental)))) goto yyL4;
  {
/* line 356 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP48->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental -> Element . SynType -> Kind == kArray))) goto yyL4;
  {
/* line 356 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckInputProtocol (yyP49, yyP48->AnExpr.Next, yyP48->AnExpr.Expr->CountArray.Pos);
  }
  }
  }
  }
   return;
yyL4:;

  }
  }
  }
/* line 358 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 358 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Input variable not writable", xxError, yyP48->AnExpr.Expr->Expr.Pos);
/* line 358 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckInputProtocol (yyP49, yyP48->AnExpr.Next, yyP48->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
  if (yyP48->Kind == kNoExpr) {
/* line 360 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 360 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("No expression list present for channel input", xxError, yyP47);
  }
   return;

  }
  if (yyP49->Kind == kNamed) {
/* line 362 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 362 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP49->Named.Sym), kDefSeqPro)))) goto yyL8;
  {
/* line 362 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckInputSeqProtocol (SymbolKind (yyP49->Named.Sym) -> DefSeqPro . SeqProList, yyP48, yyP47);
  }
  }
   return;
yyL8:;

/* line 363 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 363 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Invalid form of variant protocol input", xxError, yyP47);
  }
   return;

  }
  if (yyP48->Kind == kAnExpr) {
  if (yyP48->AnExpr.Next->Kind == kNoExpr) {
  if (yyP48->AnExpr.Expr->Kind == kElementalExpr) {
/* line 364 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 364 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL10;
  {
/* line 364 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP49, yyP48->AnExpr.Expr);
  }
  }
   return;
yyL10:;

  }
  if (yyP48->AnExpr.Expr->Kind == kCountArray) {
  if (yyP48->AnExpr.Expr->CountArray.Length->Kind == kElementalExpr) {
  if (yyP48->AnExpr.Expr->CountArray.Expr->Kind == kElementalExpr) {
/* line 365 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 365 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->CountArray.Length->ElementalExpr.Elemental)))) goto yyL11;
  {
/* line 365 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP48->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental)))) goto yyL11;
  {
/* line 365 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP49, yyP48->AnExpr.Expr);
  }
  }
  }
   return;
yyL11:;

  }
  }
  }
/* line 366 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 366 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Input item not assignable", xxError, yyP48->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
/* line 367 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 367 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too many inputs for a channel with a simple protocol", xxError, yyP48->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
;
}

static void TypeCheckSimpleProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP51, register tTree yyP50)
# else
(yyP51, yyP50)
 register tTree yyP51;
 register tTree yyP50;
# endif
{
  if (yyP51->Kind == kSimple) {
  if (yyP50->Kind == kCountArray) {
/* line 372 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 372 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Protocol does not expect a counted array", xxError, yyP50->CountArray.Pos);
  }
   return;

  }
/* line 373 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 373 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP51->Simple.Type, ExprType (yyP50)))) goto yyL2;
  }
   return;
yyL2:;

/* line 374 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 374 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Variable is not of correct type for protocol", xxError, yyP50->Expr.Pos);
  }
   return;

  }
  if (yyP51->Kind == kCounted) {
  if (yyP50->Kind == kCountArray) {
/* line 375 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 375 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((SameType (yyP51->Counted.Length, ExprType (yyP50->CountArray.Length))))) goto yyL4;
  {
/* line 375 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((SameType (yyP51->Counted.Type, ExprType (yyP50->CountArray.Expr))))) goto yyL4;
  }
  }
   return;
yyL4:;

/* line 376 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 376 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Counted array expression types do not match protocol", xxError, yyP50->CountArray.Pos);
  }
   return;

  }
/* line 377 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 377 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((SameType (yyP51->Counted.Type, ExprType (yyP50))))) goto yyL6;
  }
   return;
yyL6:;

/* line 378 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 378 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Output expression does not match protocol", xxError, yyP50->Expr.Pos);
  }
   return;

  }
;
}

void TypeCheckOutputProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP54, register tTree yyP53, register tPosition yyP52)
# else
(yyP54, yyP53, yyP52)
 register tTree yyP54;
 register tTree yyP53;
 register tPosition yyP52;
# endif
{
  if (yyP54->Kind == kAny) {
  if (yyP53->Kind == kAnExpr) {
  if (yyP53->AnExpr.Next->Kind == kNoExpr) {
/* line 385 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
/* line 386 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 387 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckOutputProtocol (yyP54, yyP53->AnExpr.Next, yyP53->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
  if (yyP53->Kind == kNoExpr) {
/* line 389 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 390 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("No expression list present for channel output", xxError, yyP52);
  }
   return;

  }
  if (yyP54->Kind == kNamed) {
/* line 392 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 392 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP54->Named.Sym), kDefSeqPro)))) goto yyL4;
  {
/* line 393 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckOutputSeqProtocol (SymbolKind (yyP54->Named.Sym) -> DefSeqPro . SeqProList, yyP53, yyP52);
  }
  }
   return;
yyL4:;

/* line 395 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 395 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (SymbolKind (yyP54->Named.Sym), kDefTagPro)))) goto yyL5;
  {
/* line 396 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckCaseOutput (SymbolKind (yyP54->Named.Sym) -> DefTagPro . TagProList, yyP53, yyP52);
  }
  }
   return;
yyL5:;

/* line 398 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 399 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Not a valid named", xxError, yyP52);
  }
   return;

  }
  if (yyP53->Kind == kAnExpr) {
  if (yyP53->AnExpr.Next->Kind == kNoExpr) {
/* line 401 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 402 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP54, yyP53->AnExpr.Expr);
  }
   return;

  }
/* line 404 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 405 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too many outputs for a channel with a simple protocol", xxError, yyP53->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
;
}

void TypeCheckCaseInputs
# if defined __STDC__ | defined __cplusplus
(register tTree yyP57, register tTree yyP56, register tPosition yyP55)
# else
(yyP57, yyP56, yyP55)
 register tTree yyP57;
 register tTree yyP56;
 register tPosition yyP55;
# endif
{
  if (yyP56->Kind == kNoCase) {
/* line 410 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
  if (yyP56->Kind == kACase) {
  if (yyP56->ACase.ExprList->Kind == kAnExpr) {
  if (yyP56->ACase.ExprList->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP56->ACase.ExprList->AnExpr.Expr->ElementalExpr.Elemental->Kind == kIdentifier) {
/* line 411 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 411 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((CheckValidTag (yyP57, yyP56->ACase.ExprList->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym)))) goto yyL2;
  {
/* line 411 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckInputSeqProtocol (SymbolKind (yyP56->ACase.ExprList->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym) -> ATagPro . SeqProList, yyP56->ACase.ExprList->AnExpr.Next, yyP55);
/* line 411 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckCaseInputs (yyP57, yyP56->ACase.Next, yyP55);
  }
  }
   return;
yyL2:;

  }
  }
/* line 412 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 412 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Variant tag is not valid for this protocol", xxError, yyP56->ACase.ExprList->AnExpr.Expr->Expr.Pos);
/* line 412 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckCaseInputs (yyP57, yyP56->ACase.Next, yyP55);
  }
   return;

  }
  if (yyP56->ACase.ExprList->Kind == kNoExpr) {
/* line 413 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 413 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Cased input missing variant protocol", xxError, yyP55);
/* line 413 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckCaseInputs (yyP57, yyP56->ACase.Next, yyP55);
  }
   return;

  }
  }
;
}

static void TypeCheckCaseOutput
# if defined __STDC__ | defined __cplusplus
(register tTree yyP60, register tTree yyP59, register tPosition yyP58)
# else
(yyP60, yyP59, yyP58)
 register tTree yyP60;
 register tTree yyP59;
 register tPosition yyP58;
# endif
{
  if (yyP59->Kind == kAnExpr) {
  if (yyP59->AnExpr.Expr->Kind == kElementalExpr) {
  if (yyP59->AnExpr.Expr->ElementalExpr.Elemental->Kind == kIdentifier) {
/* line 417 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 417 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((CheckValidTag (yyP60, yyP59->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym)))) goto yyL1;
  {
/* line 418 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckOutputSeqProtocol (SymbolKind (yyP59->AnExpr.Expr->ElementalExpr.Elemental->Identifier.Sym) -> ATagPro . SeqProList, yyP59->AnExpr.Next, yyP58);
  }
  }
   return;
yyL1:;

  }
  }
/* line 420 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 421 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Variant tag is not valid for this protocol", xxError, yyP59->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  if (yyP59->Kind == kNoExpr) {
/* line 423 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 424 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Cased output missing variant protocol", xxError, yyP58);
  }
   return;

  }
;
}

static void TypeCheckInputSeqProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP63, register tTree yyP62, register tPosition yyP61)
# else
(yyP63, yyP62, yyP61)
 register tTree yyP63;
 register tTree yyP62;
 register tPosition yyP61;
# endif
{
  if (yyP63->Kind == kNoSeqPro) {
  if (yyP62->Kind == kNoExpr) {
/* line 429 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
  if (yyP62->Kind == kAnExpr) {
/* line 430 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 430 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too many input expressions for channel protocol", xxError, yyP62->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
  if (yyP62->Kind == kNoExpr) {
/* line 431 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 431 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too few input expressions for channel protocol", xxError, yyP61);
  }
   return;

  }
  if (yyP63->Kind == kASeqPro) {
  if (yyP62->Kind == kAnExpr) {
  if (yyP62->AnExpr.Expr->Kind == kElementalExpr) {
/* line 432 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 432 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Writable (yyP62->AnExpr.Expr->ElementalExpr.Elemental)))) goto yyL4;
  {
/* line 432 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP63->ASeqPro.Protocol, yyP62->AnExpr.Expr);
/* line 432 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckInputSeqProtocol (yyP63->ASeqPro.Next, yyP62->AnExpr.Next, yyP62->AnExpr.Expr->ElementalExpr.Pos);
  }
  }
   return;
yyL4:;

  }
  if (yyP62->AnExpr.Expr->Kind == kCountArray) {
/* line 433 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 433 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP63->ASeqPro.Protocol, yyP62->AnExpr.Expr);
/* line 433 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckInputSeqProtocol (yyP63->ASeqPro.Next, yyP62->AnExpr.Next, yyP62->AnExpr.Expr->CountArray.Pos);
  }
   return;

  }
/* line 434 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 434 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Not an assignable expression", xxError, yyP62->AnExpr.Expr->Expr.Pos);
/* line 434 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckInputSeqProtocol (yyP63->ASeqPro.Next, yyP62->AnExpr.Next, yyP62->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
;
}

static void TypeCheckOutputSeqProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP66, register tTree yyP65, register tPosition yyP64)
# else
(yyP66, yyP65, yyP64)
 register tTree yyP66;
 register tTree yyP65;
 register tPosition yyP64;
# endif
{
  if (yyP66->Kind == kNoSeqPro) {
  if (yyP65->Kind == kNoExpr) {
/* line 438 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
  if (yyP65->Kind == kAnExpr) {
/* line 439 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 439 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too many output expressions for channel protocol", xxError, yyP65->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
  if (yyP65->Kind == kNoExpr) {
/* line 440 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 440 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Too few output expressions for channel protocol", xxError, yyP64);
  }
   return;

  }
  if (yyP66->Kind == kASeqPro) {
  if (yyP65->Kind == kAnExpr) {
/* line 441 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 441 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckSimpleProtocol (yyP66->ASeqPro.Protocol, yyP65->AnExpr.Expr);
/* line 441 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckOutputSeqProtocol (yyP66->ASeqPro.Next, yyP65->AnExpr.Next, yyP65->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
;
}

void TypeCheckCaseList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP68, register tTree yyP67)
# else
(yyP68, yyP67)
 register tTree yyP68;
 register tTree yyP67;
# endif
{
  if (yyP67->Kind == kNoChoice) {
/* line 445 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
  if (yyP67->Kind == kAChoice) {
  if (yyP67->AChoice.Next->Kind == kNoChoice) {
  if (yyP67->AChoice.ExprList->Kind == kAnExpr) {
  if (yyP67->AChoice.ExprList->AnExpr.Next->Kind == kNoExpr) {
  if (yyP67->AChoice.ExprList->AnExpr.Expr->Kind == kDefault) {
/* line 446 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
  }
  }
  }
  if (yyP67->AChoice.ExprList->Kind == kAnExpr) {
  if (yyP67->AChoice.ExprList->AnExpr.Next->Kind == kNoExpr) {
  if (yyP67->AChoice.ExprList->AnExpr.Expr->Kind == kDefault) {
/* line 447 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 447 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("ELSE not final option in selection", xxError, yyP67->AChoice.ExprList->AnExpr.Expr->Default.Pos);
  }
   return;

  }
  }
/* line 448 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 449 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 CountList(yyP67->AChoice.ExprList,yyP68);
/* line 450 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TypeCheckCaseList (yyP68, yyP67->AChoice.Next);
/* line 451 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 if (!ConstFlag(yyP67->AChoice.ExprList->ExprList))
        Message("CASE options must be constant",xxError,yyP67->AChoice.ExprList->AnExpr.Expr->Expr.Pos);
      if (!(CheckIsType(ExprListType(yyP67->AChoice.ExprList),kInteger)||CheckIsType(ExprListType(yyP67->AChoice.ExprList),kByte)||CheckIsType(ExprListType(yyP67->AChoice.ExprList),kBool)))
        Message("CASE options must be integer or BYTE (or BOOL)",xxError,yyP67->AChoice.ExprList->AnExpr.Expr->Expr.Pos);
      else 
        if (!CheckChoicesDiffer(yyP67->AChoice.ExprList,yyP67->AChoice.Next)) Message("CASE options must be distinct",xxError,yyP67->AChoice.ExprList->AnExpr.Expr->Expr.Pos);
  }
   return;

  }
  }
;
}

void TypeCheckRetypes
# if defined __STDC__ | defined __cplusplus
(register tTree yyP71, register tTree yyP70, register tPosition yyP69)
# else
(yyP71, yyP70, yyP69)
 register tTree yyP71;
 register tTree yyP70;
 register tPosition yyP69;
# endif
{
/* line 460 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 int LS,RS; 
/* line 461 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  tTree yyV1;
  tTree yyV2;
  {
/* line 461 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   LS = SizeType (yyP71, yyP69, true, & yyV1);
/* line 461 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   RS = SizeType (yyP70, yyP69, false, & yyV2);
/* line 461 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   DoTypeCheckRetypes (LS, yyV1, RS, yyV2, yyP69);
  }
   return;
 }

;
}

static void DoTypeCheckRetypes
# if defined __STDC__ | defined __cplusplus
(register int yyP76, register tTree yyP75, register int yyP74, register tTree yyP73, register tPosition yyP72)
# else
(yyP76, yyP75, yyP74, yyP73, yyP72)
 register int yyP76;
 register tTree yyP75;
 register int yyP74;
 register tTree yyP73;
 register tPosition yyP72;
# endif
{
  if (equalint (yyP74, - 1)) {
/* line 464 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
/* line 465 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 465 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP73 != NoTree))) goto yyL2;
  }
   return;
yyL2:;

  if (yyP75 == NULL) {
  if (yyP73 == NULL) {
/* line 466 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 466 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP76 == yyP74))) goto yyL3;
  }
   return;
yyL3:;

/* line 467 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 467 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Size of retype does not match expression size", xxError, yyP72);
  }
   return;

  }
  }
  if (yyP73 == NULL) {
/* line 468 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 468 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (((yyP74 % yyP76) == 0))) goto yyL5;
  {
/* line 468 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP75 -> Array . Expr = MakeConstInt (yyP74 / yyP76, yyP72);
  }
  }
   return;
yyL5:;

/* line 469 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 469 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Size of retype cannot match expression size", xxError, yyP72);
  }
   return;

  }
;
}

static bool SameType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP78, register tTree yyP77)
# else
(yyP78, yyP77)
 register tTree yyP78;
 register tTree yyP77;
# endif
{

  switch (yyP78->Kind) {
  case kInt16:
  if (yyP77->Kind == kInt16) {
/* line 476 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kInt32:
  if (yyP77->Kind == kInt32) {
/* line 477 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kInt64:
  if (yyP77->Kind == kInt64) {
/* line 478 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kInt:
  if (yyP77->Kind == kInt) {
/* line 479 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kBool:
  if (yyP77->Kind == kBool) {
/* line 480 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kReal32:
  if (yyP77->Kind == kReal32) {
/* line 481 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kReal64:
  if (yyP77->Kind == kReal64) {
/* line 482 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kByte:
  if (yyP77->Kind == kByte) {
/* line 483 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kTimer:
  if (yyP77->Kind == kTimer) {
/* line 484 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  break;
  case kChan:
  if (yyP77->Kind == kChan) {
/* line 485 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 485 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameProtocol (yyP78->Chan.Protocol, yyP77->Chan.Protocol))) goto yyL10;
  }
   return true;
yyL10:;

  }
  break;
  case kArray:
  if (yyP78->Array.Expr->Kind == kUnBound) {
  if (yyP77->Kind == kArray) {
/* line 486 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 486 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP78->Array.Type, yyP77->Array.Type))) goto yyL11;
  }
   return true;
yyL11:;

/* line 487 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 487 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return false;
  }

  }
  }
  if (yyP77->Kind == kArray) {
/* line 488 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 488 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP78->Array.Expr)))) goto yyL13;
  {
/* line 488 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP77->Array.Expr)))) goto yyL13;
  {
/* line 488 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP78->Array.Expr) == ValConstInt (yyP77->Array.Expr)))) goto yyL13;
  {
/* line 488 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP78->Array.Type, yyP77->Array.Type))) goto yyL13;
  }
  }
  }
  }
   return true;
yyL13:;

/* line 489 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 489 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((! IsConstInt (yyP77->Array.Expr)))) goto yyL14;
  {
/* line 489 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP78->Array.Type, yyP77->Array.Type))) goto yyL14;
  }
  }
   return true;
yyL14:;

/* line 490 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 490 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((! IsConstInt (yyP78->Array.Expr)))) goto yyL15;
  {
/* line 490 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP78->Array.Type, yyP77->Array.Type))) goto yyL15;
  }
  }
   return true;
yyL15:;

  }
  break;
  }

  return false;
}

static bool CheckValidTag
# if defined __STDC__ | defined __cplusplus
(register tTree yyP80, tSymbol yyP79)
# else
(yyP80, yyP79)
 register tTree yyP80;
 tSymbol yyP79;
# endif
{
  if (yyP80->Kind == kATagPro) {
/* line 494 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 494 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP80->ATagPro.Sym == yyP79))) goto yyL1;
  }
   return true;
yyL1:;

/* line 495 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 495 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValidTag (yyP80->ATagPro.Next, yyP79))) goto yyL2;
  }
   return true;
yyL2:;

  }
  return false;
}

static bool SameProtocol
# if defined __STDC__ | defined __cplusplus
(register tTree yyP82, register tTree yyP81)
# else
(yyP82, yyP81)
 register tTree yyP82;
 register tTree yyP81;
# endif
{
  if (yyP82->Kind == kAny) {
/* line 499 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP81->Kind == kAny) {
/* line 500 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP82->Kind == kNamed) {
  if (yyP81->Kind == kNamed) {
/* line 501 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 501 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP82->Named.Sym == yyP81->Named.Sym))) goto yyL3;
  }
   return true;
yyL3:;

  }
  }
  if (yyP82->Kind == kSimple) {
  if (yyP81->Kind == kSimple) {
/* line 502 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 502 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP82->Simple.Type, yyP81->Simple.Type))) goto yyL4;
  }
   return true;
yyL4:;

  }
  }
  if (yyP82->Kind == kCounted) {
  if (yyP81->Kind == kCounted) {
/* line 503 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 503 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP82->Counted.Length, yyP81->Counted.Length))) goto yyL5;
  {
/* line 503 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP82->Counted.Type, yyP81->Counted.Type))) goto yyL5;
  }
  }
   return true;
yyL5:;

  }
  }
  return false;
}

bool CheckWritable
# if defined __STDC__ | defined __cplusplus
(register tTree yyP83)
# else
(yyP83)
 register tTree yyP83;
# endif
{
  if (yyP83->Kind == kAnId) {
/* line 507 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP83->Kind == kAFormal) {
  if (yyP83->AFormal.By->Kind == kByRef) {
/* line 508 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  }
  if (yyP83->Kind == kIs) {
/* line 509 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP83->Kind == kRetypes) {
/* line 510 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

bool CheckWritableExprList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP84)
# else
(yyP84)
 register tTree yyP84;
# endif
{
  if (yyP84->Kind == kNoExpr) {
/* line 515 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP84->Kind == kAnExpr) {
  if (yyP84->AnExpr.Expr->Kind == kElementalExpr) {
/* line 516 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return CheckWritableExprList (yyP84->AnExpr.Next) && Writable (yyP84->AnExpr.Expr->ElementalExpr.Elemental);

  }
/* line 517 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return false;

  }
 yyAbort ("CheckWritableExprList");
}

bool CheckForVals
# if defined __STDC__ | defined __cplusplus
(register tTree yyP85)
# else
(yyP85)
 register tTree yyP85;
# endif
{
  if (yyP85->Kind == kNoFormal) {
/* line 521 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP85->Kind == kAFormal) {
  if (yyP85->AFormal.By->Kind == kByVal) {
/* line 522 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 522 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckForVals (yyP85->AFormal.Next))) goto yyL2;
  }
   return true;
yyL2:;

  }
  }
  return false;
}

bool CheckValofScope
# if defined __STDC__ | defined __cplusplus
(register tTree yyP87, register int yyP86)
# else
(yyP87, yyP86)
 register tTree yyP87;
 register int yyP86;
# endif
{
  if (yyP87->Kind == kNoExpr) {
/* line 526 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP87->Kind == kAnExpr) {
  if (yyP87->AnExpr.Expr->Kind == kElementalExpr) {
/* line 527 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 527 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP87->AnExpr.Expr->ElementalExpr.Elemental, yyP86))) goto yyL2;
  {
/* line 527 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP87->AnExpr.Next, yyP86))) goto yyL2;
  }
  }
   return true;
yyL2:;

/* line 528 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 528 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return false;
  }

  }
  if (yyP87->AnExpr.Expr->Kind == kCountArray) {
  if (yyP87->AnExpr.Expr->CountArray.Length->Kind == kElementalExpr) {
  if (yyP87->AnExpr.Expr->CountArray.Expr->Kind == kElementalExpr) {
/* line 529 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 529 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP87->AnExpr.Expr->CountArray.Expr->ElementalExpr.Elemental, yyP86))) goto yyL4;
  {
/* line 529 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP87->AnExpr.Next, yyP86))) goto yyL4;
  }
  }
   return true;
yyL4:;

/* line 530 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 530 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return false;
  }

  }
  }
  }
/* line 531 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 531 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP87->AnExpr.Next, yyP86))) goto yyL6;
  }
   return true;
yyL6:;

  }
  if (yyP87->Kind == kRange) {
/* line 532 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 532 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP87->Range.Next, yyP86))) goto yyL7;
  }
   return true;
yyL7:;

  }
  if (yyP87->Kind == kSubscript) {
/* line 533 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 533 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValofScope (yyP87->Subscript.Next, yyP86))) goto yyL8;
  }
   return true;
yyL8:;

  }
  if (yyP87->Kind == kIdentifier) {
/* line 534 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 534 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Symbol (yyP87->Identifier.Sym) . Depth >= yyP86))) goto yyL9;
  }
   return true;
yyL9:;

  }
  return false;
}

bool CheckIsType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP89, Tree_tKind yyP88)
# else
(yyP89, yyP88)
 register tTree yyP89;
 Tree_tKind yyP88;
# endif
{
/* line 538 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 538 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((Tree_IsType (yyP89, yyP88)))) goto yyL1;
  }
   return true;
yyL1:;

  return false;
}

bool IsChanOrTimerType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP90)
# else
(yyP90)
 register tTree yyP90;
# endif
{
  if (yyP90->Kind == kArray) {
/* line 542 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 542 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsChanOrTimerType (yyP90->Array.Type)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP90->Kind == kChan) {
/* line 544 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP90->Kind == kTimer) {
/* line 546 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

bool IsChanType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP91)
# else
(yyP91)
 register tTree yyP91;
# endif
{
  if (yyP91->Kind == kArray) {
/* line 551 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 551 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsChanType (yyP91->Array.Type)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP91->Kind == kChan) {
/* line 553 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

bool IsTimerType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP92)
# else
(yyP92)
 register tTree yyP92;
# endif
{
  if (yyP92->Kind == kArray) {
/* line 559 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 559 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsTimerType (yyP92->Array.Type)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP92->Kind == kTimer) {
/* line 561 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

bool IsArrayType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP93)
# else
(yyP93)
 register tTree yyP93;
# endif
{
  if (yyP93->Kind == kArray) {
/* line 567 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

static bool CheckChoicesDiffer
# if defined __STDC__ | defined __cplusplus
(register tTree yyP95, register tTree yyP94)
# else
(yyP95, yyP94)
 register tTree yyP95;
 register tTree yyP94;
# endif
{
  if (yyP95->Kind == kNoExpr) {
/* line 572 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP95->Kind == kAnExpr) {
/* line 573 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 573 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckExprDiffers (yyP95->AnExpr.Expr, yyP95->AnExpr.Next, yyP94))) goto yyL2;
  {
/* line 573 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckChoicesDiffer (yyP95->AnExpr.Next, yyP94))) goto yyL2;
  }
  }
   return true;
yyL2:;

  }
  return false;
}

static bool CheckExprDiffers
# if defined __STDC__ | defined __cplusplus
(register tTree yyP98, register tTree yyP97, register tTree yyP96)
# else
(yyP98, yyP97, yyP96)
 register tTree yyP98;
 register tTree yyP97;
 register tTree yyP96;
# endif
{
  if (yyP97->Kind == kNoExpr) {
  if (yyP96->Kind == kNoChoice) {
/* line 577 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP96->Kind == kAChoice) {
/* line 578 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 578 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckExprDiffers (yyP98, yyP96->AChoice.ExprList, yyP96->AChoice.Next))) goto yyL2;
  }
   return true;
yyL2:;

  }
  }
  if (yyP97->Kind == kAnExpr) {
/* line 579 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 579 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((! IsConstInt (yyP98)))) goto yyL3;
  }
   return true;
yyL3:;

/* line 580 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 580 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((! IsConstInt (yyP97->AnExpr.Expr)))) goto yyL4;
  {
/* line 580 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckExprDiffers (yyP98, yyP97->AnExpr.Next, yyP96))) goto yyL4;
  }
  }
   return true;
yyL4:;

/* line 581 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 581 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP98) != ValConstInt (yyP97->AnExpr.Expr)))) goto yyL5;
  {
/* line 581 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckExprDiffers (yyP98, yyP97->AnExpr.Next, yyP96))) goto yyL5;
  }
  }
   return true;
yyL5:;

  }
  return false;
}

bool CheckValidDeclType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP99)
# else
(yyP99)
 register tTree yyP99;
# endif
{
  if (yyP99->Kind == kArray) {
/* line 585 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 585 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP99->Array.Expr)))) goto yyL1;
  {
/* line 585 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP99->Array.Expr) > 0))) goto yyL1;
  {
/* line 585 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckValidDeclType (yyP99->Array.Type))) goto yyL1;
  }
  }
  }
   return true;
yyL1:;

/* line 586 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 586 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return false;
  }

  }
/* line 587 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

}

bool CheckEvalBiOp
# if defined __STDC__ | defined __cplusplus
(register tTree yyP101, register tTree yyP100)
# else
(yyP101, yyP100)
 register tTree yyP101;
 register tTree yyP100;
# endif
{
  if (Tree_IsType (yyP100, kInteger)) {
/* line 593 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 593 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckEvalBiIntOp (yyP101))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (Tree_IsType (yyP100, kReal)) {
/* line 595 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 595 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (CheckEvalBiRealOp (yyP101))) goto yyL2;
  }
   return true;
yyL2:;

  }
  if (Tree_IsType (yyP101, kRelOp)) {
  if (yyP100->Kind == kByte) {
/* line 597 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP100->Kind == kBool) {
/* line 600 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  }
  if (Tree_IsType (yyP101, kLogOp)) {
  if (yyP100->Kind == kBool) {
/* line 599 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  }
  if (yyP101->Kind == kAfterOp) {
  if (yyP100->Kind == kBool) {
/* line 601 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  }
  return false;
}

static bool CheckEvalBiIntOp
# if defined __STDC__ | defined __cplusplus
(register tTree yyP102)
# else
(yyP102)
 register tTree yyP102;
# endif
{
  if (Tree_IsType (yyP102, kMathsOp)) {
/* line 604 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP102, kClockOp)) {
/* line 605 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP102, kRelOp)) {
/* line 606 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP102, kBitOp)) {
/* line 607 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP102, kShiftOp)) {
/* line 608 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

static bool CheckEvalBiRealOp
# if defined __STDC__ | defined __cplusplus
(register tTree yyP103)
# else
(yyP103)
 register tTree yyP103;
# endif
{
  if (Tree_IsType (yyP103, kMathsOp)) {
/* line 611 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP103, kRelOp)) {
/* line 612 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

bool CheckEvalUniOp
# if defined __STDC__ | defined __cplusplus
(register tTree yyP106, register tTree yyP105, register tTree yyP104)
# else
(yyP106, yyP105, yyP104)
 register tTree yyP106;
 register tTree yyP105;
 register tTree yyP104;
# endif
{
  if (Tree_IsType (yyP106, kInteger)) {
  if (yyP105->Kind == kBitNot) {
/* line 618 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 618 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP104)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP105->Kind == kSubtract) {
/* line 620 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 620 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP104)))) goto yyL3;
  }
   return true;
yyL3:;

  }
  if (yyP105->Kind == kMinus) {
/* line 621 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 621 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP104)))) goto yyL4;
  }
   return true;
yyL4:;

  }
  if (yyP105->Kind == kPlus) {
/* line 622 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 622 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP104)))) goto yyL5;
  }
   return true;
yyL5:;

  }
  if (yyP105->Kind == kAdd) {
/* line 623 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 623 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP104)))) goto yyL6;
  }
   return true;
yyL6:;

  }
  }
  if (yyP106->Kind == kBool) {
  if (yyP105->Kind == kNot) {
/* line 619 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 619 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP104)))) goto yyL2;
  }
   return true;
yyL2:;

  }
  }
  if (Tree_IsType (yyP106, kReal)) {
  if (yyP105->Kind == kSubtract) {
/* line 624 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 624 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP104)))) goto yyL7;
  }
   return true;
yyL7:;

  }
  if (yyP105->Kind == kAdd) {
/* line 625 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 625 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP104)))) goto yyL8;
  }
   return true;
yyL8:;

  }
  }
  if (yyP106->Kind == kArray) {
  if (yyP105->Kind == kSize) {
/* line 626 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 626 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP106->Array.Expr)))) goto yyL9;
  }
   return true;
yyL9:;

  }
  }
  return false;
}

tValue EvalBiExpr
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP111, register tTree yyP110, tValue yyP109, register tTree yyP108, tValue yyP107)
# else
(yyP111, yyP110, yyP109, yyP108, yyP107)
 register tPosition yyP111;
 register tTree yyP110;
 tValue yyP109;
 register tTree yyP108;
 tValue yyP107;
# endif
{
/* line 631 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue Res; 
  if (Tree_IsType (yyP110, kInteger)) {
/* line 633 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 633 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = EvalBiIntOp (yyP111, yyP110, yyP109 . Number, yyP108, yyP107 . Number);
  }
   return Res;

  }
  if (yyP110->Kind == kByte) {
/* line 634 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 634 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = EvalBiIntOp (yyP111, yyP110, yyP109 . Number, yyP108, yyP107 . Number);
  }
   return Res;

  }
  if (yyP110->Kind == kBool) {
/* line 635 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 635 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = EvalBiBoolOp (yyP111, yyP110, yyP109 . Number, yyP108, yyP107 . Number);
  }
   return Res;

  }
  if (Tree_IsType (yyP110, kReal)) {
  if (Tree_IsType (yyP108, kMathsOp)) {
/* line 636 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 636 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . n = EvalBiRealMathsOp (yyP111, yyP110, yyP109 . RNumber . n, yyP108, yyP107 . RNumber . n);
/* line 636 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . p = MAX (yyP109 . RNumber . p, yyP107 . RNumber . p);
  }
   return Res;

  }
  if (Tree_IsType (yyP108, kRelOp)) {
/* line 637 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 637 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = EvalBiRealRelOp (yyP111, yyP110, yyP109 . RNumber . n, yyP108, yyP107 . RNumber . n);
  }
   return Res;

  }
  }
 yyAbort ("EvalBiExpr");
}

static tInt EvalBiIntOp
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP116, register tTree yyP115, tInt yyP114, register tTree yyP113, tInt yyP112)
# else
(yyP116, yyP115, yyP114, yyP113, yyP112)
 register tPosition yyP116;
 register tTree yyP115;
 tInt yyP114;
 register tTree yyP113;
 tInt yyP112;
# endif
{
/* line 641 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tInt res; 

  switch (yyP113->Kind) {
  case kAdd:
/* line 643 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return TestIntOVF (yyP116, yyP115, yyP114 + yyP112);

  case kSubtract:
/* line 644 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return TestIntOVF (yyP116, yyP115, yyP114 - yyP112);

  case kMultiply:
/* line 645 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return TestIntOVF (yyP116, yyP115, yyP114 * yyP112);

  case kDivide:
/* line 647 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 647 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP112 != 0))) goto yyL4;
  }
   return TestIntOVF (yyP116, yyP115, yyP114 / yyP112);
yyL4:;

/* line 648 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return TestIntOVF (yyP116, mUntyped (), 1);

  case kRem:
/* line 649 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 649 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP112 != 0))) goto yyL6;
  }
   return TestIntOVF (yyP116, yyP115, yyP114 % yyP112);
yyL6:;

/* line 650 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return TestIntOVF (yyP116, mUntyped (), 1);

  case kEqual:
/* line 652 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP114 == yyP112;

  case kNotEqual:
/* line 653 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP114 != yyP112;

  case kLess:
/* line 654 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP114 < yyP112;

  case kGreater:
/* line 655 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP114 > yyP112;

  case kLessEqual:
/* line 656 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP114 <= yyP112;

  case kGreaterEqual:
/* line 657 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP114 >= yyP112;

  case kBitAnd:
/* line 659 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP114 & yyP112;

  case kBitOr:
/* line 660 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP114 | yyP112;

  case kBitEor:
/* line 661 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 661 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 res = yyP114^yyP112;
  }
   return res;

  case kShiftOp:
  case kLeftShift:
  case kRightShift:
/* line 663 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 663 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP112 == 0))) goto yyL17;
  }
   return yyP114;
yyL17:;

/* line 664 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 664 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP112 >= EvalIntBits (yyP115)))) goto yyL18;
  {
/* line 664 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Shift by invalid value for Integer size. Result is always zero", xxWarning, yyP116);
  }
  }
   return 0;
yyL18:;

/* line 665 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 665 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP112 < 0))) goto yyL19;
  {
/* line 665 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Shift by invalid (negative) value", xxError, yyP116);
  }
  }
   return 0;
yyL19:;

  break;
  }

  if (yyP113->Kind == kLeftShift) {
/* line 667 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 667 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 res = (yyP114<<yyP112) & EvalIntMask(yyP115); 
  }
   return res;

  }
  if (yyP113->Kind == kRightShift) {
/* line 668 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 668 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 res = (yyP114 >> 1) & EvalMostPos(yyP115); 
/* line 668 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP112 == 1))) goto yyL21;
  }
   return res;
yyL21:;

/* line 669 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 669 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 res = res >>(yyP112-1); 
  }
   return res;

  }
  if (yyP113->Kind == kPlus) {
/* line 671 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return (yyP114 + yyP112) & EvalIntMask (yyP115);

  }
  if (yyP113->Kind == kMinus) {
/* line 672 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return (yyP114 - yyP112) & EvalIntMask (yyP115);

  }
  if (yyP113->Kind == kTimes) {
/* line 673 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return (yyP114 * yyP112) & EvalIntMask (yyP115);

  }
  if (yyP113->Kind == kAfterOp) {
/* line 675 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 675 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 res = ((yyP114-yyP112) & EvalIntMask(yyP115))>0; 
  }
   return res;

  }
 yyAbort ("EvalBiIntOp");
}

static int EvalBiBoolOp
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP121, register tTree yyP120, tInt yyP119, register tTree yyP118, tInt yyP117)
# else
(yyP121, yyP120, yyP119, yyP118, yyP117)
 register tPosition yyP121;
 register tTree yyP120;
 tInt yyP119;
 register tTree yyP118;
 tInt yyP117;
# endif
{

  switch (yyP118->Kind) {
  case kEqual:
/* line 682 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP119 == yyP117;

  case kNotEqual:
/* line 683 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP119 != yyP117;

  case kLess:
/* line 684 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP119 < yyP117;

  case kGreater:
/* line 685 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP119 > yyP117;

  case kLessEqual:
/* line 686 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP119 <= yyP117;

  case kGreaterEqual:
/* line 687 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP119 >= yyP117;

  case kAnd:
/* line 689 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP119 && yyP117;

  case kOr:
/* line 690 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP119 || yyP117;

  }

 yyAbort ("EvalBiBoolOp");
}

static double EvalBiRealMathsOp
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP126, register tTree yyP125, register double yyP124, register tTree yyP123, register double yyP122)
# else
(yyP126, yyP125, yyP124, yyP123, yyP122)
 register tPosition yyP126;
 register tTree yyP125;
 register double yyP124;
 register tTree yyP123;
 register double yyP122;
# endif
{
/* line 695 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 double Res = 0; 
  if (yyP123->Kind == kAdd) {
/* line 697 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP124 + yyP122;

  }
  if (yyP123->Kind == kSubtract) {
/* line 698 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP124 - yyP122;

  }
  if (yyP123->Kind == kMultiply) {
/* line 699 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP124 * yyP122;

  }
  if (yyP123->Kind == kDivide) {
/* line 700 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 700 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP122 != 0))) goto yyL4;
  }
   return yyP124 / yyP122;
yyL4:;

/* line 701 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 701 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 TestIntOVF(yyP126,mUntyped(),1); 
  }
   return Res;

  }
  if (yyP123->Kind == kRem) {
/* line 702 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 702 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP122 != 0))) goto yyL6;
  {
/* line 702 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res = yyP124-(yyP122*(int)(yyP124/yyP122)); 
  }
  }
   return Res;
yyL6:;

/* line 703 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 703 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 TestIntOVF(yyP126,mUntyped(),1); 
  }
   return Res;

  }
 yyAbort ("EvalBiRealMathsOp");
}

static int EvalBiRealRelOp
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP131, register tTree yyP130, register double yyP129, register tTree yyP128, register double yyP127)
# else
(yyP131, yyP130, yyP129, yyP128, yyP127)
 register tPosition yyP131;
 register tTree yyP130;
 register double yyP129;
 register tTree yyP128;
 register double yyP127;
# endif
{
  if (yyP128->Kind == kEqual) {
/* line 709 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP129 == yyP127;

  }
  if (yyP128->Kind == kNotEqual) {
/* line 710 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP129 != yyP127;

  }
  if (yyP128->Kind == kLess) {
/* line 711 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP129 < yyP127;

  }
  if (yyP128->Kind == kGreater) {
/* line 712 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP129 > yyP127;

  }
  if (yyP128->Kind == kLessEqual) {
/* line 713 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP129 <= yyP127;

  }
  if (yyP128->Kind == kGreaterEqual) {
/* line 714 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP129 >= yyP127;

  }
 yyAbort ("EvalBiRealRelOp");
}

tValue EvalUniExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP134, register tTree yyP133, register tTree yyP132)
# else
(yyP134, yyP133, yyP132)
 register tTree yyP134;
 register tTree yyP133;
 register tTree yyP132;
# endif
{
/* line 721 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue Res; 
  if (Tree_IsType (yyP134, kInteger)) {
  if (yyP133->Kind == kBitNot) {
/* line 723 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 723 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = ~ ValConstInt (yyP132);
  }
   return Res;

  }
  if (yyP133->Kind == kSubtract) {
/* line 724 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 724 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = - ValConstInt (yyP132);
  }
   return Res;

  }
  if (yyP133->Kind == kMinus) {
/* line 725 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 725 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = - ValConstInt (yyP132);
  }
   return Res;

  }
  if (yyP133->Kind == kPlus) {
/* line 726 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 726 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = ValConstInt (yyP132);
  }
   return Res;

  }
  if (yyP133->Kind == kAdd) {
/* line 727 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 727 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = ValConstInt (yyP132);
  }
   return Res;

  }
  }
  if (yyP134->Kind == kBool) {
  if (yyP133->Kind == kNot) {
/* line 729 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 729 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = ! (ValConstInt (yyP132));
  }
   return Res;

  }
  }
  if (Tree_IsType (yyP134, kReal)) {
  if (yyP133->Kind == kSubtract) {
/* line 730 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 730 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . n = - ValConstExpr (yyP132) . RNumber . n;
/* line 730 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . p = ValConstExpr (yyP132) . RNumber . p;
  }
   return Res;

  }
  if (yyP133->Kind == kAdd) {
/* line 731 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 731 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . n = - ValConstExpr (yyP132) . RNumber . n;
/* line 731 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . p = ValConstExpr (yyP132) . RNumber . p;
  }
   return Res;

  }
  }
  if (yyP134->Kind == kArray) {
  if (yyP133->Kind == kSize) {
/* line 733 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 733 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = ValConstInt (yyP134->Array.Expr);
  }
   return Res;

  }
  }
 yyAbort ("EvalUniExpr");
}

bool CheckConstConvert
# if defined __STDC__ | defined __cplusplus
(register tTree yyP135)
# else
(yyP135)
 register tTree yyP135;
# endif
{
  if (Tree_IsType (yyP135, kInteger)) {
/* line 741 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP135->Kind == kBool) {
/* line 742 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (yyP135->Kind == kByte) {
/* line 743 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

tValue EvalConstConvert
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP138, register tTree yyP137, register tTree yyP136)
# else
(yyP138, yyP137, yyP136)
 register tPosition yyP138;
 register tTree yyP137;
 register tTree yyP136;
# endif
{
/* line 747 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue Res; 
/* line 749 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 749 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = TestIntOVF (yyP138, yyP137, ValConstInt (yyP136));
  }
   return Res;

}

tValue CheckConst
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP142, register tTree yyP141, tInt yyP140, register bool yyP139)
# else
(yyP142, yyP141, yyP140, yyP139)
 register tPosition yyP142;
 register tTree yyP141;
 tInt yyP140;
 register bool yyP139;
# endif
{
/* line 753 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue Res; 
/* line 755 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 755 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP139 == false))) goto yyL1;
  {
/* line 755 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res.Number = TestIntOVF(yyP142,yyP141,yyP140); 
  }
  }
   return Res;
yyL1:;

/* line 756 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 756 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res.Number = SignExtendInt(yyP141,yyP140); 
  }
   return Res;

}

bool CheckConstRoundTrunc
# if defined __STDC__ | defined __cplusplus
(register tTree yyP144, register tTree yyP143)
# else
(yyP144, yyP143)
 register tTree yyP144;
 register tTree yyP143;
# endif
{
  if (Tree_IsType (yyP144, kReal)) {
/* line 762 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  if (Tree_IsType (yyP143, kReal)) {
/* line 763 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

tValue EvalConstTrunc
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP148, register tTree yyP147, register tTree yyP146, tValue yyP145)
# else
(yyP148, yyP147, yyP146, yyP145)
 register tPosition yyP148;
 register tTree yyP147;
 register tTree yyP146;
 tValue yyP145;
# endif
{
/* line 782 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue Res; 
  if (Tree_IsType (yyP147, kReal)) {
  if (Tree_IsType (yyP146, kReal)) {
/* line 784 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 784 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res.RNumber.n = floor(yyP145.RNumber.n); Res.RNumber.p = 1.0+log10(fabs(Res.RNumber.n)); 
  }
   return Res;

  }
  if (Tree_IsType (yyP146, kInteger)) {
/* line 786 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 786 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res.RNumber.n = (double)yyP145.Number; Res.RNumber.p = 1.0+log10(fabs(Res.RNumber.n)); 
  }
   return Res;

  }
  }
  if (Tree_IsType (yyP147, kInteger)) {
  if (Tree_IsType (yyP146, kReal)) {
/* line 785 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 785 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res.Number = TestIntOVF(yyP148,yyP147,(tInt)yyP145.RNumber.n); 
  }
   return Res;

  }
  }
 yyAbort ("EvalConstTrunc");
}

tValue EvalConstRound
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP152, register tTree yyP151, register tTree yyP150, tValue yyP149)
# else
(yyP152, yyP151, yyP150, yyP149)
 register tPosition yyP152;
 register tTree yyP151;
 register tTree yyP150;
 tValue yyP149;
# endif
{
/* line 806 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue Res; 
  if (Tree_IsType (yyP151, kReal)) {
  if (Tree_IsType (yyP150, kReal)) {
/* line 808 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 808 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res.RNumber.n = floor(yyP149.RNumber.n + 0.5); Res.RNumber.p = 1.0+log10(fabs(Res.RNumber.n));; 
  }
   return Res;

  }
  if (Tree_IsType (yyP150, kInteger)) {
/* line 810 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 810 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res.RNumber.n = (double)yyP149.Number; Res.RNumber.p = 1.0+log10(fabs(Res.RNumber.n));; 
  }
   return Res;

  }
  }
  if (Tree_IsType (yyP151, kInteger)) {
  if (Tree_IsType (yyP150, kReal)) {
/* line 809 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 809 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 Res.Number = TestIntOVF(yyP152,yyP151,(tInt)(yyP149.RNumber.n + 0.5)); 
  }
   return Res;

  }
  }
 yyAbort ("EvalConstRound");
}

bool CheckConstId
# if defined __STDC__ | defined __cplusplus
(register tTree yyP153)
# else
(yyP153)
 register tTree yyP153;
# endif
{
  if (Tree_IsType (yyP153, kAVal)) {
/* line 817 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 817 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP153->AVal.Expr)))) goto yyL1;
  }
   return true;
yyL1:;

  }
  if (yyP153->Kind == kATagPro) {
/* line 818 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return true;

  }
  return false;
}

tValue EvalConstId
# if defined __STDC__ | defined __cplusplus
(register tTree yyP154)
# else
(yyP154)
 register tTree yyP154;
# endif
{
/* line 822 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue Res; 
  if (yyP154->Kind == kVal) {
/* line 824 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return ValConstExpr (yyP154->Val.Expr);

  }
  if (yyP154->Kind == kValRetypes) {
/* line 826 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 826 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsArrayType (yyP154->ValRetypes.Type)))) goto yyL2;
  }
   return ValConstExpr (yyP154->ValRetypes.Expr);
yyL2:;

/* line 828 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 828 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsArrayType (ExprType (yyP154->ValRetypes.Expr))))) goto yyL3;
  {
/* line 829 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 
    unsigned char tmp[8];
    tConstArray D = (tConstArray)tmp;
    int SS = CalcTypeSize(ArrayPrimType(ExprType(yyP154->ValRetypes.Expr)));
    int DS = CalcTypeSize(yyP154->ValRetypes.Type);

    RetypeConst(SS,GetConstArray(yyP154->ValRetypes.Expr),DS,D);
    Res = ReadConstArray(yyP154->ValRetypes.Type,D);
  
  }
  }
   return Res;
yyL3:;

/* line 839 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 840 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 
    unsigned char tmp1[8],tmp2[8];
    tConstArray D = (tConstArray)tmp1;
    tConstArray S = (tConstArray)tmp2;
    int SS = CalcTypeSize(ArrayPrimType(ExprType(yyP154->ValRetypes.Expr)));
    int DS = CalcTypeSize(yyP154->ValRetypes.Type);

    WriteConstArray(ExprType(yyP154->ValRetypes.Expr),ValConstExpr(yyP154->ValRetypes.Expr),S);
    RetypeConst(SS,S,DS,D);
    Res = ReadConstArray(yyP154->ValRetypes.Type,D);
  
  }
   return Res;

  }
  if (yyP154->Kind == kATagPro) {
/* line 853 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 853 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . Number = CountTags (yyP154->ATagPro.Sym);
  }
   return Res;

  }
 yyAbort ("EvalConstId");
}

tInt TestIntOVF
# if defined __STDC__ | defined __cplusplus
(register tPosition yyP157, register tTree yyP156, tInt yyP155)
# else
(yyP157, yyP156, yyP155)
 register tPosition yyP157;
 register tTree yyP156;
 tInt yyP155;
# endif
{
  if (yyP156->Kind == kInt64) {
/* line 861 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP155;

  }
  if (yyP156->Kind == kInt) {
/* line 862 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 862 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP155 >= MOSTNEGINT && yyP155 <= MOSTPOSINT))) goto yyL2;
  }
   return yyP155;
yyL2:;

  }
  if (yyP156->Kind == kInt32) {
/* line 863 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 863 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP155 >= MOSTNEGINT32 && yyP155 <= MOSTPOSINT32))) goto yyL3;
  }
   return yyP155;
yyL3:;

  }
  if (yyP156->Kind == kInt16) {
/* line 864 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 864 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP155 >= MOSTNEGINT16 && yyP155 <= MOSTPOSINT16))) goto yyL4;
  }
   return yyP155;
yyL4:;

  }
  if (yyP156->Kind == kByte) {
/* line 865 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 865 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP155 & (~ BYTEMASK)) == 0)) goto yyL5;
  }
   return yyP155;
yyL5:;

  }
  if (yyP156->Kind == kBool) {
/* line 866 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 866 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP155 & (~ BOOLMASK)) == 0)) goto yyL6;
  }
   return yyP155;
yyL6:;

  }
/* line 868 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 868 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP155 = 0;
/* line 868 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Overflow when evaluating constant expression", xxError, yyP157);
  }
   return yyP155;

}

tInt SignExtendInt
# if defined __STDC__ | defined __cplusplus
(register tTree yyP159, tInt yyP158)
# else
(yyP159, yyP158)
 register tTree yyP159;
 tInt yyP158;
# endif
{
  if (yyP159->Kind == kInt64) {
/* line 873 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP158;

  }
  if (yyP159->Kind == kInt) {
/* line 874 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 874 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IS_Mode (xx16bitINT)))) goto yyL2;
  {
/* line 874 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP158 & (~ INTMASK)) == 0)) goto yyL2;
  {
/* line 874 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 yyP158 = (tInt)((short)yyP158); 
  }
  }
  }
   return yyP158;
yyL2:;

/* line 875 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 875 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP158 & (~ INTMASK)) == 0)) goto yyL3;
  {
/* line 875 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 yyP158 = ((int)yyP158); 
  }
  }
   return yyP158;
yyL3:;

  }
  if (yyP159->Kind == kInt32) {
/* line 876 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 876 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP158 & (~ INT32MASK)) == 0)) goto yyL4;
  {
/* line 876 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 yyP158 = ((int)yyP158); 
  }
  }
   return yyP158;
yyL4:;

  }
  if (yyP159->Kind == kInt16) {
/* line 877 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 877 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP158 & (~ INT16MASK)) == 0)) goto yyL5;
  {
/* line 877 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 yyP158 = ((short)yyP158); 
  }
  }
   return yyP158;
yyL5:;

  }
  if (yyP159->Kind == kByte) {
/* line 878 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 878 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP158 & (~ BYTEMASK)) == 0)) goto yyL6;
  }
   return yyP158;
yyL6:;

  }
  if (yyP159->Kind == kBool) {
/* line 879 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 879 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((yyP158 & (~ BOOLMASK)) == 0)) goto yyL7;
  }
   return yyP158;
yyL7:;

  }
/* line 881 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP158;

}

static int CountTags
# if defined __STDC__ | defined __cplusplus
(tSymbol yyP160)
# else
(yyP160)
 tSymbol yyP160;
# endif
{
/* line 886 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 886 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((! Tree_IsType (SymbolKind (yyP160 - 1), kATagPro)))) goto yyL1;
  }
   return 0;
yyL1:;

/* line 887 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 1 + CountTags (yyP160 - 1);

}

static tInt EvalIntBits
# if defined __STDC__ | defined __cplusplus
(register tTree yyP161)
# else
(yyP161)
 register tTree yyP161;
# endif
{
  if (yyP161->Kind == kInt) {
/* line 892 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 32;

  }
  if (yyP161->Kind == kInt16) {
/* line 893 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 16;

  }
  if (yyP161->Kind == kInt32) {
/* line 894 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 32;

  }
  if (yyP161->Kind == kInt64) {
/* line 895 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 64;

  }
 yyAbort ("EvalIntBits");
}

static tInt EvalIntMask
# if defined __STDC__ | defined __cplusplus
(register tTree yyP162)
# else
(yyP162)
 register tTree yyP162;
# endif
{
  if (yyP162->Kind == kInt) {
/* line 899 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return INTMASK;

  }
  if (yyP162->Kind == kInt16) {
/* line 900 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return INT16MASK;

  }
  if (yyP162->Kind == kInt32) {
/* line 901 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return INT32MASK;

  }
  if (yyP162->Kind == kInt64) {
/* line 902 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return INT64MASK;

  }
 yyAbort ("EvalIntMask");
}

tInt EvalMostPos
# if defined __STDC__ | defined __cplusplus
(register tTree yyP163)
# else
(yyP163)
 register tTree yyP163;
# endif
{
  if (yyP163->Kind == kInt) {
/* line 906 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return MOSTPOSINT;

  }
  if (yyP163->Kind == kInt16) {
/* line 907 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return MOSTPOSINT16;

  }
  if (yyP163->Kind == kInt32) {
/* line 908 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return MOSTPOSINT32;

  }
  if (yyP163->Kind == kInt64) {
/* line 909 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return MOSTPOSINT64;

  }
 yyAbort ("EvalMostPos");
}

tInt EvalMostNeg
# if defined __STDC__ | defined __cplusplus
(register tTree yyP164)
# else
(yyP164)
 register tTree yyP164;
# endif
{
  if (yyP164->Kind == kInt) {
/* line 913 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return MOSTNEGINT;

  }
  if (yyP164->Kind == kInt16) {
/* line 914 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return MOSTNEGINT16;

  }
  if (yyP164->Kind == kInt32) {
/* line 915 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return MOSTNEGINT32;

  }
  if (yyP164->Kind == kInt64) {
/* line 916 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return MOSTNEGINT64;

  }
 yyAbort ("EvalMostNeg");
}

tValue EvalConstSubscript
# if defined __STDC__ | defined __cplusplus
(register tTree yyP167, register int yyP166, tConstArray yyP165)
# else
(yyP167, yyP166, yyP165)
 register tTree yyP167;
 register int yyP166;
 tConstArray yyP165;
# endif
{
/* line 921 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue Res; tTree E; 
  if (yyP167->Kind == kReal32) {
/* line 923 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 923 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . n =  ((float *)yyP165)[yyP166] ;
/* line 923 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . p = 0;
  }
   return Res;

  }
  if (yyP167->Kind == kReal64) {
/* line 924 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 924 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . n =  ((double *)yyP165)[yyP166] ;
/* line 924 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Res . RNumber . p = 0;
  }
   return Res;

  }
  if (Tree_IsType (yyP167, kPrimitive)) {
/* line 925 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 926 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */

      switch(CalcTypeSize(yyP167))
      {
        case 1:  Res.Number = ((unsigned char *)yyP165)[yyP166]; break;
        case 2:  Res.Number = ((short *)yyP165)[yyP166]; break;
        case 4:  Res.Number = ((int *)yyP165)[yyP166]; break;
        case 8:  Res.Number = ((tInt *)yyP165)[yyP166]; break;
      }
    
  }
   return Res;

  }
 yyAbort ("EvalConstSubscript");
}

tConstArray ConstArrayFromString
# if defined __STDC__ | defined __cplusplus
(register tTree yyP169, register tStringRef yyP168)
# else
(yyP169, yyP168)
 register tTree yyP169;
 register tStringRef yyP168;
# endif
{
/* line 940 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tConstArray CA; 
/* line 942 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 942 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   CA = NewConstArray (LengthSt (yyP168));
/* line 943 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 StGetString(yyP168,CA); 
  }
   return CA;

}

tConstArray ConstArrayFromExprList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP171, register tTree yyP170)
# else
(yyP171, yyP170)
 register tTree yyP171;
 register tTree yyP170;
# endif
{
/* line 947 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tConstArray CA; 
  if (yyP171->Kind == kArray) {
/* line 949 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 949 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   CA = NewConstArray (CalcTypeSize (yyP171));
/* line 949 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   FillConstArray (yyP171->Array.Type, yyP170, CA);
  }
   return CA;

  }
 yyAbort ("ConstArrayFromExprList");
}

tConstArray ConstArrayFromDecl
# if defined __STDC__ | defined __cplusplus
(register tTree yyP173, register tTree yyP172)
# else
(yyP173, yyP172)
 register tTree yyP173;
 register tTree yyP172;
# endif
{
/* line 956 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tConstArray CA; 
  if (yyP172->Kind == kVal) {
  if (yyP172->Val.Expr->Kind == kElementalExpr) {
/* line 958 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 958 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsArrayType (ExprType (yyP172->Val.Expr))))) goto yyL1;
  }
   return  yyP172->Val.Expr->ElementalExpr.Elemental->Elemental.CA ;
yyL1:;

  }
  if (Tree_IsType (yyP172->Val.Expr, kStringElement)) {
/* line 959 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 959 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsArrayType (ExprType (yyP172->Val.Expr))))) goto yyL2;
  }
   return  yyP172->Val.Expr->StringElement.CA ;
yyL2:;

  }
  }
  if (yyP173->Kind == kArray) {
  if (yyP172->Kind == kValRetypes) {
  if (yyP172->ValRetypes.Expr->Kind == kElementalExpr) {
/* line 961 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 961 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsArrayType (ExprType (yyP172->ValRetypes.Expr))))) goto yyL3;
  {
/* line 962 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */

      { tConstArray S,D;
        int SS = CalcTypeSize(ArrayPrimType(ExprType(yyP172->ValRetypes.Expr)));
        int DS = CalcTypeSize(ArrayPrimType(yyP173));
        int sz = CalcTypeSize(yyP173);
        int psz = CalcTypeSize(ArrayPrimType(yyP173));
        int count = sz/psz;

        CA = NewConstArray(sz);
        S = GetConstArray(yyP172->ValRetypes.Expr);
        D = CA;

        while(count-- > 0)
        {
          RetypeConst(SS,S,DS,D);
          D += DS; S += DS;
        }
      }
    
  }
  }
   return CA;
yyL3:;

  }
/* line 983 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 984 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */

      { tConstArray S,D;
        int SS = CalcTypeSize(ExprType(yyP172->ValRetypes.Expr));
        int DS = CalcTypeSize(ArrayPrimType(yyP173));

        CA = NewConstArray(CalcTypeSize(yyP173));
        S = CA; D = CA;
        WriteConstArray(ExprType(yyP172->ValRetypes.Expr),ValConstExpr(yyP172->ValRetypes.Expr),CA);
        RetypeConst(SS,S,DS,D);
      }
    
  }
   return CA;

  }
  }
/* line 997 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 997 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyWrite ("ConstArrayFromDecl-");
/* line 997 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   WriteTreeNode (yyf, yyP172);
  }
   return 0;

}

static void FillConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP176, register tTree yyP175, tConstArray yyP174)
# else
(yyP176, yyP175, yyP174)
 register tTree yyP176;
 register tTree yyP175;
 tConstArray yyP174;
# endif
{
  if (yyP176->Kind == kArray) {
  if (yyP175->Kind == kAnExpr) {
  if (yyP175->AnExpr.Expr->Kind == kElementalExpr) {
/* line 1001 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1002 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */

      int sz=CalcTypeSize(yyP176);

      memcpy(yyP174,yyP175->AnExpr.Expr->ElementalExpr.Elemental->Elemental.CA,sz);
      FillConstArray(yyP176,yyP175->AnExpr.Next,yyP174+sz);
    
  }
   return;

  }
  if (Tree_IsType (yyP175->AnExpr.Expr, kStringElement)) {
/* line 1010 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1011 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */

      int sz=CalcTypeSize(yyP176);

      memcpy(yyP174,yyP175->AnExpr.Expr->StringElement.CA,sz);
      FillConstArray(yyP176,yyP175->AnExpr.Next,yyP174+sz);
    
  }
   return;

  }
  }
  }
  if (Tree_IsType (yyP176, kPrimitive)) {
  if (yyP175->Kind == kAnExpr) {
/* line 1019 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1020 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */

      WriteConstArray(yyP176,ValConstExpr(yyP175->AnExpr.Expr),yyP174);
      FillConstArray(yyP176,yyP175->AnExpr.Next,yyP174+CalcTypeSize(yyP176));
    
  }
   return;

  }
  }
;
}

tConstArray RangeConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP179, tConstArray yyP178, register int yyP177)
# else
(yyP179, yyP178, yyP177)
 register tTree yyP179;
 tConstArray yyP178;
 register int yyP177;
# endif
{
  if (yyP179->Kind == kArray) {
/* line 1028 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1028 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP178 = yyP178 +  (yyP177*CalcTypeSize(yyP179->Array.Type));
/* line 1029 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */


    
  }
   return yyP178;

  }
 yyAbort ("RangeConstArray");
}

tConstArray SubscriptConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP182, tConstArray yyP181, register int yyP180)
# else
(yyP182, yyP181, yyP180)
 register tTree yyP182;
 tConstArray yyP181;
 register int yyP180;
# endif
{
/* line 1037 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1037 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP181 = yyP181 + (yyP180*CalcTypeSize(yyP182));
/* line 1038 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */


    
  }
   return yyP181;

}

static tConstArray GetConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree EX)
# else
(EX)
 register tTree EX;
# endif
{
  if (EX->Kind == kElementalExpr) {
/* line 1046 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1046 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsArrayType (ExprType (EX))))) goto yyL1;
  }
   return EX->ElementalExpr.Elemental -> Elemental . CA;
yyL1:;

  }
  if (Tree_IsType (EX, kStringElement)) {
/* line 1047 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1047 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsArrayType (ExprType (EX))))) goto yyL2;
  }
   return EX -> StringElement . CA;
yyL2:;

  }
/* line 1048 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1048 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Error in ExprConstArray()", xxFatal, EX->Expr.Pos);
  }
   return (tConstArray)NULL;

}

tValue ReadConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP184, tConstArray yyP183)
# else
(yyP184, yyP183)
 register tTree yyP184;
 tConstArray yyP183;
# endif
{
/* line 1052 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tValue V; 

  switch (yyP184->Kind) {
  case kByte:
/* line 1054 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1054 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.Number = *((unsigned char *)yyP183); 
  }
   return V;

  case kBool:
/* line 1055 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1055 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.Number = *((unsigned char *)yyP183); 
  }
   return V;

  case kInt:
/* line 1057 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1057 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IS_Mode (xx16bitINT)))) goto yyL3;
  {
/* line 1057 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.Number = *((short *)yyP183); 
  }
  }
   return V;
yyL3:;

/* line 1060 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1060 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.Number = *((int *)yyP183) ; 
  }
   return V;

  case kInt16:
/* line 1058 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1058 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.Number = *((short *)yyP183); 
  }
   return V;

  case kInt32:
/* line 1061 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1061 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.Number = *((int *)yyP183) ; 
  }
   return V;

  case kReal32:
/* line 1062 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1062 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.RNumber.n=  *((float *)yyP183); V.RNumber.p = 7; 
  }
   return V;

  case kInt64:
/* line 1064 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1064 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.Number = *((tInt *)yyP183) ; 
  }
   return V;

  case kReal64:
/* line 1065 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1065 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
V.RNumber.n= *((double *)yyP183); V.RNumber.p = 14; 
  }
   return V;

  }

 yyAbort ("ReadConstArray");
}

void WriteConstArray
# if defined __STDC__ | defined __cplusplus
(register tTree yyP187, tValue yyP186, tConstArray yyP185)
# else
(yyP187, yyP186, yyP185)
 register tTree yyP187;
 tValue yyP186;
 tConstArray yyP185;
# endif
{

  switch (yyP187->Kind) {
  case kByte:
/* line 1069 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1069 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
*((char *)yyP185) = yyP186.Number; 
  }
   return;

  case kBool:
/* line 1070 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1070 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
*((char *)yyP185) = yyP186.Number; 
  }
   return;

  case kInt:
/* line 1072 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1072 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IS_Mode (xx16bitINT)))) goto yyL3;
  {
/* line 1072 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
*((short *)yyP185) = yyP186.Number; 
  }
  }
   return;
yyL3:;

/* line 1075 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1075 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
*((int *)yyP185) = yyP186.Number; 
  }
   return;

  case kInt16:
/* line 1073 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1073 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
*((short *)yyP185) = yyP186.Number; 
  }
   return;

  case kInt32:
/* line 1076 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1076 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
*((int *)yyP185) = yyP186.Number; 
  }
   return;

  case kReal32:
/* line 1077 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1077 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 *((float *)yyP185) = yyP186.RNumber.n; 
  }
   return;

  case kInt64:
/* line 1079 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1079 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
*((tInt *)yyP185) = yyP186.Number; 
  }
   return;

  case kReal64:
/* line 1080 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1080 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 *((double *)yyP185) = yyP186.RNumber.n; 
  }
   return;

  }

;
}

static tConstArray NewConstArray
# if defined __STDC__ | defined __cplusplus
(register int yyP188)
# else
(yyP188)
 register int yyP188;
# endif
{
/* line 1085 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tConstArray CA; 
/* line 1087 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1088 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */

    if (!(CA = (tConstArray)malloc(yyP188))) Message("Out of heap allocating array",xxError,NoPosition);
  
  }
   return CA;

}

static void RangeCheckSubscript
# if defined __STDC__ | defined __cplusplus
(register tTree yyP190, register tTree yyP189)
# else
(yyP190, yyP189)
 register tTree yyP190;
 register tTree yyP189;
# endif
{
/* line 1096 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1096 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP190)))) goto yyL1;
  {
/* line 1096 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP189)))) goto yyL1;
  {
/* line 1096 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP190) >= 0))) goto yyL1;
  {
/* line 1096 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP190) < ValConstInt (yyP189)))) goto yyL1;
  }
  }
  }
  }
   return;
yyL1:;

/* line 1097 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1097 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP190)))) goto yyL2;
  {
/* line 1097 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP189)))) goto yyL2;
  {
/* line 1097 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Subscript out of range", xxError, yyP190->Expr.Pos);
  }
  }
  }
   return;
yyL2:;

/* line 1098 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1098 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP190)))) goto yyL3;
  {
/* line 1098 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP190) >= 0))) goto yyL3;
  }
  }
   return;
yyL3:;

/* line 1099 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1099 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP190)))) goto yyL4;
  {
/* line 1099 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Subscript out of range", xxError, yyP190->Expr.Pos);
  }
  }
   return;
yyL4:;

/* line 1100 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

;
}

static void RangeCheckSlice
# if defined __STDC__ | defined __cplusplus
(register tTree yyP193, register tTree yyP192, register tTree yyP191)
# else
(yyP193, yyP192, yyP191)
 register tTree yyP193;
 register tTree yyP192;
 register tTree yyP191;
# endif
{
/* line 1104 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1104 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP193)))) goto yyL1;
  {
/* line 1104 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP192)))) goto yyL1;
  {
/* line 1104 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP191)))) goto yyL1;
  {
/* line 1105 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP193) >= 0))) goto yyL1;
  {
/* line 1105 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((ValConstInt (yyP192) >= 0))) goto yyL1;
  {
/* line 1105 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (((ValConstInt (yyP193) + ValConstInt (yyP192)) <= ValConstInt (yyP191)))) goto yyL1;
  }
  }
  }
  }
  }
  }
   return;
yyL1:;

/* line 1106 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1106 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP193)))) goto yyL2;
  {
/* line 1106 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP192)))) goto yyL2;
  {
/* line 1106 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP191)))) goto yyL2;
  {
/* line 1107 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Array slice exceeds array bounds", xxError, yyP193->Expr.Pos);
  }
  }
  }
  }
   return;
yyL2:;

/* line 1108 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1108 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   RangeCheckSubscript (yyP193, yyP191);
  }
   return;

;
}

tTree MakeConstInt
# if defined __STDC__ | defined __cplusplus
(register int yyP195, register tPosition yyP194)
# else
(yyP195, yyP194)
 register int yyP195;
 register tPosition yyP194;
# endif
{
/* line 1113 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tTree T; tValue TMP; 
/* line 1114 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1114 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   TMP . Number = yyP195;
/* line 1114 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   T = mConst (yyP194, TMP, mInt ());
/* line 1114 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   ExprType (T) = mInt ();
/* line 1114 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   ConstFlag (T -> Expr) = true;
/* line 1114 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   ValConstInt (T) = yyP195;
  }
   return T;

}

static tTree MakeAddExpr
# if defined __STDC__ | defined __cplusplus
(register tTree yyP197, register tTree yyP196)
# else
(yyP197, yyP196)
 register tTree yyP197;
 register tTree yyP196;
# endif
{
/* line 1117 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 tTree T; 
/* line 1118 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1118 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP197)))) goto yyL1;
  {
/* line 1118 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstInt (yyP196)))) goto yyL1;
  {
/* line 1118 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   T = mBinary (yyP197->Expr.Pos, yyP197, yyP196, mAdd ());
/* line 1118 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   ExprType (T) = ExprType (yyP197);
/* line 1118 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   ConstFlag (T -> Expr) = true;
/* line 1118 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   ValConstInt (T) = ValConstInt (yyP197) + ValConstInt (yyP196);
  }
  }
  }
   return T;
yyL1:;

/* line 1119 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1119 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   T = mBinary (yyP197->Expr.Pos, yyP197, yyP196, mAdd ());
/* line 1119 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   ExprType (T) = ExprType (yyP197);
/* line 1119 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   ConstFlag (T -> Expr) = false;
  }
   return T;

}

static int CountList
# if defined __STDC__ | defined __cplusplus
(register tTree yyP199, register tTree yyP198)
# else
(yyP199, yyP198)
 register tTree yyP199;
 register tTree yyP198;
# endif
{
  if (yyP199->Kind == kAnExpr) {
/* line 1124 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1124 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SameType (yyP198, ExprType (yyP199->AnExpr.Expr)))) goto yyL1;
  }
   return CountList (yyP199->AnExpr.Next, yyP198) + 1;
yyL1:;

/* line 1126 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1126 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Type mismatch in expression list", xxError, yyP199->AnExpr.Expr->Expr.Pos);
  }
   return CountList (yyP199->AnExpr.Next, yyP198) + 1;

  }
  if (yyP199->Kind == kNoExpr) {
/* line 1125 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 1;

  }
 yyAbort ("CountList");
}

static int SizeType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP202, register tPosition yyP201, register bool yyP200, register tTree * yyP203)
# else
(yyP202, yyP201, yyP200, yyP203)
 register tTree yyP202;
 register tPosition yyP201;
 register bool yyP200;
 register tTree * yyP203;
# endif
{
/* line 1130 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 int V; 

  switch (yyP202->Kind) {
  case kArray:
  if (yyP202->Array.Expr->Kind == kUnBound) {
 {
  tTree yyV1;
  if (equalbool (yyP200, true)) {
/* line 1131 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1132 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   V = SizeType (yyP202->Array.Type, yyP201, true, & yyV1);
/* line 1133 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 if (yyV1!=NoTree) Message("Too many unspecified dimensions to retype",xxError,yyP201); 
  }
   * yyP203 = yyP202;
  {
   return V;
  }

  }
 }
  }
/* line 1135 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  tTree yyV1;
  {
/* line 1135 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((! IsConstInt (yyP202->Array.Expr)))) goto yyL2;
  {
/* line 1135 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! (SizeType (yyP202->Array.Type, yyP201, yyP200, & yyV1))) goto yyL2;
  }
  }
   * yyP203 = yyV1;
  {
   return - 1;
  }
 }
yyL2:;

/* line 1136 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
 {
  tTree yyV1;
  {
/* line 1136 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   V = SizeType (yyP202->Array.Type, yyP201, yyP200, & yyV1);
  }
   * yyP203 = yyV1;
  {
   return (V<0)?V:V*ValConstInt(yyP202->Array.Expr);
  }
 }

  case kInt:
/* line 1137 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP203 = NULL;
   return IS_Mode(xx16bitINT) ? 2 : 4 ;

  case kInt16:
/* line 1138 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP203 = NULL;
   return 2;

  case kInt32:
/* line 1139 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP203 = NULL;
   return 4;

  case kInt64:
/* line 1140 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP203 = NULL;
   return 8;

  case kReal32:
/* line 1141 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP203 = NULL;
   return 4;

  case kReal64:
/* line 1142 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP203 = NULL;
   return 8;

  case kBool:
/* line 1143 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP203 = NULL;
   return 1;

  case kByte:
/* line 1144 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP203 = NULL;
   return 1;

  case kChan:
/* line 1145 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   * yyP203 = NULL;
   return sizeof(void*);

  }

/* line 1146 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1146 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Cannot perform retype involving this base type", xxError, yyP201);
  }
   * yyP203 = NULL;
   return - 1;

}

int CalcTypeSize
# if defined __STDC__ | defined __cplusplus
(register tTree yyP204)
# else
(yyP204)
 register tTree yyP204;
# endif
{

  switch (yyP204->Kind) {
  case kArray:
/* line 1150 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1150 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   if (! ((IsConstExpr (yyP204->Array.Expr)))) goto yyL1;
  }
   return  ValConstInt(yyP204->Array.Expr) * CalcTypeSize(yyP204->Array.Type) ;
yyL1:;

  break;
  case kInt:
/* line 1151 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return IS_Mode(xx16bitINT) ? 2 : 4 ;

  case kInt16:
/* line 1152 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 2;

  case kInt32:
/* line 1153 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 4;

  case kInt64:
/* line 1154 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 8;

  case kReal32:
/* line 1155 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 4;

  case kReal64:
/* line 1156 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 8;

  case kBool:
/* line 1157 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 1;

  case kByte:
/* line 1158 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return 1;

  }

/* line 1159 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1159 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   Message ("Internal Error - ConstArray Evaluation", xxError, NoPosition);
  }
   return - 1;

}

tTree ReduceElement
# if defined __STDC__ | defined __cplusplus
(register tTree yyP206, register tTree yyP205)
# else
(yyP206, yyP205)
 register tTree yyP206;
 register tTree yyP205;
# endif
{
  if (yyP206->Kind == kIdentifier) {
/* line 1167 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP206;

  }
  if (yyP206->Kind == kRange) {
  if (yyP205 == NULL) {
/* line 1168 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1168 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP206->Range.Next = ReduceElement (yyP206->Range.Next, yyP206);
  }
   return yyP206;

  }
  if (yyP205->Kind == kRange) {
/* line 1169 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1169 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP205->Range.From = MakeAddExpr (yyP205->Range.From, yyP206->Range.From);
  }
   return ReduceElement (yyP206->Range.Next, yyP205);

  }
  if (yyP205->Kind == kSubscript) {
/* line 1170 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1170 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP205->Subscript.Expr = MakeAddExpr (yyP205->Subscript.Expr, yyP206->Range.From);
  }
   return ReduceElement (yyP206->Range.Next, yyP205);

  }
  }
  if (yyP206->Kind == kSubscript) {
/* line 1171 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1171 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   yyP206->Subscript.Next = ReduceElement (yyP206->Subscript.Next, yyP206);
  }
   return yyP206;

  }
 yyAbort ("ReduceElement");
}

tTree ReduceElemental
# if defined __STDC__ | defined __cplusplus
(register tTree yyP207)
# else
(yyP207)
 register tTree yyP207;
# endif
{
  if (Tree_IsType (yyP207, kElement)) {
/* line 1176 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return ReduceElement (yyP207, NoTree);

  }
  if (Tree_IsType (yyP207, kTableElement)) {
/* line 1178 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP207;

  }
 yyAbort ("ReduceElemental");
}

tTree ArrayPrimType
# if defined __STDC__ | defined __cplusplus
(register tTree yyP208)
# else
(yyP208)
 register tTree yyP208;
# endif
{
  if (yyP208->Kind == kArray) {
/* line 1184 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return ArrayPrimType (yyP208->Array.Type);

  }
  if (Tree_IsType (yyP208, kPrimitive)) {
/* line 1185 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return yyP208;

  }
 yyAbort ("ArrayPrimType");
}

void MarkNonAtomicIf
# if defined __STDC__ | defined __cplusplus
(register tTree IF)
# else
(IF)
 register tTree IF;
# endif
{
  if (IF->Kind == kIf) {
/* line 1193 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1194 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
IF->If.ATOMIC = false; 
/* line 1195 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   MarkNonAtomicIfList (IF->If.ChoiceList);
  }
   return;

  }
  if (IF->Kind == kIfRep) {
/* line 1198 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1199 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
IF->IfRep.ATOMIC = false; 
/* line 1200 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   MarkNonAtomicIfList (IF->IfRep.ChoiceList);
  }
   return;

  }
;
}

static void MarkNonAtomicIfList
# if defined __STDC__ | defined __cplusplus
(register tTree IF)
# else
(IF)
 register tTree IF;
# endif
{
  if (IF->Kind == kAChoice) {
/* line 1205 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1206 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
IF->AChoice.ATOMIC = false; 
/* line 1207 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   MarkNonAtomicIfList (IF->AChoice.Next);
  }
   return;

  }
  if (IF->Kind == kANewIf) {
/* line 1210 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
  {
/* line 1211 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
IF->ANewIf.ATOMIC = false; 
/* line 1212 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   MarkNonAtomicIf (IF->ANewIf.IfType);
/* line 1213 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   MarkNonAtomicIfList (IF->ANewIf.Next);
  }
   return;

  }
  if (IF->Kind == kNoChoice) {
/* line 1216 "/home/ringwood/smw/occam/source/gmd/typechk.trafo" */
   return;

  }
;
}

void BeginTypeChk ()
{
}

void CloseTypeChk ()
{
}
